C                                                                                                                                   
      SUBROUTINE UEL(RHS,AMATRX,SVARS,ENERGY,NDOFEL,NRHS,NSVARS,PROPS,                                                              
     1 NPROPS,COORDS,MCRD,NNODE,U,DU,V,A,JTYPE,TIME,DTIME,KSTEP,KINC,                                                               
     2 JELEM,PARAMS,NDLOAD,JDLTYP,ADLMAG,PREDEF,NPREDF,LFLAGS,                                                                      
     3 MLVARX,DDLMAG,MDLOAD,PNEWDT,JPROPS,NJPROP,PERIOD)                                                                            
C                                                                                                                                   
C------------------------------------------                                                                                         
C     last modification date:12.4.99                                                                                                
C     last modification:                                                                                                            
C    12.4.99: implementation of 3d cohesive zone elements                                                                           
C     9.4.99: new structure of procedure                                                                                            
C    17.3.99: variable shear/normal combination power law via MPOWER                                                                
C     9.3.99: parabolic unloading function                                                                                          
C------------------------------------------                                                                                         
C                                                                                                                                   
      INCLUDE 'ABA_PARAM.INC'                                                                                                       
C                                                                                                                                   
      DIMENSION RHS(MLVARX,NRHS),AMATRX(NDOFEL,NDOFEL),SVARS(NSVARS),                                                               
     1 PROPS(NPROPS),COORDS(MCRD,NNODE),                                                                                            
     2 U(NDOFEL),                                                                                                                   
     3 PARAMS(3),JDLTYP(MDLOAD,*),ADLMAG(MDLOAD,*),                                                                                 
     4 DDLMAG(MDLOAD,*),PREDEF(2,NPREDF,NNODE),LFLAGS(*),JPROPS(*)                                                                  
      DIMENSION SRESID(6)                                                                                                           
C                                                                                                                                   
       COMMON/QBERT/Q0,Q1,Q2,Q3,Q4,QP5,Q2SQR3,IFIRST                                                                                
       DIMENSION X(NNODE),Y(NNODE),Z(NNODE)                                                                                         
C                                                                                                                                   
      DO 6 K1=1,NDOFEL                                                                                                              
      DO 2 KRHS=1,NRHS                                                                                                              
      RHS(K1,KRHS)  = 0.0D0                                                                                                         
    2 CONTINUE                                                                                                                      
      DO 4 K2=1,NDOFEL                                                                                                              
      AMATRX(K2,K1)=0.0D0                                                                                                           
    4 CONTINUE                                                                                                                      
    6 CONTINUE                                                                                                                      
                                                                                                                                    
C                                                                                                                                   
C--------------------------------------------------------------------                                                               
C                                                                                                                                   
C USER ELEMENTS FOR USE WITH 5.6 - 5.8 OF ABAQUS                                                                                    
C                                                                                                                                   
C  U1  AXISYMMETRIC INTERFACE ELEMENT                                                                                               
C  U2  PLANE STRAIN INTERFACE ELEMENT                                                                                               
C                                                                                                                                   
C--------------------------------------------------------------------                                                               
C                                                                                                                                   
C                                                                                                                                   
C                                                                                                                                   
       INTMDL=JPROPS(1)                                                                                                             
       DEL_N =PROPS(1)                                                                                                              
       DEL_T =PROPS(2)                                                                                                              
       SIGM  =PROPS(3)                                                                                                              
       AL    =PROPS(4)                                                                                                              
       DEPTH =PROPS(5)                                                                                                              
       DEL1RA=PROPS(6)                                                                                                              
       DEL2RA=PROPS(7)                                                                                                              
C                                                                                                                                   
C                                                                                                                                   
       IF (IFIRST.NE.1) THEN                                                                                                        
          Q0=0.D0                                                                                                                   
          Q1=1.D0                                                                                                                   
          Q2=2.D0                                                                                                                   
          Q3=3.D0                                                                                                                   
          Q4=4.D0                                                                                                                   
          QP5=0.5D0                                                                                                                 
          Q2SQR3= Q1/SQRT(Q3) * QP5                                                                                                 
          PI=Q2*ASIN(Q1)                                                                                                            
          PI2=Q2*PI                                                                                                                 
C                                                                                                                                   
	  WRITE (*,1000)                                                                                                                   
C         WRITE (*,1110) '  EL.-TYPE ',JTYPE                                                                                        
	  WRITE (*,1100) ' THICKNESS ',DEPTH                                                                                               
	  WRITE (*,1100) '   SIGMA_N ',SIGM                                                                                                
	  WRITE (*,1100) '   DELTA_N ',DEL_N                                                                                               
	  WRITE (*,1100) '    DELTA1 ',DEL1RA                                                                                              
	  WRITE (*,1100) '    DELTA2 ',DEL2RA                                                                                              
	  WRITE (*,1100) '     ALPHA ',AL                                                                                                  
	  WRITE (*,1100) '   DELTA_T ',DEL_T                                                                                               
          IF(LFLAGS(2).NE.1) THEN                                                                                                   
	     WRITE(6,29)LFLAGS(2)                                                                                                          
   29        FORMAT(/'***SET THE "*NLGEOM" FLAG***',/,I3)                                                                           
          END IF                                                                                                                    
 1000     FORMAT (//,'******************************',/,                                                                            
     1               '** COHESIVE ZONE PARAMETERS **',/,                                                                            
     2               '******************************')                                                                              
 1100     FORMAT (A,G10.4)                                                                                                          
 1110     FORMAT (A,I5)                                                                                                             
	  IFIRST = 1                                                                                                                       
       ENDIF                                                                                                                        
C                                                                                                                                   
       IF (NSVARS .LT. 12) GOTO 2100                                                                                                
C                                                                                                                                   
C JTYPE=1: AXISYMMETRIC,                                                                                                            
C       2: PLANE STRAIN,                                                                                                            
C       3: 3D-INTERFACE ELEMENTS                                                                                                    
C                                                                                                                                   
C JPROPS(1)    INTERFACE MODEL SELECTION                                                                                            
C                 =1 FOR MEEDLEMAN'S POTENTIAL                                                                                      
C                 =2 FOR ROSE ET AL.                                                                                                
C                 =3 FOR LIN                                                                                                        
C PROPS(1)     CHARACTERISTIC DISTANCE, DELTA                                                                                       
C PROPS(2)     CHARACTERISTIC SHEAR DISTANCE, DELTA_T                                                                               
C PROPS(3)     MAX STRESS PARAMETER, SIGMA_M                                                                                        
C PROPS(4)     NORMAL-SHEAR COUPLING PARAMETER, ALPHA                                                                               
C PROPS(5)     OUT OF PLANE DEPTH FOR PLANE STRAIN                                                                                  
C PROPS(6)     1. STABLIZING PARAMETER FOR LINS LAW                                                                                 
C PROPS(7)     2. STABLIZING PARAMETER FOR LINS LAW                                                                                 
C                                                                                                                                   
C ROUTINE NEEDS 14 STATE VARIABLES                                                                                                  
C                                                                                                                                   
C EVALUATE CURRENT COORDINATES                                                                                                      
C                                                                                                                                   
       DO 1010 I=1,NNODE                                                                                                            
          X(I)=COORDS(1,I)+U(3*I-2)                                                                                                 
          Y(I)=COORDS(2,I)+U(3*I-1)                                                                                                 
	  IF (MCRD.EQ.3) Z(I)=COORDS(3,I)+U(3*I)                                                                                           
Ctest     WRITE (6,*) 'ELEMENT,NODE',JELEM,I                                                                                        
Ctest     WRITE (6,*) X(I),Y(I),Z(I)                                                                                                
 1010  CONTINUE                                                                                                                     
C                                                                                                                                   
C CHOOSE ROUTINE FOR 2D AND 3D CZELEMENTS                                                                                           
C                                                                                                                                   
       IF (JTYPE.EQ.1 .OR. JTYPE.EQ.2) THEN                                                                                         
          CALL CZE2D(RHS,AMATRX,SVARS,NDOFEL,NRHS,MLVARX,NSVARS,                                                                    
     1               NNODE,U,JTYPE,JELEM,X,Y,                                                                                       
     2               INTMDL,DEL_N,DEL_T,SIGM,AL,DEPTH,DEL1RA,DEL2RA)                                                                
       ELSEIF (JTYPE.EQ.3) THEN                                                                                                     
          CALL CZE3D(RHS,AMATRX,SVARS,NDOFEL,NRHS,MLVARX,NSVARS,                                                                    
     1               NNODE,U,JTYPE,JELEM,X,Y,Z,                                                                                     
     2               INTMDL,DEL_N,DEL_T,SIGM,AL,DEPTH,DEL1RA,DEL2RA)                                                                
       ELSE                                                                                                                         
C ********NEW ELEMENT TYPES**********                                                                                               
          WRITE (6,7778) JTYPE                                                                                                      
          CALL XIT                                                                                                                  
          RETURN                                                                                                                    
       ENDIF                                                                                                                        
C                                                                                                                                   
       RETURN                                                                                                                       
C                                                                                                                                   
C                                                                                                                                   
 2100  CONTINUE                                                                                                                     
       WRITE (6,7780) NSVARS                                                                                                        
       CALL XIT                                                                                                                     
       RETURN                                                                                                                       
 7778  FORMAT (/,'***  ELEMENT TYPE ",I2," IS NOT IMPLEMENTED  ***',/,                                                              
     1          '***  PROGRAM WILL STOP                   ***')                                                                     
 7780  FORMAT (/,'***  YOU HAVE TO DEFINE AT LEAST ',I2,                                                                            
     1          ' STATE VARIABLES  ***',/,                                                                                          
     2          '***  PROGRAM WILL STOP                   ***')                                                                     
       END                                                                                                                          
C                                                                                                                                   
C                                                                                                                                   
C                                                                                                                                   
C ***************************************************                                                                               
C *                                                 *                                                                               
      INCLUDE '/wer62/software/czm-aba/cze2d.f'                                                                                     
      INCLUDE '/wer62/software/czm-aba/cze3d.f'                                                                                     
      INCLUDE '/wer62/software/czm-aba/czlaw.f'                                                                                     
C *                                                 *                                                                               
C ***************************************************                                                                               
C                                                                                                                                   
C                                                                                                                                   
