C
C     PROGRAM FOR GENERATING 4-NODES CRACK_TIP ELEMENT MESH
C     FOR BLUNTING CRACK-TIP 
C
      SUBROUTINE BLFMESH1
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XSG1(3),YSG1(3),XSG2(3),YSG2(3),EL(100),CL(100)
      DIMENSION XB(50),YB(50),XE(50),YE(50),INBLF(50),XSG(5),YSG(5),
     1 NL(20),NR(20),RA(1000),SC1(20),SC2(20),N1OUT(1000),RBLF(500)
      CHARACTER*6 CTYPE
      CHARACTER*80 TITLE
C
C     INPUT INITIAL DATA
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB.BLFMESH1'
C
      TEXT='NOW EXCUTING SUB.BLFMESH1'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      READ(IO_INPUT,*) TITLE
C
      READ(IO_INPUT,*) IMSET,NODE,NX1,NX2,NX3,NY1,XH,YH,R0,DR,SR,R1
c     WRITE(IO_WRITE,'(6I5,10E8.3)') IMSET,NODE,NX1,NX2,NX3,NY1,XH,R0,DR,SR,R1
C
      IF(NODE.EQ.8) THEN
        SCMAX=1.5
        IF((NX1/2)*2.NE.NX1) NX1=NX1+1
        IF((NX2/2)*2.NE.NX2) NX2=NX2+1
        IF((NX3/2)*2.NE.NX3) NX3=NX3+1
      END IF
      IBLF=0
      IF(R0.NE.0) IBLF=1
      XTIP=R0+XORIGN
      YTIP=YORIGN
      XTIPL=R0+XORIGN
      YTIPL=YORIGN+R0
      NTNUM=1
      NDTIP(NTNUM,1)=NDTIP(NTNUM,1)+1
C     NDTIP(NTNUM,NDTIP(NTNUM,1))=(NX2+NX3)*(NODE/4)+1
      NDTIP(NTNUM,NDTIP(NTNUM,1))=NX2+NX3+1
      NX12=NX1+NX2
      NX3=NX3/2
      NX4=NX3
      NX34=NX3+NX4
      NX123=NX1+NX2+NX34
      N1T=1
      IE=0
      PI=4.0*DATAN(1.0D0)
      NELEM=0
      NNODE=0
C
      R=R0
      KBLF=1
      RBLF(1)=R0
      DO I=1,NX1
      R=R+DR*SR**(I-1)
      KBLF=KBLF+1
      RBLF(KBLF)=R
      END DO
      EL0=RBLF(NX1+1)-RBLF(NX1)
      RL=R1-RBLF(NX1+1)
      CALL SOLVSL(NY1,EL0,RL,SCL)
C     write(IO_WORK,2201) SCL,NY1,EL0,RL
 2201 format(/' Calculated SCL in  first tip-regin is: ',
     1 ' Scl=',F6.3,' N=',I2,' EL0=',E10.4,' RL=',E10.4)
      IF(SCL.LE.1.0) THEN
      DO I=1,90
      NY1=NY1-1
      IF(NY1.LT.1) GOTO 91
      CALL SOLVSL(NY1,EL0,RL,SCL)
      IF(SCL.GT.1.0) GOTO 91
      END DO
   91 CONTINUE
      IF(NY1.LT.1) NY1=1
      IF((NY1/2)*2.NE.NY1) THEN
      NY1=NY1+1
      CALL SOLVSL(NY1,EL0,RL,SCL)
      END IF
C     WRITE(IO_WORK,2203) SCL,NY1,EL0,RL
 2203 format(/' Calculated SCL < 1. Suggested value is:',
     1 ' Scl=',F6.3,' N=',I2,' EL0=',E10.4,' RL=',E10.4)
      ELSE IF(SCL.GT.SCMAX) THEN
      DO I=1,90
      NY1=NY1+1
      CALL SOLVSL(NY1,EL0,RL,SCL)
      IF(SCL.LT.SCMAX) GOTO 92
      END DO
   92 CONTINUE
      IF(NODE.EQ.8.AND.(NY1/2)*2.NE.NY1) NY1=NY1+1
      CALL SOLVSL(NY1,EL0,RL,SCL)
C     WRITE(IO_WORK,2205) SCL,NY1,EL0,RL
 2205 format(/' Calculated SCL > SCMAX Suggested value is:',
     1 ' Scl=',F6.3,' N=',I2,' EL0=',E10.4,' RL=',E10.4)
      END IF
      R=RBLF(NX1+1)
      DO I=1,NY1
      R=R+EL0*SCL**I
      KBLF=KBLF+1
      RBLF(KBLF)=R
      END DO
C     WRITE(IO_WORK,'(1he,10e12.5)') (RBLF(i),i=1,kblf)
C     WRITE(IO_WORK,'(1he,10e12.5)') (LOG10(RBLF(i)),i=1,kblf)
C
      RH=RBLF(NX1+1)-RBLF(1)
      YH=YH*RH
      XH=XH*RH
      DY=YH/NX1
      DX=XH/NX2
C
C     GENERATING NODES COORDINATES
C
      XH1=-RH
      YH1=R0
      XH2=-XH
      YH2=YH+R0
      IN=0
      DT=PI/2.0/NX34
      DO I=1,NX1+1
      X1=XH1+FLOAT(I-1)*(XH2-XH1)/FLOAT(NX1)
      Y1=YH1+FLOAT(I-1)*(YH2-YH1)/FLOAT(NX1)
      X2=0.
      Y2=RBLF(I)
      DXH=(X2-X1)/FLOAT(NX2)
      SCXH=1.0
      IF(I.LE.NX1) THEN
        AM=FLOAT(NX3)/5.0
        IF(AM.GT.3.0) AM=3.0
        EL0=DXH+2.0*DXH*(1.0-FLOAT(I-1)/FLOAT(NX1))
        RL=X2-X1
        CALL SOLVSL(NX2,EL0,RL,SCXH)
        DXH=EL0
      END IF
      X=X1-DXH
      DO J=1,NX2
      X=X+DXH*SCXH**(J-1)
      Y=Y1+FLOAT(J-1)*(Y2-Y1)/FLOAT(NX2)
c     IF(I.EQ.1) Y=R0
      IN=IN+1
      COORD(IN,1)=X
      COORD(IN,2)=Y
      END DO
      TT=PI/2.0+DT
      R=RBLF(I)
      DO J=1,NX34+1
      TT=TT-DT
      IF(J.EQ.NX34+1) TT=0.0
      X=R*COS(TT)
      Y=R*SIN(TT)
      IN=IN+1
      COORD(IN,1)=X
      COORD(IN,2)=Y
      END DO
      END DO
C
C     GENERATE ELEMENT DEFINITION
C
      IE=0
      IF(NODE.EQ.4) THEN
        L2=0
        L3=NX2+NX34+1
        DO I=1,NX1
          L1=L2
          L4=L3
          DO J=1,NX2+NX34
            IE=IE+1
            L1=L1+1
            L2=L1+1
            L4=L4+1
            L3=L4+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L2
            LNODS(IE,3)=L3
            LNODS(IE,4)=L4
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D4'
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.8) THEN
        L6=0
        DO I=1,NX1/2
          L1=L6-1
          DO J=1,(NX2+NX34)/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX2+NX34+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX2+NX34+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D8'
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.9) THEN
        L6=0
        DO I=1,NX1/2
          L1=L6-1
          DO J=1,(NX2+NX34)/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX2+NX34+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX2+NX34+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D9'
            CALL DNODE(IE,NODE)
          END DO
        END DO
      END IF
      IF(NODE.GE.8) THEN
        IENX1=NELEM+1-(NX2+NX34)/2
        DO IK=1,NX1/2
          IENX1=IENX1+(NX2+NX34)/2
          IENX2=IENX1+NX2/2
          CALL NODXY(1,IENX1,IENX2)
        END DO
      END IF
      IF(NODE.GE.8) CALL NODXY(2,NELEM+1,IE)
      IN1=IN
      NELEM=IE
      NNODE=IN
      DT=PI/2.0/FLOAT(NX12)
      XO1=0.0
      YO1=R0
      R=RBLF(KBLF)-R0
      TT=PI+DT
      DO I=1,NX12
      TT=TT-DT
      XE(I)=R*COS(TT)+XO1
      YE(I)=R*SIN(TT)+YO1
      END DO
      Y=R0-DY
      K=0
      IK=1-NX2-NX34-1
      DO I=1,NX1+1
      IK=IK+NX2+NX34+1
      K=K+1
      XB(K)=COORD(IK,1)
      YB(K)=COORD(IK,2)
      END DO
      DO I=1,NX2-1
      IK=IK+1
      K=K+1
      XB(K)=COORD(IK,1)
      YB(K)=COORD(IK,2)
      END DO
C
      SL=0
      DO I=1,NY1
      SL=SL+SCL**I
      END DO
      ET=0
      DO I=1,NY1
      ET=ET+SCL**I
      DO J=1,NX12
      X1=XE(J)
      Y1=YE(J)
      X2=XB(J)
      Y2=YB(J)
      X=X2+ET/SL*(X1-X2)
      Y=Y2+ET/SL*(Y1-Y2)
      IF(I.EQ.NY1) THEN
      X=X1
      Y=Y1
      END IF
      IN=IN+1
      COORD(IN,1)=X
      COORD(IN,2)=Y
      END DO
      DT=PI/2.0/NX34
      TT=PI/2.0+DT
      R=RBLF(NX1+1+I)
      DO J=1,NX34+1
      TT=TT-DT
      IF(J.EQ.1) TT=PI/2.0
      IF(J.EQ.NX34+1) TT=0.0
      X=R*COS(TT)
      Y=R*SIN(TT)
      IN=IN+1
      COORD(IN,1)=X
      COORD(IN,2)=Y
      END DO
      END DO
      K=0
      IK=1-(NX2+NX34+1)
      DO I=1,NX1+1
      IK=IK+NX2+NX34+1
      K=K+1
      INBLF(K)=IK
      END DO
      DO I=1,NX2+NX34
      IK=IK+1
      K=K+1
      INBLF(K)=IK
      END DO
      IF(NODE.EQ.4) THEN
        L1=IN1-(NX123+1)
        L4=IN1
        DO I=1,NY1
          DO J=1,NX123
            IE=IE+1
            L1=L1+1
            L2=L1+1
            L4=L4+1
            L3=L4+1
            LN1=L1
            LN2=L2
            IF(I.EQ.1) THEN
              LN1=INBLF(J)
              LN2=INBLF(J+1)
            END IF
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=LN1
            LNODS(IE,2)=LN2
            LNODS(IE,3)=L3
            LNODS(IE,4)=L4
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D4'
            CALL DNODE(IE,NODE)
          END DO
          L1=L2
          L4=L3
        END DO
      ELSE IF(NODE.EQ.8) THEN
        L6=IN1-(NX123+1)
        DO I=1,NY1/2
          L1=L6-1
          DO J=1,NX123/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX123+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX123+1
            L8=L7+1
            L9=L8+1
            LN1=L1
            LN2=L2
            LN3=L3
            IF(I.EQ.1) THEN
              LN1=INBLF(2*J-1)
              LN2=INBLF(2*J)
              LN3=INBLF(2*J+1)
            END IF
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=LN1
            LNODS(IE,2)=LN3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=LN2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D8'
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.9) THEN
        L6=IN1-(NX123+1)
        DO I=1,NY1/2
          L1=L6-1
          DO J=1,NX123/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX123+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX123+1
            L8=L7+1
            L9=L8+1
            LN1=L1
            LN2=L2
            LN3=L3
            IF(I.EQ.1) THEN
              LN1=INBLF(2*J-1)
              LN2=INBLF(2*J)
              LN3=INBLF(2*J+1)
            END IF
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=LN1
            LNODS(IE,2)=LN3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=LN2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D9'
            CALL DNODE(IE,NODE)
          END DO
        END DO
      END IF
      IF(NODE.GE.8) CALL NODXY(2,NELEM+1,IE)
      IN1=IN
      NELEM=IE
      NNODE=IN
      NEBLF=IE
      IEBLF=NELEM
      NBLF2=NNODE
      NBLF1=NBLF2-(NX123+1)
      NBLF3=1
      INN1=NBLF2
      INN2=INN1-(NX123+1)
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      READ(IO_INPUT,'(120A1)') TITLE
c     WRITE(IO_WRITE,'(120A1)') TITLE
      READ(IO_INPUT,*) NA
      IF(NA.GT.0) THEN
      READ(IO_INPUT,*) IMSET,NODE,(NR(I),SC1(I),I=1,NA)
C
      IF(NODE.GE.8) SCMAX=1.5
c     WRITE(IO_WRITE,'(2I5/I5,E8.3)') IMSET,NODE,(NR(I),SC1(I),I=1,NA)
      KBLF0=KBLF
      RN0=RBLF(KBLF)
      RNA=LOG10(RN0)
      EL0=RBLF(KBLF)-RBLF(KBLF-1)
      DO IA=1,NA
       S1=SC1(IA)
       NY=NR(IA)
       IF(NY.EQ.1) GOTO 45
       IF(S1.LT.1.0) THEN
       DRA=1.0/FLOAT(NY)
       RLOGA=RNA-1.0+FLOAT(IA)
       ENDIF
       DO J=1,NY
       KBLF=KBLF+1
       IF(S1.LT.1.0) THEN
       RLOGA=RLOGA+DRA
       R=10.0**RLOGA
       ELSE
       R=R+EL0*S1**J
       ENDIF
       RBLF(KBLF)=R
       END DO
       EL0=EL0*S1**NY
       GOTO 46
  45  CONTINUE
       KBLF=KBLF+1
       RBLF(KBLF)=S1
  46  CONTINUE
      END DO
      DO I=KBLF0+1,KBLF
      R=RBLF(I)
      TH0=ASIN(R0/R)*0.0
      DT=(PI/2.0-TH0)/FLOAT(NX12)
      TT=PI-TH0+DT
      DO J=1,NX12
      TT=TT-DT
      X=XTIPL+(R-R0)*COS(TT)
      Y=YTIPL+(R-R0)*SIN(TT)
      IF(J.EQ.1) Y=YTIPL
      IN=IN+1
      COORD(IN,1)=X
      COORD(IN,2)=Y
      END DO
      DT=PI/2.0/FLOAT(NX34)
      TT=PI/2.0+DT
      DO J=1,NX34+1
      TT=TT-DT
      IF(J.EQ.1) TT=PI/2.0
      IF(J.EQ.NX34+1) TT=0.0
      X=R*COS(TT)
      Y=R*SIN(TT)
      IN=IN+1
      COORD(IN,1)=X
      COORD(IN,2)=Y
      END DO
      END DO
C
C     GENERATING NODE DEFINITION
C
      IF(NODE.EQ.4) THEN
        L1=IN1-(NX123+1)
        L4=IN1
        DO IA=KBLF0+1,KBLF
          DO J=1,NX123
            IE=IE+1
            L1=L1+1
            L2=L1+1
            L4=L4+1
            L3=L4+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L2
            LNODS(IE,3)=L3
            LNODS(IE,4)=L4
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D4'
            CALL DNODE(IE,NODE)
          END DO
          L1=L2
          L4=L3
        END DO
      ELSE IF(NODE.EQ.8) THEN
        L6=IN1-(NX123+1)
        DO I=KBLF0+1,KBLF,2
          L1=L6-1
          DO J=1,NX123/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX123+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX123+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D8'
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.9) THEN
        L6=IN1-(NX123+1)
        DO I=KBLF0+1,KBLF,2
          L1=L6-1
          DO J=1,NX123/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX123+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX123+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D9'
            CALL DNODE(IE,NODE)
          END DO
        END DO
      END IF
      IF(NODE.GE.8) CALL NODXY(2,NELEM+1,IE)
      IN1=IN
      NELEM=IE
      NNODE=IN
      NEBLF=IE
      IEBLF=NELEM
      NBLF2=NNODE
      NBLF1=NBLF2-NX123
      NBLF3=1
      INN1=NBLF2
      INN2=INN1-(NX123+1)
      END IF
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      K=1
      DO I=NBLF1,NBLF2,NBLF3
      K=K+1
      NDBLF(K)=I
      END DO
      NDBLF(1)=K
c     WRITE(9,'(10E12.5)') (RBLF(i),I=1,KBLF)
c     WRITE(9,'(10E12.5)') (RBLF(i+1)-RBLF(i),I=1,KBLF-1)
      DO I=1,NELEM
      NODE=LNODS(I,MXNOD)
c     WRITE(9,'(5I5)') I,(LNODS(I,J),J=1,NODE)
      END DO
      DO I=1,NNODE
      X=COORD(I,1)
      Y=COORD(I,2)
c     WRITE(9,'(I5,2E15.8)') I,X,Y
      END DO
      II=NNODE-NX123-1
      DO I=1,NX123+1
      II=II+1
      NXYB(I)=II
      END DO
      IN1=NNODE
      IN2=NNODE-NX123-1
      ELL=DABS(COORD(IN1,1)-COORD(IN2,1))
      ELU=ELL
      ELD=ELL
      ELR=ELL
C
      TEXT='END OF EXCUTING SUB.BLFMESH1'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
      SUBROUTINE BLFMESH2
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XSG1(3),YSG1(3),XSG2(3),YSG2(3),EL(100),CL(100),RBLF(20)
      DIMENSION XB(90),YB(90),XE(90),YE(90),INBLF(90),XSG(5),YSG(5),
     1 NL(20),NR(20),RA(1000),SC1(20),SC2(20),N1OUT(1000),THI(90)
      CHARACTER*6 CTYPE
C
C     INPUT INITIAL DATA
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. BLFMESH2'
      TEXT='NOW EXCUTING SUB. BLFMESH2'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      IBL=0
      READ(IO_INPUT,*) IMSET,NODE,NX1,NX2,TH1,TH2,TH3,
     &  X0,Y0,KCON,KS,RK
      READ(IO_INPUT,*) NA,(NR(I),SC1(I),I=1,NA)
c     WRITE(IO_WRITE,'(2I5,F7.3)') (NL(I),NR(I),SC1(I),I=1,NA)
      XTIP=X0+XORIGN
      YTIP=Y0+YORIGN
      IF(NTYPE.LT.IMSET) NTYPE=IMSET
      N1T=1
      KSSET=0
      IF(KS.EQ.3) KSSET=1
      NX=NX1+NX2
      NX3=NX2
      NX4=NX2
      NX1=NX1
      NX2=NX1
      NX12=NX1+NX2
      NX34=NX3+NX4
      NX123=NX1+NX2+NX34
      IE=0
      IBL=0
      L1E=0
      L8E=2*NX+1
C
      IF(KS.LE.1) THEN
        NTNUM=1
        NDTIP(NTNUM,1)=1
        DO I=1,2*NX+1
          NDTIP(NTNUM,1)=NDTIP(NTNUM,1)+1
          NDTIP(NTNUM,NDTIP(NTNUM,1))=I
        END DO
      ELSE
        NTNUM=1
        NDTIP(NTNUM,1)=NDTIP(NTNUM,1)+1
        NDTIP(NTNUM,NDTIP(NTNUM,1))=1
      END IF
C
C     LOOP FOR MESH AREAS
C
      PI=4.0*DATAN(1.0D0)
      TH1=TH1*PI/180.0D0
      TH2=TH2*PI/180.0D0
      TH3=TH3*PI/180.0D0
      THB=TH1
      THE=TH3
      TH12=TH2-TH1
      TH32=TH3-TH2
      DT12=TH12/FLOAT(NX12)
      DT32=TH32/FLOAT(NX34)
      TH=THB-DT12
      IX=0
      DO K=1,NX1+1
        IX=IX+1
        TH=TH+DT12
        THI(IX)=TH
      END DO
      DO K=1,NX2
        IX=IX+1
        TH=TH+DT12
        THI(IX)=TH
      END DO
      DO K=1,NX3
        IX=IX+1
        TH=TH+DT32
        THI(IX)=TH
      END DO
      DO K=1,NX4
        IX=IX+1
        TH=TH+DT32
        THI(IX)=TH
      END DO
      NELEM=0
      NNODE=0
      L0=0
C
C     READ(IO_INPUT,*) IBL,RBL,RK,IMSET,NODE
C
      IBLF=IBL
      DO I=1,2*NX+1
        N1T=N1T+1
        N1OUT(N1T)=I
      END DO
      RBL=1.0
C
      KRA=0
      IKRA=0
      EL0=RBL
      R=0
      IF(IBL.NE.0.AND.SC1(1).GE.1.0) R=3.0*RBL
      IKRA=1
      RNA1=-FLOAT(NA)+LOG10(RK)
      R0=10.0**RNA1
      IF(IBL.NE.0.0) THEN
        RNA3=LOG10(3.0D0*RBL)
        RNA1=LOG10(RBL)
        R0=2.0*RBL
      ENDIF
      IF(IBL.EQ.0) R0=-10.0D0**RNA1
      DO IA=1,NA
       S1=SC1(IA)
       NY=NR(IA)
       IF(NY.EQ.1) GOTO 45
       IF(S1.LT.1.0) THEN
         DRA=1.0/FLOAT(NY)
         RNA=RNA1
         RLOGA=RNA-1.0+FLOAT(IA)
         DO J=1,NY
           KRA=KRA+1
           RLOGA=RLOGA+DRA
           R=10.0**RLOGA+R0
           IF(IA.EQ.NA.AND.J.EQ.NY) R=10.0**RLOGA
           RA(KRA)=R
         END DO
       ELSE
         RL0=10.0**(RNA1-1.0+FLOAT(IA))
         IF(IA.EQ.1) RL0=0.0
         RL=10.0**(RNA1+FLOAT(IA))-RL0
         RT=0.0
         DO J=1,NY
           RT=RT+S1**(J-1)
         END DO
         EL0=RL/RT
         R=RL0
         DO J=1,NY
           R=R+EL0*S1**(J-1)
           KRA=KRA+1
           RA(KRA)=R
         END DO
       ENDIF
       GOTO 46
  45  CONTINUE
       KRA=KRA+1
       RA(KRA)=S1
  46  CONTINUE
      END DO
      IF(IBL.NE.0) RA(1)=1.5*RBL+RA(2)/2.0
C     WRITE(IO_WORK,'(1hR,10e12.5)') (RA(i),i=1,kra)
C     WRITE(IO_WORK,'(1hL,10e12.5)') (LOG10(RA(i)),i=1,kra)
C
      IF(KS.LT.2) THEN
       L1=-1+L1E
       L8=L8E
       L7=L1+3*NX+2
       ND1=2*NX+1
      ELSE
       L1=-1
       L8=1
       L7=NX+1
       ND1=1
      ENDIF
C
      DO IA=1,KRA
C
       R=RA(IA)
       DT=TH/2.0D0/NX
       IF(IBL.EQ.0.AND.IA.EQ.1) THEN
C
       DO IX=1,ND1
       IN=IX
       COORD(IN,1)=0.
       COORD(IN,2)=0.
       END DO
C
       T1=TH1-2.0D0*DT
       R1=R/2.0D0
       IF(KS.EQ.0.AND.KCON.EQ.0) R1=R/4.0D0
       DO IX=1,NX+1
        IN=IN+1
C       T1=T1+2.0D0*DT
        T1=THI(2*IX-1)
        X=R1*COS(T1)
        Y=R1*SIN(T1)
        IF(IX.EQ.NX+1) Y=0.0D0
        COORD(IN,1)=X
        COORD(IN,2)=Y
C
       END  DO
       IN=IN-NX-1
C
       END IF
C
        IN=IN+NX+1
        T=TH1-DT
C
        DO IX=1,2*NX+1
C
         IN=IN+1
C        T=T+DT
         T=THI(IX)
         X=R*COS(T)
         Y=R*SIN(T)
        IF(IX.EQ.2*NX+1) Y=0.0D0
         COORD(IN,1)=X
         COORD(IN,2)=Y
C
        END DO
C
       END DO
C
C     GENERATING NODE DEFINITION
C
      DO IA=1,NA
C
        NY=NR(IA)
        DO IY=1,NY
C
          DO IX=1,NX
C
            IF(IA.EQ.1.AND.IY.EQ.1.AND.KS.GT.1) THEN
              IF(KS.EQ.2) THEN
C        singular element with same tip node
                IE=IE+1
                L1=1
                L2=L1
                L3=L1
                L8=L8+1
                L4=L8+1
                L7=L7+2
                L6=L7+1
                L5=L6+1
                LNODS(IE,1)=L1
                LNODS(IE,2)=L3
                LNODS(IE,3)=L5
                LNODS(IE,4)=L7
                LNODS(IE,5)=L2
                LNODS(IE,6)=L4
                LNODS(IE,7)=L6
                LNODS(IE,8)=L8
                LNODS(IE,MXNOD-1)=IMSET
                LNODS(IE,MXNOD)=8
                NODE=8
                ELTYP(IE)='C2D8'
                CALL DNODE(IE,NODE)
                MATSET(IMSET,1)=MATSET(IMSET,1)+1
                MATSET(IMSET,MATSET(IMSET,1))=IE
              ELSE IF(KS.EQ.3) THEN
C       3 or 6 node element
                IE=IE+1
                L1=1
                L2=L1
                L3=L1
                L8=L8+1
                L4=L8+1
                L7=L7+2
                L6=L7+1
                L5=L6+1
                NODE=3
                ELTYP(IE)='C2D3'
                LNODS(IE,1)=L1
                LNODS(IE,2)=L5
                LNODS(IE,3)=L7
		IF (NODE.NE.3) THEN
                   LNODS(IE,4)=L4
                   LNODS(IE,5)=L6
                   LNODS(IE,6)=L8
                   NODE=6
                   ELTYP(IE)='C2D6'
		ENDIF
                LNODS(IE,MXNOD-1)=IMSET+KSSET
                LNODS(IE,MXNOD)=NODE
                CALL DNODE(IE,NODE)
                MATSET(KSSET+IMSET,1)=MATSET(KSSET+IMSET,1)+1
                MATSET(KSSET+IMSET,MATSET(KSSET+IMSET,1))=IE
              ENDIF
            ELSE
C       collapse element with ks=0 1/4 middle node ks=1 1/2 middle node 
              IE=IE+1
              L1=L1+2
              L2=L1+1
              L3=L2+1
              L8=L8+1
              L4=L8+1
              L7=L7+2
              L6=L7+1
              L5=L6+1
              LNODS(IE,1)=L1
              LNODS(IE,2)=L3
              LNODS(IE,3)=L5
              LNODS(IE,4)=L7
	      NODE = 4
              ELTYP(IE)='C2D4'
	      IF (NODE.NE.4) THEN
                 LNODS(IE,5)=L2
                 LNODS(IE,6)=L4
                 LNODS(IE,7)=L6
                 LNODS(IE,8)=L8
                 NODE=8
                 ELTYP(IE)='C2D8'
	      ENDIF
              LNODS(IE,MXNOD-1)=IMSET
              LNODS(IE,MXNOD)=NODE
              CALL DNODE(IE,NODE)
              MATSET(IMSET,1)=MATSET(IMSET,1)+1
              MATSET(IMSET,MATSET(IMSET,1))=IE
            ENDIF
          END DO
          L1=L4-1
          L8=L5
          L7=L1+3*NX+2
        END DO
        N1=L4+1
        N2=N1+2*NX
        N3=1
      END DO
      NELEM=IE
      NNODE=IN
      NEBLF=IE
      IEBLF=NELEM
      NBLF2=NNODE
      NBLF1=NBLF2-2*NX
      NBLF3=1
      INN1=NBLF2
      INN2=INN1-3*NX-2
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      K=1
      DO I=NBLF1,NBLF2,NBLF3
      K=K+1
      NDBLF(K)=I
      END DO
      NDBLF(1)=K
C
      IF(IBL.NE.0) THEN
      DO ID=IBL,NNODE
      X=COORD(ID,1)
      Y=COORD(ID,2)
      R=DSQRT(X*X+Y*Y)
       IF(R.NE.0.0) THEN
        IF(X.LT.0.0) THEN
         Y1=Y+(1.0-Y/R)*RBL
         COORD(ID,2)=Y1
        END IF
       END IF
      END DO
      END IF
      IE1=IBL+1
      IF(IBL.EQ.0) THEN
      IE1=NX+1
      DO I=1,IE1-1
      NODE=LNODS(I,MXNOD)
      CALL DNODE(IE,NODE)
      END DO
      END IF
      CALL NODXY(2,IE1,NELEM)
      II=NNODE-NX123-1
      DO I=1,NX123+1
      II=II+1
      NXYB(I)=II
      END DO
      IN1=NNODE
      IN2=NNODE-NX123-1
      ELL=DABS(COORD(IN1,1)-COORD(IN2,1))
      ELU=ELL
      ELD=ELL
      ELR=ELL
C
      TEXT='END OF EXCUTING SUB.BLFMESH2'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
C     PROGRAM FOR GENERATING UNIFORM CRACK_TIP ELEMENT MESH
C
      SUBROUTINE BLFMESH3
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XSG1(3),YSG1(3),XSG2(3),YSG2(3),EL(100),CL(100)
      DIMENSION XB(500),YB(500),XE(500),YE(500),INBLF(500),
     1 NL(20),NR(20),RA(1000),SC1(20),SC2(20),N1OUT(1000),RBLF(500),
     2 NXYB1(500),NXYB2(500),NXYB3(500),XSG(5),YSG(5)
      CHARACTER*6 CTYPE
C
C     INPUT INITIAL DATA
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. BLFMESH3'
      TEXT='NOW EXCUTING SUB.BLFMESH3'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      READ(IO_INPUT,*) NX1,NX2,NX3,IMSET,NODE
C
      READ(IO_INPUT,*) (XSG(I),YSG(I),I=1,5)
      IF(NODE.GE.8) THEN
        NX1=(NX1/2)*2
        NX2=(NX2/2)*2
        NX3=(NX3/2)*2
      END IF
C
      NTNUM=1
      NDTIP(NTNUM,1)=NDTIP(NTNUM,1)+1
      NDTIP(NTNUM,NDTIP(NTNUM,1))=NX2+1
      XTIP=XSG(3)+XORIGN
      YTIP=YORIGN
      NX4=NX1
      NX12=NX1+NX2
      NX23=NX2+NX3
      NX34=NX3+NX4
      NX123=NX1+NX2+NX3+NX4
      XB1=XSG(1)
      YB1=YSG(1)
      XB2=XSG(2)
      YB2=YSG(2)
      XE1=XSG(5)
      YE1=YSG(5)
      XE2=XSG(4)
      YE2=YSG(4)
      XM1=XSG(3)
      YM1=YB1+(XM1-XB1)/(XE1-XB1)*(YE1-YB1)
      XM2=XSG(3)
      YM2=YSG(3)
      DXB=(XB2-XB1)/NX1
      DYB=(YB2-YB1)/NX1
      DXE=(XE2-XE1)/NX1
      DYE=(YE2-YE1)/NX1
      DXM=(XM2-XM1)/NX1
      DYM=(YM2-YM1)/NX1
      X1=XB1-DXB
      Y1=YB1-DYB
      X2=XE1-DXE
      Y2=YE1-DYE
      X3=XM1-DXM
      Y3=YM1-DYM
      IN=NNODE
      INXYB=0
C
      DO I=1,NX1+1
         X1=X1+DXB
         Y1=Y1+DYB
         X2=X2+DXE
         Y2=Y2+DYE
         X3=X3+DXM
         Y3=Y3+DYM
         DX1=(X3-X1)/NX2
C-----   DY1=(Y3-Y1)/NX1
         DY1=(Y3-Y1)/NX2
         DX2=(X2-X3)/NX3
C-----   DY2=(Y2-Y3)/NX1
         DY2=(Y2-Y3)/NX3
         DO J=1,NX2+NX3+1
         IF(J.LE.NX2) THEN
            X=X1+FLOAT(J-1)*DX1
            Y=Y1+FLOAT(J-1)*DY1
         ELSE
            X=X3+FLOAT(J-NX2-1)*DX2
            Y=Y3+FLOAT(J-NX2-1)*DY2
         END IF
         IN=IN+1
         COORD(IN,1)=X
         COORD(IN,2)=Y
         COORD(IN,3)=0.0
         IF(J.EQ.1) THEN
            NXYB1(I)=IN
         END IF
         IF(I.EQ.NX1+1) THEN
            NXYB2(J)=IN
         END IF
         IF(J.EQ.NX2+NX3+1) THEN
            NXYB3(I)=IN
         END IF
            IF(I.EQ.1.AND.J.EQ.1) THEN
               ELL=DX1
            END IF
            IF(I.EQ.1.AND.J.EQ.NX2+NX3+1) THEN
               ELR=DX2
            END IF
         END DO
      END DO
      DO I=1,NX1
        NXYB(I)=NXYB1(I)
      END DO
      INXYB=NX1
      DO I=1,NX2+NX3
         INXYB=INXYB+1
         NXYB(INXYB)=NXYB2(I)
      END DO
      DO I=1,NX1+1
         INXYB=INXYB+1
         NXYB(INXYB)=NXYB3(NX1+2-I)
      END DO
      IF(NODE.EQ.8) THEN
        L6=0
        DO I=1,NX1/2
           L1=L6-1
          DO J=1,(NX2+NX3)/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX23+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX23+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            ELTYP(IE)='C2D8'
            LNODS(IE,MXNOD-1)=IMSET
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.9) THEN
        L6=0
        DO I=1,NX1/2
           L1=L6-1
          DO J=1,(NX2+NX3)/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX23+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX23+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            ELTYP(IE)='C2D9'
            LNODS(IE,MXNOD-1)=IMSET
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L1=0
        DO I=1,NX1
          DO J=1,NX23
            IE=IE+1
            L1=L1+1
            L2=L1+1
            L3=L1+NX23+1
            L4=L3+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L2
            LNODS(IE,3)=L4
            LNODS(IE,4)=L3
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D4'
            CALL DNODE(IE,NODE)
          END DO
          L1=L2
        END DO
      END IF
      NELEM=IE
      NNODE=IN
      IF(NODE.GE.8) CALL NODXY(3,NELEM+1,IE)
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      TEXT='END OF EXCUTING SUB.BLFMESH3'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      ELU=(YSG(2)-YSG(1))/NX1/(NODE/4)
      ELD=(YSG(2)-YSG(1))/NX1/(NODE/4)
      ELR=(XSG(4)-XSG(3))/NX3/(NODE/4)
      ELL=(XSG(3)-XSG(2))/NX2/(NODE/4)
      RETURN
      END
C
C     PROGRAM FOR GENERATING UNIFORM CRACK_TIP ELEMENT MESH
C
      SUBROUTINE BLFMESH4
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XSG1(3),YSG1(3),XSG2(3),YSG2(3),EL(100),CL(100)
      DIMENSION XB(500),YB(500),XE(500),YE(500),INBLF(500),
     1 NL(20),NR(20),RA(1000),SC1(20),SC2(20),N1OUT(1000),RBLF(500),
     2 NXYB1(500),NXYB2(500),NXYB3(500),XSG(5),YSG(5)
      CHARACTER*6 CTYPE
C
C     INPUT INITIAL DATA
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. BLFMESH4'
      TEXT='NOW EXCUTING SUB.BLFMESH4'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      READ(IO_INPUT,*) NX1,NX2,IMSET,NODE
      IF(NODE.GE.8) THEN
        NX1=(NX1/2)*2
        NX2=(NX2/2)*2
      END IF
C
      READ(IO_INPUT,*) (XSG(I),YSG(I),I=1,4)
C
      NTNUM=1
      NDTIP(NTNUM,1)=NDTIP(NTNUM,1)+1
      NDTIP(NTNUM,NDTIP(NTNUM,1))=NX2+1
      XTIP=XSG(3)+XORIGN
      YTIP=YORIGN
C---  NX3=0
      NX3 = NX2 / 2
      NX2 = NX2 - NX3
      NX4=NX1
      NX12=NX1+NX2
      NX23=NX2+NX3
      NX34=NX3+NX4
      NX123=NX1+NX2+NX3+NX4
      XB1=XSG(1)
      YB1=YSG(1)
      XB2=XSG(2)
      YB2=YSG(2)
      XE1=XSG(4)
      YE1=YSG(4)
      XE2=XSG(3)
      YE2=YSG(3)
      DXB=(XB2-XB1)/NX1
      DYB=(YB2-YB1)/NX1
      DXE=(XE2-XE1)/NX1
      DYE=(YE2-YE1)/NX1
      X1=XB1-DXB
      Y1=YB1-DYB
      X2=XE1-DXE
      Y2=YE1-DYE
      IN=NNODE
      INXYB=0
      DO I=1,NX1+1
         X1=X1+DXB
         Y1=Y1+DYB
         X2=X2+DXE
         Y2=Y2+DYE
C------  DX1=(X2-X1)/NX2
         DX1=(X2-X1)/NX23
         DY1=(Y2-Y1)/NX1
C------  DO J=1,NX2+1
         DO J=1,NX23+1
            X=X1+FLOAT(J-1)*DX1
            Y=Y1+FLOAT(J-1)*DY1
            IN=IN+1
            COORD(IN,1)=X
            COORD(IN,2)=Y
            COORD(IN,3)=0.0
            IF(J.EQ.1) NXYB1(I)=IN
            IF(I.EQ.NX1+1) NXYB2(J)=IN
C---------  IF(J.EQ.NX2+1) NXYB3(I)=IN
            IF(J.EQ.NX23+1) NXYB3(I)=IN
         END DO
      END DO
      DO I=1,NX1
        NXYB(I)=NXYB1(I)
      END DO
      INXYB=NX1
C---- DO I=1,NX2
      DO I=1,NX23
        INXYB=INXYB+1
        NXYB(INXYB)=NXYB2(I)
      END DO
      DO I=1,NX1+1
        INXYB=INXYB+1
        NXYB(INXYB)=NXYB3(NX1+2-I)
      END DO
      IF(NODE.EQ.8) THEN
        L6=0
        DO I=1,NX1/2
           L1=L6-1
C-------- DO J=1,NX2/2
          DO J=1,NX3
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX23+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX23+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            ELTYP(IE)='C2D8'
            LNODS(IE,MXNOD-1)=IMSET
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.9) THEN
        L6=0
        DO I=1,NX1/2
           L1=L6-1
          DO J=1,NX23/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX23+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX23+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            ELTYP(IE)='C2D9'
            LNODS(IE,MXNOD-1)=IMSET
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L1=0
        DO I=1,NX1
          DO J=1,NX23
            IE=IE+1
            L1=L1+1
            L2=L1+1
            L3=L1+NX23+1
            L4=L3+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L2
            LNODS(IE,3)=L4
            LNODS(IE,4)=L3
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D4'
            CALL DNODE(IE,NODE)
          END DO
          L1=L2
        END DO
      END IF
      NELEM=IE
      NNODE=IN
      IF(NODE.GE.8) CALL NODXY(3,NELEM+1,IE)
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      TEXT='END OF EXCUTING SUB.BLFMESH4'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      ELU=(YSG(2)-YSG(1))/NX1/(NODE/4)
      ELD=ELU
C---- ELL=(XSG(3)-XSG(2))/NX2/(NODE/4)
      ELL=(XSG(3)-XSG(2))/NX23/(NODE/4)
      ELR=ELL
      RETURN
      END
C
      SUBROUTINE mesh_9node
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION KWORK(20)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. mesh_9node'
C
      TEXT='NOW EXCUTING SUB. mesh_9node'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      KEY=-999
      DO I=1,NELEM
        NODE=LNODS(I,MXNOD)
        IMSET=LNODS(I,MXNOD-1)
        IF(NODE.NE.8) GOTO 999
        IF(KEY.NE.IMSET) THEN
          KEY=IMSET
          MATSET(IMSET,1)=1
          ELSET_TYP(IMSET)='CPE9'
        END IF
        XM=0.0D0
        YM=0.0D0
        DO K=1,4
          IM=LNODS(I,K)
          XM=XM+COORD(IM,1)
          YM=YM+COORD(IM,2)
        END DO
        XM=XM/4.0D0
        YM=YM/4.0D0
        IM_NODE=NNODE+I
        COORD(IM_NODE,1)=XM
        COORD(IM_NODE,2)=YM
        IE=I
        LNODS(IE,9)=IM_NODE
        LNODS(IE,MXNOD)=9
        LNODS(IE,MXNOD-1)=IMSET
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IE
        ELTYP(IE)='C2D9'
        CALL DNODE(IE,9)
  999   CONTINUE
      END DO
      NNODE=NNODE+NELEM
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      TEXT='END OF EXCUTING SUB. mesh_9node'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      RETURN
      END
