C
C     SUBROUTINE FOR GENERATING CRACK GROWTH TIP MESH
C
      SUBROUTINE CGROWTH1
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. CGROWTH '
C
      TEXT='NOW EXCUTING SUB. CGROWTH '
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
    1 READ(IO_INPUT,*) DELEM,CGZONE,IMSET,NODE
C
      NDTYP=NODE/4
      NCGX=NINT(CGZONE/DELEM)
      IF(NCGX.EQ.0) NCGX = 1
      IF(INT(NCGX/NDTYP)*NDTYP.NE.NCGX) NCGX=(NCGX/NDTYP+1)*NDTYP
      XTIP=XORIGN
      YTIP=YORIGN
      NTNUM=1
      NDTIP(NTNUM,1)=NDTIP(NTNUM,1)+1
      NDTIP(NTNUM,NDTIP(NTNUM,1))=2*NDTYP+1
      NCGY=2
      YI=-DELEM*NDTYP
      DO IY=1,NCGY
        YI=XTIP+YI+DELEM*NDTYP
        XI=YTIP-3.0D0*DELEM*NDTYP
        L1=NNODE+(IY-1)*NDTYP*(NCGX+1)+1-NDTYP
        DO IX=1,NCGX/NDTYP
          L1=L1+NDTYP
          XI=XI+DELEM*NDTYP
          IF(NODE.EQ.4) THEN
            CALL ELEM4(IE,IMSET,L1,NCGX,XI,YI,DELEM)
          ELSE IF(NODE.EQ.8) THEN
            CALL ELEM8(IE,IMSET,L1,NCGX,XI,YI,DELEM)
          END IF
        END DO
      END DO
      NELEM=IE
      NNODE=NNODE+(NCGY*NDTYP+1)*(NCGX+1)
      ELL  = DELEM
      ELR  = DELEM
      ELU  = DELEM
      ELD  = DELEM
      RETURN
      END
      SUBROUTINE ELEM4(IE,IMSET,L1,NCGX,XI,YI,DELEM)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION CDLOC(4,2)
      DATA CDLOC/0.0D0, 1.0D0,1.0D0,0.0D0,0.0D0,0.0D0,1.0D0,1.0D0/
      NODE=4
      IE=IE+1
      L2=L1+1
      L3=L1+NCGX+1
      L4=L3+1
      MATSET(IMSET,1)=MATSET(IMSET,1)+1
      MATSET(IMSET,MATSET(IMSET,1))=IE
      LNODS(IE,1)=L1
      LNODS(IE,2)=L2
      LNODS(IE,3)=L4
      LNODS(IE,4)=L3
      DO K=1,NODE
        LN=LNODS(IE,K)
        COORD(LN,1)=XI+CDLOC(K,1)*DELEM
        COORD(LN,2)=YI+CDLOC(K,2)*DELEM
      END DO
      LNODS(IE,MXNOD)=NODE
      LNODS(IE,MXNOD-1)=IMSET
      ELTYP(IE)='C2D8'
      CALL DNODE(IE,NODE)
      RETURN
      END
      SUBROUTINE ELEM8(IE,IMSET,L1,NCGX,XI,YI,DELEM)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION CDLOC(8,2)
      DATA CDLOC/0.0D0,2.0D0,2.0D0,0.0D0,1.0D0,2.0D0,1.0D0,0.0D0,
     &           0.0D0,0.0D0,2.0D0,2.0D0,0.0D0,1.0D0,2.0D0,1.0D0/
      NODE=8
      IE=IE+1
      L2=L1+1
      L3=L2+1
      L4=L1+NCGX+1
      L5=L4+1
      L6=L5+1
      L7=L4+NCGX+1
      L8=L7+1
      L9=L8+1
      MATSET(IMSET,1)=MATSET(IMSET,1)+1
      MATSET(IMSET,MATSET(IMSET,1))=IE
      LNODS(IE,1)=L1
      LNODS(IE,2)=L3
      LNODS(IE,3)=L9
      LNODS(IE,4)=L7
      LNODS(IE,5)=L2
      LNODS(IE,6)=L6
      LNODS(IE,7)=L8
      LNODS(IE,8)=L4
      DO K=1,NODE
        LN=LNODS(IE,K)
        COORD(LN,1)=XI+CDLOC(K,1)*DELEM
        COORD(LN,2)=YI+CDLOC(K,2)*DELEM
      END DO
      LNODS(IE,MXNOD)=NODE
      LNODS(IE,MXNOD-1)=IMSET
      ELTYP(IE)='C2D8'
      CALL DNODE(IE,NODE)
      RETURN
      END
C
C     SUBROUTINE FOR GENERATING CRACK GROWTH TIP MESH
C
      SUBROUTINE CGROWTH2
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. CGROWTH2'
C
      TEXT='NOW EXCUTING SUB. CGROWTH2'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      NELEM0 = NELEM
C
    1 READ(IO_INPUT,*) IMSET,NODE,NUEXT
      NDTYP=NODE/4
C
      CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
C
      CALL SEAND(IWORK,2,YMAX,NDCGX,1)
C
      IL1=IWORK(1)
      IL2=IWORK(2)
      X1=COORD(IL1,1)
      Y1=COORD(IL1,2)
      X2=COORD(IL2,1)
      Y2=COORD(IL2,2)
      FTYPE  = 4.0/FLOAT(NODE)
      DELEM  = 0.0E0
      DELEMA = 0.0E0
      DELEMR = 0.0E0
      DELEML = 0.0E0
      DELEMU = 0.0E0
      DELEMD = 0.0E0
      NCGX=NDCGX-1
      READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE 1
      ELSE
        CALL LOCCHR(STRING,'RA      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          READ(STRING(K1:K2),*) AGASH
          DELEMR = 0.5E0*(AGASH - XMAX)*FTYPE
          DELEMA = DELEMA + ABS(DELEMR)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'RD      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          READ(STRING(K1:K2),*) AGASH
          DELEMR = AGASH
          DELEMA = DELEMA + ABS(DELEMR)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'LA      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          READ(STRING(K1:K2),*) AGASH
          DELEML = 0.5E0*(XMIN - AGASH)*FTYPE
          DELEMA = DELEMA + ABS(DELEML)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'LD      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          READ(STRING(K1:K2),*) AGASH
          DELEML = AGASH
          DELEMA = DELEMA + ABS(DELEML)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'UA      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          READ(STRING(K1:K2),*) AGASH
          DELEMU = 0.5E0*(AGASH-YMAX)*FTYPE
          DELEMA = DELEMA + ABS(DELEMU)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'UD      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          READ(STRING(K1:K2),*) AGASH
          DELEMU = AGASH
          DELEMA = DELEMA + ABS(DELEMU)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'DA      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          READ(STRING(K1:K2),*) AGASH
          DELEMD = 0.5E0*(YMIN-AGASH)*FTYPE
          DELEMA = DELEMA + ABS(DELEMD)
          KDELEM = KDELEM + 1
        END IF
      END IF
      IF(ABS(DELEMA).GT.TOLER) DELEMA = DELEMA/FLOAT(KDELEM)
C
      NGELE=0
      IF(INT(NCGX/NODE)*NODE.NE.NCGX) NGELE=(NCGX/NODE+1)*NODE-NCGX
      IF(NUEXT.GT.0) NGELE=NGELE+(NUEXT/NODE+1)*NODE
      IF(NGELE.NE.0) THEN
        BLMIN = 1.0E30
        BLMAX = 0.0E0
        DO I=1,NDCGX-1
          IL1  = IWORK(I)
          IL2  = IWORK(I+1)
          X1   = COORD(IL1,1)
          Y1   = COORD(IL1,2)
          X2   = COORD(IL2,1)
          Y2   = COORD(IL2,2)
          BLELC= SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2))
          IF(BLMIN.GT.BLELC) BLMIN=BLELC
          IF(BLMAX.LT.BLELC) BLMAX=BLELC
        END DO
        DELEMY = 0.5*(BLMIN+BLMAX)
        CALL GMESHR(XMAX,DELEMY,NGELE,IMSET,NODE)
      END IF
      CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
      IF(NODE.EQ.4) THEN
        CALL SEAND(IWORK,2,YMAX,NNINTER,1)
        DELEM = DELEMU
        CALL ELEV4_1U(IWORK,NNINTER,DELEM,IMSET,NODE)
        DELEMU = DELEM
        IF(ABS(DELEMA).LT.TOLER) DELEMA = DELEM
        CALL SEAND(IWORK,1,XMIN,NNINTER,1)
        IF(ABS(DELEML).LT.TOLER) DELEML = DELEMA
        DELEM = DELEML
        CALL ELEV4_1L(IWORK,NNINTER,DELEM,IMSET,NODE)
        CALL SEAND(IWORK,1,XMAX,NNINTER,3)
        IF(ABS(DELEMR).LT.TOLER) DELEMR = DELEMA
        DELEM = DELEMR
        CALL ELEV4_1R(IWORK,NNINTER,DELEM,IMSET,NODE)
      ELSE IF(NODE.EQ.8) THEN
        CALL SEAND(IWORK,2,YMAX,NNINTER,1)
        DELEM = DELEMU
        CALL ELEV8_1U(IWORK,NNINTER,DELEM,IMSET,NODE)
        DELEMU = DELEM
        IF(ABS(DELEMA).LT.TOLER) DELEMA = DELEM
        CALL SEAND(IWORK,1,XMIN,NNINTER,1)
        IF(ABS(DELEML).LT.TOLER) DELEML = DELEMA
        DELEM = DELEML
        CALL ELEV8_1L(IWORK,NNINTER,DELEM,IMSET,NODE)
        CALL SEAND(IWORK,1,XMAX,NNINTER,3)
        IF(ABS(DELEMR).LT.TOLER) DELEMR = DELEMA
        DELEM = DELEMR
        CALL ELEV8_1R(IWORK,NNINTER,DELEM,IMSET,NODE)
        NELEM1 = NELEM0 + 1
        CALL NODXY(3,NELEM1,NELEM)
      END IF
      ELL  = DELEML*0.4*NODE
      ELR  = DELEMR*0.4*NODE
      ELU  = DELEMU*0.4*NODE
      RETURN
      END
      SUBROUTINE CGROWTH3
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. CGROWTH3'
C
      TEXT='NOW EXCUTING SUB. CGROWTH3'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      NELEM0 = NELEM
C
    1 READ(IO_INPUT,*) IMSET,NODE,NUEXT
      NDTYP  = NODE/4
      FTYPE  = 4.0/FLOAT(NODE)
C
      CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
C
      CALL SEAND(IWORK,2,YMAX,NDCGX,1)
C
      IL1=IWORK(1)
      IL2=IWORK(2)
      X1=COORD(IL1,1)
      Y1=COORD(IL1,2)
      X2=COORD(IL2,1)
      Y2=COORD(IL2,2)
      DELEMA = 0.0E0
      DELEMR = 0.0E0
      DELEML = 0.0E0
      DELEMU = 0.0E0
      DELEMD = 0.0E0
      KDELEM = 0
      NCGX=NDCGX-1
      READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE 1
      ELSE
        CALL LOCCHR(STRING,'RA      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          READ(STRING(K1:K2),*) AGASH
          DELEMR = 0.5E0*(AGASH - XMAX)*FTYPE
          DELEMA = DELEMA + ABS(DELEMR)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'RD      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          READ(STRING(K1:K2),*) AGASH
          DELEMR = AGASH
          DELEMA = DELEMA + ABS(DELEMR)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'LA      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          READ(STRING(K1:K2),*) AGASH
          DELEML = 0.5E0*(XMIN - AGASH)*FTYPE
          DELEMA = DELEMA + ABS(DELEML)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'LD      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          READ(STRING(K1:K2),*) AGASH
          DELEML = AGASH
          DELEMA = DELEMA + ABS(DELEML)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'UA      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          READ(STRING(K1:K2),*) AGASH
          DELEMU = 0.5E0*(AGASH-YMAX)*FTYPE
          DELEMA = DELEMA + ABS(DELEMU)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'UD      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          READ(STRING(K1:K2),*) AGASH
          DELEMU = AGASH
          DELEMA = DELEMA + ABS(DELEMU)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'DA      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          READ(STRING(K1:K2),*) AGASH
          DELEMD = 0.5E0*(AGASH-YMIN)*FTYPE
          DELEMA = DELEMA + ABS(DELEMD)
          KDELEM = KDELEM + 1
        END IF
      END IF
      IF(ABS(DELEMA).GT.TOLER) DELEMA = DELEMA/FLOAT(KDELEM)
C
      IF(NODE.EQ.4) THEN
        CALL SEAND(IWORK,2,YMAX,NNINTER,1)
        DELEM = DELEMU
        CALL ELEV4_1U1(IWORK,NNINTER,DELEM,IMSET,NODE)
        DELEMU = DELEM
        IF(ABS(DELEMA).LT.TOLER) DELEMA = DELEM
        CALL SEAND(IWORK,1,XMIN,NNINTER,1)
        IF(ABS(DELEML).LT.TOLER) DELEML = DELEMA
        DELEM = DELEML
        CALL ELEV4_1L(IWORK,NNINTER,DELEM,IMSET,NODE)
      ELSE IF(NODE.EQ.8) THEN
        CALL SEAND(IWORK,2,YMAX,NNINTER,1)
        DELEM = DELEMU
        CALL ELEV8_1U1(IWORK,NNINTER,DELEM,IMSET,NODE)
        DELEMU = DELEM
        IF(ABS(DELEMA).LT.TOLER) DELEMA = DELEM
        CALL SEAND(IWORK,1,XMIN,NNINTER,1)
        IF(ABS(DELEML).LT.TOLER) DELEML = DELEMA
        DELEM = DELEML
        CALL ELEV8_1L(IWORK,NNINTER,DELEM,IMSET,NODE)
        NELEM1 = NELEM0 + 1
        CALL NODXY(3,NELEM1,NELEM)
      END IF
      ELL  = DELEML*0.4*NODE
      ELU  = DELEMU*0.4*NODE
      RETURN
      END
      SUBROUTINE ELEV4_1L(NDINTER,NNINTER,DELEM,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDINTER(*)
      DIMENSION LNLOC(4,4),CDLOC(2,9),NDLOC(9),INLOC(4),LOCIN(9)
      DATA LNLOC/ 1, 4, 5, 2, 2, 5, 7, 3, 4, 6, 7, 5, 6, 8, 9, 7/
      DATA INLOC/ 1, 4, 6, 8/
      DATA LOCIN/ 1, 1, 1, 2, 2, 3, 3, 4, 4/
      DATA CDLOC/0.0D0,0.0D0,0.0D0,1.0D0,0.0D0,2.0D0,1.0D0,0.0D0,
     &           1.0D0,1.0D0,2.0D0,0.0D0,2.0D0,2.0D0,4.0D0,0.0D0,
     &           4.0D0,2.0D0/
      NNLOC = 9
      NNINT = 4
      DO K=1,NNLOC
        NDLOC(K)=K
      END DO
      DO K=1,NNINT
        NGASH=INLOC(K)
        NDLOC(NGASH)=NDINTER(K)-NNODE
      END DO
      IL=NDINTER(1)
      XI=COORD(IL,1)
      YI=COORD(IL,2)
      IE=NELEM
      DO K=1,4
        IE=IE+1
        DO J=1,NODE
          NGASH=LNLOC(J,K)
          LNODE=NDLOC(NGASH)+NNODE
          IGASH= LOCIN(NGASH)
          IGASH= NDINTER(IGASH)
          XNEW = XI-CDLOC(2,NGASH)*DELEM
          YNEW = COORD(IGASH,2)
          COORD(LNODE,1)=XNEW
          COORD(LNODE,2)=YNEW
          LNODS(IE,J)=LNODE
        END DO
        LNODS(IE,MXNOD)=NODE
        LNODS(IE,MXNOD-1)=IMSET
        ELTYP(IE)='C2D4'
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IE
        CALL DNODE(IE,NODE)
      END DO
      NELEM=IE
      NNODE=NNODE+NNLOC
      RETURN
      END
      SUBROUTINE ELEV4_1R(NDINTER,NNINTER,DELEM,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDINTER(*)
      DIMENSION LNLOC(4,4),CDLOC(2,9),NDLOC(9),INLOC(4),LOCIN(9)
      DATA LNLOC/ 1, 2, 5, 4, 2, 3, 7, 5, 4, 5, 7, 6, 6, 7, 9, 8/
      DATA INLOC/8,6,4,1/
      DATA LOCIN/ 4, 4, 4, 3, 3, 2, 2, 1, 1/
      DATA CDLOC/0.0D0,0.0D0,1.0D0,0.0D0,2.0D0,0.0D0,0.0D0,1.0D0,
     &           1.0D0,1.0D0,0.0D0,2.0D0,2.0D0,2.0D0,0.0D0,4.0D0,
     &           2.0D0,4.0D0/
      NNLOC = 9
      NNINT = 4
      DO K=1,NNLOC
        NDLOC(K)=K
      END DO
      DO K=1,NNINT
        NGASH=INLOC(K)
        NDLOC(NGASH)=NDINTER(K)-NNODE
      END DO
      IL=NDINTER(NNINTER)
      XI=COORD(IL,1)
      YI=COORD(IL,2)
      IE=NELEM
      DO K=1,4
        IE=IE+1
        DO J=1,NODE
          NGASH=LNLOC(J,K)
          LNODE=NDLOC(NGASH)+NNODE
          IGASH= LOCIN(NGASH)
          IGASH= NDINTER(IGASH)
          XNEW = XI+CDLOC(1,NGASH)*DELEM
          YNEW = COORD(IGASH,2)
          COORD(LNODE,1)=XNEW
          COORD(LNODE,2)=YNEW
          LNODS(IE,J)=LNODE
        END DO
        LNODS(IE,MXNOD)=NODE
        LNODS(IE,MXNOD-1)=IMSET
        ELTYP(IE)='C2D4'
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IE
        CALL DNODE(IE,NODE)
      END DO
      NELEM=IE
      NNODE=NNODE+NNLOC
      RETURN
      END
      SUBROUTINE ELEV4_1U(NDINTER,NNINTER,DELEM,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDINTER(*)
      DIMENSION LNLOC(4,6),CDLOC(2,11),NDLOC(11),INLOC(5),LOCIN(11)
      DATA LNLOC/ 1, 3, 4, 2, 3, 5, 6, 4, 4, 6, 7, 2, 5, 8, 9, 6,
     &            6, 9,11, 7, 8,10,11, 9/
      DATA INLOC/1,3,5,8,10/
      DATA LOCIN/ 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5/
      DATA CDLOC/0.0D0,0.0D0,0.0D0,2.0D0,1.0D0,0.0D0,1.0D0,1.0D0,
     &           2.0D0,0.0D0,2.0D0,1.0D0,2.0D0,2.0D0,3.0D0,0.0D0,
     &           3.0D0,1.0D0,4.0D0,0.0D0,4.0D0,2.0D0/
      NNLOC = 11
      NNINT = 5
      BLMIN = 1.0E30
      BLMAX = 0.0E0
      DO I=1,NNINTER-1
        IL1  = NDINTER(I)
        IL2  = NDINTER(I+1)
        X1   = COORD(IL1,1)
        Y1   = COORD(IL1,2)
        X2   = COORD(IL2,1)
        Y2   = COORD(IL2,2)
        BLELC= SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2))
        IF(BLMIN.GT.BLELC) BLMIN=BLELC
        IF(BLMAX.LT.BLELC) BLMAX=BLELC
      END DO
      IF(ABS(DELEM).LT.TOLER) DELEM = 0.5*(BLMIN+BLMAX)
      NNODE0=NNODE
      IE=NELEM
      DO I=1,NNINTER/NODE
        DO K=1,NNLOC
          NDLOC(K)=K
        END DO
        DO K=1,NNINT
          NGASH=INLOC(K)
          NDLOC(NGASH)=NDINTER(K+(I-1)*NODE)-NNODE0
        END DO
        IL=NDINTER(1+(I-1)*NODE)
        XI=COORD(IL,1)
        YI=COORD(IL,2)
        DO K=1,6
          IE=IE+1
          DO J=1,NODE
            NGASH=LNLOC(J,K)
            LNODE=NDLOC(NGASH)+NNODE0
            IGASH= LOCIN(NGASH)+(I-1)*NODE
            IGASH= NDINTER(IGASH)
            XNEW = COORD(IGASH,1)
            YNEW = YI+CDLOC(2,NGASH)*DELEM
            COORD(LNODE,1)=XNEW
            COORD(LNODE,2)=YNEW
            LNODS(IE,J)=LNODE
          END DO
          LNODS(IE,MXNOD)=NODE
          LNODS(IE,MXNOD-1)=IMSET
          MATSET(IMSET,1)=MATSET(IMSET,1)+1
          MATSET(IMSET,MATSET(IMSET,1))=IE
          ELTYP(IE)='C2D4'
          CALL DNODE(IE,NODE)
        END DO
        NNODE0=NNODE0+NNLOC-2
      END DO
      NELEM=IE
      NNODE=NNODE0+2
      RETURN
      END
      SUBROUTINE ELEV4_1U1(NDINTER,NNINTER,DELEM,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDINTER(*)
      DIMENSION LNLOC(4,6),CDLOC(2,11),NDLOC(11),INLOC(5),LOCIN(11)
      DIMENSION LNLOC1(4,1),CDLOC1(2,4),INLOC1(2)
      DATA LNLOC/ 1, 3, 4, 2, 3, 5, 6, 4, 4, 6, 7, 2, 5, 8, 9, 6,
     &            6, 9,11, 7, 8,10,11, 9/
      DATA INLOC/1,3,5,8,10/
      DATA LOCIN/ 1, 1, 2, 2, 3, 3, 3, 4, 4, 5, 5/
      DATA CDLOC/0.0D0,0.0D0,0.0D0,2.0D0,1.0D0,0.0D0,1.0D0,1.0D0,
     &           2.0D0,0.0D0,2.0D0,1.0D0,2.0D0,2.0D0,3.0D0,0.0D0,
     &           3.0D0,1.0D0,4.0D0,0.0D0,4.0D0,2.0D0/
      DATA LNLOC1/ 1, 3, 4, 2/
      DATA INLOC1/1,3/
      DATA CDLOC1/0.0D0,0.0D0,0.0D0,2.0D0,2.0D0,0.0D0,2.0D0,2.0D0/
      NNLOC = 11
      NNINT = 5
      BLMIN = 1.0E30
      BLMAX = 0.0E0
      DO I=1,NNINTER-1
        IL1  = NDINTER(I)
        IL2  = NDINTER(I+1)
        X1   = COORD(IL1,1)
        Y1   = COORD(IL1,2)
        X2   = COORD(IL2,1)
        Y2   = COORD(IL2,2)
        BLELC= SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2))
        IF(BLMIN.GT.BLELC) BLMIN=BLELC
        IF(BLMAX.LT.BLELC) BLMAX=BLELC
      END DO
      IF(ABS(DELEM).LT.TOLER) DELEM = 0.5*(BLMIN+BLMAX)
      NNODE0=NNODE
      IE=NELEM
      NGELE=(NNINTER-1)/NODE
      NGRES = NNINTER-1-NGELE*NODE
      DO I=1,NGELE
        DO K=1,NNLOC
          NDLOC(K)=K
        END DO
        DO K=1,NNINT
          NGASH=INLOC(K)
          NDLOC(NGASH)=NDINTER(K+(I-1)*NODE)-NNODE0
        END DO
        IL=NDINTER(1+(I-1)*NODE)
        XI=COORD(IL,1)
        YI=COORD(IL,2)
        DO K=1,6
          IE=IE+1
          DO J=1,NODE
            NGASH=LNLOC(J,K)
            LNODE=NDLOC(NGASH)+NNODE0
            IGASH= LOCIN(NGASH)+(I-1)*NODE
            IGASH= NDINTER(IGASH)
            XNEW = COORD(IGASH,1)
            YNEW = YI+CDLOC(2,NGASH)*DELEM
            COORD(LNODE,1)=XNEW
            COORD(LNODE,2)=YNEW
            LNODS(IE,J)=LNODE
          END DO
          LNODS(IE,MXNOD)=NODE
          LNODS(IE,MXNOD-1)=IMSET
          MATSET(IMSET,1)=MATSET(IMSET,1)+1
          MATSET(IMSET,MATSET(IMSET,1))=IE
          ELTYP(IE)='C2D4'
          CALL DNODE(IE,NODE)
        END DO
        NNODE0=NNODE0+NNLOC-2
      END DO
      DO I=1,NGRES
        IE=IE+1
        DO K=1,4
          NDLOC(K)=K
        END DO
        DO K=1,2
          NGASH=INLOC1(K)
          NDLOC(NGASH)=NDINTER(K+NGELE*NODE+I-1)-NNODE0
        END DO
        DO J=1,NODE
          NGASH=LNLOC1(J,1)
          LNODE=NDLOC(NGASH)+NNODE0
          IGASH= LOCIN(NGASH)+NGELE*NODE+I-1
          IGASH= NDINTER(IGASH)
          XNEW = COORD(IGASH,1)
          YNEW = YI+CDLOC1(2,NGASH)*DELEM
          COORD(LNODE,1)=XNEW
          COORD(LNODE,2)=YNEW
          LNODS(IE,J)=LNODE
        END DO
        LNODS(IE,MXNOD)=NODE
        LNODS(IE,MXNOD-1)=IMSET
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IE
        ELTYP(IE)='C2D4'
        CALL DNODE(IE,NODE)
        NNODE0=NNODE0+2
      END DO
      NELEM=IE
      NNODE=NNODE0+2
      RETURN
      END
      SUBROUTINE ELEV8_1L(NDINTER,NNINTER,DELEM,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDINTER(*)
      DIMENSION LNLOC(9,4),CDLOC(2,25),NDLOC(25),INLOC(7),LOCIN(25)
      DATA LNLOC/ 1,11,13, 3, 6,12, 8, 2, 7,
     &           11,17,19,13,14,18,16,12,15,
     &            3,13,19, 5, 8,16,10, 4, 9,
     &           17,23,25,19,20,24,22,18,21/
      DATA INLOC/1,6,11,14,17,20,23/
      DATA LOCIN/1,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,5,5,5,6,6,6,7,7,7/
      DATA CDLOC/0.0D0,0.0D0,0.0D0,1.0D0,0.0D0,2.0D0,0.0D0,3.0D0,
     &           0.0D0,4.0D0,1.0D0,0.0D0,1.0D0,1.0D0,1.0D0,2.0D0,
     &           1.5D0,3.0D0,2.0D0,4.0D0,2.0D0,0.0D0,2.0D0,1.0D0,
     &           2.0D0,2.0D0,3.0D0,0.0D0,3.0D0,1.5D0,3.0D0,3.0D0,
     &           4.0D0,0.0D0,4.0D0,2.0D0,4.0D0,4.0D0,6.0D0,0.0D0,
     &           6.0D0,2.0D0,6.0D0,4.0D0,8.0D0,0.0D0,8.0D0,2.0D0,
     &           8.0D0,4.0D0/
      DO K=1,25
        NDLOC(K)=K
      END DO
      DO K=1,7
        NGASH=INLOC(K)
        NDLOC(NGASH)=NDINTER(K)-NNODE
      END DO
      IL=NDINTER(1)
      XI=COORD(IL,1)
      YI=COORD(IL,2)
      IE=NELEM
      DO K=1,4
        IE=IE+1
        DO J=1,NODE
          NGASH=LNLOC(J,K)
          LNODE=NDLOC(NGASH)+NNODE
          IGASH= LOCIN(NGASH)
          IGASH= NDINTER(IGASH)
          XNEW = XI-CDLOC(2,NGASH)*DELEM
          YNEW = COORD(IGASH,2)
          COORD(LNODE,1)=XNEW
          COORD(LNODE,2)=YNEW
          LNODS(IE,J)=LNODE
        END DO
        LNODS(IE,MXNOD)=NODE
        LNODS(IE,MXNOD-1)=IMSET
        ELTYP(IE)='C2D8'
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IE
        CALL DNODE(IE,NODE)
      END DO
      NELEM=IE
      NNODE=NNODE+25
      RETURN
      END
      SUBROUTINE ELEV8_1R(NDINTER,NNINTER,DELEM,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDINTER(*)
      DIMENSION LNLOC(9,4),CDLOC(2,25),NDLOC(25),INLOC(7),LOCIN(25)
      DATA LNLOC/ 1,11,13, 3, 6,12, 8, 2, 7,
     &           11,17,19,13,14,18,16,12,15,
     &            3,13,19, 5, 8,16,10, 4, 9,
     &            5,19,25,23,10,22,24,20,21/
      DATA INLOC/23,20,5,4,3,2,1/
      DATA LOCIN/7,6,5,4,3,7,6,5,4,3,7,6,5,7,6,4,7,5,3,2,2,2,1,1,1/
      DATA CDLOC/0.0D0,0.0D0,0.0D0,1.0D0,0.0D0,2.0D0,0.0D0,3.0D0,
     &           0.0D0,4.0D0,1.0D0,0.0D0,1.0D0,1.0D0,1.0D0,2.0D0,
     &           1.5D0,3.0D0,2.0D0,4.0D0,2.0D0,0.0D0,2.0D0,1.0D0,
     &           2.0D0,2.0D0,3.0D0,0.0D0,3.0D0,1.5D0,3.0D0,3.0D0,
     &           4.0D0,0.0D0,4.0D0,2.0D0,4.0D0,4.0D0,0.0D0,6.0D0,
     &           2.0D0,6.0D0,4.0D0,6.0D0,0.0D0,8.0D0,2.0D0,8.0D0,
     &           4.0D0,8.0D0/
      DO K=1,25
        NDLOC(K)=K
      END DO
      DO K=1,7
        NGASH=INLOC(K)
        NDLOC(NGASH)=NDINTER(K)-NNODE
      END DO
      IL=NDINTER(7)
      XI=COORD(IL,1)
      YI=COORD(IL,2)
      IE=NELEM
      DO K=1,4
        IE=IE+1
        DO J=1,NODE
          NGASH=LNLOC(J,K)
          LNODE=NDLOC(NGASH)+NNODE
          IGASH= LOCIN(NGASH)
          IGASH= NDINTER(IGASH)
          XNEW = XI+CDLOC(1,NGASH)*DELEM
          YNEW = COORD(IGASH,2)
          COORD(LNODE,1)=XNEW
          COORD(LNODE,2)=YNEW
          LNODS(IE,J)=LNODE
        END DO
        LNODS(IE,MXNOD)=NODE
        LNODS(IE,MXNOD-1)=IMSET
        ELTYP(IE)='C2D8'
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IE
        CALL DNODE(IE,NODE)
      END DO
      NELEM=IE
      NNODE=NNODE+25
      RETURN
      END
      SUBROUTINE ELEV8_1U(NDINTER,NNINTER,DELEM,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDINTER(*)
      DIMENSION LNLOC(9,6),CDLOC(2,33),NDLOC(33),INLOC(9),LOCIN(33)
      DATA LNLOC/ 1, 7, 9, 3, 4, 8, 6, 2, 5,
     &            7,15,17, 9,10,16,12, 8,11,
     &            9,17,19, 3,12,18,14, 6,13,
     &           15,25,27,17,20,26,22,16,21,
     &           25,31,33,27,28,32,30,26,29,
     &           17,27,33,19,22,30,24,18,23/
      DATA INLOC/1,4,7,10,15,20,25,28,31/
      DATA LOCIN/1,1,1,2,2,2,3,3,3,4,4,4,4,3,5,5,5,5,5,6,6,6,6,7,
     &           7,7,7,8,8,8,9,9,9/
      DATA CDLOC/0.0D0,0.0D0,0.0D0,2.0D0,0.0D0,4.0D0,1.0D0,0.0D0,
     &           1.0D0,1.5D0,1.0D0,3.0D0,2.0D0,0.0D0,2.0D0,1.0D0,
     &           2.0D0,2.0D0,3.0D0,0.0D0,3.0D0,1.0D0,3.0D0,2.0D0,
     &           2.5D0,3.0D0,2.0D0,4.0D0,4.0D0,0.0D0,4.0D0,1.0D0,
     &           4.0D0,2.0D0,4.0D0,3.0D0,4.0D0,4.0D0,5.0D0,0.0D0,
     &           5.0D0,1.0D0,5.0D0,2.0D0,5.5D0,3.0D0,6.0D0,4.0D0,
     &           6.0D0,0.0D0,6.0D0,1.0D0,6.0D0,2.0D0,7.0D0,0.0D0,
     &           7.0D0,1.5D0,7.0D0,3.0D0,8.0D0,0.0D0,8.0D0,2.0D0,
     &           8.0D0,4.0D0/
C
      BLMIN = 1.0E30
      BLMAX = 0.0E0
      DO I=1,NNINTER-1
        IL1  = NDINTER(I)
        IL2  = NDINTER(I+1)
        X1   = COORD(IL1,1)
        Y1   = COORD(IL1,2)
        X2   = COORD(IL2,1)
        Y2   = COORD(IL2,2)
        BLELC= SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2))
        IF(BLMIN.GT.BLELC) BLMIN=BLELC
        IF(BLMAX.LT.BLELC) BLMAX=BLELC
      END DO
      IF(ABS(DELEM).LT.TOLER) DELEM = 0.5*(BLMIN+BLMAX)
C
      NNODE0=NNODE
      IE=NELEM
      DO I=1,NNINTER/NODE
        DO K=1,33
          NDLOC(K)=K
        END DO
        DO K=1,9
          NGASH=INLOC(K)
          NDLOC(NGASH)=NDINTER(K+(I-1)*NODE)-NNODE0
        END DO
        IL=NDINTER(1+(I-1)*NODE)
        XI=COORD(IL,1)
        YI=COORD(IL,2)
        DO K=1,6
          IE=IE+1
          DO J=1,NODE
            NGASH=LNLOC(J,K)
            LNODE=NDLOC(NGASH)+NNODE0
            IGASH= LOCIN(NGASH)+(I-1)*8
            IGASH= NDINTER(IGASH)
            XNEW = COORD(IGASH,1)
            YNEW = YI+CDLOC(2,NGASH)*DELEM
            COORD(LNODE,1)=XNEW
            COORD(LNODE,2)=YNEW
            LNODS(IE,J)=LNODE
          END DO
          LNODS(IE,MXNOD)=NODE
          LNODS(IE,MXNOD-1)=IMSET
          MATSET(IMSET,1)=MATSET(IMSET,1)+1
          MATSET(IMSET,MATSET(IMSET,1))=IE
          ELTYP(IE)='C2D8'
          CALL DNODE(IE,NODE)
        END DO
        NNODE0=NNODE0+30
      END DO
      NELEM=IE
      NNODE=NNODE0+3
      RETURN
      END
C******************************************************************
C     Added in Aug. 4, 1995
C******************************************************************
      SUBROUTINE ELEV8_1U1(NDINTER,NNINTER,DELEM,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDINTER(*)
      DIMENSION LNLOC(9,6),CDLOC(2,33),NDLOC(33),INLOC(9),LOCIN(33)
      DIMENSION INLOC1(3),LNLOC1(9,1),CDLOC1(2,9),LOCIN1(9)
      DATA LNLOC/ 1, 7, 9, 3, 4, 8, 6, 2, 5,
     &            7,15,17, 9,10,16,12, 8,11,
     &            9,17,19, 3,12,18,14, 6,13,
     &           15,25,27,17,20,26,22,16,21,
     &           25,31,33,27,28,32,30,26,29,
     &           17,27,33,19,22,30,24,18,23/
      DATA INLOC/1,4,7,10,15,20,25,28,31/
      DATA LOCIN/1,1,1,2,2,2,3,3,3,4,4,4,4,3,5,5,5,5,5,6,6,6,6,7,
     &           7,7,7,8,8,8,9,9,9/
      DATA CDLOC/0.0D0,0.0D0,0.0D0,2.0D0,0.0D0,4.0D0,1.0D0,0.0D0,
     &           1.0D0,1.5D0,1.0D0,3.0D0,2.0D0,0.0D0,2.0D0,1.0D0,
     &           2.0D0,2.0D0,3.0D0,0.0D0,3.0D0,1.0D0,3.0D0,2.0D0,
     &           2.5D0,3.0D0,2.0D0,4.0D0,4.0D0,0.0D0,4.0D0,1.0D0,
     &           4.0D0,2.0D0,4.0D0,3.0D0,4.0D0,4.0D0,5.0D0,0.0D0,
     &           5.0D0,1.0D0,5.0D0,2.0D0,5.5D0,3.0D0,6.0D0,4.0D0,
     &           6.0D0,0.0D0,6.0D0,1.0D0,6.0D0,2.0D0,7.0D0,0.0D0,
     &           7.0D0,1.5D0,7.0D0,3.0D0,8.0D0,0.0D0,8.0D0,2.0D0,
     &           8.0D0,4.0D0/
      DATA INLOC1/1,4,7/
      DATA LNLOC1/1,7,9,3,4,8,6,2,5/
      DATA CDLOC1/0.0D0,0.0D0,0.0D0,2.0D0,0.0D0,4.0D0,2.0D0,0.0D0,
     &            2.0D0,2.0D0,2.0D0,4.0D0,4.0D0,0.0D0,4.0D0,2.0D0,
     &            4.0D0,4.0D0/
C
      BLMIN = 1.0E30
      BLMAX = 0.0E0
      DO I=1,NNINTER-1
        IL1  = NDINTER(I)
        IL2  = NDINTER(I+1)
        X1   = COORD(IL1,1)
        Y1   = COORD(IL1,2)
        X2   = COORD(IL2,1)
        Y2   = COORD(IL2,2)
        BLELC= SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2))
        IF(BLMIN.GT.BLELC) BLMIN=BLELC
        IF(BLMAX.LT.BLELC) BLMAX=BLELC
      END DO
      IF(ABS(DELEM).LT.TOLER) DELEM = 0.5*(BLMIN+BLMAX)
C
      NNODE0=NNODE
      IE=NELEM
      NGELE = (NNINTER-1)/NODE
      NGRES = NNINTER-1-NGELE*NODE
      NGRES = NGRES/2
      DO I=1,NGELE
        DO K=1,33
          NDLOC(K)=K
        END DO
        DO K=1,9
          NGASH=INLOC(K)
          NDLOC(NGASH)=NDINTER(K+(I-1)*NODE)-NNODE0
        END DO
        IL=NDINTER(1+(I-1)*NODE)
        XI=COORD(IL,1)
        YI=COORD(IL,2)
        DO K=1,6
          IE=IE+1
          DO J=1,NODE
            NGASH=LNLOC(J,K)
            LNODE=NDLOC(NGASH)+NNODE0
            IGASH= LOCIN(NGASH)+(I-1)*8
            IGASH= NDINTER(IGASH)
            XNEW = COORD(IGASH,1)
            YNEW = YI+CDLOC(2,NGASH)*DELEM
            COORD(LNODE,1)=XNEW
            COORD(LNODE,2)=YNEW
            LNODS(IE,J)=LNODE
          END DO
          LNODS(IE,MXNOD)=NODE
          LNODS(IE,MXNOD-1)=IMSET
          MATSET(IMSET,1)=MATSET(IMSET,1)+1
          MATSET(IMSET,MATSET(IMSET,1))=IE
          ELTYP(IE)='C2D8'
          CALL DNODE(IE,NODE)
        END DO
        NNODE0=NNODE0+30
      END DO
      DO I=1,NGRES
        IE=IE+1
        DO K=1,NODE
          NDLOC(K)=K
        END DO
        DO K=1,3
          NGASH=INLOC1(K)
          NDLOC(NGASH)=NDINTER(K+NGELE*NODE+(I-1)*2)-NNODE0
        END DO
        DO J=1,NODE
          NGASH=LNLOC1(J,1)
          LNODE=NDLOC(NGASH)+NNODE0
          IGASH= LOCIN(NGASH)+NGELE*NODE+(I-1)*2
          IGASH= NDINTER(IGASH)
          XNEW = COORD(IGASH,1)
          YNEW = YI+CDLOC1(2,NGASH)*DELEM
          COORD(LNODE,1)=XNEW
          COORD(LNODE,2)=YNEW
          LNODS(IE,J)=LNODE
        END DO
        LNODS(IE,MXNOD)=NODE
        LNODS(IE,MXNOD-1)=IMSET
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IE
        ELTYP(IE)='C2D8'
        CALL DNODE(IE,NODE)
        NNODE0=NNODE0+6
      END DO
      NELEM=IE
      NNODE=NNODE0+3
      RETURN
      END
C
C     SUBROUTINE FOR GENERATING CRACK GROWTH TIP MESH
C
      SUBROUTINE GMESHR(XMAX,DELEM,NGELE,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION IEL(9)
      CALL SEAND(IWORK,1,XMAX,NNINTER,3)
      XI=XMAX
      NDTYP=NODE/4
      IN=NNODE
      DO IG1=1,NGELE
C *** GENERATING NODE COORDINATES
        XI=XI+DELEM
        DO IG2=1,NNINTER
          IL=IWORK(IG2)
          YI=COORD(IL,2)
          IN=IN+1
          COORD(IN,1)=XI
          COORD(IN,2)=YI
        END DO
      END DO
      IE=NELEM
      L6=NNODE-NNINTER
      IF(NODE.EQ.8) THEN
        DO IG1=1,NGELE/NDTYP
          L1=L6-1
          DO IG2=1,NNINTER/NDTYP
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NNINTER
            L5=L4+1
            L6=L5+1
            L7=L4+NNINTER
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D8'
            IF(IG1.EQ.1) THEN
              LNODS(IE,1)=IWORK(2*IG2-1)
              LNODS(IE,5)=IWORK(2*IG2)
              LNODS(IE,2)=IWORK(2*IG2+1)
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L2=NNODE-NNINTER
        DO IG1=1,NGELE
          L1=L2
          DO IG2=1,NNINTER-1
            IE=IE+1
            L1=L1+1
            L2=L1+1
            L3=L1+NNINTER
            L4=L3+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L2
            LNODS(IE,3)=L4
            LNODS(IE,4)=L3
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D4'
            IF(IG1.EQ.1) THEN
              LNODS(IE,1)=IWORK(IG2)
              LNODS(IE,2)=IWORK(IG2+1)
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      END IF
      NNODE=IN
      NELEM=IE
      RETURN
      END
C******************************************************************
C     Added in Aug.18, 1995
C******************************************************************
C
C     SUBROUTINE FOR GENERATING CRACK GROWTH TIP MESH
C
      SUBROUTINE CGROWTH4
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. CGROWTH4'
C
      TEXT='NOW EXCUTING SUB. CGROWTH4'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      NELEM0 = NELEM
C
    1 READ(IO_INPUT,*) IMSET,NODE,NUEXT
      NDTYP=NODE/4
C
      CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
C
      CALL SEAND(IWORK,2,YMAX,NDCGX,1)
C
      FTYPE  = 4.0/FLOAT(NODE)
      KR     = 0
      KL     = 0
      DELEM  = 0.0E0
      DELEMA = 0.0E0
      DELEMR = 0.0E0
      DELEML = 0.0E0
      READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE 1
      ELSE
        CALL LOCCHR(STRING,'RA      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          KR = 1
          READ(STRING(K1:K2),*) AGASH
          DELEMR = 0.5E0*(AGASH - XMAX)*FTYPE
          DELEMA = DELEMA + ABS(DELEMR)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'RD      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          KR = 1
          READ(STRING(K1:K2),*) AGASH
          DELEMR = AGASH
          DELEMA = DELEMA + ABS(DELEMR)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'LA      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          KL = 1
          READ(STRING(K1:K2),*) AGASH
          DELEML = 0.5E0*(XMIN - AGASH)*FTYPE
          DELEMA = DELEMA + ABS(DELEML)
          KDELEM = KDELEM + 1
        END IF
        CALL LOCCHR(STRING,'LD      ',2,1,K1,K2)
        IF(K2.GT.K1) THEN
          KL = 1
          READ(STRING(K1:K2),*) AGASH
          DELEML = AGASH
          DELEMA = DELEMA + ABS(DELEML)
          KDELEM = KDELEM + 1
        END IF
      END IF
      IF(ABS(DELEMA).GT.TOLER) DELEMA = DELEMA/FLOAT(KDELEM)
C
      IF(NODE.EQ.4) THEN
        CALL SEAND(IWORK,1,XMIN,NNINTER,1)
        DELEM = DELEML
        IF(KL.EQ.1) CALL ELEV4_1L1(IWORK,NNINTER,DELEM,IMSET,NODE)
        CALL SEAND(IWORK,1,XMAX,NNINTER,3)
        DELEM = DELEMR
        IF(KR.EQ.1) CALL ELEV4_1R1(IWORK,NNINTER,DELEM,IMSET,NODE)
      ELSE IF(NODE.EQ.8) THEN
        CALL SEAND(IWORK,1,XMIN,NNINTER,1)
        DELEM = DELEML
        IF(KL.EQ.1) CALL ELEV8_1L1(IWORK,NNINTER,DELEM,IMSET,NODE)
        CALL SEAND(IWORK,1,XMAX,NNINTER,3)
        DELEM = DELEMR
        IF(KR.EQ.1) CALL ELEV8_1R1(IWORK,NNINTER,DELEM,IMSET,NODE)
        NELEM1 = NELEM0 + 1
        CALL NODXY(3,NELEM1,NELEM)
      END IF
      ELL  = DELEML*0.4*NODE
      ELR  = DELEMR*0.4*NODE
      RETURN
      END
      SUBROUTINE ELEV8_1L1(NDINTER,NNINTER,DELEM,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      PARAMETER (NNLOC = 19, NNINT = 5, NENEW = 3)
      DIMENSION NDINTER(*)
      DIMENSION LNLOC(9,NENEW),CDLOC(2,NNLOC),NDLOC(NNLOC),
     &          INLOC(NNINT),LOCIN(NNLOC)
      DATA LNLOC/ 1,11,13, 3, 6,12, 8, 2, 7,
     &           11,17,19,13,14,18,16,12,15,
     &            3,13,19, 5, 8,16,10, 4, 9/
      DATA INLOC/1,6,11,14,17/
      DATA LOCIN/1,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,5,5,5/
      DATA CDLOC/0.0D0,0.0D0,0.0D0,1.0D0,0.0D0,2.0D0,0.0D0,3.0D0,
     &           0.0D0,4.0D0,1.0D0,0.0D0,1.0D0,1.0D0,1.0D0,2.0D0,
     &           1.5D0,3.0D0,2.0D0,4.0D0,2.0D0,0.0D0,2.0D0,1.0D0,
     &           2.0D0,2.0D0,3.0D0,0.0D0,3.0D0,1.5D0,3.0D0,3.0D0,
     &           4.0D0,0.0D0,4.0D0,2.0D0,4.0D0,4.0D0/
C
      BLMIN = 1.0E30
      BLMAX = 0.0E0
      DO I=1,NNINTER-1
        IL1  = NDINTER(I)
        IL2  = NDINTER(I+1)
        X1   = COORD(IL1,1)
        Y1   = COORD(IL1,2)
        X2   = COORD(IL2,1)
        Y2   = COORD(IL2,2)
        BLELC= SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2))
        IF(BLMIN.GT.BLELC) BLMIN=BLELC
        IF(BLMAX.LT.BLELC) BLMAX=BLELC
      END DO
      IF(ABS(DELEM).LT.TOLER) DELEM = 0.5*(BLMIN+BLMAX)
C
      DO K=1,NNLOC
        NDLOC(K)=K
      END DO
      DO K=1,NNINT
        NGASH=INLOC(K)
        NDLOC(NGASH)=NDINTER(K)-NNODE
      END DO
      IL=NDINTER(1)
      XI=COORD(IL,1)
      YI=COORD(IL,2)
      IE=NELEM
      DO K=1,NENEW
        IE=IE+1
        DO J=1,NODE
          NGASH=LNLOC(J,K)
          LNODE=NDLOC(NGASH)+NNODE
          IGASH= LOCIN(NGASH)
          IGASH= NDINTER(IGASH)
          XNEW = XI-CDLOC(2,NGASH)*DELEM
          YNEW = COORD(IGASH,2)
          COORD(LNODE,1)=XNEW
          COORD(LNODE,2)=YNEW
          LNODS(IE,J)=LNODE
        END DO
        LNODS(IE,MXNOD)=NODE
        LNODS(IE,MXNOD-1)=IMSET
        ELTYP(IE)='C2D8'
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IE
        CALL DNODE(IE,NODE)
      END DO
      NELEM=IE
      NNODE=NNODE+19
      RETURN
      END
      SUBROUTINE ELEV8_1R1(NDINTER,NNINTER,DELEM,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'

      PARAMETER (NNLOC = 19, NNINT = 5, NENEW = 3)
      DIMENSION NDINTER(*)
      DIMENSION LNLOC(9,NENEW),CDLOC(2,NNLOC),NDLOC(NNLOC),
     &          INLOC(NNINT),LOCIN(NNLOC)

C     DIMENSION LNLOC(9,3),CDLOC(2,19),NDLOC(19),INLOC(5),LOCIN(19)

      DATA LNLOC/ 1,11,13, 3, 6,12, 8, 2, 7,
     &           11,17,19,13,14,18,16,12,15,
     &            3,13,19, 5, 8,16,10, 4, 9/
      DATA INLOC/5,4,3,2,1/
      DATA LOCIN/5,4,3,2,1,5,4,3,2,1,5,4,3,5,2,4,5,3,1/
      DATA CDLOC/0.0D0,0.0D0,0.0D0,1.0D0,0.0D0,2.0D0,0.0D0,3.0D0,
     &           0.0D0,4.0D0,1.0D0,0.0D0,1.0D0,1.0D0,1.0D0,2.0D0,
     &           1.5D0,3.0D0,2.0D0,4.0D0,2.0D0,0.0D0,2.0D0,1.0D0,
     &           2.0D0,2.0D0,3.0D0,0.0D0,3.0D0,1.5D0,3.0D0,3.0D0,
     &           4.0D0,0.0D0,4.0D0,2.0D0,4.0D0,4.0D0/
C
      BLMIN = 1.0E30
      BLMAX = 0.0E0
      DO I=1,NNINTER-1
        IL1  = NDINTER(I)
        IL2  = NDINTER(I+1)
        X1   = COORD(IL1,1)
        Y1   = COORD(IL1,2)
        X2   = COORD(IL2,1)
        Y2   = COORD(IL2,2)
        BLELC= SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2))
        IF(BLMIN.GT.BLELC) BLMIN=BLELC
        IF(BLMAX.LT.BLELC) BLMAX=BLELC
      END DO
      IF(ABS(DELEM).LT.TOLER) DELEM = 0.5*(BLMIN+BLMAX)
C
      DO K=1,19
        NDLOC(K)=K
      END DO
      DO K=1,5
        NGASH=INLOC(K)
        NDLOC(NGASH)=NDINTER(K)-NNODE
      END DO
      IL=NDINTER(5)
      XI=COORD(IL,1)
      YI=COORD(IL,2)
      IE=NELEM
      DO K=1,NENEW
        IE=IE+1
        DO J=1,NODE
          NGASH=LNLOC(J,K)
          LNODE=NDLOC(NGASH)+NNODE
          IGASH= LOCIN(NGASH)
          IGASH= NDINTER(IGASH)
          XNEW = XI+CDLOC(1,NGASH)*DELEM
          YNEW = COORD(IGASH,2)
          COORD(LNODE,1)=XNEW
          COORD(LNODE,2)=YNEW
          LNODS(IE,J)=LNODE
        END DO
        LNODS(IE,MXNOD)=NODE
        LNODS(IE,MXNOD-1)=IMSET
        ELTYP(IE)='C2D8'
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IE
        CALL DNODE(IE,NODE)
      END DO
      NELEM=IE
      NNODE=NNODE+19
      RETURN
      END
      SUBROUTINE ELEV4_1L1(NDINTER,NNINTER,DELEM,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      PARAMETER (NNLOC = 7, NNINT = 3, NENEW = 3)
      DIMENSION NDINTER(*)
      DIMENSION LNLOC(4,NENEW),CDLOC(2,NNLOC),NDLOC(NNLOC),
     &          INLOC(NNINT),LOCIN(NNLOC)
      DATA LNLOC/ 1, 4, 5, 2, 2, 5, 7, 3, 4, 6, 7, 5/
      DATA INLOC/ 1, 4, 6/
      DATA LOCIN/ 1, 1, 1, 2, 2, 3, 3/
      DATA CDLOC/0.0D0,0.0D0,0.0D0,1.0D0,0.0D0,2.0D0,1.0D0,0.0D0,
     &           1.0D0,1.0D0,2.0D0,0.0D0,2.0D0,2.0D0/
C
      BLMIN = 1.0E30
      BLMAX = 0.0E0
      DO I=1,NNINTER-1
        IL1  = NDINTER(I)
        IL2  = NDINTER(I+1)
        X1   = COORD(IL1,1)
        Y1   = COORD(IL1,2)
        X2   = COORD(IL2,1)
        Y2   = COORD(IL2,2)
        BLELC= SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2))
        IF(BLMIN.GT.BLELC) BLMIN=BLELC
        IF(BLMAX.LT.BLELC) BLMAX=BLELC
      END DO
      IF(ABS(DELEM).LT.TOLER) DELEM = 0.5*(BLMIN+BLMAX)
C
      DO K=1,NNLOC
        NDLOC(K)=K
      END DO
      DO K=1,NNINT
        NGASH=INLOC(K)
        NDLOC(NGASH)=NDINTER(K)-NNODE
      END DO
      IL=NDINTER(1)
      XI=COORD(IL,1)
      YI=COORD(IL,2)
      IE=NELEM
      DO K=1,NENEW
        IE=IE+1
        DO J=1,NODE
          NGASH=LNLOC(J,K)
          LNODE=NDLOC(NGASH)+NNODE
          IGASH= LOCIN(NGASH)
          IGASH= NDINTER(IGASH)
          XNEW = XI-CDLOC(2,NGASH)*DELEM
          YNEW = COORD(IGASH,2)
          COORD(LNODE,1)=XNEW
          COORD(LNODE,2)=YNEW
          LNODS(IE,J)=LNODE
        END DO
        LNODS(IE,MXNOD)=NODE
        LNODS(IE,MXNOD-1)=IMSET
        ELTYP(IE)='C2D4'
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IE
        CALL DNODE(IE,NODE)
      END DO
      NELEM=IE
      NNODE=NNODE+NNLOC
      RETURN
      END
      SUBROUTINE ELEV4_1R1(NDINTER,NNINTER,DELEM,IMSET,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      PARAMETER (NNLOC = 7, NNINT = 3, NENEW = 3)
      DIMENSION NDINTER(*)
      DIMENSION LNLOC(4,NENEW),CDLOC(2,NNLOC),NDLOC(NNLOC),
     &          INLOC(NNINT),LOCIN(NNLOC)
      DATA LNLOC/ 1, 2, 5, 4, 2, 3, 7, 5, 4, 5, 7, 6/
      DATA INLOC/6,4,1/
      DATA LOCIN/ 3, 3, 2, 2, 1, 1, 1/
      DATA CDLOC/0.0D0,0.0D0,1.0D0,0.0D0,2.0D0,0.0D0,0.0D0,1.0D0,
     &           1.0D0,1.0D0,0.0D0,2.0D0,2.0D0,2.0D0/
C
      BLMIN = 1.0E30
      BLMAX = 0.0E0
      DO I=1,NNINTER-1
        IL1  = NDINTER(I)
        IL2  = NDINTER(I+1)
        X1   = COORD(IL1,1)
        Y1   = COORD(IL1,2)
        X2   = COORD(IL2,1)
        Y2   = COORD(IL2,2)
        BLELC= SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2))
        IF(BLMIN.GT.BLELC) BLMIN=BLELC
        IF(BLMAX.LT.BLELC) BLMAX=BLELC
      END DO
      IF(ABS(DELEM).LT.TOLER) DELEM = 0.5*(BLMIN+BLMAX)
C
      DO K=1,NNLOC
        NDLOC(K)=K
      END DO
      DO K=1,NNINT
        NGASH=INLOC(K)
        NDLOC(NGASH)=NDINTER(K)-NNODE
      END DO
      IL=NDINTER(NNINTER)
      XI=COORD(IL,1)
      YI=COORD(IL,2)
      IE=NELEM
      DO K=1,NENEW
        IE=IE+1
        DO J=1,NODE
          NGASH=LNLOC(J,K)
          LNODE=NDLOC(NGASH)+NNODE
          IGASH= LOCIN(NGASH)
          IGASH= NDINTER(IGASH)
          XNEW = XI+CDLOC(1,NGASH)*DELEM
          YNEW = COORD(IGASH,2)
          COORD(LNODE,1)=XNEW
          COORD(LNODE,2)=YNEW
          LNODS(IE,J)=LNODE
        END DO
        LNODS(IE,MXNOD)=NODE
        LNODS(IE,MXNOD-1)=IMSET
        ELTYP(IE)='C2D4'
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IE
        CALL DNODE(IE,NODE)
      END DO
      NELEM=IE
      NNODE=NNODE+NNLOC
      RETURN
      END
