C
C     SUBROUTINE FOR GENERATING SIDE GROOVE SPECIMEN
C
      SUBROUTINE SGROOV
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XP1(3),XP2(3),AGROOV(4),KAXI(3)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. SGROOV'
C
      TEXT='NOW EXCUTING SUB. SGROOV'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      KEY_GROOVE=1
    1 READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:2).EQ.'**') THEN
        GOTO 1
      ELSE IF(INDEX(STRING,'BOX').NE.0 .OR. 
     1        STRING(1:8).EQ.'*POLYGON'      ) THEN
        READ(IO_INPUT,*) XP1,XP2
        GOTO 1
      ELSE IF(STRING(1:15).EQ.'*SIDE GROOVE=YX') THEN
        KEY_GROOVE=1
        KAXI(1)  = 2
        KAXI(2)  = 1
        KAXI(3)  = 3
        READ(IO_INPUT,*) AGROOV
      ELSE IF(STRING(1:15).EQ.'*SIDE GROOVE=XZ') THEN
        KEY_GROOVE=1
        KAXI(1)  = 1
        KAXI(2)  = 3
        KAXI(3)  = 2
        READ(IO_INPUT,*) AGROOV
      ELSE IF(STRING(1:15).EQ.'*SIDE GROOVE=ZY') THEN
        KEY_GROOVE=1
        KAXI(1)  = 3
        KAXI(2)  = 2
        KAXI(3)  = 1
        READ(IO_INPUT,*) AGROOV
      ELSE IF(STRING(1:15).EQ.'*SIDE GROOVE=YZ') THEN
        KEY_GROOVE=2
        KAXI(1)  = 3
        KAXI(2)  = 2
        KAXI(3)  = 1
        READ(IO_INPUT,*) AGROOV
      ELSE
        BACKSPACE IO_INPUT
      END IF
   10 CONTINUE
      X0 = AGROOV(1)
      Y0 = AGROOV(2)
      X1 = AGROOV(3)
      Y1 = AGROOV(4)
      X0 = X0 - X1
      DO IN=1,NNODE
        X=COORD(IN,1)
        Y=COORD(IN,2)
        Z=COORD(IN,3)
        XH = (X-XP1(1))*(X-XP2(1))
        YH = (Y-XP1(2))*(Y-XP2(2))
        ZH = (Z-XP1(3))*(Z-XP2(3))
        IF(XH.LT.1.0D-10.AND.YH.LT.1.0D-10.AND.ZH.LT.1.0D-10) THEN
          IF(KEY_GROOVE.EQ.1) THEN
            X=COORD(IN,KAXI(1))
            Y=COORD(IN,KAXI(2))
            XN = X + (X/X1)*X0*(Y-Y1)/(Y0-Y1)
            COORD(IN,KAXI(1)) = XN
          ELSE IF(KEY_GROOVE.EQ.2) THEN
            H = AGROOV(1)
            X=COORD(IN,KAXI(1))
            Y=COORD(IN,KAXI(2))
            X0=XP1(KAXI(1))
            Y0=XP1(KAXI(2))
            X1=XP2(KAXI(1))
            Y1=XP2(KAXI(2))
            YN = Y + (X-X0)/(X1-X0)*(Y-Y1)/(Y0-Y1)*H
            COORD(IN,KAXI(2)) = YN
          END IF
        END IF
      END DO
      RETURN
      END
C
C     SUBROUTINE FOR ROTATING MESH
C
      SUBROUTINE ROTAT2
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION AXIS(5),ANGLE(5),KWAXI(3)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MESH_ROT3D'
C
      TEXT='NOW EXCUTING SUB. MESH_ROT3D'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      KWAXI(1)=3
      KWAXI(2)=2
      KWAXI(3)=1
      KEY_ROTAT2=1
    1 READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE IO_INPUT
        GOTO 10
C     rotating whole structure along a given axis
C     KWAXI(1) corespond to radial direction  (r) default  2
C     KWAXI(2) corespond to hoop   direction  (h) default  3
C     KWAXI(3) corespond to rotat   axis      (z) default  1
C     key word is
C                      ROTAT =rhz or
C                      R     =rhz
C     for example:     R=ZYX (default)
      ELSE IF(STRING(1:1).EQ.'R') THEN
        DO LS=1,100
          IF(STRING(LS:LS).EQ.'=') GOTO 2
        END DO
    2   CONTINUE
        DO K=1,3
          IF(STRING(LS+K:LS+K).EQ.'X') KWAXI(K)=1
          IF(STRING(LS+K:LS+K).EQ.'Y') KWAXI(K)=2
          IF(STRING(LS+K:LS+K).EQ.'Z') KWAXI(K)=3
        END DO
        GOTO 1
      ELSE IF(STRING(1:1).EQ.'D') THEN
        READ(IO_INPUT,*) NSEG,XO_ROTAT2,YO_ROTAT2,
     &                   (ANGLE(I),AXIS(I),I=1,NSEG)
        GOTO 1
      END IF
   10 CONTINUE
C     IF(KWAXI(3).EQ.1) THEN
C       IRAXIS(1)=2
C       IRAXIS(2)=3
C       IRAXIS(3)=1
C     ELSE IF(KWAXI(3).EQ.2) THEN
C       IRAXIS(1)=3
C       IRAXIS(2)=1
C       IRAXIS(3)=2
C     ELSE IF(KWAXI(3).EQ.3) THEN
C       IRAXIS(1)=1
C       IRAXIS(2)=2
C       IRAXIS(3)=3
C     END IF
      DO I=1,NSEG
        ANGLE(I)=ANGLE(I)*PI/180.0E0
      END DO
      DO IN=1,NNODE
        X=COORD(IN,KWAXI(1))
        Y=COORD(IN,KWAXI(2))
        Z=COORD(IN,KWAXI(3))
        DX=X-XO_ROTAT2
        DY=Y-YO_ROTAT2
        R=SQRT(DX*DX+DY*DY)
        TH=ACOS(DX/R)
        IF(DY.LT.0.0) TH=2*PI-TH
        IF(DY.EQ.0.0.AND.DX.LT.0.0) TH=PI
        IF(DY.EQ.0.0.AND.DX.GT.0.0) TH=0.0E0
        DO K=1,NSEG-1
          IF((Z.GE.AXIS(K).AND.Z.LE.AXIS(K+1)).OR.
     &       (Z.LE.AXIS(K).AND.Z.GE.AXIS(K+1))) GOTO 20
        END DO
   20   CONTINUE
        K1=K
        K2=K1+1
        Z1=AXIS(K1)
        Z2=AXIS(K2)
        T1=ANGLE(K1)
        T2=ANGLE(K2)
        FACT=(Z-Z1)/(Z2-Z1)
        T=T1+FACT*(T2-T1)
        TN=TH+T
        X=R*COS(TN)+XO_ROTAT2
        Y=R*SIN(TN)+YO_ROTAT2
        COORD(IN,KWAXI(1))=X
        COORD(IN,KWAXI(2))=Y
      END DO
      RETURN
      END
C
C     SUBROUTINE FOR GENERATING 3-D mesh from 2-D mesh
C
      SUBROUTINE MESH3DNEW
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NN_SCZ(5),ND_SCZ(5,20),SCZ_DI(5,20),NDU(MXNSET),
     & JRRAY(4),XZ(2),IAXI(2),NFACE_EL(MXESET,9),
     & XREF(5,20),ZREF(5,20),ELLEN(3),XYZOLD(3),XYZNEW(3),KWAXI(3),
     & V_EXT(20),IEL_2D(10),IEL(50),AXI(2),ELCOD(3,MXNOD)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MESH3DNEW'
C
      TEXT='NOW EXCUTING SUB. MESH3DNEW'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      KWAXI(1)=3
      KWAXI(2)=2
      KWAXI(3)=1
C
      CALL CVMAX(CBOUND(2),CBOUND(1),CBOUND(4),CBOUND(3),
     &           CBOUND(6),CBOUND(5))
C
    1 READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE IO_INPUT
        GOTO 10
C     plane translating along a given axis
      ELSE IF(STRING(1:1).EQ.'T'.OR.STRING(1:1).EQ.'R') THEN
        KEY_EXT=1
        IF(STRING(1:1).EQ.'R') KEY_EXT=2
        DO LS=1,100
          IF(STRING(LS:LS).EQ.'=') GOTO 2
        END DO
    2   CONTINUE
        DO K=1,3
          IF(STRING(LS+K:LS+K).EQ.'X') KWAXI(K)=1
          IF(STRING(LS+K:LS+K).EQ.'Y') KWAXI(K)=2
          IF(STRING(LS+K:LS+K).EQ.'Z') KWAXI(K)=3
        END DO
        GOTO 1
C     plane rotating around a given axis
      ELSE IF(STRING(1:1).EQ.'E') THEN
        READ(IO_INPUT,*) NTEXT
        READ(IO_INPUT,*) 
     &  (V_EXT(K),
     &  NN_SCZ(K),(ND_SCZ(I,K),SCZ_DI(I,K),I=1,NN_SCZ(K)),
     &  (XREF(I,K),I=1,5),
     &  (ZREF(I,K),I=1,5),K=1,NTEXT)
        GOTO 1
      ELSE IF(STRING(1:1).EQ.'P') THEN
        DO LS=1,100
          IF(STRING(LS:LS).EQ.'=') GOTO 3
        END DO
    3   CONTINUE
        IF(STRING(LS+1:LS+4).EQ.'XMAX') THEN
          KAXIS=1
          KREOD=2
          VAXIS=CBOUND(2)
        ELSE IF(STRING(LS+1:LS+4).EQ.'XMIN') THEN
          KAXIS=1
          KREOD=1
          VAXIS=CBOUND(1)
        ELSE IF(STRING(LS+1:LS+4).EQ.'YMAX') THEN
          KAXIS=2
          KREOD=2
          VAXIS=CBOUND(4)
        ELSE IF(STRING(LS+1:LS+4).EQ.'YMIN') THEN
          KAXIS=2
          KREOD=1
          VAXIS=CBOUND(3)
        ELSE IF(STRING(LS+1:LS+4).EQ.'ZMAX') THEN
          KAXIS=3
          KREOD=2
          VAXIS=CBOUND(6)
        ELSE IF(STRING(LS+1:LS+4).EQ.'ZMIN') THEN
          KAXIS=3
          KREOD=1
          VAXIS=CBOUND(5)
        ELSE IF(STRING(LS+1:LS+1).EQ.'V') THEN
          KAXIS=1
          IF(STRING(LS+2:LS+2).EQ.'Y') KAXIS=2
          IF(STRING(LS+2:LS+2).EQ.'Z') KAXIS=3
          READ(STRING(LS+3:LS+20),*) VAXIS
        END IF
        GOTO 1
      ELSE
        GOTO 1
      END IF
   10 CONTINUE
C
      DO I=1,NDMAX
        INCOD_2D(I,1)=0
        INCOD_2D(I,2)=0
      END DO
C
C     determing the in plane 2D element definition
C
      XZ(1)=VAXIS
      IAXI(1)=KAXIS
      XZ(2)=0.0
      IAXI(2)=0.0
C
      CALL DELFACE(NDU,NFACE_EL,XZ,IAXI)
C
      IE_2D=0
      LNODE_MAX=0
      DO I=2,NDU(1)
        IE=NDU(I)
        NODE=LNODS(IE,MXNOD)
        ISET=LNODS(IE,MXNOD-1)
        STRING=ELTYP(IE)
        LARRAY=NFACE_EL(I,1)-1
        IF(STRING(1:3).EQ.'C3D'.AND.LARRAY.GT.2) THEN
          NEMEM=NELEM
          DO J=1,4
            JRRAY(J)=0
          END DO
          IF(STRING(1:4).EQ.'C3D8') THEN
            NTFACE=6
            ID_FACE=1
            KEY_QUARD=1
          ELSE IF(STRING(1:4).EQ.'C3D6') THEN
            NTFACE=5
            ID_FACE=2
            KEY_QUARD=1
          ELSE IF(STRING(1:5).EQ.'C3D20') THEN
            NTFACE=6
            ID_FACE=1
            KEY_QUARD=2
          ELSE IF(STRING(1:5).EQ.'C3D15') THEN
            NTFACE=5
            ID_FACE=7
            KEY_QUARD=2
          END IF
          DO J=1,LARRAY
            JRRAY(J)=NFACE_EL(I,J+1)
          END DO
          STRING=' '
          DO J=1,LARRAY
            WRITE(STRING(J:J),'(I1)') JRRAY(J)
          END DO
          DO KFACE=1,NTFACE
            IF(STRING(1:4).EQ.CFACE_DF(KFACE,ID_FACE)) GOTO 200
          END DO
  200     CONTINUE
          IE_2D=IE_2D+1
          NODE_2D=LARRAY*KEY_QUARD
          LNODS_2D(IE_2D,MXNOD_2D)=NODE_2D
          LNODS_2D(IE_2D,MXNOD_2D-1)=ISET
          DO J=1,NODE_2D
            INODE=NFACE_DF(J,KFACE,ID_FACE)
            LNODE=LNODS(IE,INODE)
            LNODS_2D(IE_2D,J)=LNODE
            IF(LNODE.GT.LNODE_MAX) LNODE_MAX=LNODE
            INCOD_2D(LNODE,1)=1
          END DO
        ELSE IF(STRING(1:3).EQ.'C2D') THEN
          NEMEM=0
          IE_2D=IE_2D+1
          NODE_2D=NODE
          KEY_QUARD=1
          IF(NODE_2D.GT.4) KEY_QUARD=2
          LNODS_2D(IE_2D,MXNOD_2D)=NODE_2D
          LNODS_2D(IE_2D,MXNOD_2D-1)=ISET
          IF(KREOD.EQ.2) THEN
          DO J=1,NODE_2D
            LNODE=LNODS(IE,J)
            LNODS_2D(IE_2D,J)=LNODE
            IF(LNODE.GT.LNODE_MAX) LNODE_MAX=LNODE
            INCOD_2D(LNODE,1)=1
          END DO
          ELSE IF(KREOD.EQ.1) THEN
            IF(NODE_2D.EQ.3) THEN
              LNODS_2D(IE_2D,1)=LNODS(IE,1)
              LNODS_2D(IE_2D,2)=LNODS(IE,3)
              LNODS_2D(IE_2D,3)=LNODS(IE,2)
            ELSE IF(NODE_2D.EQ.4) THEN
              LNODS_2D(IE_2D,1)=LNODS(IE,1)
              LNODS_2D(IE_2D,2)=LNODS(IE,4)
              LNODS_2D(IE_2D,3)=LNODS(IE,3)
              LNODS_2D(IE_2D,4)=LNODS(IE,2)
            ELSE IF(NODE_2D.EQ.6) THEN
              LNODS_2D(IE_2D,1)=LNODS(IE,1)
              LNODS_2D(IE_2D,2)=LNODS(IE,3)
              LNODS_2D(IE_2D,3)=LNODS(IE,2)
              LNODS_2D(IE_2D,4)=LNODS(IE,6)
              LNODS_2D(IE_2D,5)=LNODS(IE,5)
              LNODS_2D(IE_2D,6)=LNODS(IE,4)
            ELSE IF(NODE_2D.EQ.8) THEN
              LNODS_2D(IE_2D,1)=LNODS(IE,1)
              LNODS_2D(IE_2D,2)=LNODS(IE,4)
              LNODS_2D(IE_2D,3)=LNODS(IE,3)
              LNODS_2D(IE_2D,4)=LNODS(IE,2)
              LNODS_2D(IE_2D,5)=LNODS(IE,8)
              LNODS_2D(IE_2D,6)=LNODS(IE,7)
              LNODS_2D(IE_2D,7)=LNODS(IE,6)
              LNODS_2D(IE_2D,8)=LNODS(IE,5)
            END IF
            DO J=1,NODE_2D
              LNODE=LNODS_2D(IE_2D,J)
              IF(LNODE.GT.LNODE_MAX) LNODE_MAX=LNODE
              INCOD_2D(LNODE,1)=1
            END DO
          END IF
        END IF
      END DO
      IF(NEMEM.EQ.0) THEN
        DO IMSET=1,MXMSET
          MATSET(IMSET,1)=1
        END DO
      END IF
      NNODE_2D=0
      NELEM_2D=IE_2D
      DO I=1,LNODE_MAX
        IF(INCOD_2D(I,1).NE.0) THEN
          NNODE_2D=NNODE_2D+1
          INCOD_2D(I,1)=NNODE_2D
          INCOD_2D(NNODE_2D,2)=I
        END IF
      END DO
      DO IE_2D=1,NELEM_2D
        NODE=LNODS_2D(IE_2D,MXNOD_2D)
        DO J=1,NODE
          LNODE=LNODS_2D(IE_2D,J)
          LNODS_2D(IE_2D,J)=INCOD_2D(LNODE,1)
        END DO
      END DO
      CALL DELENGTH(NDU,ELLEN)
      IENEW=NEMEM
      NDMEM=NNODE
      IN=LNODS_2D(1,1)
      LN=INCOD_2D(IN,2)
      VEX1=COORD(LN,KAXIS)
      VEXT0=VEXT1
      DO ITEXT=1,NTEXT
        NNL1=ND_SCZ(1,ITEXT)
        SCL=SCZ_DI(1,ITEXT)
        VEX2=V_EXT(ITEXT)
        VEXL=VEX2-VEX1
        ST=0.0E0
        DO INL=1,NNL1
          ST=ST+SCL**(INL-1)
        END DO
        EL0=VEXL/ST
        X1=XREF(1,ITEXT)
        X2=XREF(2,ITEXT)
        X3=XREF(3,ITEXT)
        X4=XREF(4,ITEXT)
        X5=XREF(5,ITEXT)
        Z1=ZREF(1,ITEXT)
        Z2=ZREF(2,ITEXT)
        Z3=ZREF(3,ITEXT)
        Z4=ZREF(4,ITEXT)
        Z5=ZREF(5,ITEXT)
        DX21=X2-X1
        DX32=X3-X2
        DX43=X4-X3
        DX54=X5-X4
        IF(DX32*DX21.LT.0.0) DX32=0.0E0
        IF(DX43*DX21.LT.0.0) DX43=0.0E0
        IF(DX54*DX21.LT.0.0) DX54=0.0E0
        DZ21=Z2-Z1
        DZ32=Z3-Z2
        DZ43=Z4-Z3
        DZ54=Z5-Z4
        IF(DZ32*DZ21.LT.0.0) DZ32=0.0E0
        IF(DZ43*DZ21.LT.0.0) DZ43=0.0E0
        IF(DZ54*DZ21.LT.0.0) DZ54=0.0E0
        IF(KEY_EXT.EQ.1) THEN
          NNL=NNL1
          DEXT=EL0
          DO INL=1,NNL1
            DEXT=EL0*SCL**(INL-1)
            DO INODE_2D=1,NNODE_2D
              LN=INCOD_2D(INODE_2D,2)
              DO K=1,3
                XYZOLD(K)=COORD(LN,K)
              END DO
              VW1AXI=XYZOLD(KWAXI(1))
              VW2AXI=XYZOLD(KWAXI(2))
              VW3AXI=XYZOLD(KWAXI(3))
              IF((X1.LE.VW1AXI.AND.VW1AXI.LE.X2).OR.
     &           (X2.LE.VW1AXI.AND.VW1AXI.LE.X1)) THEN
                FACT=(VW1AXI-X1)/(X2-X1)
                ZM=Z1+FACT*(Z2-Z1)
              ELSE IF((X2.LE.VW1AXI.AND.VW1AXI.LT.X3).OR.
     &                (X3.LT.VW1AXI.AND.VW1AXI.LE.X2)) THEN
                FACT=(VW1AXI-X2)/(X3-X2)
                ZM=Z2+FACT*(Z3-Z2)
              ELSE IF((X3.LE.VW1AXI.AND.VW1AXI.LT.X4).OR.
     &                (X4.LT.VW1AXI.AND.VW1AXI.LE.X3)) THEN
                FACT=(VW1AXI-X3)/(X4-X3)
                ZM=Z3+FACT*(Z4-Z3)
              ELSE IF((X4.LE.VW1AXI.AND.VW1AXI.LE.X5).OR.
     &                (X5.LE.VW1AXI.AND.VW1AXI.LE.X4)) THEN
                FACT=(VW1AXI-X4)/(X5-X4)
                ZM=Z4+FACT*(Z5-Z4)
              END IF
              IF(KEY_QUARD.EQ.1) THEN
                INNEW=INODE_2D+(INL-1)*NNODE_2D+NDMEM
                VEXT=VEXT0+DEXT
                XYZNEW(KWAXI(1))=VW1AXI+VEXT/VEXL*(ZM-VW1AXI)
                XYZNEW(KWAXI(2))=VW2AXI
                XYZNEW(KWAXI(3))=VW3AXI+VEXT
                COORD(INNEW,KWAXI(1))=XYZNEW(KWAXI(1))
                COORD(INNEW,KWAXI(2))=XYZNEW(KWAXI(2))
                COORD(INNEW,KWAXI(3))=XYZNEW(KWAXI(3))
              ELSE IF(KEY_QUARD.EQ.2) THEN
                INNEW=INODE_2D+2*(INL-1)*NNODE_2D+NDMEM
                VEXT=VEXT0+DEXT/2.0E0
                XYZNEW(KWAXI(1))=VW1AXI+VEXT/VEXL*(ZM-VW1AXI)
                XYZNEW(KWAXI(2))=VW2AXI
                XYZNEW(KWAXI(3))=VW3AXI+VEXT
                COORD(INNEW,KWAXI(1))=XYZNEW(KWAXI(1))
                COORD(INNEW,KWAXI(2))=XYZNEW(KWAXI(2))
                COORD(INNEW,KWAXI(3))=XYZNEW(KWAXI(3))
                INNEW=INODE_2D+(2*INL-1)*NNODE_2D+NDMEM
                VEXT=VEXT0+DEXT
                XYZNEW(KWAXI(1))=VW1AXI+VEXT/VEXL*(ZM-VW1AXI)
                XYZNEW(KWAXI(2))=VW2AXI
                XYZNEW(KWAXI(3))=VW3AXI+VEXT
                COORD(INNEW,KWAXI(1))=XYZNEW(KWAXI(1))
                COORD(INNEW,KWAXI(2))=XYZNEW(KWAXI(2))
                COORD(INNEW,KWAXI(3))=XYZNEW(KWAXI(3))
              END IF
            END DO
            VEXT0=VEXT0+DEXT
          END DO
        ELSE IF(KEY_EXT.EQ.2) THEN
          DEXT=EL0
          NNL1=ND_SCZ(1,ITEXT)
          SCL1=SCZ_DI(1,ITEXT)
          NNL2=ND_SCZ(2,ITEXT)
          SCL2=SCZ_DI(2,ITEXT)
          NNL=NNL1+NNL2
          XO=X1
          ZO=Z1
          XE=0.0E0
          ZE=0.0E0
          PHAI1=0.0E0
          VEXL1=DZ21+DZ32+DZ43+DZ54
          VEXL2=DX21+DX32+DX43+DX54
          CALL CLEL0(NNL1,SCL1,EL01,VEXL1)
          CALL CLEL0(NNL2,SCL2,EL02,VEXL2)
          DO INL=1,NNL1+NNL2
            IF(INL.LE.NNL1) THEN
              XE=VEXL2
              DZE=EL01*SCL1**(INL-1)
              ZE=ZE+DZE
            ELSE
              ZE=VEXL1
              DXE=EL02*SCL2**(INL-NNL1-1)
              XE=XE-DXE
            END IF
            DO INODE_2D=1,NNODE_2D
              LN=INCOD_2D(INODE_2D,2)
              DO K=1,3
                XYZOLD(K)=COORD(LN,K)
              END DO
              VW1AXI=XYZOLD(KWAXI(1))
              VW2AXI=XYZOLD(KWAXI(2))
              VW3AXI=XYZOLD(KWAXI(3))
              IF((X1.LE.VW1AXI.AND.VW1AXI.LE.X2).OR.
     &           (X2.LE.VW1AXI.AND.VW1AXI.LE.X1)) THEN
                FACT=(VW1AXI-X1)/(X2-X1)
                A=(X2-X1)*FACT
                C=(Z2-Z1)*FACT
              ELSE IF((X2.LT.VW1AXI.AND.VW1AXI.LE.X3).OR.
     &                (X3.LE.VW1AXI.AND.VW1AXI.LT.X2)) THEN
                FACT=(VW1AXI-X2)/(X3-X2)
                A=X2-X1+FACT*(X3-X2)
                C=Z2-Z1+FACT*(Z3-Z2)
              ELSE IF((X3.LT.VW1AXI.AND.VW1AXI.LE.X4).OR.
     &                (X4.LE.VW1AXI.AND.VW1AXI.LT.X3)) THEN
                FACT=(VW1AXI-X1)/(X4-X1)
                A=X3-X1+FACT*(X4-X3)
                C=Z3-Z1+FACT*(Z4-Z3)
              ELSE IF((X4.LT.VW1AXI.AND.VW1AXI.LE.X5).OR.
     &                (X5.LE.VW1AXI.AND.VW1AXI.LT.X4)) THEN
                FACT=(VW1AXI-X4)/(X5-X4)
                A=X4-X1+FACT*(X5-X4)
                C=Z4-Z1+FACT*(Z5-Z4)
              END IF
              IF((INL.GT.NNL1.AND.ABS(C-ZE).LT.TOLER).OR.
     &                (INL.LE.NNL1.AND.ABS(A-XE).LT.TOLER)) THEN
                XM=XE
                ZM=ZE
                KEY=1
              ELSE IF(XE.EQ.0.0) THEN
                XM=0.0E0
                ZM=C
                KEY=0
              ELSE IF(ZE.EQ.0.0) THEN
                XM=A
                ZM=0.0E0
                KEY=0
              ELSE IF(ABS(A).EQ.0.0.OR.ABS(C).EQ.0.0) THEN
                XM=0.0E0
                ZM=0.0E0
                KEY=2
              ELSE
C               A=ABS(A)
C               C=ABS(C)
                KEY=0
                CALL FELLIP(A,C,XE,ZE,XM,ZM)
              END IF
              IF(KEY_QUARD.EQ.1) THEN
                INNEW=INODE_2D+(INL-1)*NNODE_2D+NDMEM
                XYZNEW(KWAXI(1))=XO+XM
                XYZNEW(KWAXI(2))=VW2AXI
                XYZNEW(KWAXI(3))=ZO+ZM
                COORD(INNEW,KWAXI(1))=XYZNEW(KWAXI(1))
                COORD(INNEW,KWAXI(2))=XYZNEW(KWAXI(2))
                COORD(INNEW,KWAXI(3))=XYZNEW(KWAXI(3))
              ELSE IF(KEY_QUARD.EQ.2) THEN
                INNEW=INODE_2D+(2*INL-1)*NNODE_2D+NDMEM
                XYZNEW(KWAXI(1))=XO+XM
                XYZNEW(KWAXI(2))=VW2AXI
                XYZNEW(KWAXI(3))=ZO+ZM
                COORD(INNEW,KWAXI(1))=XYZNEW(KWAXI(1))
                COORD(INNEW,KWAXI(2))=XYZNEW(KWAXI(2))
                COORD(INNEW,KWAXI(3))=XYZNEW(KWAXI(3))
                IF(KEY.EQ.0) THEN
                  IF(XM.NE.0.0) THEN
                    PHAI2=ATAN(ABS(ZM*A/XM/C))
                  ELSE
                    PHAI2=PI/2.0E0
C                   PHAI2=SIGN(PHAI2,ZM)
                  END IF
                  PHAI=0.5E0*(PHAI1+PHAI2)
C                 A=ABS(A)
C                 C=ABS(C)
                  XM=A*COS(PHAI)
                  ZM=C*SIN(PHAI)
                ELSE IF(KEY.EQ.1) THEN
                  IF(INL.LE.NNL1) THEN
                    XM=XE
                    ZM=ZE-0.5E0*DZE
                  ELSE
                    XM=XE+0.5E0*DXE
                    ZM=ZE
                  END IF
                ELSE IF(KEY.EQ.2) THEN
                  XM=0.0E0
                  ZM=0.0E0
                END IF
                INNEW=INODE_2D+2*(INL-1)*NNODE_2D+NDMEM
                XYZNEW(KWAXI(1))=XO+XM
                XYZNEW(KWAXI(2))=VW2AXI
                XYZNEW(KWAXI(3))=ZO+ZM
                COORD(INNEW,KWAXI(1))=XYZNEW(KWAXI(1))
                COORD(INNEW,KWAXI(2))=XYZNEW(KWAXI(2))
                COORD(INNEW,KWAXI(3))=XYZNEW(KWAXI(3))
              END IF
            END DO
            PHAI1=PHAI2
            IF(KEY_QUARD.EQ.2) THEN
              DO IE_2D=1,NELEM_2D
                DO J=1,4
                  JM=4+J
                  J1=J
                  J2=J+1
                  IF(J2.GT.4) J2=1
                  LN1=LNODS_2D(IE_2D,J1)+(2*INL-1)*NNODE_2D+NDMEM
                  LN2=LNODS_2D(IE_2D,J2)+(2*INL-1)*NNODE_2D+NDMEM
                  LNM=LNODS_2D(IE_2D,JM)+(2*INL-1)*NNODE_2D+NDMEM
                  COORD(LNM,1)=0.5E0*(COORD(LN1,1)+COORD(LN2,1))
                  COORD(LNM,2)=0.5E0*(COORD(LN1,2)+COORD(LN2,2))
                  COORD(LNM,3)=0.5E0*(COORD(LN1,3)+COORD(LN2,3))
                END DO
              END DO
            END IF
          END DO
        END IF
        NTNUM0=NTNUM
        DO INL=1,NNL
          DO IE_2D=1,NELEM_2D
            NODE_2D=LNODS_2D(IE_2D,MXNOD_2D)
            ISET_2D=LNODS_2D(IE_2D,MXNOD_2D-1)
            ISET_NEW=ISET_2D
            IENEW=IENEW+1
            DO K=1,NODE_2D
              IF(KEY_QUARD.EQ.1) THEN
                IEL_2D(K)=LNODS_2D(IE_2D,K)+NNODE+(INL-2)*NNODE_2D
              ELSE IF(KEY_QUARD.EQ.2) THEN
                IEL_2D(K)=LNODS_2D(IE_2D,K)+NNODE+(2*INL-3)*NNODE_2D
              END IF
            END DO
            IF(NODE_2D.EQ.3) THEN
              NODE_NEW=6
              ELTYP(IENEW)='C3D6'
              IEL(1)=IEL_2D(1)
              IEL(2)=IEL_2D(2)
              IEL(3)=IEL_2D(3)
              IEL(4)=IEL_2D(1)+NNODE_2D
              IEL(5)=IEL_2D(2)+NNODE_2D
              IEL(6)=IEL_2D(3)+NNODE_2D
            ELSE IF(NODE_2D.EQ.4) THEN
              NODE_NEW=8
              ELTYP(IENEW)='C3D8'
              IEL(1)=IEL_2D(1)
              IEL(2)=IEL_2D(2)
              IEL(3)=IEL_2D(3)
              IEL(4)=IEL_2D(4)
              IEL(5)=IEL_2D(1)+NNODE_2D
              IEL(6)=IEL_2D(2)+NNODE_2D
              IEL(7)=IEL_2D(3)+NNODE_2D
              IEL(8)=IEL_2D(4)+NNODE_2D
            ELSE IF(NODE_2D.EQ.6) THEN
              NODE_NEW=15
              ELTYP(IENEW)='C3D15'
              IEL( 1)=IEL_2D(1)
              IEL( 2)=IEL_2D(2)
              IEL( 3)=IEL_2D(3)
              IEL( 4)=IEL_2D(1)+NNODE_2D*2
              IEL( 5)=IEL_2D(2)+NNODE_2D*2
              IEL( 6)=IEL_2D(3)+NNODE_2D*2
              IEL( 7)=IEL_2D(4)
              IEL( 8)=IEL_2D(5)
              IEL( 9)=IEL_2D(6)
              IEL(10)=IEL_2D(4)+NNODE_2D*2
              IEL(11)=IEL_2D(5)+NNODE_2D*2
              IEL(12)=IEL_2D(6)+NNODE_2D*2
              IEL(13)=IEL_2D(1)+NNODE_2D
              IEL(14)=IEL_2D(2)+NNODE_2D
              IEL(15)=IEL_2D(3)+NNODE_2D
            ELSE IF(NODE_2D.EQ.8) THEN
              NODE_NEW=20
              ELTYP(IENEW)='C3D20'
              IEL( 1)=IEL_2D(1)
              IEL( 2)=IEL_2D(2)
              IEL( 3)=IEL_2D(3)
              IEL( 4)=IEL_2D(4)
              IEL( 5)=IEL_2D(1)+NNODE_2D*2
              IEL( 6)=IEL_2D(2)+NNODE_2D*2
              IEL( 7)=IEL_2D(3)+NNODE_2D*2
              IEL( 8)=IEL_2D(4)+NNODE_2D*2
              IEL( 9)=IEL_2D(5)
              IEL(10)=IEL_2D(6)
              IEL(11)=IEL_2D(7)
              IEL(12)=IEL_2D(8)
              IEL(13)=IEL_2D(5)+NNODE_2D*2
              IEL(14)=IEL_2D(6)+NNODE_2D*2
              IEL(15)=IEL_2D(7)+NNODE_2D*2
              IEL(16)=IEL_2D(8)+NNODE_2D*2
              IEL(17)=IEL_2D(1)+NNODE_2D
              IEL(18)=IEL_2D(2)+NNODE_2D
              IEL(19)=IEL_2D(3)+NNODE_2D
              IEL(20)=IEL_2D(4)+NNODE_2D
            END IF
            IF(INL.EQ.1) THEN
              IF(NODE_2D.LE.4) THEN
                DO K=1,NODE_2D
                  IN=LNODS_2D(IE_2D,K)
                  IEL(K)=INCOD_2D(IN,2)
                END DO
              ELSE
                NN=NODE_2D/2
                DO K=1,NN
                  IN=LNODS_2D(IE_2D,K)
                  IEL(K)=INCOD_2D(IN,2)
                  IN=LNODS_2D(IE_2D,K+NN)
                  IEL(K+NODE_2D)=INCOD_2D(IN,2)
                END DO
              END IF
            END IF
            DO K=1,NODE_NEW
              LNODS(IENEW,K)=IEL(K)
            END DO
            MATSET(ISET_NEW,1)=MATSET(ISET_NEW,1)+1
            MATSET(ISET_NEW,MATSET(ISET_NEW,1))=IENEW
            LNODS(IENEW,MXNOD)=NODE_NEW
            LNODS(IENEW,MXNOD-1)=ISET_NEW
            CALL DNODE(IENEW,LNODS(IENEW,MXNOD))
          END DO
        END DO
        IF(NTEXT.GT.1) THEN
          DO I=1,NNODE_2D
            IN=I+(NNL*KEY_QUARD-1)*NNODE_2D+NDMEM
            INCOD_2D(IN,1)=I
            INCOD_2D(I,2)=IN
          END DO
        END IF
        NNESUF=NESUF(MXESET)
        NELEM=IENEW
        NNODE=NNODE+INL*NNODE_2D*KEY_QUARD
        NDMEM=NNODE
        NEMEM=NELEM
        VEX1=VEX2
        VEXT0=VEXT1
      END DO
C
      IF(KEY_EXT.EQ.1) RETURN
      XZ(1)=XO
      XZ(2)=ZO
      IAXI(1)=KWAXI(1)
      IAXI(2)=KWAXI(3)
      CALL DELFACE(IESET(1,1),NFACE_EL,XZ,IAXI)
      IF(IESET(1,1).LT.2) RETURN
      DO I=2,IESET(1,1)
        IE=IESET(I,1)
        NODE=LNODS(IE,MXNOD)
        ID_FACE=1
        IF(NODE.EQ.20) ID_FACE=4
        STRING=ELTYP(IE)
        LARRAY=NFACE_EL(I,1)-1
        IF(LARRAY.GT.2) THEN
          DO J=1,LARRAY
            JRRAY(J)=NFACE_EL(I,J+1)
          END DO
C         CALL ARRANGI(JRRAY,LARRAY,ND_ARRAY)
          DO J=1,LARRAY
            WRITE(STRING(J:J),'(I1)') JRRAY(J)
          END DO
          DO KFACE=1,6
            IF(STRING(1:4).EQ.CFACE_DF(KFACE,ID_FACE)) GOTO 300
          END DO
  300     CONTINUE
          IF(KFACE.EQ.3.OR.KFACE.EQ.5) THEN
            IEL(MXNOD)=NODE
            IEL(1)=LNODS(IE,5)
            IEL(2)=LNODS(IE,6)
            IEL(3)=LNODS(IE,2)
            IEL(4)=LNODS(IE,1)
            IEL(5)=LNODS(IE,8)
            IEL(6)=LNODS(IE,7)
            IEL(7)=LNODS(IE,3)
            IEL(8)=LNODS(IE,4)
            IF(NODE.EQ.20) THEN
              IEL( 9)=LNODS(IE,13)
              IEL(10)=LNODS(IE,18)
              IEL(11)=LNODS(IE, 9)
              IEL(12)=LNODS(IE,17)
              IEL(13)=LNODS(IE,15)
              IEL(14)=LNODS(IE,19)
              IEL(15)=LNODS(IE,11)
              IEL(16)=LNODS(IE,20)
              IEL(17)=LNODS(IE,16)
              IEL(18)=LNODS(IE,14)
              IEL(19)=LNODS(IE,10)
              IEL(20)=LNODS(IE,12)
            END IF
          ELSE IF(KFACE.EQ.4.OR.KFACE.EQ.6) THEN
            IEL(MXNOD)=NODE
            IEL(1)=LNODS(IE,2)
            IEL(2)=LNODS(IE,6)
            IEL(3)=LNODS(IE,7)
            IEL(4)=LNODS(IE,3)
            IEL(5)=LNODS(IE,1)
            IEL(6)=LNODS(IE,5)
            IEL(7)=LNODS(IE,8)
            IEL(8)=LNODS(IE,4)
            IF(NODE.EQ.20) THEN
              IEL( 9)=LNODS(IE,18)
              IEL(10)=LNODS(IE,14)
              IEL(11)=LNODS(IE,19)
              IEL(12)=LNODS(IE,10)
              IEL(13)=LNODS(IE,17)
              IEL(14)=LNODS(IE,16)
              IEL(15)=LNODS(IE,20)
              IEL(16)=LNODS(IE,12)
              IEL(17)=LNODS(IE, 9)
              IEL(18)=LNODS(IE,13)
              IEL(19)=LNODS(IE,15)
              IEL(20)=LNODS(IE,11)
            END IF
          ELSE
            DO J=1,MXNOD
              IEL(J)=LNODS(IE,J)
            END DO
          END IF
          DO J=1,NODE
            DO K=1,3
              ELCOD(K,J)=COORD(IEL(J),K)
            END DO
          END DO
          CALL RELORD(ELCOD,IEL,MXNOD,TOLER)
          NODE=IEL(MXNOD)
          IF(NODE.EQ.15) THEN
            ELTYP(IE)='C3D15'
          ELSE IF(NODE.EQ.6) THEN
            ELTYP(IE)='C3D6'
          END IF
          LNODS(IE,MXNOD)=NODE
          DO J=1,NODE
            LNODS(IE,J)=IEL(J)
          END DO
          CALL DNODE(IE,NODE)
        END IF
      END DO
C
      TEXT='END OF EXCUTING SUB. MESH3DNEW'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
      SUBROUTINE RELORD(ELCOD,IEL,MXNOD,TOLER)
      REAL*8 TOLER,ELCOD(3,MXNOD),X1,X2,Y1,Y2,Z1,Z2,DIST
      INTEGER J,IEL(MXNOD),J1,IE,IEL_OLD(40)
      NODE=IEL(MXNOD)
      DO J=1,MXNOD
        IEL_OLD(J)=IEL(J)
        IEL(J)=0 
      END DO
      DO J=1,8
        J1=J+1
              IF(J.EQ.4) J1=1
              IF(J.EQ.8) J1=5
              X1=ELCOD(1,J)
              Y1=ELCOD(2,J)
              Z1=ELCOD(3,J)
              X2=ELCOD(1,J1)
              Y2=ELCOD(2,J1)
              Z2=ELCOD(3,J1)
              DIST=SQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1)+(Z2-Z1)*(Z2-Z1))
              IF(DIST.LT.TOLER) GOTO 251
            END DO
  251       CONTINUE
            IF(J.EQ.1) THEN
              IEL(1)=IEL_OLD(1)
              IEL(2)=IEL_OLD(5)
              IEL(3)=IEL_OLD(6)
              IEL(4)=IEL_OLD(4)
              IEL(5)=IEL_OLD(8)
              IEL(6)=IEL_OLD(7)
              IF(NODE.EQ.20) THEN
                IEL( 7)=IEL_OLD(17)
                IEL( 8)=IEL_OLD(13)
                IEL( 9)=IEL_OLD(18)
                IEL(10)=IEL_OLD(20)
                IEL(11)=IEL_OLD(15)
                IEL(12)=IEL_OLD(19)
                IEL(13)=IEL_OLD(12)
                IEL(14)=IEL_OLD(16)
                IEL(15)=IEL_OLD(14)
              END IF
            ELSE IF(J.EQ.5) THEN
              IEL(1)=IEL_OLD(1)
              IEL(2)=IEL_OLD(5)
              IEL(3)=IEL_OLD(2)
              IEL(4)=IEL_OLD(4)
              IEL(5)=IEL_OLD(8)
              IEL(6)=IEL_OLD(3)
              IF(NODE.EQ.20) THEN
                IEL( 7)=IEL_OLD(17)
                IEL( 8)=IEL_OLD(18)
                IEL( 9)=IEL_OLD( 9)
                IEL(10)=IEL_OLD(20)
                IEL(11)=IEL_OLD(19)
                IEL(12)=IEL_OLD(21)
                IEL(13)=IEL_OLD(12)
                IEL(14)=IEL_OLD(16)
                IEL(15)=IEL_OLD(10)
              END IF
            ELSE IF(J.EQ.2) THEN
              IEL(1)=IEL_OLD(1)
              IEL(2)=IEL_OLD(8)
              IEL(3)=IEL_OLD(5)
              IEL(4)=IEL_OLD(2)
              IEL(5)=IEL_OLD(7)
              IEL(6)=IEL_OLD(6)
              IF(NODE.EQ.20) THEN
                IEL( 7)=IEL_OLD(20)
                IEL( 8)=IEL_OLD(16)
                IEL( 9)=IEL_OLD(17)
                IEL(10)=IEL_OLD(19)
                IEL(11)=IEL_OLD(14)
                IEL(12)=IEL_OLD(18)
                IEL(13)=IEL_OLD( 9)
                IEL(14)=IEL_OLD(15)
                IEL(15)=IEL_OLD(13)
              END IF
            ELSE IF(J.EQ.6) THEN
              IEL(1)=IEL_OLD(1)
              IEL(2)=IEL_OLD(4)
              IEL(3)=IEL_OLD(8)
              IEL(4)=IEL_OLD(2)
              IEL(5)=IEL_OLD(3)
              IEL(6)=IEL_OLD(7)
              IF(NODE.EQ.20) THEN
                IEL( 7)=IEL_OLD(12)
                IEL( 8)=IEL_OLD(20)
                IEL( 9)=IEL_OLD(17)
                IEL(10)=IEL_OLD(10)
                IEL(11)=IEL_OLD(19)
                IEL(12)=IEL_OLD(18)
                IEL(13)=IEL_OLD( 9)
                IEL(14)=IEL_OLD(11)
                IEL(15)=IEL_OLD(15)
              END IF
            END IF
      IF(NODE.EQ.20)  THEN
        NODE=15
      ELSE IF(NODE.EQ.8)  THEN
        NODE=6
      END IF
      IEL(MXNOD)=NODE
      RETURN
      END
C
      SUBROUTINE DELENGTH(NDU,ELLEN)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION ELLEN(3),NDU(MXNSET),INLEN(3)
      DO K=1,3
        ELLEN(K)=0.0
      END DO
      DO I=2,NDU(1)
        IE=NDU(I)
        NODE=LNODS(IE,MXNOD)
        IN0 =LNODS(IE,1)
        IF(ELTYP(IE)(1:4).EQ.'C3D8'.OR.
     &      ELTYP(IE)(1:5).EQ.'C3D20') THEN
          INLEN(1)=LNODS(IE,2)
          INLEN(2)=LNODS(IE,4)
          INLEN(3)=LNODS(IE,5)
        ELSE IF(ELTYP(IE)(1:4).EQ.'C3D6'.OR.
     &      ELTYP(IE)(1:5).EQ.'C3D15') THEN
          INLEN(1)=LNODS(IE,2)
          INLEN(2)=LNODS(IE,3)
          INLEN(3)=LNODS(IE,4)
        ELSE IF(ELTYP(IE)(1:4).EQ.'C2D4'.OR.
     &      ELTYP(IE)(1:4).EQ.'C2D8') THEN
          INLEN(1)=LNODS(IE,2)
          INLEN(2)=LNODS(IE,4)
          INLEN(3)=0
        ELSE IF(ELTYP(IE)(1:4).EQ.'C2D3'.OR.
     &      ELTYP(IE)(1:4).EQ.'C2D6') THEN
          INLEN(1)=LNODS(IE,2)
          INLEN(2)=LNODS(IE,3)
          INLEN(3)=0
        END IF
        DO K=1,3
          IN=INLEN(K)
          IF(IN.GT.0) THEN
            DO J=1,3
              EL=COORD(IN,J)-COORD(IN0,J)
              IF(ABS(EL).GT.ELLEN(J)) ELLEN(J)=ABS(EL)
            END DO
          END IF
        END DO
      END DO
      RETURN
      END
C
      SUBROUTINE FELLIP(A,C,XE,ZE,XM,ZM)
      IMPLICIT REAL*8(A-H,O-Z)
      FACT=ABS(XE/ZE)
      FACT2=FACT*FACT
      ZM=SQRT(1.0E0/(FACT2/A/A+1.0E0/C/C))
      XM=FACT*ZM
      XM=SIGN(XM,XE)
      ZM=SIGN(ZM,ZE)
      RETURN
      END
C
      SUBROUTINE CLEL0(NNL,SCL,EL0,VEXL)
      REAL*8 SCL,EL0,VEXL,ST
      INTEGER NNL,INL
      ST=0.0E0
      DO INL=1,NNL
        ST=ST+SCL**(INL-1)
      END DO
      EL0=VEXL/ST
      RETURN
      END
C
C
C     SUBROUTINE FOR GENERATING 3-D shallow crack mesh form 2-D mesh
C
      SUBROUTINE MESH_SHALLOW1
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION KWORK(28)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MESH_SHALLOW1'
C
      TEXT='NOW EXCUTING SUB. MESH_SHALLOW1'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      READ(IO_INPUT,*) 
     &  KEY_SHALLOW,NZ1,NZ2,SCZ1,SCZ2,Z_width,X_width,AXIS_X,AXIS_Z
C
      CALL CVMAX(CBOUND(2),CBOUND(1),CBOUND(4),CBOUND(3),
     &           CBOUND(6),CBOUND(5))
C
      X_width=CBOUND(1)-CBOUND(2)
C
      DO K=1,2
        CALL SEAND(INSET(1,K),1,CBOUND(K),NNSET(K),1)
      END DO
C
      CALL SEAEL(IESET(1,1),1,CBOUND(1),NESET(1))
C
      IF(KEY_SHALLOW.EQ.1) THEN
        DO K=1,NNSET(1)
          INCOD(INSET(K,1))=-1
        END DO
        DO K=1,NESET(1)
          LNODS_2D(IESET(K,1),MXNOD_2D-2)=-1
        END DO
      END IF
C
      ST=0.0
      DO I=1,NZ1
        ST=ST+SCZ1**(I-1)
      END DO
      ZL1=Z_width/ST
      ZLN1=ZL1*SCZ1**(NZ1-1)
      IF(SCZ2.EQ.1.0) THEN
        ZLN2=X_width/NZ2
        IF(ZLN2.LT.ABS(ZLN1)) THEN
          NZ2=NINT(X_width/ABS(ZLN1))
          ZLN2=X_width/NZ2
        END IF
        ZL2=ZLN2
      ELSE
        ST=0.0
        DO I=1,NZ2
          ST=ST+SCZ2**(I-1)
        END DO
        ZL2=X_width/ST
      END IF
C
      R_width=SQRT(X_width*X_width+Z_width*Z_width)
C
      IF(XORIGN.NE.AXIS_X)THEN
        DX=AXIS_X-XORIGN
        DO IN=1,NNODE
          COORD(IN,1)=COORD(IN,1)+DX
        END DO
      END IF
      DO IE=1,NELEM
        LNODS_2D(IE,MXNOD_2D)=LNODS(IE,MXNOD)
        LNODS_2D(IE,MXNOD_2D-1)=LNODS(IE,MXNOD-1)
        DO J=1,LNODS_2D(IE,MXNOD_2D)
          LNODS_2D(IE,J)=LNODS(IE,J)
        END DO
      END DO
C
      INC=NNODE
      IET=0
      DO I=1,MXMSET
        MATSET(I,1)=1
      END DO
      SHALLOW_Z=0.0
      SHALLOW_X=X_width
      DO I=1,NZ1
        SHALLOW_Z=SHALLOW_Z+ZL1*SCZ1**(I-1)
        IF(SHALLOW_Z.NE.0.0) THEN
          TANTH=SHALLOW_X*AXIS_Z/SHALLOW_Z/AXIS_X
          TH=ATAN(TANTH)
          IF(SHALLOW_Z.LT.0.0) TH=PI+TH
        ELSE IF(SHALLOW_Z.EQ.0.0) THEN
          TH=PI/2.0
          IF(SHALLOW_X.LT.0.0) TH=3.0*PI/2.0
        END IF
        ELLIP_X=AXIS_X*SIN(TH)
        ELLIP_Z=AXIS_Z*COS(TH)
        ELLIP_R=SQRT(ELLIP_X*ELLIP_X+ELLIP_Z*ELLIP_Z)
        DO IN=1,NNODE
          INC=INC+1
          X_2D=COORD(IN,1)
          Y_2D=COORD(IN,2)
          KEY_ED=INCOD(IN)
          X_3D=0.0
          Y_3D=0.0
          Z_3D=0.0
          IF(KEY_ED.NE.-1) THEN
            Y_3D=Y_2D
            IF(X_2D.LE.AXIS_X) THEN
              X_3D=X_2D/AXIS_X*ELLIP_X         
              Z_3D=X_2D/AXIS_X*ELLIP_Z         
            ELSE IF(X_2D.GT.AXIS_X) THEN
              X_3D=ELLIP_X         
              Z_3D=ELLIP_Z         
              X_3D=X_3D+
     &        (SHALLOW_X-ELLIP_X)*(X_2D-AXIS_X)/(X_width-AXIS_X)
              Z_3D=Z_3D+
     &        (SHALLOW_Z-ELLIP_Z)*(X_2D-AXIS_X)/(X_width-AXIS_X)
            END IF
            COORD(INC,1)=X_3D
            COORD(INC,2)=Y_3D
            COORD(INC,3)=Z_3D
          END IF
        END DO
      END DO
C
      SHALLOW_X=X_width
      SHALLOW_Z=Z_width
      DO I=1,NZ2
        SHALLOW_X=SHALLOW_X-ZL2*SCZ2**(I-1)
        IF(I.EQ.NZ2) SHALLOW_X=0.0
        IF(SHALLOW_X.NE.0.0.AND.SHALLOW_Z.NE.0.0) THEN
          TANTH=SHALLOW_X*AXIS_Z/SHALLOW_Z/AXIS_X
          TH=ATAN(TANTH)
          IF(SHALLOW_Z.LT.0.0) TH=PI+TH
        ELSE IF(SHALLOW_Z.EQ.0.0) THEN
          TH=PI/2.0
          IF(SHALLOW_X.LT.0.0) TH=3.0*PI/2.0
        ELSE IF(SHALLOW_X.EQ.0.0) THEN
          TH=0.0
          IF(SHALLOW_Z.LT.0.0) TH=PI
        END IF
        ELLIP_X=AXIS_X*SIN(TH)
        ELLIP_Z=AXIS_Z*COS(TH)
        SHALLOW_R=SQRT(SHALLOW_X*SHALLOW_X+SHALLOW_Z*SHALLOW_Z)
        ELLIP_R=SQRT(ELLIP_X*ELLIP_X+ELLIP_Z*ELLIP_Z)
        DIST=SHALLOW_R-ELLIP_R
        DO IN=1,NNODE
          INC=INC+1
          X_2D=COORD(IN,1)
          Y_2D=COORD(IN,2)
          KEY_ED=INCOD(IN)
          X_3D=0.0
          Y_3D=0.0
          Z_3D=0.0
          IF(KEY_ED.NE.-1) THEN
            Y_3D=Y_2D
            IF(X_2D.LE.AXIS_X) THEN
              X_3D=X_2D/AXIS_X*ELLIP_X         
              Z_3D=X_2D/AXIS_X*ELLIP_Z         
            ELSE IF(X_2D.GT.AXIS_X) THEN
              X_3D=ELLIP_X         
              Z_3D=ELLIP_Z         
              FACT=(X_2D-AXIS_X)/(X_width-AXIS_X)
              IF(FACT.LT.1.0) THEN
                FACT_SC=0.5*(1.0+DIST/(X_width-AXIS_X))
                IF(FACT_SC.GT.1.0) FACT=FACT/FACT_SC
              END IF
              X_3D=X_3D+FACT*(SHALLOW_X-ELLIP_X)
              Z_3D=Z_3D+FACT*(SHALLOW_Z-ELLIP_Z)
            END IF
            COORD(INC,1)=X_3D
            COORD(INC,2)=Y_3D
            COORD(INC,3)=Z_3D
          END IF
        END DO
      END DO
C
      DO I=1,NZ1+NZ2
        DO IE=1,NELEM
          IET=IET+1
          NODE=LNODS_2D(IE,MXNOD_2D)
          IMSET=LNODS_2D(IE,MXNOD_2D-1)
          KEY_ED=LNODS_2D(IE,MXNOD_2D-2)
          IF(NODE.EQ.4) THEN
            IF(KEY_ED.EQ.-1) THEN
              NODE=6
              IMSET=IMSET+1
              LNODS(IET,1)=LNODS_2D(IE,1)
              LNODS(IET,2)=LNODS_2D(IE,2)+NNODE*(I-1)
              LNODS(IET,3)=LNODS_2D(IE,2)+NNODE*I
              LNODS(IET,4)=LNODS_2D(IE,4)
              LNODS(IET,5)=LNODS_2D(IE,3)+NNODE*(I-1)
              LNODS(IET,6)=LNODS_2D(IE,3)+NNODE*I
              LNODS(IET,MXNOD)=NODE
              LNODS(IET,MXNOD-1)=IMSET
              ELTYP(IET)='C3D6'
              MATSET(IMSET,1)=MATSET(IMSET,1)+1
              MATSET(IMSET,MATSET(IMSET,1))=IET
              CALL DNODE(IE,NODE)
            ELSE
              NODE=8
              LNODS(IET,1)=LNODS_2D(IE,1)+NNODE*(I-1)
              LNODS(IET,2)=LNODS_2D(IE,2)+NNODE*(I-1)
              LNODS(IET,3)=LNODS_2D(IE,2)+NNODE*I
              LNODS(IET,4)=LNODS_2D(IE,1)+NNODE*I
              LNODS(IET,5)=LNODS_2D(IE,4)+NNODE*(I-1)
              LNODS(IET,6)=LNODS_2D(IE,3)+NNODE*(I-1)
              LNODS(IET,7)=LNODS_2D(IE,3)+NNODE*I
              LNODS(IET,8)=LNODS_2D(IE,4)+NNODE*I
              LNODS(IET,MXNOD)=NODE
              LNODS(IET,MXNOD-1)=IMSET
              ELTYP(IET)='C3D8'
              MATSET(IMSET,1)=MATSET(IMSET,1)+1
              MATSET(IMSET,MATSET(IMSET,1))=IET
              CALL DNODE(IE,NODE)
            END IF
          ELSE IF(NODE.EQ.8) THEN
          END IF
        END DO
      END DO
      ICOCOORD=1
      NNODE=INC
      NELEM=IET
C
      TEXT='END OF EXCUTING SUB. MESH_SHALLOW1'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
C     SUBROUTINE FOR GENERATING 3-D shallow crack mesh form 2-D mesh
C
      SUBROUTINE MESH_SHALLOW2
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION ZTHICKP(MXZNUM),X_ELLIP2(2,MXZNUM),Z_ELLIP2(2,MXZNUM),
     &          FAI_ANGLE(MXZNUM),XZ(2),IAXI(2),NFACE_EL(MXESET,9),
     &          JRRAY(4),IEL(20)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MESH_SHALLOW2'
C
      TEXT='NOW EXCUTING SUB. MESH_SHALLOW2'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      CALL CVMAX(CBOUND(2),CBOUND(1),CBOUND(4),CBOUND(3),
     &           CBOUND(6),CBOUND(5))
C
      DO I=1,MXZNUM
        ZTHICK (I)=0.0
        ZTHICKP(I)=0.0
      END DO
      CALL DTHICK
      CALL DTHICKP(CBOUND(2),K_AXIS(2),ZTHICKP,NTNUMP)
      DO I=1,NTNUM
        ZTHICK(I)=-1.0*ZTHICK(I)
      END DO
      CALL ARRANG(ZTHICK,NTNUM,MXZNUM)
      DO I=1,NTNUM
        ZTHICK(I)=-1.0*ZTHICK(I)
      END DO
      DO I=1,NTNUMP
        ZTHICKP(I)=-1.0*ZTHICKP(I)
      END DO
      CALL ARRANG(ZTHICKP,NTNUMP,MXZNUM)
      DO I=1,NTNUMP
        ZTHICKP(I)=-1.0*ZTHICKP(I)
      END DO
      DO I=NTNUM,1,-1
        Z=ZTHICK(I)
        ER=1.0D-5*ABS(ZTHICK(I))+1.0D-15
        DO K=NTNUMP,1,-1
          IF(ABS(ZTHICKP(K)-Z).LT.ER) THEN
            ZTHICKP(I)=ZTHICKP(K)
            IF(K.NE.I) ZTHICKP(K)=0.0
          END IF
        END DO
      END DO
C
      NZWPO1=NINT(0.5*NTNUM)
      NZWPO=NINT(0.62*NTNUM)
      IF(NTNUM.GT.20) THEN
        NZWPO=NINT(0.67*NTNUM)
      ELSE IF(NTNUM.LT.12) THEN
        NZWPO=NINT(0.51*NTNUM)
      END IF
      IKEEP=10000000
      DO I=1,NTNUM
        IF(ZTHICKP(I).NE.0.0) THEN
          IF(IABS(I-NZWPO).LE.IKEEP) THEN
            IKEEP=IABS(I-NZWPO)
            NZWPO_KEEP=I
          END IF
        END IF
      END DO
      NZWPO=NZWPO_KEEP
      READ(IO_INPUT,*) C_ELLIP1,A_ELLIP1,C_ELLIP2
C
      BT=CBOUND(2)-CBOUND(1)
      WD=CBOUND(5)-CBOUND(6)
C
      ZWD1=ZTHICK(NZWPO)-ZTHICK(1)
      ZWD2=ZTHICK(NTNUM)-ZTHICK(NZWPO)
      FAIB1=ATAN(WD/BT)
      FAIB2=-PI/2.0-FAIB1
C
      A_ELLIP0=0.0
      C_ELLIP0=0.0
      A_ELLIP2=(C_ELLIP2-C_ELLIP1)/(BT-C_ELLIP1)*
     &          (ABS(WD)-A_ELLIP1)+A_ELLIP1
      A_ELLIP3=ABS(WD)
      C_ELLIP3=BT
C
      X0=CBOUND(1)
      Z0=CBOUND(6)
      X1=X0+C_ELLIP1
      X2=X0+C_ELLIP2
      X3=X0+C_ELLIP3
C
      DO KTHICK=1,NTNUM
        Z=ZTHICK(KTHICK)
        ETA1=(Z-Z0)/ZWD1
        IF(ETA1.GT.1.0) ETA1=1.0
        ETA2=(Z-ZWD1-Z0)/ZWD2
        IF(ETA2.LT.0.0) ETA2=0.0
        FAIB=ETA1*FAIB1+ETA2*FAIB2
        IF(Z.GT.ZWD1+Z0) THEN
          X=C_ELLIP3
          Z=C_ELLIP3*TAN(FAIB)
        ELSE
          X=A_ELLIP3*TAN(FAIB+PI/2.0)
          Z=-A_ELLIP3
        END IF
        FAI_ANGLE(KTHICK)=FAIB
        X_ELLIP2(2,KTHICK)=X
        Z_ELLIP2(2,KTHICK)=Z
C
        TAN_FAIB=TAN(FAIB)
        THETA=ATAN(C_ELLIP2/A_ELLIP2*TAN_FAIB)
        X_ELLIP2(1,KTHICK)=C_ELLIP2*COS(THETA)
        Z_ELLIP2(1,KTHICK)=A_ELLIP2*SIN(THETA)
        IF(KTHICK.EQ.NTNUM) THEN
        X_ELLIP2(1,KTHICK)=0.0
        X_ELLIP2(2,KTHICK)=0.0
        END IF
C
      END DO

      DO INODE=1,NNODE
        X=COORD(INODE,1)
        Y=COORD(INODE,2)
        Z=COORD(INODE,3)
        DO KTHICK=1,NTNUM
          IF(ABS(Z-ZTHICK(KTHICK)).LT.TOLER) GOTO 50
        END DO
   50   CONTINUE
C       ETA1=(Z-Z0)/ZWD1
C       IF(ETA1.GT.1.0) ETA1=1.0
C       ETA2=(Z-ZWD1-Z0)/ZWD2
C       IF(ETA2.LT.0.0) ETA2=0.0
C       FAIB=ETA1*FAIB1+ETA2*FAIB2
        FAIB=FAI_ANGLE(KTHICK)
        TAN_FAIB=TAN(FAIB)
        IF(X0.LT.X.AND.X.LE.X1+TOLER) THEN
          C_ELLIP=X-X0
          A_ELLIP=(X-X0)/(X1-X0)*A_ELLIP1
          THETA=ATAN(C_ELLIP/A_ELLIP*TAN_FAIB)
          X_NEW=C_ELLIP*COS(THETA)
          Z_NEW=A_ELLIP*SIN(THETA)
        ELSE IF(X1.LT.X.AND.X.LE.X2+TOLER) THEN
          C_ELLIP=X-X0
          A_ELLIP=(X-X1)/(X2-X1)*(A_ELLIP2-A_ELLIP1)+A_ELLIP1
          THETA=ATAN(C_ELLIP/A_ELLIP*TAN_FAIB)
          X_NEW=C_ELLIP*COS(THETA)
          Z_NEW=A_ELLIP*SIN(THETA)
        ELSE IF(X2.LT.X) THEN
          XP1=X_ELLIP2(1,KTHICK)
          ZP1=Z_ELLIP2(1,KTHICK)
          XP2=X_ELLIP2(2,KTHICK)
          ZP2=Z_ELLIP2(2,KTHICK)
          X_NEW=(X-X2)/(X3-X2)*(XP2-XP1)+XP1
          Z_NEW=(X-X2)/(X3-X2)*(ZP2-ZP1)+ZP1
C       ELSE IF(ABS(X-X3).LT.TOLER) THEN
C         IF(Z.GT.ZWD1+Z0) THEN
C           X=C_ELLIP3
C           Z=C_ELLIP3*TAN(FAIB)
C         ELSE
C           X=A_ELLIP3*TAN(FAIB+PI/2.0)
C           Z=-A_ELLIP3
C         END IF
        ELSE IF(ABS(X-X0).LT.TOLER) THEN
          X_NEW=0.0D0
          Z_NEW=0.0D0
        END IF
        COORD(INODE,1)=X_NEW
        COORD(INODE,3)=Z_NEW
      END DO
C
      XZ(1)=0.0
      XZ(2)=0.0
      IAXI(1)=1
      IAXI(2)=3
      CALL DELFACE(IESET(1,1),NFACE_EL,XZ,IAXI)
      DO I=2,IESET(1,1)
        IE=IESET(I,1)
        NODE=LNODS(IE,MXNOD)
        STRING=ELTYP(IE)
        LARRAY=NFACE_EL(I,1)-1
        IF(STRING(1:4).EQ.'C3D8'.AND.LARRAY.GT.2) THEN
          DO J=1,LARRAY
            JRRAY(J)=NFACE_EL(I,J+1)
          END DO
C         CALL ARRANGI(JRRAY,LARRAY,ND_ARRAY)
          DO J=1,LARRAY
            WRITE(STRING(J:J),'(I1)') JRRAY(J)
          END DO
          DO KFACE=1,6
            IF(STRING(1:4).EQ.CFACE_DF(KFACE,1)) GOTO 200
          END DO
  200     CONTINUE
          IF(KFACE.GT.2) THEN
            DO J=1,NODE/2
              IN1=LNODS(IE,J)
              J1=J+1
              IF(J1.GT.NODE/2) J1=1
              IN2=LNODS(IE,J1)
              X1=COORD(IN1,1)
              Y1=COORD(IN1,2)
              Z1=COORD(IN1,3)
              X2=COORD(IN2,1)
              Y2=COORD(IN2,2)
              Z2=COORD(IN2,3)
              DIST=SQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1)+(Z2-Z1)*(Z2-Z1))
              IF(DIST.LT.TOLER) GOTO 250
            END DO
  250       CONTINUE
            IF(J1.NE.1) THEN
              LNODS(IE,J1)=0
              LNODS(IE,J1+4)=0
            ELSE
              LNODS(IE,J)=0
              LNODS(IE,J+4)=0
            END IF
            JN=0
            DO J=1,NODE
              IF(LNODS(IE,J).NE.0) THEN
                JN=JN+1
                IEL(JN)=LNODS(IE,J)
              END IF
            END DO
          ELSE
            DO J=1,NODE
              IN1=LNODS(IE,J)
              J1=J+1
              IF(J1.GT.NODE) J1=1
              IN2=LNODS(IE,J1)
              X1=COORD(IN1,1)
              Y1=COORD(IN1,2)
              Z1=COORD(IN1,3)
              X2=COORD(IN2,1)
              Y2=COORD(IN2,2)
              Z2=COORD(IN2,3)
              DIST=SQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1)+(Z2-Z1)*(Z2-Z1))
              IF(DIST.LT.TOLER) GOTO 251
            END DO
  251       CONTINUE
            IF(J.EQ.1) THEN
              IEL(1)=LNODS(IE,1)
              IEL(2)=LNODS(IE,5)
              IEL(3)=LNODS(IE,6)
              IEL(4)=LNODS(IE,4)
              IEL(5)=LNODS(IE,8)
              IEL(6)=LNODS(IE,7)
            ELSE IF(J.EQ.5) THEN
              IEL(1)=LNODS(IE,1)
              IEL(2)=LNODS(IE,5)
              IEL(3)=LNODS(IE,2)
              IEL(4)=LNODS(IE,4)
              IEL(5)=LNODS(IE,8)
              IEL(6)=LNODS(IE,3)
            ELSE IF(J.EQ.2) THEN
              IEL(1)=LNODS(IE,1)
              IEL(2)=LNODS(IE,8)
              IEL(3)=LNODS(IE,5)
              IEL(4)=LNODS(IE,2)
              IEL(5)=LNODS(IE,7)
              IEL(6)=LNODS(IE,6)
            ELSE IF(J.EQ.6) THEN
              IEL(1)=LNODS(IE,1)
              IEL(2)=LNODS(IE,4)
              IEL(3)=LNODS(IE,8)
              IEL(4)=LNODS(IE,2)
              IEL(5)=LNODS(IE,3)
              IEL(6)=LNODS(IE,7)
            END IF
          END IF
          NODE=6
          LNODS(IE,MXNOD)=NODE
          ELTYP(IE)='C3D6'
          DO J=1,NODE
            LNODS(IE,J)=IEL(J)
          END DO
          CALL DNODE(IE,NODE)
        END IF
      END DO
C
C     CALL COCOORD
C
      TEXT='END OF EXCUTING SUB. MESH_SHALLOW2'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
C     SUBROUTINE FOR DETERMINING THICKNESS COORDINATES
C
      SUBROUTINE DTHICK
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      NTNUM=0
      DO INODE=1,NNODE
        Z=COORD(INODE,3)
        IF(NTNUM.EQ.0) THEN
          NTNUM=NTNUM+1
          ZTHICK(NTNUM)=Z
        ELSE IF(NTNUM.GT.0) THEN
          KEY=0
          DO K=1,NTNUM
            ER=1.0D-5*ABS(ZTHICK(K))+1.0D-15
            IF(ABS(ZTHICK(K)-Z).LE.ER) KEY=1
          END DO
          IF(KEY.NE.1) THEN
            NTNUM=NTNUM+1
            ZTHICK(NTNUM)=Z
          END IF
        END IF
      END DO
      RETURN
      END
C
C     SUBROUTINE FOR DETERMINING THICKNESS COORDINATES AT GIVEN LINE
C
      SUBROUTINE DTHICKP(CP_GIVEN,IP_AXIS,ZTHICKP,NTNUMP)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION ZTHICKP(MXZNUM)
C
      NTNUMP=0
      CP_ER=1.0D-5*ABS(CP_GIVEN)+1.0D-15
      DO INODE=1,NNODE
        Z=COORD(INODE,3)
        CP=COORD(INODE,IP_AXIS)
        IF(ABS(CP-CP_GIVEN).LT.CP_ER) THEN
          IF(NTNUMP.EQ.0) THEN
            NTNUMP=NTNUMP+1
            ZTHICKP(NTNUMP)=Z
          ELSE IF(NTNUMP.GT.0) THEN
            KEY=0
            DO K=1,NTNUMP
              ER=1.0D-5*ABS(ZTHICKP(K))+1.0D-15
              IF(ABS(ZTHICKP(K)-Z).LE.ER) GOTO 100
            END DO
            NTNUMP=NTNUMP+1
            ZTHICKP(NTNUMP)=Z
          END IF
        END IF
  100   CONTINUE
      END DO
      RETURN
      END
C
      SUBROUTINE ARRANG(ARRAY,LARRAY,ND_ARRAY)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION ARRAY(ND_ARRAY)
      IF(LARRAY.GT.ND_ARRAY) THEN
        WRITE(*,1000) 'ARRAY out bound in ARRANG:',LARRAY,ND_ARRAY
        STOP
      END IF
 1000 FORMAT(A,' Required=',I10,' Current=',I10)
      REF=0.0
      DO I=1,LARRAY
        JR=I
        REF=ARRAY(I)
        DO J=I+1,LARRAY
          IF(ARRAY(J).LT.REF) THEN
            JR=J
            REF=ARRAY(J)
          END IF
        END DO
        IF(JR.NE.I) THEN
          AM=ARRAY(I)
          ARRAY(I)=ARRAY(JR)
          ARRAY(JR)=AM
        END IF
      END DO
      RETURN
      END
C
      SUBROUTINE DELFACE(NDU,NFACE_EL,XZ,IAXI)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDU(MXESET),XZ(2),IAXI(2),NFACE_EL(MXESET,9),AXI(3)
C
      NDU(1)=1
      DO I=1,NELEM
        NODE=LNODS(I,MXNOD)
        IF(ELTYP(I)(1:4).EQ.'ICOH'.OR.
     &     ELTYP(I)(1:1).EQ.'I')  GOTO 100
        IF(ELTYP(I)(1:4).EQ.'C2D3'.OR.
     &     ELTYP(I)(1:4).EQ.'C2D4'.OR.
     &     ELTYP(I)(1:4).EQ.'C3D6'.OR.
     &     ELTYP(I)(1:4).EQ.'C3D8') THEN
          NN=NODE
        ELSE IF(ELTYP(I)(1:4).EQ.'C2D6'.OR.
     &          ELTYP(I)(1:4).EQ.'C2D8') THEN
          NN=NODE/2
        ELSE IF(ELTYP(I)(1:5).EQ.'C3D15') THEN
          NN=6
        ELSE IF(ELTYP(I)(1:5).EQ.'C3D20') THEN
          NN=8
        END IF
        NFACE_EL(NDU(1)+1,1)=1
        KEY=0
        DO J=1,NN
          IN=LNODS(I,J)
          X=XZ(1)
          Z=XZ(2)
          IF(KEY_ROTAT2.EQ.0) THEN
            IF(IAXI(1).GT.0) X=COORD(IN,IAXI(1))
            IF(IAXI(2).GT.0) Z=COORD(IN,IAXI(2))
          ELSE
            X=COORD(IN,IRAXIS(1))
            Y=COORD(IN,IRAXIS(2))
            Z=COORD(IN,IRAXIS(3))
            DX=X-XO_ROTAT2
            DY=Y-YO_ROTAT2
            RO=SQRT(DX*DX+DY*DY)
            TH=ACOS(DX/RO)
            IF(DY.LT.0.0) TH=2*PI-TH
            IF(DY.EQ.0.0.AND.DX.LT.0.0) TH=PI
            IF(DY.EQ.0.0.AND.DX.GT.0.0) TH=0.0E0
            AXI(1)=RO
            AXI(2)=TH
            AXI(3)=Z
            X=XZ(1)
            Z=XZ(2)
            IF(IAXI(1).GT.0) X=AXI(IAXI(1))
            IF(IAXI(2).GT.0) Z=AXI(IAXI(2))
          END IF
          IF(ABS(X-XZ(1)).LT.TOLER.AND.
     &       ABS(Z-XZ(2)).LT.TOLER) THEN
            KEY=1
            NDU(NDU(1)+1)=I
            NFACE_EL(NDU(1)+1,1)=NFACE_EL(NDU(1)+1,1)+1
            NFACE_EL(NDU(1)+1,NFACE_EL(NDU(1)+1,1))=J
          END IF
        END DO
        IF(KEY.EQ.1) THEN
          NDU(1)=NDU(1)+1
        END IF
  100   CONTINUE
      END DO
      RETURN
      END
C
      SUBROUTINE DELFACE1(NDU,NFACE_EL,XZ,IAXI)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDU(MXESET),XZ(2),IAXI(2),NFACE_EL(MXESET,9),AXI(3)
C
      DO I=2,NDU(1)
        IE=NDU(I)
        NODE=LNODS(IE,MXNOD)
        IF(ELTYP(IE)(1:4).EQ.'C2D3'.OR.
     &     ELTYP(IE)(1:4).EQ.'C2D4'.OR.
     &     ELTYP(IE)(1:4).EQ.'C3D6'.OR.
     &     ELTYP(IE)(1:4).EQ.'C3D8') THEN
          NN=NODE
        ELSE IF(ELTYP(IE)(1:4).EQ.'C2D6'.OR.
     &          ELTYP(IE)(1:4).EQ.'C2D8') THEN
          NN=NODE/2
        ELSE IF(ELTYP(IE)(1:5).EQ.'C3D15') THEN
          NN=6
        ELSE IF(ELTYP(IE)(1:5).EQ.'C3D20') THEN
          NN=8
        END IF
        NFACE_EL(I,1)=1
        KEY=0
        DO J=1,NN
          IN=LNODS(IE,J)
          X=XZ(1)
          Z=XZ(2)
          IF(IAXI(1).GT.0) X=COORD(IN,IAXI(1))
          IF(IAXI(2).GT.0) Z=COORD(IN,IAXI(2))
          FACT=0.0E0
          DO K=1,NTNUM
            INTIP=NDTIP(K,3)
            IF(IN.EQ.INTIP) FACT=1.0E0
            INTIP=NDTIP(K,4)
            IF(IN.EQ.INTIP) FACT=1.0E0
            IF(NDTIP(K,1).GT.2) THEN
              INTIP=NDTIP(K,NDTIP(K,1)-1)
              IF(IN.EQ.INTIP) FACT=1.0E0
            END IF
            IF(NDTIP(K,1).GT.3) THEN
              INTIP=NDTIP(K,NDTIP(K,1)-2)
              IF(IN.EQ.INTIP) FACT=1.0E0
            END IF
          END DO
          X=X+2.0*TOLER*FACT
          IF(ABS(X-XZ(1)).LT.TOLER.AND.
     &       ABS(Z-XZ(2)).LT.TOLER) THEN
            KEY=1
            NFACE_EL(I,1)=NFACE_EL(I,1)+1
            NFACE_EL(I,NFACE_EL(I,1))=J
          END IF
        END DO
      END DO
      RETURN
      END
C
      SUBROUTINE ARRANGI(JRRAY,LARRAY,ND_ARRAY)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION JRRAY(ND_ARRAY)
      IF(LARRAY.GT.ND_ARRAY) THEN
        WRITE(*,1000) 'JRRAY out bound in ARRANG:',LARRAY,ND_ARRAY
        STOP
      END IF
 1000 FORMAT(A,' Required=',I10,' Current=',I10)
      REF=0.0
      DO I=1,LARRAY
        JR=I
        IREF=JRRAY(I)
        DO J=I+1,LARRAY
          IF(JRRAY(J).LT.IREF) THEN
            JR=J
            IREF=JRRAY(J)
          END IF
        END DO
        IF(JR.NE.I) THEN
          IM=JRRAY(I)
          JRRAY(I)=JRRAY(JR)
          JRRAY(JR)=IM
        END IF
      END DO
      RETURN
      END
C
C     SUBROUTINE FOR GENERATING 3-D mesh form 2-D mesh
C
      SUBROUTINE MESHROT3D
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION TRANS(3),KWAXI(3)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MESH3D'
C
      TEXT='NOW EXCUTING SUB. MESH_ROT3D'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      KWAXI(1)   = 2
      KWAXI(2)   = 3
      KWAXI(3)   = 1
      XO         = 0.0E0
      YO         = 0.0E0
      AM         = 1.0E0
      TH_REF     = 90.0E0
      KEY_ROTAT2 = 1
C
      CALL CVMAX(CBOUND(2),CBOUND(1),CBOUND(4),CBOUND(3),
     &           CBOUND(6),CBOUND(5))
C
    1 READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE IO_INPUT
        GOTO 10
C     rotating whole structure along a given axis
C     KWAXI(1) corespond to radial direction  (r)
C     KWAXI(2) corespond to hoop   direction  (h)
C     KWAXI(3) corespond to rotat   axis      (z)
C     key word is
C                      ROTAT =rhz or
C                      R     =rhz
C     for example:     R=ZYX (default)
      ELSE IF(STRING(1:1).EQ.'R') THEN
        DO LS=1,100
          IF(STRING(LS:LS).EQ.'=') GOTO 2
        END DO
    2   CONTINUE
        DO K=1,3
          IF(STRING(LS+K:LS+K).EQ.'X') KWAXI(K)=1
          IF(STRING(LS+K:LS+K).EQ.'Y') KWAXI(K)=2
          IF(STRING(LS+K:LS+K).EQ.'Z') KWAXI(K)=3
        END DO
        IF(STRING(LS+1:LS+3).NE.'XYZ'.AND.
     &     STRING(LS+1:LS+3).NE.'YZX'.AND.
     &     STRING(LS+1:LS+3).NE.'ZXY') AM=-1.0E0
        READ(IO_INPUT,*) XO,YO,TH_REF,VV_REF
        TH_REF=TH_REF*PI/180.0E0
        GOTO 1
      ELSE IF(STRING(1:1).EQ.'T') THEN
        READ(IO_INPUT,*) TRANS
        GOTO 1
      END IF
   10 CONTINUE
      IF(KWAXI(3).EQ.1) THEN
        IRAXIS(1)=2
        IRAXIS(2)=3
        IRAXIS(3)=1
      ELSE IF(KWAXI(3).EQ.2) THEN
        IRAXIS(1)=3
        IRAXIS(2)=1
        IRAXIS(3)=2
      ELSE IF(KWAXI(3).EQ.3) THEN
        IRAXIS(1)=1
        IRAXIS(2)=2
        IRAXIS(3)=3
      END IF
      IF(VV_REF.LE.0.0) THEN
        CALL CVMAX(CBOUND(2),CBOUND(1),CBOUND(4),CBOUND(3),
     &           CBOUND(6),CBOUND(5))
        VV_REF=CBOUND(2*KWAXI(2))
      END IF
C
      DO I=1,NNODE
        IF(INCOD(I).GT.0) THEN
          DO J=1,3
            COORD(I,J)=COORD(I,J)+TRANS(J)
          END DO
          X=COORD(I,KWAXI(1))
          Y=COORD(I,KWAXI(2))
          Z=COORD(I,KWAXI(3))
          R=ABS(X-XO)
          T=Y-YO
          T=(T/VV_REF)*TH_REF
          X_NEW=R*COS(T)*AM
          Y_NEW=R*SIN(T)
          COORD(I,KWAXI(1))=X_NEW
          COORD(I,KWAXI(2))=Y_NEW
          COORD(I,KWAXI(3))=Z
        END IF
      END DO
C
      TEXT='END OF EXCUTING SUB. MESH_ROT3D'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
C     SUBROUTINE FOR GENERATING 3-D curved crack front
C
      SUBROUTINE CFRONT
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
       WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. CFRONT'
       WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. CFRONT'
C
      TEXT='NOW EXCUTING SUB. CFRONT'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      IFRONT=1
      CALL GETLINE (LEN,IERR)
      DO I = 1,4
         ITYPE(I) = 2
      ENDDO
      INVAR = 4
      CALL SLVLINE (STRING,LEN,IERR)
      A_ELLIP1 = 0.0
      A_ELLIP2 = RVARR(1)
      A_ELLIP3 = RVARR(2)
      A_ELLIP4 = RVARR(3)
      A_ELLIP5 = 0.0
      IF (RVARR(4).GT.TOLER) THEN
         C_ELLIP = RVARR(4)
      ELSE
         C_ELLIP = THICK
      ENDIF
      ZMAX = C_ELLIP*C_ELLIP
      READ(IO_INPUT,*) X1,X2,X3,X4,X5
      IF(X3.NE.XTIP) X3=XTIP
C---  print *,"thickness:",c_ellip
C---  print *,"stuetzstellen:",x1,x2,x3,x4,x5
C
      DO I=1,NNODE
        IF(INCOD(I).NE.0) THEN
          IN=INCOD(I)
          X=COORD(IN,1)
          Y=COORD(IN,2)
          Z=COORD(IN,3)
          DZ=Z-ZTIP
	  IF (DZ.GE.C_ELLIP) GOTO 100
          IF(X.GT.X1.AND.X.LT.X2) THEN
            A_ELLIP = A_ELLIP1+(X-X1)/(X2-X1)*(A_ELLIP2-A_ELLIP1)
            X_NEW   = X+A_ELLIP*SQRT(1.0-DZ*DZ/ZMAX)
          ELSE IF(X.GE.X2.AND.X.LT.X3) THEN
            A_ELLIP = A_ELLIP2+(X-X2)/(X3-X2)*(A_ELLIP3-A_ELLIP2)
            X_NEW   = X+A_ELLIP*SQRT(1.0-DZ*DZ/ZMAX)
          ELSE IF(X.GE.X3.AND.X.LT.X4) THEN
            A_ELLIP = A_ELLIP3+(X-X3)/(X4-X3)*(A_ELLIP4-A_ELLIP3)
            X_NEW   = X+A_ELLIP*SQRT(1.0-DZ*DZ/ZMAX)
          ELSE IF(X.GE.X4.AND.X.LT.X5) THEN
            A_ELLIP = A_ELLIP4+(X-X4)/(X5-X4)*(A_ELLIP5-A_ELLIP4)
            X_NEW   = X+A_ELLIP*SQRT(1.0-DZ*DZ/ZMAX)
	  ELSE
	    X_NEW   = X
          END IF
          COORD(IN,1)=X_NEW
        END IF
 100    CONTINUE
      END DO
      ELLIP_C=A_ELLIP2
      ELLIP_A=C_ELLIP
      RETURN
      END
