C *** SUBROUTINE FOR APPLYING elastic K-Field for Bi-Material
C *** of perpendicular crack
      SUBROUTINE BLFBPV
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      READ(IO_INPUT,*) YOUNG1,POISS1,YOUNG2,POISS2,
     &  PHI,BLF_X0,BLF_Y0,BLF_R0,SIGMA0
      IF(SIGMA0.LE.0.0) SIGMA0=300.0D0
      PHI  = PHI*PI/180.0E0
      AKI1 = COS(PHI)
      AKI2 = SIN(PHI)
      SIG0 = SIGMA0    
      G1   = 0.5E0*YOUNG1/(1.0E0+POISS1)
      G2   = 0.5E0*YOUNG2/(1.0E0+POISS2)
      C1   = 4.0E0*(1.0E0-POISS1)/G1
      C2   = 4.0E0*(1.0E0-POISS2)/G2
      RKP1 = 3.0-4.0*POISS1
      RKP2 = 3.0-4.0*POISS2
      AFA  = (G1*(1.0E0-POISS2)-G2*(1.0E0-POISS1))/
     &       (G1*(1.0E0-POISS2)+G2*(1.0E0-POISS1))
      BFA  = (G1*(1.0E0-2.0E0*POISS2)-G2*(1.0E0-2.0E0*POISS1))/
     &       (G1*(1.0E0-POISS2)+G2*(1.0E0-POISS1))
      BFA  = 0.5E0*BFA
      EPSI = 0.5E0/PI*LOG((1.0E0-BFA)/(1.0E0+BFA))
      PSI  = ATAN(2.0E0*EPSI)
      SRB  = DSQRT(BLF_R0)
      CON1 = 0.5E0/SQRT(2.0E0*PI)/COSH(PI*EPSI)*SRB
      CON2 = 0.125E0*2.0*C2/(C1+C2)*BLF_R0
      CON3 = 0.125E0*2.0*C1/(C1+C2)*BLF_R0
      CON4 = 1.0E0/SQRT(1.0E0+4.0E0*EPSI*EPSI)
      NNBLF=0
 3002 format(3i5,12f12.5)
      IF(BLF_R0.GT.0.0D0) THEN
        KCONT=1
        DO IN=1,NNODE
          X=COORD(IN,1)
          Y=COORD(IN,2)
          R=SQRT((X-BLF_X0)**2+(Y-BLF_Y0)**2)
          IF(ABS(R-BLF_R0).LT.1.0E-6*BLF_R0) THEN
            KCONT=KCONT+1
            NDBLF(KCONT)=IN
          END IF
        END DO
        NDBLF(1)=KCONT
      END IF
   15 CONTINUE
      NNBLF=0
      DO I=2,NDBLF(1)
        IN=NDBLF(I)
        X=COORD(IN,1)
        Y=COORD(IN,2)
        Z=COORD(IN,3)
        DX=X-XORIGN
        DY=Y-YORIGN
        RK=DSQRT(DX*DX+DY*DY)
        TT=DASIN(ABS(DY/RK))
        IF(DX.LT.0.0.AND.DY.GT.0.0) TT = PI-TT
        IF(DX.LT.0.0.AND.DY.LE.0.0) TT =-PI+TT
        IF(DX.GE.0.0.AND.DY.LT.0.0) TT =-TT
        IF(ABS(TT).LT.1.D-8) TT = 0.0E0
        IF(ABS(TT-PI).LT.1.D-8) TT = PI
        RWORK(I) =TT
        THI   = TT - PI
        IF(TT.LT.0.0E0) THI = TT + PI
        PSI1  = PSI + 0.5E0*TT - PHI
        PSI2  = PSI - 0.5E0*TT - PHI
        PHI2  = PHI + 0.5E0*TT
        AG1   = EXP( EPSI*THI)
        AG2   = EXP(-EPSI*THI)
        CPSI1 = COS(PSI1)
        CPSI2 = COS(PSI2)
        SPSI1 = SIN(PSI1)
        SPSI2 = SIN(PSI2)
        CPHI2 = COS(PHI2)
        SPHI2 = SIN(PHI2)
        CTH   = COS(TT)
        STH   = SIN(TT)
        IF(TT.GE.0.0E0) THEN
          GX  = (RKP1*CON4*AG1*CPSI1-CON4*AG2*CPSI2+AG1*STH*SPHI2)
          GY  = (RKP1*CON4*AG1*SPSI1-CON4*AG2*SPSI2-AG1*STH*CPHI2)
          GX  = GX/G1
          GY  = GY/G1
          GXT = CON2*(RKP1+1.0E0)*CTH/G1
          GYT = CON2*(RKP1-3.0E0)*STH/G1
        ELSE
          GX  = (RKP2*CON4*AG1*CPSI1-CON4*AG2*CPSI2+AG1*STH*SPHI2)
          GY  = (RKP2*CON4*AG1*SPSI1-CON4*AG2*SPSI2-AG1*STH*CPHI2)
          GX  = GX/G2
          GY  = GY/G2
          GXT = CON3*(RKP2+1.0E0)*CTH/G2
          GYT = CON3*(RKP2-3.0E0)*STH/G2
        END IF
        UB    = CON1*GX
        VB    = CON1*GY
        UBT   = GXT
        VBT   = GYT
        NNBLF = NNBLF+1
        NFBLF(NNBLF)=IN*10+1
        VVBLF(NNBLF)=UB
        BPBLF(NNBLF)=UBT
        RWORK(NNBLF)=TT
        NNBLF=NNBLF+1
        NFBLF(NNBLF)=IN*10+2
        VVBLF(NNBLF)=VB
        BPBLF(NNBLF)=VBT
        RWORK(NNBLF)=TT
      END DO
      IF(NNBLF.GT.LNB) THEN
      WRITE(2,4000) NNBLF,LNB
 4000 FORMAT(' NNBLF=',I5,'>','LNB=',I5,' PROGRAM STOP')
      STOP
      END IF
 3009 format(5x,'T STRESS PARAMETER B=',F6.3,' RK=',E12.5)
C     WRITE(9,3300) (NFBLF(K)/10,NFBLF(K)-NFBLF(K)/10*10,
C    1 RWORK(K)*180./PI,VVBLF(K),BPBLF(K),K=1,NNBLF)
 3300 FORMAT(I6,I2,3E15.5)
      RETURN
      END
