C
C     PROGRAM FOR GENERATING MODEL AND HISTORY INPUT DATA FOR ABAQUS F.E.M. CODE
C
      PROGRAM femesh
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
CCCC      INCLUDE 'mcommon1'
C
      LOGICAL FEXIST1
C
      CHARACTER FCAEDS*30
C
      CPU_TIME = 0.0D0
      CALL EVCPU(CPU_TIME)
C
      CALL INIT_DATA
C
      WRITE(IO_INFO,2000)
C
C *** INITIALIZE PARAMETERS
C
      IENSET   = 0
C
    1 CONTINUE
      CALL GETLINE (LEN,IERR)
      IF (IERR.NE.0) GOTO 99
      WRITE(IO_INFO,2010) STRING(1:LEN)
      IF(STRING(1:8).EQ.'*END PRE') THEN
        GOTO 5
      ELSE IF(STRING(1:12).EQ.'*RENEW ELSET') THEN
        CALL MRNELSET
        GOTO 1
      ELSE IF(STRING(1:6).EQ.'*SCALE') THEN
        CALL SCALE
        CALL CMINLEN
        GOTO 1
      ELSE IF(STRING(1:10).EQ.'*NO OUTPUT') THEN
        IOUT=1
        GOTO 1
      ELSE IF(STRING(1:7).EQ.'*ORIGIN') THEN
        CALL GETLINE (LEN,IERR)
        IF (IERR.NE.0) GOTO 99
	INVAR = 2
	ITYPE(1) = 2
	ITYPE(2) = 2
        CALL SLVLINE (STRING,LEN,IERR)
	XORIGIN = RVARR(1)
	YORIGIN = RVARR(2)
        GOTO 1
      ELSE IF(STRING(1:7).EQ.'*ELTYPE') THEN
        CALL GETLINE (LEN,IERR)
	INVAR = 1
	ITYPE(1) = 1
        CALL SLVLINE (STRING,LEN,IERR)
	NTYPE = IVARR(1)
	DO I = 1,NTYPE
           CALL GETLINE (LEN,IERR)
	   ELSET_TYP(I) = STRING(1:8)
	ENDDO
        GOTO 1
      ELSE IF(STRING(1:7).EQ.'*COORDI') THEN
        CALL COORDI
        GOTO 1
      ELSE IF(STRING(1:7).EQ.'*MAPE2D') THEN
        CALL MAPE2D
        CALL CMINLEN
        GOTO 1
      ELSE IF(STRING(1:14).EQ.'*SURFACE ELSET') THEN
        ISURFSET=1
        GOTO 1
      ELSE IF(STRING(1:7).EQ.'*ROTATE') THEN
        CALL ROTAT
        GOTO 1
      ELSE IF(STRING(1:5).EQ.'*FLIP') THEN
        CALL MFLIP
        GOTO 1
      ELSE IF(STRING(1:5).EQ.'*COPY') THEN
        CALL MCOPY
        GOTO 1
      ELSE IF(STRING(1:7).EQ.'*ROTAT2') THEN
        CALL ROTAT2
        GOTO 1
      ELSE IF(STRING(1:9).EQ.'*DRAWMESH') THEN
        MDRAW=1
        CALL DRAWMESH(0)
        GOTO 1
      ELSE IF(STRING(1:15).EQ.'*DRAW FREE EDGE') THEN
        CALL MDR_FR_ED(0)
        GOTO 1
      ELSE IF(STRING(1:9).EQ.'*CLOSE WI') THEN
        IWINDOW=1
        GOTO 1
      ELSE IF(STRING(1:10).EQ.'*CRACKTIP1') THEN
        CALL CRACKTIP1
        CALL CMINLEN
        GOTO 1
      ELSE IF(STRING(1:9).EQ.'*CGROWTH1') THEN
        CALL CGROWTH1
        CALL CMINLEN
        GOTO 1
      ELSE IF(STRING(1:9).EQ.'*CGROWTH2') THEN
        CALL CGROWTH2
        GOTO 1
      ELSE IF(STRING(1:9).EQ.'*CGROWTH3') THEN
        CALL CGROWTH3
        GOTO 1
      ELSE IF(STRING(1:9).EQ.'*CGROWTH4') THEN
        CALL CGROWTH4
        GOTO 1
      ELSE IF(STRING(1:9).EQ.'*BLFMESH1') THEN
        CALL BLFMESH1
        CALL CMINLEN
        GOTO 1
      ELSE IF(STRING(1:9).EQ.'*BLFMESH2') THEN
        CALL BLFMESH2
        CALL CMINLEN
        GOTO 1
      ELSE IF(STRING(1:9).EQ.'*BLFMESH3') THEN
        CALL BLFMESH3
        CALL CMINLEN
        GOTO 1
      ELSE IF(STRING(1:9).EQ.'*BLFMESH4') THEN
        CALL BLFMESH4
        CALL CMINLEN
        GOTO 1
      ELSE IF(STRING(1:12).EQ.'*MESH 3 NODE') THEN
        CALL CNV2TRI
        GOTO 1
      ELSE IF(STRING(1:8).EQ.'*CNV2TRI') THEN
        CALL CNV2TRI
        GOTO 1
      ELSE IF(STRING(1:8).EQ.'*CNV2TET') THEN
        CALL CNV2TET
        GOTO 1
      ELSE IF(STRING(1:12).EQ.'*MESH 9 NODE') THEN
        CALL mesh_9node
        GOTO 1
      ELSE IF(STRING(1: 9).EQ.'*COHESIV1') THEN
        CALL COHESIV1
        GOTO 1
      ELSE IF(STRING(1: 9).EQ.'*COHESIV3') THEN
        CALL COHESIV3
        GOTO 1
      ELSE IF(STRING(1: 5).EQ.'*CZDS') THEN
        CALL CZDS
        GOTO 1
      ELSE IF(STRING(1: 9).EQ.'*CZDOMAIN') THEN
        CALL CZDOMAIN
        GOTO 1
C     ELSE IF(STRING(1: 9).EQ.'*COHESIV2') THEN
C       CALL COHESIV2
C       GOTO 1
C      ELSE IF(STRING(1: 6).EQ.'*CZM3D   ') THEN
C        CALL CZM3DEL
C        GOTO 1
C      ELSE IF(STRING(1: 9).EQ.'*COHESIV4') THEN
C        CALL COHESIV4
C        GOTO 1
C     ELSE IF(STRING(1: 6).EQ.'*CZDS3') THEN
C       CALL CZDS3
C       GOTO 1
C     ELSE IF(STRING(1: 9).EQ.'*COHESIV5') THEN
C       CALL COHESIV5
C       GOTO 1
C     ELSE IF(STRING(1: 9).EQ.'*CZM2DEL1') THEN
C       CALL CZM2DEL1
C       GOTO 1
C      ELSE IF(STRING(1: 9).EQ.'*CZM2DEL2') THEN
C        CALL CZM2DEL2
C        GOTO 1
      ELSE IF(STRING(1: 7).EQ.'*TRANSL') THEN
        CALL TRANSCD
        GOTO 1
      ELSE IF(STRING(1: 7).EQ.'*MESHVL') THEN
        CALL MESHVL
        GOTO 1
      ELSE IF(STRING(1: 8).EQ.'*LEFMESH') THEN
        CALL LEFMESH
        GOTO 1
      ELSE IF(STRING(1: 8).EQ.'*RIGMESH') THEN
        CALL RIGMESH
        GOTO 1
      ELSE IF(STRING(1: 8).EQ.'*IRTMESH') THEN
        CALL IRTMESH
        GOTO 1
      ELSE IF(STRING(1: 8).EQ.'*IPLMESH') THEN
        CALL IPLMESH
        GOTO 1
      ELSE IF(STRING(1: 8).EQ.'*HBLF ME') THEN
        CALL MESH_HBLF
        GOTO 1
      ELSE IF(STRING(1: 8).EQ.'*FBLF ME') THEN
        CALL MESH_FBLF
        GOTO 1
      ELSE IF(STRING(1: 8).EQ.'*UPSMESH'.OR.
     &        STRING(1: 8).EQ.'*DWNMESH') THEN
        CALL UPDNMESH
        GOTO 1
      ELSE IF(STRING(1: 7).EQ.'*CRACK2') THEN
        CALL CRACK2
        GOTO 1
      ELSE IF(STRING(1: 9).EQ.'*SIDE GRO') THEN
        CALL SGROOV
        GOTO 1
      ELSE IF(STRING(1:8).EQ.'*MESH3D ') THEN
        CALL MESH3D
        CALL CMINLEN
        GOTO 1
      ELSE IF(STRING(1:8).EQ.'*DNDSURF') THEN
        CALL DNDSURF
        GOTO 1
      ELSE IF(STRING(1:8).EQ.'*DELSURF') THEN
        CALL DELSURF
        GOTO 1
      ELSE IF(STRING(1:10).EQ.'*MESH3DNEW') THEN
        CALL MESH3DNEW
        CALL CMINLEN
        GOTO 1
C     ELSE IF(STRING(1:8).EQ.'*EXT_3D1') THEN
C       CALL MESH_EX3D1
C       GOTO 1
C     ELSE IF(STRING(1:8).EQ.'*EXT_3D2') THEN
C       CALL MESH_EX3D2
C       GOTO 1
      ELSE IF(STRING(1:8).EQ.'*EXT_3D3') THEN
        CALL MESH_EX3D3
        GOTO 1
      ELSE IF(STRING(1:8).EQ.'*EXT_3D4') THEN
        CALL MESH_EX3D4
        GOTO 1
      ELSE IF(STRING(1:9).EQ.'*SHALLOW1') THEN
        CALL MESH_SHALLOW1
        CALL CMINLEN
        GOTO 1
      ELSE IF(STRING(1:9).EQ.'*SHALLOW2') THEN
        CALL MESH_SHALLOW2
        CALL CMINLEN
        GOTO 1
      ELSE IF(STRING(1:9).EQ.'*ROTAT_3D') THEN
        CALL MESHROT3D
        GOTO 1
      ELSE IF(STRING(1:7).EQ.'*RCAEDS') THEN
        IRCAEDS=1
        CALL RCAEDS
        CALL CMINLEN
        GOTO 1
    6   CONTINUE
        WRITE(IO_WRITE,'(5HFile ,A)') 
     &  FCAEDS(1:KF)//' not exists, program stop'
        STOP
C      ELSE IF(STRING(1:6).EQ.'*MESH1') THEN
C        IF(NELEM.GT.0) CALL CMINLEN
C        CALL MESH1
C        GOTO 1
      ELSE IF(STRING(1:6).EQ.'*MESH2') THEN
        CALL CMINLEN
        CALL MESH2
        GOTO 1
      ELSE IF(STRING(1:8).EQ.'*COCOORD') THEN
        ICOCOORD=1
        CALL COCOORD
        GOTO 1
      ELSE IF(STRING(1:6).EQ.'*TOLER') THEN
        CALL TOLERAN
        GOTO 1
      ELSE IF(STRING(1:8).EQ.'*REORDER') THEN
        CALL REORDER
        GOTO 1
      ELSE IF(STRING(1:8).EQ.'*SYSMESH') THEN
C       CALL REORDER
C       CALL COCOORD
        CALL SYSMESH
C       ICOCOORD=1
        GOTO 1
C     ELSE IF(STRING(1:7).EQ.'*DELCNE') THEN
C       CALL DELCNE
C       GOTO 1
      ELSE IF(STRING(1:7).EQ.'*CFRONT') THEN
        CALL CFRONT
        GOTO 1
      ELSE IF(STRING(1:9).EQ.'*MULTIMAT') THEN
        CALL MULTIMAT
        GOTO 1
      ELSE
        WRITE(IO_INFO,2020)
        GOTO 1
      END IF
    5 CONTINUE
      IF(TOLER.LE.1.0E-20) CALL CMINLEN
      IF(IRCAEDS.NE.1) THEN
        IF(ICOCOORD.EQ.1) THEN
        ELSE
          CALL REORDER
        END IF
      END IF
      CALL CHECK_DAT
      CALL WRITE_INFO
C
C *** INPUT HISTORY INFORMATION
C
      WRITE(IO_INFO,2100)
C
   11 CONTINUE
      CALL GETLINE (LEN,IERR)
      IF (IERR.NE.0) GOTO 98
      IF(STRING(1:9).NE.'*END POST') 
     &  WRITE(IO_INFO,2010) STRING(1:LEN)
      IF(STRING(1:9).EQ.'*END POST') THEN
        GOTO 15
      ELSE IF(STRING(1:13).EQ.'*MODE COMMAND') THEN
        CALL GETLINE (LEN,IERR)
	INVAR = 1
	ITYPE(1) = 1
        CALL SLVLINE (STRING,LEN,IERR)
	NCOMMD = IVARR(1)
	DO I = 1,NCOMMD
           CALL GETLINE (LEN,IERR)
	   ELSET_TYP(I) = STRING(1:8)
           WRITE(IO_OUTP,'(A)') STRING(1:LEN)
	ENDDO
        GOTO 11
      ELSE IF(STRING(1:12).EQ.'*RENEW ELSET') THEN
        CALL MRNELSET
        GOTO 11
      ELSE IF(STRING(1:7).EQ.'*DSLINE') THEN
        CALL DSLINE
        GOTO 11
C     ELSE IF(STRING(1:9).EQ.'*WAVEFRON') THEN
C       CALL WRENUM
C       GOTO 11
      ELSE IF(STRING(1:8).EQ.'*CRACKED') THEN
        CALL CRACKED
        GOTO 11
      ELSE IF(STRING(1:11).EQ.'*INTER USER') THEN
        CALL INTER
        GOTO 11
      ELSE IF(STRING(1:6).EQ.'*SCALE') THEN
        CALL SCALE
        GOTO 11
      ELSE IF(STRING(1:4).EQ.'*SET') THEN
        CALL DFSET
        GOTO 11
      ELSE IF(STRING(1:8).EQ.'*MESHOUT') THEN
        CALL MESHOUT
        GOTO 11
      ELSE IF(STRING(1:6).EQ.'*CAEDS') THEN
      CALL TCAEDS
        GOTO 11
      ELSE IF(STRING(1:9).EQ.'*DRAWMESH') THEN
        MDRAW=1
        CALL DRAWMESH(0)
        GOTO 11
      ELSE IF(STRING(1:15).EQ.'*DRAW FREE EDGE') THEN
        CALL MDR_FR_ED(0)
        GOTO 11
      ELSE IF(STRING(1:6).EQ.'*SOLID') THEN
        CALL SOLID
        GOTO 11
      ELSE IF(STRING(1:11).EQ.'*SAME SOLID') THEN
        CALL MSSSN
        GOTO 11
      ELSE IF(STRING(1:8).EQ.'*CONTACT') THEN
        CALL CONTACT
        GOTO 11
      ELSE IF(STRING(1:6).EQ.'*ENSET') THEN
        CALL ENSET
        GOTO 11
      ELSE IF(STRING(1:7).EQ.'*BOUND1') THEN
        CALL BOUND1
        GOTO 11
      ELSE IF(STRING(1:9).EQ.'*BOUNDARY') THEN
        CALL MBOUNDARY
        GOTO 11
      ELSE IF(STRING(1:7).EQ.'*MPCSUB') THEN
        CALL MPCSUB
        GOTO 11
      ELSE IF(STRING(1:7).EQ.'*EQUATS') THEN
        CALL EQUATS
        GOTO 11
      ELSE IF(STRING(1:7).EQ.'*PERIOD') THEN
        CALL EQUATP
        GOTO 11
      ELSE IF(STRING(1:7).EQ.'*EQUATQ') THEN
        CALL EQUATQ
        GOTO 11
      ELSE IF(STRING(1:7).EQ.'*EQUATD') THEN
        CALL EQUATD
        GOTO 11
      ELSE IF(STRING(1:8).EQ.'*HISTORY') THEN
        CALL SHISTORY
        GOTO 11
      ELSE
        WRITE(IO_INFO,2020)
        GOTO 11
      END IF
  15  CONTINUE
      GOTO 100
  99  CONTINUE
      WRITE(IO_WRITE,1000)
      GOTO 200
  98  CONTINUE
      WRITE(IO_WRITE,1001)
      GOTO 200
  100 CONTINUE
C
      CALL EVCPU(CPU_TIME)
      WRITE(IO_WRITE,1100) CPU_TIME
      WRITE(IO_INFO ,1100) CPU_TIME
C
  200 CONTINUE
      CLOSE (IO_INPUT)
      CLOSE (IO_JNL  )
      CLOSE (IO_OUTP )
C     CLOSE (IO_WORK )
      CLOSE (IO_INFO )
C     CLOSE (IOJPOINT)
      WRITE(IO_WRITE,1010) 
C
 1000 FORMAT(50H  !!! STATEMENT '*END PRE ' NO FOUND PROGRAM STOP )
 1001 FORMAT(50H  !!! STATEMENT '*END POST' NO FOUND PROGRAM STOP )
 1010 FORMAT(27H  !!! PROGRAM STOP NORMALLY)
 1100 FORMAT(//5X,'JOB TIME SUMMARY'/7X,'CPU TIME (Sec.):',G12.5)
 2000 FORMAT(///5X,'OPTIONS BEING PROCESSED IN MESH GENERATING'/
     &          3X,45(1H*)//)
 2100 FORMAT(///5X,'OPTIONS BEING PROCESSED IN HISTORY INFO. etc.'/
     &          3X,48(1H*)//)
 2010 FORMAT(2X,A,A)
 2020 FORMAT(2X,'***** ERROR *****',2X,'UNDEFINED OPTION')
C
      STOP
      END
C
      SUBROUTINE INIT_DATA
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      INCLUDE 'mcom_map'
      CHARACTER FINFO*160,FJNL*160,FWORK*160,FJPT*160
      LOGICAL LEXIST
C
C
C *** MESH INITIALIZATION
      NNODE = 0
      NELEM = 0
      NSETS = 0
C *** MAPE MESH INITIALIZED DATA
      NRG      = 0
      INPRG    = MDLRG+1
      NDSET    = 0
      NPERD    = 0
      IADPRD   = 0
      MEQUATP  = 0

      NRAND    = 0
C
      AFA      = 0.0E0
      BTA      = 0.0E0
      TSTRES   = 0.0E0
      THSTRS   = 0.0E0
C
      ISURFSET = 1
      IOUT     = 0
      IWINDOW  = 0
      MDRAW    = 0
      KEY_WT   = 0
      NTYPE    = 0
      ICOCOORD = 0
      NTNUM    = 1
      XORIGN   = 0.0E0
      YORIGN   = 0.0E0
      XTIP     = 1.0E30
      YTIP     = 1.0E30
      TOLER    = 1.0E-8
      CJNAM    = 'JS'
      SCMAX    = 2.0
C
      DO I=1,MXZNUM
        NDTIP(I,1)=1
      END DO
C
      DO I=1,MXMSET
        MATSET(I,1)=1
      END DO
      DO I=1,MXMSET
        ELSET_TYP(I)=' '
      END DO
C
C     CONSTANT
C
      PI=4.0D0*DATAN(1.0D0)
C
      KSYSM=0
C
C     IO DATA
C
      IO_INPUT    = 1
      IO_JNL      = 4
      IO_READ     = 5
      IO_WRITE    = 6
      IO_OUTP     = 11
      IO_WORK     = 12
      IO_INFO     = 13
      IOJPOINT    = 14
  111 CONTINUE
      IF (iargc().EQ.1) THEN
	 CALL getarg(1,FINPUT)
	 write (io_write,*) 'reading input file ',finput
	 CALL DTEXT(FINPUT,LINPUT)
	 IF (FINPUT(LINPUT-1:LINPUT).EQ.".1") LINPUT = LINPUT - 2
         FINPUT(LINPUT+1:LINPUT+2)='.1'
	 INQUIRE(FILE=FINPUT(1:LINPUT+2),EXIST=LEXIST)
         LJNL  =LINPUT+4
         LOUTP =LINPUT+4
         LWORK =LINPUT+4
         LINFO =LINPUT+4
         LJPT  =LINPUT+4
         FJNL  (1:LJNL    )=FINPUT(1:LINPUT)//'.jnl'
         FOUTP (1:LOUTP   )=FINPUT(1:LINPUT)//'.inp'
         FWORK (1:LWORK   )=FINPUT(1:LINPUT)//'.wrk'
         FINFO (1:LINFO   )=FINPUT(1:LINPUT)//'.inf'
         FJPT  (1:LJPT    )=FINPUT(1:LINPUT)//'.jpt'
         LINPUT=LINPUT+2
	 IF (LEXIST) GOTO 200
      ENDIF
      WRITE(IO_WRITE,'(///A)') 'Enter input filename:'
      READ (IO_READ ,'(A)') FINPUT
      IF(FINPUT(1:1).EQ.' ') THEN
        LINPUT=6
        LJNL  =7
        LOUTP =7
        LWORK =7
        LINFO =7
        LJPT  =7
        FINPUT(1:6)='FORT.1'
        FJNL  (1:7)='FORT.4'
        FOUTP (1:7)='FORT.11'
        FWORK (1:7)='FORT.12'
        FINFO (1:7)='FORT.13'
        FJPT  (1:7)='FORT.14'
      ELSE
         CALL DTEXT(FINPUT,LINPUT)
         IF (FINPUT(LINPUT-1:LINPUT).EQ.".1") LINPUT = LINPUT - 2
         LJNL  =LINPUT+4
         LOUTP =LINPUT+4
         LWORK =LINPUT+4
         LINFO =LINPUT+4
         LJPT  =LINPUT+4
         FINPUT(LINPUT+1:LINPUT+2)='.1'
         FJNL  (1:LJNL    )=FINPUT(1:LINPUT)//'.jnl'
         FOUTP (1:LOUTP   )=FINPUT(1:LINPUT)//'.inp'
         FWORK (1:LWORK   )=FINPUT(1:LINPUT)//'.wrk'
         FINFO (1:LINFO   )=FINPUT(1:LINPUT)//'.inf'
         FJPT  (1:LJPT    )=FINPUT(1:LINPUT)//'.jpt'
         LINPUT=LINPUT+2
      ENDIF
  200 CONTINUE
      OPEN(IO_INPUT   ,FILE=FINPUT(1:LINPUT),STATUS='OLD',ERR=111)
      OPEN(IO_JNL     ,FILE=FJNL  (1:LJNL  ),STATUS='UNKNOWN')
      OPEN(IO_OUTP    ,FILE=FOUTP (1:LOUTP ),STATUS='UNKNOWN')
C     OPEN(IO_WORK    ,FILE=FWORK (1:LWORK ),STATUS='UNKNOWN')
      OPEN(IO_INFO    ,FILE=FINFO (1:LINFO ),STATUS='UNKNOWN')
C     OPEN(IOJPOINT   ,FILE=FJPT  (1:LJPT  ),STATUS='UNKNOWN')
C
      TXT( 1)=' Finite element mesh automatically generating program   '
      TXT( 2)='             for ABAQUS program system                  '
      TXT( 4)='                                                        '
      TXT( 5)='              developed by Guoyu, Lin                   '
      TXT( 6)='                   WMA Abteilung                        '
      TXT( 7)='          Institut of materials research                '
      TXT( 8)='               GKSS research center                     '
      TXT( 9)='                      Germany                           '
      TXT(10)='                    1992 - 2000                         '
      TXT(11)='                    Version 1.1a                        '
      TXT(12)='                     21.07.2000                         '
C
      CNUM( 1)='01'
      CNUM( 2)='02'
      CNUM( 3)='03'
      CNUM( 4)='04'
      CNUM( 5)='05'
      CNUM( 6)='06'
      CNUM( 7)='07'
      CNUM( 8)='08'
      CNUM( 9)='09'
      DO I=10,99
        WRITE(CNUM(I)(1:2),'(I2)') I
      END DO
C
      K_AXIS(1)=1
      K_AXIS(2)=1
      K_AXIS(3)=2
      K_AXIS(4)=2
      K_AXIS(5)=3
      K_AXIS(6)=3
      IRAXIS(1)=1
      IRAXIS(2)=2
      IRAXIS(3)=3
C     Type 1: 3D 8 or 20-27 node element
      NFACE_DF(1,1,1)=1
      NFACE_DF(2,1,1)=4
      NFACE_DF(3,1,1)=3
      NFACE_DF(4,1,1)=2
      NFACE_DF(5,1,1)=12
      NFACE_DF(6,1,1)=11
      NFACE_DF(7,1,1)=10
      NFACE_DF(8,1,1)=9
      NFACE_DF(9,1,1)=22
      NFACE_DF(1,2,1)=5
      NFACE_DF(2,2,1)=6
      NFACE_DF(3,2,1)=7
      NFACE_DF(4,2,1)=8
      NFACE_DF(5,2,1)=13
      NFACE_DF(6,2,1)=14
      NFACE_DF(7,2,1)=15
      NFACE_DF(8,2,1)=16
      NFACE_DF(9,2,1)=23
      NFACE_DF(1,3,1)=1
      NFACE_DF(2,3,1)=2
      NFACE_DF(3,3,1)=6
      NFACE_DF(4,3,1)=5
      NFACE_DF(5,3,1)=9
      NFACE_DF(6,3,1)=18
      NFACE_DF(7,3,1)=13
      NFACE_DF(8,3,1)=17
      NFACE_DF(9,3,1)=24
      NFACE_DF(1,4,1)=2
      NFACE_DF(2,4,1)=3
      NFACE_DF(3,4,1)=7
      NFACE_DF(4,4,1)=6
      NFACE_DF(5,4,1)=10
      NFACE_DF(6,4,1)=19
      NFACE_DF(7,4,1)=14
      NFACE_DF(8,4,1)=18
      NFACE_DF(9,4,1)=25
      NFACE_DF(1,5,1)=3
      NFACE_DF(2,5,1)=4
      NFACE_DF(3,5,1)=8
      NFACE_DF(4,5,1)=7
      NFACE_DF(5,5,1)=11
      NFACE_DF(6,5,1)=20
      NFACE_DF(7,5,1)=15
      NFACE_DF(8,5,1)=19
      NFACE_DF(9,5,1)=26
      NFACE_DF(1,6,1)=4
      NFACE_DF(2,6,1)=1
      NFACE_DF(3,6,1)=5
      NFACE_DF(4,6,1)=8
      NFACE_DF(5,6,1)=12
      NFACE_DF(6,6,1)=17
      NFACE_DF(7,6,1)=16
      NFACE_DF(8,6,1)=20
      NFACE_DF(9,6,1)=27
C     Type 2: 3D 6-node element
      NFACE_DF(1,1,2)=1
      NFACE_DF(2,1,2)=3
      NFACE_DF(3,1,2)=2
      NFACE_DF(1,2,2)=4
      NFACE_DF(2,2,2)=5
      NFACE_DF(3,2,2)=6
      NFACE_DF(1,3,2)=1
      NFACE_DF(2,3,2)=2
      NFACE_DF(3,3,2)=5
      NFACE_DF(4,3,2)=4
      NFACE_DF(1,4,2)=2
      NFACE_DF(2,4,2)=3
      NFACE_DF(3,4,2)=6
      NFACE_DF(4,4,2)=5
      NFACE_DF(1,5,2)=3
      NFACE_DF(2,5,2)=1
      NFACE_DF(3,5,2)=4
      NFACE_DF(4,5,2)=6
C     Type 3: 3D 4 - 10node element
      NFACE_DF(1,1,3)=1
      NFACE_DF(2,1,3)=2
      NFACE_DF(3,1,3)=3
      NFACE_DF(4,1,3)=5
      NFACE_DF(5,1,3)=6
      NFACE_DF(6,1,3)=7
      NFACE_DF(1,2,3)=1
      NFACE_DF(2,2,3)=4
      NFACE_DF(3,2,3)=2
      NFACE_DF(4,2,3)=8
      NFACE_DF(5,2,3)=9
      NFACE_DF(6,2,3)=5
      NFACE_DF(1,3,3)=2
      NFACE_DF(2,3,3)=4
      NFACE_DF(3,3,3)=3
      NFACE_DF(4,3,3)=9
      NFACE_DF(5,3,3)=10
      NFACE_DF(6,3,3)=6
      NFACE_DF(1,4,3)=3
      NFACE_DF(2,4,3)=4
      NFACE_DF(3,4,3)=1
      NFACE_DF(4,4,3)=10
      NFACE_DF(5,4,3)=8
      NFACE_DF(6,4,3)=7
C     Type 4: 3D 20-node element
C     Type 5: 2-D quadrilateral linear or quadratic element
      NFACE_DF(1,1,5)=1
      NFACE_DF(2,1,5)=2
      NFACE_DF(1,2,5)=2
      NFACE_DF(2,2,5)=3
      NFACE_DF(1,3,5)=3
      NFACE_DF(2,3,5)=4
      NFACE_DF(1,4,5)=1
      NFACE_DF(2,4,5)=4
C     Type 6: 2-D triangular linear or quadratic element
      NFACE_DF(1,1,6)=1
      NFACE_DF(2,1,6)=2
      NFACE_DF(1,2,6)=2
      NFACE_DF(2,2,6)=3
      NFACE_DF(1,3,6)=1
      NFACE_DF(2,3,6)=3
C     Type 7: 3D 15-node element
      NFACE_DF(1,1,7)=1
      NFACE_DF(2,1,7)=3
      NFACE_DF(3,1,7)=2
      NFACE_DF(4,1,7)=9
      NFACE_DF(5,1,7)=8
      NFACE_DF(6,1,7)=7
      NFACE_DF(1,2,7)=4
      NFACE_DF(2,2,7)=5
      NFACE_DF(3,2,7)=6
      NFACE_DF(4,2,7)=10
      NFACE_DF(5,2,7)=11
      NFACE_DF(6,2,7)=12
      NFACE_DF(1,3,7)=1
      NFACE_DF(2,3,7)=2
      NFACE_DF(3,3,7)=5
      NFACE_DF(4,3,7)=4
      NFACE_DF(5,3,7)=7
      NFACE_DF(6,3,7)=14
      NFACE_DF(7,3,7)=10
      NFACE_DF(8,3,7)=13
      NFACE_DF(1,4,7)=2
      NFACE_DF(2,4,7)=3
      NFACE_DF(3,4,7)=6
      NFACE_DF(4,4,7)=5
      NFACE_DF(5,4,7)=8
      NFACE_DF(6,4,7)=15
      NFACE_DF(7,4,7)=11
      NFACE_DF(8,4,7)=14
      NFACE_DF(1,5,7)=3
      NFACE_DF(2,5,7)=1
      NFACE_DF(3,5,7)=4
      NFACE_DF(4,5,7)=6
      NFACE_DF(5,5,7)=9
      NFACE_DF(6,5,7)=13
      NFACE_DF(7,5,7)=12
      NFACE_DF(8,5,7)=15
c
c     Type 1: 8-node brick element
c
      CFACE_DF(1,1)='1234'
      CFACE_DF(2,1)='5678'
      CFACE_DF(3,1)='1256'
      CFACE_DF(4,1)='2367'
      CFACE_DF(5,1)='3478'
      CFACE_DF(6,1)='1458'
c
c     Type 2: 6-node brick element
c
      CFACE_DF(1,2)='123 '
      CFACE_DF(2,2)='456 '
      CFACE_DF(3,2)='1245'
      CFACE_DF(4,2)='2356'
      CFACE_DF(5,2)='1346'
c
c     Type 3: 4-node brick element
c
      CFACE_DF(1,3)='123 '
      CFACE_DF(2,3)='124 '
      CFACE_DF(3,3)='234 '
      CFACE_DF(4,3)='134 '
c
c     Type 4: 20-node quadratic element
c
      CFACE_DF(1,4)='1234'
      CFACE_DF(2,4)='5678'
      CFACE_DF(3,4)='1256'
      CFACE_DF(4,4)='2367'
      CFACE_DF(5,4)='3478'
      CFACE_DF(6,4)='1458'
c
c     Type 5: 2-D 4-node linear element and 8-node quadratic element
c
      CFACE_DF(1,5)='12  '
      CFACE_DF(2,5)='23  '
      CFACE_DF(3,5)='34  '
      CFACE_DF(4,5)='14  '
c
c     Type 6: 2-D 3-node constant element and 6-node quadratic element 
c
      CFACE_DF(1,6)='12  '
      CFACE_DF(2,6)='23  '
      CFACE_DF(3,6)='13  '
c
c     Type 7: 3D 15-node brick element
c
      CFACE_DF(1,7)='123 '
      CFACE_DF(2,7)='456 '
      CFACE_DF(3,7)='1245'
      CFACE_DF(4,7)='2356'
      CFACE_DF(5,7)='1346'
C
      CESET(1)='EBOUNDX1'
      CESET(2)='EBOUNDX2'
      CESET(3)='EBOUNDY1'
      CESET(4)='EBOUNDY2'
      CESET(5)='EBOUNDZ1'
      CESET(6)='EBOUNDZ2'
      CNSET(1)='NBOUNDX1'
      CNSET(2)='NBOUNDX2'
      CNSET(3)='NBOUNDY1'
      CNSET(4)='NBOUNDY2'
      CNSET(5)='NBOUNDZ1'
      CNSET(6)='NBOUNDZ2'
C
      DO I=1,10
        KIDFACE(1,I)=1
        DO J=2,7
          KIDFACE(J,I)=0
        END DO
      END DO
C
      WRITE(IO_WRITE,'(10(/))')
      WRITE(IO_WRITE,'(//80(1H*)//)')
      WRITE(IO_WRITE,9000) (TXT(I),I=1,12)
      WRITE(IO_WRITE,'(//80(1H*)//)')
      WRITE(IO_INFO,'(//80(1H*)//)')
      WRITE(IO_INFO,9000) (TXT(I),I=1,10)
      WRITE(IO_INFO,'(//80(1H*)//)')
 9000 FORMAT(12X,A56)
C
      RETURN
      END
