C
C     PROGRAM FOR GENERATING 3-NODES ELEMENT MESH
C
      SUBROUTINE CNV2TRI
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION KMIDND(4)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. CNV2TRI'
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. CNV2TRI'
C
      TEXT='NOW EXCUTING SUB. CNV2TRI'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      IMSET1 = 1
      IMSET2 = 0
      CALL LOCCHR(STRING,'ELSET    ',5,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET1
      END IF
C     IMSET2 = 1
C     DO I=1,MXMSET
C       IF(MATSET(I,1).GT.1) IMSET2 = I
C     END DO
C
      CALL FIND_ELSET_new (IMSET1,IWORK,NELE)
      IM_ELEM=NELEM
      IM_NODE=NNODE
C
      DO I1 = 1,NELE
        I   = IWORK(I1)
        NODE=LNODS(I,MXNOD)
	IF (NODE.NE.4 .AND. NODE.NE.8) GOTO 900
C------ generating new node in the middle of the existing element
        IM_NODE=IM_NODE+1
	IK3    =IM_NODE
        XM=0.0
        YM=0.0
        DO J=1,4
          IN=LNODS(I,J)
          XM=XM+COORD(IN,1)
          YM=YM+COORD(IN,2)
        END DO
        XM = XM/4.0
        YM = YM/4.0
        COORD(IM_NODE,1) = XM
        COORD(IM_NODE,2) = YM
        COORD(IM_NODE,3) = COORD(IN,3)
	INCOD(IM_NODE)   = IM_NODE
	IF (NODE.EQ.8) THEN
C--------- generating new mid nodes for 6 node triangulars
	   DO J = 1, 4
	      IM_NODE = IM_NODE + 1
	      KMIDND(J) = IM_NODE
	      COORD(IM_NODE,1) = 0.5*(COORD(LNODS(I,J),1)+XM)
	      COORD(IM_NODE,2) = 0.5*(COORD(LNODS(I,J),2)+YM)
	      COORD(IM_NODE,3) = COORD(LNODS(I,J),3)
	      INCOD(IM_NODE)   = IM_NODE
	   END DO
	ENDIF
        DO K=1,4
C--------- generating new triangular elements
          IF(K.EQ.4) THEN
            IE      = I
          ELSE
            IM_ELEM = IM_ELEM+1
            IE      = IM_ELEM
            MATSET(IMSET1,1)=MATSET(IMSET1,1)+1
            MATSET(IMSET1,MATSET(IMSET1,1))=IE
          END IF
          K2=K+1
          IF(K2.GT.4) K2=1
          IK1=LNODS(I,K)
          IK2=LNODS(I,K2)
          LNODS(IE,1)=IK1
          LNODS(IE,2)=IK2
          LNODS(IE,3)=IK3
          LNODS(IE,MXNOD-1)=IMSET1
	  IF (NODE .EQ. 4) THEN
             LNODS(IE,MXNOD)=3
             ELTYP(IE)='C2D3'
	  ELSE
             LNODS(IE,MXNOD)=6
             LNODS(IE,4) = LNODS(I,K+4)
             LNODS(IE,5) = KMIDND(K2)
             LNODS(IE,6) = KMIDND(K)
	     ELTYP(IE) = 'C2D6'
	  ENDIF
Ctest     print *,ie,(lnods(ie,kk),kk=1,lnods(ie,mxnod))
        END DO
      END DO
      NNODE=IM_NODE
      NELEM=IM_ELEM
C
CC    IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      TEXT='END OF EXCUTING SUB. CNV2TRI'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
  900 CONTINUE
      WRITE(IO_WRITE,1000) NODE
 1000 FORMAT(//4(1H#),' Cannot change',I2,
     &        ' node element to triangular element'/
     &        ' check your input data !!!'//)
      RETURN
      END
C
C
C
C     PROGRAM FOR GENERATING 4-NODE TET-ELEMENT MESH
C
      SUBROUTINE CNV2TET
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION KMIDND(4),ITETND(4,6)
C
      DATA ITETND /1,2,3,5 ,5,2,3,6 ,5,6,3,7 ,5,3,1,4 ,5,7,3,4 ,5,8,7,4/
C
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. CNV2TET'
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. CNV2TET'
C
      TEXT='NOW EXCUTING SUB. CNV2TET'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      IMSET1 = 1
      IMSET2 = 0
      CALL LOCCHR(STRING,'ELSET    ',5,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET1
      END IF
C---  itypnd=1:  6 tetrahedral elements
C---  itypnd=2: 24 tetrahedral elements
      ITYPND = 1
      CALL LOCCHR(STRING,'TYPE    ',4,1,K1,K2)
      IF(K2.GE.K1) THEN
         READ(STRING(K1:K2),*) ITYPND
         IF (ITYPND.NE.1 .AND. ITYPND.NE.2) ITYPND = 1
      END IF
C     IMSET2 = 1
C     DO I=1,MXMSET
C       IF(MATSET(I,1).GT.1) IMSET2 = I
C     END DO
C
      CALL FIND_ELSET_new (IMSET1,IWORK,NELE)
      IM_ELEM=NELEM
      IM_NODE=NNODE
C
      DO I1 = 1,NELE
         I   = IWORK(I1)
         NODE=LNODS(I,MXNOD)
Cnotyet  IF (NODE.NE.8 .AND. NODE.NE.20) GOTO 900
	 IF (NODE.NE.8) GOTO 900
         IF (ITYPND.EQ.2) THEN
C---------  generating element mid node for 24 tetelements
            IM_NODE=IM_NODE+1
	    IK4    =IM_NODE
            XM=0.0
            YM=0.0
            ZM=0.0
            DO J=1,8
               IN=LNODS(I,J)
               XM=XM+COORD(IN,1)
               YM=YM+COORD(IN,2)
               ZM=ZM+COORD(IN,3)
            END DO
            XM = XM/8.0
            YM = YM/8.0
            ZM = ZM/8.0
            COORD(IM_NODE,1) = XM
            COORD(IM_NODE,2) = YM
            COORD(IM_NODE,3) = ZM
	    INCOD(IM_NODE)   = IM_NODE
	 ENDIF
         DO K=1,6
            IF (ITYPND.EQ.2) THEN
C------------- generating face mid node for 24 tetelements
               IM_NODE=IM_NODE+1
	       IK3    =IM_NODE
               XM=0.0
               YM=0.0
               ZM=0.0
               DO J=1,4
                 IN=LNODS(I,NFACE_DF(J,K,1))
                 XM=XM+COORD(IN,1)
                 YM=YM+COORD(IN,2)
                 ZM=ZM+COORD(IN,3)
               END DO
               XM = XM/4.0
               YM = YM/4.0
               ZM = ZM/4.0
               COORD(IM_NODE,1) = XM
               COORD(IM_NODE,2) = YM
               COORD(IM_NODE,3) = ZM
	       INCOD(IM_NODE)   = IM_NODE
C------------  generating new tetrahedral elements
	       DO KK = 1,4
                  IF(K.EQ.6 .AND. KK.EQ.4) THEN
                     IE      = I
                  ELSE
                     IM_ELEM = IM_ELEM+1
                     IE      = IM_ELEM
                     MATSET(IMSET1,1)=MATSET(IMSET1,1)+1
                     MATSET(IMSET1,MATSET(IMSET1,1))=IE
                  END IF
		  KK1 = KK + 1
		  IF (KK.EQ.4) KK1 = 1
		  IK1 = LNODS(I,NFACE_DF(KK1,K,1))
		  IK2 = LNODS(I,NFACE_DF(KK,K,1))
                  LNODS(IE,1) = IK1
                  LNODS(IE,2) = IK2
                  LNODS(IE,3) = IK3
                  LNODS(IE,4) = IK4
                  LNODS(IE,MXNOD)=4
                  LNODS(IE,MXNOD-1)=IMSET1
                  ELTYP(IE)='C3D4'
	       END DO
	    ELSE
C------------  generating 6 new tetrahedral elements from brick el.
               IF(K.EQ.6) THEN
                  IE      = I
               ELSE
                  IM_ELEM = IM_ELEM+1
                  IE      = IM_ELEM
                  MATSET(IMSET1,1)=MATSET(IMSET1,1)+1
                  MATSET(IMSET1,MATSET(IMSET1,1))=IE
               END IF
	       DO IN = 1,4
                  LNODS(IE,IN) = LNODS(I,ITETND(IN,K))
	       END DO
               LNODS(IE,MXNOD-1)=IMSET1
	       IF (NODE .EQ. 8) THEN
                  LNODS(IE,MXNOD)=4
                  ELTYP(IE)='C3D4'
	       ENDIF
Ctest          print *,ie,(lnods(ie,kk),kk=1,lnods(ie,mxnod))
	    ENDIF
         END DO
      END DO
      NNODE=IM_NODE
      NELEM=IM_ELEM
C
      TEXT='END OF EXCUTING SUB. CNV2TET'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
  900 CONTINUE
      WRITE(IO_WRITE,1000) NODE
 1000 FORMAT(//4(1H#),' Cannot change',I2,
     &        ' node element to triangular element'/
     &        ' check your input data !!!'//)
      RETURN
      END
