C
C *** SUBROUTINE FOR GENERATING UPER SIDE BOUNDARY LAYER FORMULATION MESH
C *** FOR SYSMETRIC CASES
C
      SUBROUTINE MESH_HBLF
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XSG1(3),YSG1(3),XSG2(3),YSG2(3),EL(100),CL(100)
      DIMENSION XB(200),YB(200),XE(200),YE(200),XSG(5),YSG(5),
     1 NL(20),NR(20),RA(1000),SC1(200),SC2(200),N1OUT(1000),
     2 NDYLF(500),NDYRT(500),NDU(500),NDDWN(500),NCT(500),
     & NOUTCL(1000),MSEC(10),SECCD(1000,2,2),SECXY(10,5)
      CHARACTER*6 CTYPE
C
C     INPUT INITIAL DATA
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MESH_HBLF'
      TEXT='NOW EXCUTING SUB. MESH_HBLF'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      IE=NELEM
      IN=NNODE
      PI=4.0D0*ATAN(1.0D0)
C
      READ(IO_INPUT,*) NEXT,IMSET,NODE
      READ(IO_INPUT,*) NSEC,((SECXY(I,J),J=1,5),I=1,NSEC)
C
      KFULL = 0
      READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE 1
      ELSE
        CALL LOCCHR(STRING,'FULL    ',4,1,K1,K2)
        IF(K2.GT.K1) THEN
          IF(STRING(K1:K1).EQ.'L') THEN
            KFULL = 1
          ELSE
          END IF
          READ(IO_INPUT,*) B_REF
        END IF
      END IF
C
      KEY_PL=0
      IF(NEXT.LT.0) THEN
        KEY_PL=1
        NEXT=-NEXT
      END IF
      IF(NODE.GE.8) SCMAX=1.5
      IF(NODE.GE.8.AND.INT(NEXT/2)*2.NE.NEXT) NEXT=NEXT+1
      IF(NTOUTC.EQ.0) THEN
        CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
        CALL SEAND(NDYLF,1,XMIN,NYLF,1)
        CALL SEAND(NDU,2,YMAX,KU,1)
        CALL SEAND(NDYRT,1,XMAX,NYRT,3)
        CALL SEAND(NDDWN,2,YMIN,NDWN,3)
        NTOUTC=0
        DO I=1,NYLF
          NTOUTC=NTOUTC+1
          NOUTCL(NTOUTC)=NDYLF(I)
        END DO
        MSEC(1)=NTOUTC
        DO I=2,KU
          NTOUTC=NTOUTC+1
          NOUTCL(NTOUTC)=NDU  (I)
        END DO
        MSEC(2)=NTOUTC
        DO I=2,NYRT
          NTOUTC=NTOUTC+1
          NOUTCL(NTOUTC)=NDYRT(I)
        END DO
        MSEC(3)=NTOUTC
      END IF
      DO I=1,NTOUTC
        INP=NOUTCL(I)
        X=COORD(INP,1)
        Y=COORD(INP,2)
        SECCD(I,1,1)=X
        SECCD(I,2,1)=Y
      END DO
      NSECD=1
      JBEGIN=1
      DO K=1,NSEC
        X0=SECXY(K,1)
        Y0=SECXY(K,2)
        R0=SECXY(K,3)
        T1=SECXY(K,4)*PI/180.0D0
        T2=SECXY(K,5)*PI/180.0D0
        JSTOP =MSEC(K)
        NSECD=JSTOP-JBEGIN
        DT=(T2-T1)/NSECD
        T=T1-DT
        DO J=JBEGIN,JSTOP
          T=T+DT
          X=X0+R0*COS(T)
          Y=Y0+R0*SIN(T)
          SECCD(J,1,2)=X
          SECCD(J,2,2)=Y
        END DO
        JBEGIN=JSTOP
      END DO
      NX123=MSEC(NSEC)-1
      IF(NODE.EQ.8) THEN
        L6=NNODE-NX123-1
        DO I=1,NEXT/2
          L1=L6-1
          DO J=1,NX123/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX123+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX123+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            ELTYP(IE)='C2D8'
            IF(I.EQ.1) THEN
              IK1=2*J-1
              IK2=2*J
              IK3=2*J+1
              LNODS(IE,1)=NOUTCL(IK1)
              LNODS(IE,2)=NOUTCL(IK3)
              LNODS(IE,5)=NOUTCL(IK2)
            END IF
            LNODS(IE,MXNOD-1)=IMSET
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.GE.9) THEN
        L6=NNODE-NX123-1
        DO I=1,NEXT/2
          L1=L6-1
          DO J=1,NX123/2
            IE=IE+1
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NX123+1
            L5=L4+1
            L6=L5+1
            L7=L4+NX123+1
            L8=L7+1
            L9=L8+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            ELTYP(IE)='C2D9'
            IF(I.EQ.1) THEN
              IK1=2*J-1
              IK2=2*J
              IK3=2*J+1
              LNODS(IE,1)=NOUTCL(IK1)
              LNODS(IE,2)=NOUTCL(IK3)
              LNODS(IE,5)=NOUTCL(IK2)
            END IF
            LNODS(IE,MXNOD-1)=IMSET
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L1=NNODE-(NX123+1)
        DO I=1,NEXT
          DO J=1,NX123
            IE=IE+1
            L1=L1+1
            L2=L1+1
            L3=L1+NX123+1
            L4=L3+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L2
            LNODS(IE,3)=L4
            LNODS(IE,4)=L3
            IF(I.EQ.1) THEN
              IK1=J
              IK2=J+1
              LNODS(IE,1)=NOUTCL(IK1)
              LNODS(IE,2)=NOUTCL(IK2)
            END IF
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D4'
            CALL DNODE(IE,NODE)
          END DO
          L1=L2
        END DO
      END IF
C
C     GENERATE NODE COORDINATES
C
      EL0=ELL
      IF(EL0.LT.ELU) EL0=ELU
      IF(EL0.LT.ELR) EL0=ELR
      IF(EL0.LT.ELD) EL0=ELD
      DO I=1,NX123+1
        X1=SECCD(I,1,1)
        Y1=SECCD(I,2,1)
        X2=SECCD(I,1,2)
        Y2=SECCD(I,2,2)
        RL=DSQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
        ST=RL/EL0
        CALL SOLVSL(NEXT,EL0,RL,SCL)
        IF(SCL.LT.1.0.OR.KEY_PL.EQ.1) THEN
          SCL=1.0
          EL0=RL/NEXT
          ST=RL/EL0
        END IF
        SC2(I)=SCL
        SL=0.0
        IN=NNODE-NX123-1+I
        DO J=1,NEXT
          IN=IN+NX123+1
          SL=SL+SCL**J
          X=X1+SL*(X2-X1)/ST
          Y=Y1+SL*(Y2-Y1)/ST
          IF(J.EQ.NEXT) THEN
            X=X2
            Y=Y2
          END IF
          COORD(IN,1)=X
          COORD(IN,2)=Y
        END DO
        IF(I.EQ.1) ELL=EL0*SCL**NEXT
        IF(I.EQ.NX12+1) ELU=EL0*SCL**NEXT
        IF(I.EQ.NX123+1) ELR=EL0*SCL**NEXT
      END DO
C
      IF(NODE.GE.8) CALL NODXY(2,NELEM+1,IE)
      NELEM=IE
      NNODE=IN
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      INL1=NNODE-NX123
      INL2=INL1-NX123-1
      INR1=IN
      INR2=INR1-NX123-1
      INU1=IN-NX34
      INU2=INU1-NX123-1
      N1T=N1T+1
      N1OUT(N1T)=NNODE-NX123
C     WRITE(IO_WORK,903) (XB(I),YB(I),XE(I),YE(I),SC2(I),I=1,NX123+1)
C     WRITE(IO_WORK,*) ' INL1',INL1,INL2,INR1,INR2
C
C
C     NODE COORDINATES TRANSLATION
C
      DO I=1,NNODE
        COORD(I,1)=COORD(I,1)+XORIGN
        COORD(I,2)=COORD(I,2)+YORIGN
      END DO
      N1OUT(1)=N1T
C
      TEXT='END OF EXCUTING SUB. MESH_HBLF'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
