C
C     PROGRAM FOR GENERATING CRACK_TIP ELEMENT MESH
C
      SUBROUTINE IRTMESH
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XSG1(3),YSG1(3),XSG2(3),YSG2(3),EL(100),CL(100)
      DIMENSION XB(200),YB(200),XE(200),YE(200),XSG(5),YSG(5),
     1 NL(20),NR(20),RA(1000),SC1(200),SC2(200),N1OUT(1000)
      CHARACTER*6 CTYPE
C
C     INPUT INITIAL DATA
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. IRTMESH'
      TEXT='NOW EXCUTING SUB. IRTMESH'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      IE=NELEM
      IN=NNODE
      PI=4.0D0*ATAN(1.0D0)
C
C     GENERATE RECTANGULE FRAME SHAPE MESH
C
C     ELSE IF(STRING(1:8).EQ.'*IRTMESH') THEN
      READ(IO_INPUT,*) NY,IMSET,NODE
C
      IF(NODE.GE.8) SCMAX=1.5
      IF(NODE.GE.8.AND.INT(NY/2)*2.NE.NY) NY=NY+1
      READ(IO_INPUT,*) (XSG1(I),YSG1(I),I=1,3)
c     WRITE(IO_WRITE,'(i5/6E12.5)') NY,(XSG1(I),YSG1(I),I=1,3)
      DO I=1,NX2+NX34+1
        XB(I)=XE(I+NX1)
        YB(I)=YE(I+NX1)
      END DO
      X1=XSG1(1)
      X2=XSG1(2)
      Y1=YSG1(1)
      Y2=YSG1(2)
      XE(1)=XSG1(1)
      YE(1)=YSG1(1)
      II=1
      NX = NX2 + NX34/2
      DO I=1,NX
        II=II+1
        X=X1+FLOAT(I)*(X2-X1)/FLOAT(NX)
        Y=Y1+FLOAT(I)*(Y2-Y1)/FLOAT(NX)
        XE(II)=X
        YE(II)=Y
      END DO 
      X1=XSG1(2)
      X2=XSG1(3)
      Y1=YSG1(2)
      Y2=YSG1(3)
      DO I=1,NX34/2
        II=II+1
        X=X1+FLOAT(I)*(X2-X1)/FLOAT(NX34/2)
        Y=Y1+FLOAT(I)*(Y2-Y1)/FLOAT(NX34/2)
        XE(II)=X
        YE(II)=Y
      END DO
      NXRT=II
      N1RT=NNODE-NXRT
C
C     GENERATE NODE COORDINATES
C
      DO I=1,NXRT
        IK=I
        IF(I.LT.NX2+NX34/2+1) IK=1
        IF(I.GE.NX2+NX34/2+1) IK=NXRT
        X1=COORD(N1RT+IK,1)
        X2=COORD(N1RT+IK-NX123-1,1)
        Y1=COORD(N1RT+IK,2)
        Y2=COORD(N1RT+IK-NX123-1,2)
        EL0=DSQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
        X1=XB(I)
        Y1=YB(I)
        X2=XE(I)
        Y2=YE(I)
        RL=DSQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
        ST=RL/EL0
        CALL SOLVSL(NY,EL0,RL,SCL)
        SC2(I)=SCL
        SL=0.0
        IN=N1RT+I
        DO J=1,NY
          IN=IN+NXRT
          SL=SL+SCL**J
          X=X1+SL*(X2-X1)/ST
          Y=Y1+SL*(Y2-Y1)/ST
          IF(ABS(X).LT.1.0D-10) X=0.0
          IF(ABS(Y).LT.1.0D-10) Y=0.0
          IF(J.EQ.NY) THEN
            X=X2
            Y=Y2
          END IF
          COORD(IN,1)=X
          COORD(IN,2)=Y
        END DO
        IF(I.EQ.1) ELU=EL0*SCL**NY
        IF(I.EQ.NXRT) ELR=EL0*SCL**NY
      END DO
C
C     GENERATE NODE DEFINITION 
C
      IF(NODE.EQ.8) THEN
        L6=NNODE-NXRT
        DO I=1,NY/2
          L1=L6-1
          DO J=1,NXRT/2
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NXRT
            L5=L4+1
            L6=L5+1
            L7=L4+NXRT
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D8'
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.9) THEN
        L6=NNODE-NXRT
        DO I=1,NY/2
          L1=L6-1
          DO J=1,NXRT/2
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NXRT
            L5=L4+1
            L6=L5+1
            L7=L4+NXRT
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D9'
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L2=NNODE-NXRT
        DO I=1,NY
          L1=L2
          DO J=1,NXRT-1
            IE=IE+1
            L1=L1+1
            L2=L1+1
            L3=L1+NXRT
            L4=L3+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L2
            LNODS(IE,3)=L4
            LNODS(IE,4)=L3
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D4'
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ENDIF
      IF(NODE.GE.8) CALL NODXY(3,NELEM+1,IE)
      NELEM=IE
      NNODE=IN
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      INR1=IN
      INR2=INR1-NXRT
      INU1=IN-NXRT+1
      INU2=INU1-NXRT
C
C     WRITE(IO_WORK,904) (XB(I),YB(I),XE(I),YE(I),SC2(I),I=1,NXRT)
  904 FORMAT(' FRAME REGION II'/
     1 2(5X,2HXB,10X,2HYB,10X,2HXE,10X,2HYE,10X,2HSC,5X)
     1 /(2(5E12.4)))
C
      TEXT='END OF EXCUTING SUB. IRTMESH'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
