C
C     PROGRAM FOR GENERATING CRACK_TIP ELEMENT MESH
C
      SUBROUTINE LEFMESH
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XP1(3),XP2(3)
      DIMENSION XSG1(3),YSG1(3),XSG2(3),YSG2(3),EL(100),CL(100)
      CHARACTER*6 CTYPE
C
C     INPUT INITIAL DATA
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. LEFMESH'
      TEXT='NOW EXCUTING SUB. LEFMESH'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      XP1(1) = -1.0E30
      XP1(2) = -1.0E30
      XP1(3) = 0.0E0
      XP2(1) = 1.0E30
      XP2(2) = 1.0E30
      XP2(3) = 0.0E0
C
      CALL LOCCHR(STRING,'YMIN    ',4,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) XP1(2)
      END IF
C
      CALL LOCCHR(STRING,'YMAX    ',4,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) XP2(2)
      END IF
C
      IE=NELEM
      IN=NNODE
      PI=4.0D0*ATAN(1.0D0)
C
      READ(IO_INPUT,*) ILEFT
C
      ND0=NNODE
C
      DO IL=1,ILEFT
C
        CALL CVMAXN(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN,XP1,XP2)
        XP1(1) = XMIN
        XP2(1) = XMIN
        CALL FN_LIN_ND(XP1,XP2,IWORK,NYLF)
        IF(NYLF.LT.2) THEN
          RETURN
        END IF
        CALL SORTCD(IWORK,NYLF,2)
C
        READ(IO_INPUT,*) NLEFT,XLEFT,IMSET,NODE
C
        IF(NODE.GE.8) SCMAX=1.5
        IN1=IWORK(1)
        IN2=IN1-NX123-1
        RL=COORD(IN1,1)-XLEFT
        IF(NLEFT.GT.0) THEN
          EL0=ELL
          IF(NODE.GE.8.AND.INT(NLEFT/2)*2.NE.NLEFT) NLEFT=NLEFT+1
          CALL SOLVSL(NLEFT,EL0,RL,SCL)
        ELSE IF(NLEFT.EQ.-999) THEN
          NLEFT=NINT(RL/EL0)
          IF(NODE.GE.8) NLEFT=2*NINT(RL/EL0/2.0)
          EL0=RL/NLEFT
          SCL=1.0
        ELSE
          NLEFT=IABS(NLEFT)
          IF(NODE.GE.8.AND.INT(NLEFT/2)*2.NE.NLEFT) NLEFT=NLEFT+1
          EL0=RL/NLEFT
          SCL=1.0
        END IF
C     if(scl.ge.1.and.scl.lt.SCMAX) WRITE(IO_WORK,6000) SCL,NLEFT,EL0,RL
 6000 format(/' Suggest SCL in  left side',F6.3,' N=',I2,
     1 ' EL0=',E10.4,' RL=',E10.4)
      IF(SCL.GE.SCMAX) THEN
        SCL=1.2
        B=RL*(SCL-1.0)/SCL/EL0+1.0
        NLEFT=LOG(B)/LOG(SCL)
        IF(NLEFT.LT.1) NLEFT=1
        IF(NODE.GE.8.AND.INT(NLEFT/2)*2.NE.NLEFT) NLEFT=NLEFT+1
        CALL SOLVSL(NLEFT,EL0,RL,SCL)
C       WRITE(IO_WORK,6001) scl,nleft,el0,rl
 6001   format(' SCL > SCMAX Program sets ',
     1   'that in  left side SCL=',F6.3,' N=',I2,
     1   ' EL0=',E10.4,' RL=',E10.4)
      ELSE IF(SCL.LT.1.0) THEN
        NLEFT=RL/EL0
        IF(NLEFT.LT.1) NLEFT=1
        IF(NODE.GE.8.AND.INT(NLEFT/2)*2.NE.NLEFT) NLEFT=NLEFT+1
        EL0=RL/NLEFT
        SCL=1.0D0
C       WRITE(IO_WORK,6012) scl,nleft,el0,rl
 6012   format(' SCL < 1.0 Program sets ',
     1   'that in  left side SCL=',F6.3,' N=',I2,
     1   ' EL0=',E10.4,' RL=',E10.4)
      ENDIF
C
C     GENERATING NODE COORDINATES
C
      IN=NNODE
      X=COORD(IN1,1)
      DO K=1,NLEFT
      X=X-EL0*SCL**K
      IF(K.EQ.NLEFT) X=XLEFT
      DO I=1,NYLF
      IN=IN+1
      INP=IWORK(I)
      Y=COORD(INP,2)
      COORD(IN,1)=X
      COORD(IN,2)=Y
      END DO
      END DO
      ELL=EL0*SCL**NLEFT
C
C     GENERATING ELEMENT DEFINITIONS
C
      IF(NODE.EQ.8) THEN
        L6=NNODE-NYLF
        IE=NELEM
        DO J=1,NLEFT/2
          L1=L6-1
          DO I=1,NYLF/2
            L01=IWORK(2*I-1)
            L02=IWORK(2*I)
            L03=IWORK(2*I+1)
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NYLF
            L5=L4+1
            L6=L5+1
            L7=L4+NYLF
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L7
            LNODS(IE,2)=L1
            LNODS(IE,3)=L3
            LNODS(IE,4)=L9
            LNODS(IE,5)=L4
            LNODS(IE,6)=L2
            LNODS(IE,7)=L6
            LNODS(IE,8)=L8
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D8'
            IF(J.EQ.1) THEN
              LNODS(IE,2)=L01
              LNODS(IE,3)=L03
              LNODS(IE,6)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.9) THEN
        L6=NNODE-NYLF
        IE=NELEM
        DO J=1,NLEFT/2
          L1=L6-1
          DO I=1,NYLF/2
            L01=IWORK(2*I-1)
            L02=IWORK(2*I)
            L03=IWORK(2*I+1)
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NYLF
            L5=L4+1
            L6=L5+1
            L7=L4+NYLF
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L7
            LNODS(IE,2)=L1
            LNODS(IE,3)=L3
            LNODS(IE,4)=L9
            LNODS(IE,5)=L4
            LNODS(IE,6)=L2
            LNODS(IE,7)=L6
            LNODS(IE,8)=L8
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D9'
            IF(J.EQ.1) THEN
              LNODS(IE,2)=L01
              LNODS(IE,3)=L03
              LNODS(IE,6)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L2=NNODE-NYLF
        IE=NELEM
        DO J=1,NLEFT
          L1=L2
          DO I=1,NYLF-1
            L01=IWORK(I)
            L02=IWORK(I+1)
            L1=L1+1
            L2=L1+1
            L3=L1+NYLF
            L4=L3+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L3
            LNODS(IE,2)=L1
            LNODS(IE,3)=L2
            LNODS(IE,4)=L4
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D4'
            IF(J.EQ.1) THEN
              LNODS(IE,2)=L01
              LNODS(IE,3)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ENDIF
      IF(NODE.GE.8) CALL NODXY(3,NELEM+1,IE)
      NELEM=IE
      NNODE=IN
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      INL1=NNODE-NYLF+1
      INL2=INL1-NYLF
      N1T=N1T+1
C
C     FOR LOOP IL=1,ILEFT
C
      END DO
C
C     NODE COORDINATES TRANSLATION
C
C     DO I=1,NNODE
C     COORD(I,1)=COORD(I,1)+XORIGN
C     COORD(I,2)=COORD(I,2)+YORIGN
C     END DO
C
      TEXT='END OF EXCUTING SUB. LEFMESH'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
 1000 FORMAT(5X,'!!! ERROR     INPUT:',1X,A,' - ',A,A)
 1001 FORMAT(5X,'!!! COMMAND        :',1X,A,' - ',
     &  /20X,'*LEFMESH,OLD ELSET=?,NEW ELSET=?')
 1002 FORMAT(
     & /20X,'*LINE   ',20X,'(option)'/21X,'X1, Y1, X2, Y2',
     & /20X,'*POLYGON',20X,'(option)'/21X,'X1, Y1, X2, Y2',
     & /20X,'*CIRCLE ',20X,'(option)'/21X,'Xo, Yo , Ri, TH1, TH2'/,
     & /20X,'*ELSET  ',20X,'(option)'/21X,'ELSET1 , ELSET2 '/)
 1010 FORMAT(5X,'!!! UNKNOWN COMMAND:',1X,A,' - ',A,A)
      END
