C
C     PROGRAM FOR GENERATING CRACK_TIP ELEMENT MESH
C
      SUBROUTINE RIGMESH
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XP1(3),XP2(3)
      DIMENSION XSG1(3),YSG1(3),XSG2(3),YSG2(3),EL(100),CL(100)
      CHARACTER*6 CTYPE
C
C     INPUT INITIAL DATA
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. RIGMESH'
      TEXT='NOW EXCUTING SUB. RIGMESH'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      XP1(2) = -1.0E30
      XP1(3) = 0.0E0
      XP2(2) = 1.0E30
      XP2(3) = 0.0E0
C
      CALL LOCCHR(STRING,'YMIN    ',4,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) XP1(2)
      END IF
C
      CALL LOCCHR(STRING,'YMAX    ',4,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) XP2(2)
      END IF
C
      IE=NELEM
      IN=NNODE
      PI=4.0D0*ATAN(1.0D0)
C
C     GENERATING RIGHT SIDE ELEMENT
C
      READ(IO_INPUT,*) IRIGT
      DO III=1,IRIGT
C
        CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
        XP1(1) = XMAX
        XP2(1) = XMAX
        CALL FN_LIN_ND(XP1,XP2,IWORK,NYRT)
        IF(NYRT.LT.2) THEN
          RETURN
        END IF
        CALL SORTCD(IWORK,NYRT,2)
        CALL INVERIA(IWORK,NYRT)
C
      READ(IO_INPUT,*) NRIGT,XRIGT,IMSET,NODE
C
      IF(NODE.GE.8) SCMAX=1.5
      IN1=IWORK(NYRT)
      IN2=IN1-NX123-1
      EL0=ELR
      RL=XRIGT-COORD(IN1,1)
      IF(NRIGT.GT.0) THEN
        IF(NODE.GE.8.AND.INT(NRIGT/2)*2.NE.NRIGT) NRIGT=NRIGT+1
        CALL SOLVSL(NRIGT,EL0,RL,SCL)
      ELSE IF(NRIGT.EQ.-999) THEN
        NRIGT=NINT(RL/EL0)
        IF(NODE.GE.8) NRIGT=2*NINT(RL/EL0/2.0)
        EL0=RL/NRIGT
        SCL=1.0
      ELSE
        NRIGT=IABS(NRIGT)
        IF(NODE.GE.8.AND.INT(NRIGT/2)*2.NE.NRIGT) NRIGT=NRIGT+1
        EL0=RL/NRIGT
        SCL=1.0
      END IF
C     if(scl.ge.1.and.scl.lt.SCMAX) WRITE(IO_WORK,6002) SCL,NRIGT,EL0,RL
 6002 format(/' Suggest SCL in right side',F6.3,' N=',I2,
     1 ' EL0=',E10.4,' RL=',E10.4)
      IF(SCL.GE.SCMAX) THEN
      SCL=0.9*SCMAX
      B=RL*(SCL-1.0)/SCL/EL0+1.0
      NRIGT=LOG(B)/LOG(SCL)
      IF(NRIGT.LT.1) NRIGT=1
      IF(NODE.GE.8.AND.INT(NRIGT/2)*2.NE.NRIGT) NRIGT=NRIGT+1
      CALL SOLVSL(NRIGT,EL0,RL,SCL)
C     WRITE(IO_WORK,6003) scl,nrigt,el0,rl
 6003 format(' SCL > SCMAX Program sets ',
     1 'that in right side SCL=',F6.3,' N=',I2,
     1 ' EL0=',E10.4,' RL=',E10.4)
      ELSE IF(SCL.LT.1.0) THEN
      NRIGT=RL/EL0
      IF(NRIGT.LT.1) NRIGT=1
      IF(NODE.GE.8.AND.INT(NRIGT/2)*2.NE.NRIGT) NRIGT=NRIGT+1
      EL0=RL/NRIGT
      SCL=1.0D0
C     WRITE(IO_WORK,6004) scl,nrigt,el0,rl
 6004 format(' SCL < 1.0 Program sets ',
     1 'that in right side SCL=',F6.3,' N=',I2,
     1 ' EL0=',E10.4,' RL=',E10.4)
      ENDIF
C
C     GENERATING NODE COORDINATES
C
      IN=NNODE
      X=COORD(IN1,1)
      DO K=1,NRIGT
      X=X+EL0*SCL**K
      IF(K.EQ.NRIGT) X=XRIGT
      DO I=1,NYRT
      IN=IN+1
      INP=IWORK(I)
      Y=COORD(INP,2)
      COORD(IN,1)=X
      COORD(IN,2)=Y
      END DO
      END DO
      ELR=EL0*SCL**NRIGT
C
C     GENERATING ELEMENT DEFINITIONS
C
      IF(NODE.EQ.8) THEN
        L6=NNODE-NYRT
        IE=NELEM
        DO J=1,NRIGT/2
          L1=L6-1
          DO I=1,NYRT/2
            L01=IWORK(2*I-1)
            L02=IWORK(2*I)
            L03=IWORK(2*I+1)
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NYRT
            L5=L4+1
            L6=L5+1
            L7=L4+NYRT
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L3
            LNODS(IE,2)=L9
            LNODS(IE,3)=L7
            LNODS(IE,4)=L1
            LNODS(IE,5)=L6
            LNODS(IE,6)=L8
            LNODS(IE,7)=L4
            LNODS(IE,8)=L2
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D8'
            IF(J.EQ.1) THEN
              LNODS(IE,4)=L01
              LNODS(IE,1)=L03
              LNODS(IE,8)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.9) THEN
        L6=NNODE-NYRT
        IE=NELEM
        DO J=1,NRIGT/2
          L1=L6-1
          DO I=1,NYRT/2
            L01=IWORK(2*I-1)
            L02=IWORK(2*I)
            L03=IWORK(2*I+1)
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+NYRT
            L5=L4+1
            L6=L5+1
            L7=L4+NYRT
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L3
            LNODS(IE,2)=L9
            LNODS(IE,3)=L7
            LNODS(IE,4)=L1
            LNODS(IE,5)=L6
            LNODS(IE,6)=L8
            LNODS(IE,7)=L4
            LNODS(IE,8)=L2
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D9'
            IF(J.EQ.1) THEN
              LNODS(IE,4)=L01
              LNODS(IE,1)=L03
              LNODS(IE,8)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L2=NNODE-NYRT
        IE=NELEM
        DO J=1,NRIGT
          L1=L2
          DO I=1,NYRT-1
            L01=IWORK(I)
            L02=IWORK(I+1)
            L1=L1+1
            L2=L1+1
            L3=L1+NYRT
            L4=L3+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L2
            LNODS(IE,2)=L4
            LNODS(IE,3)=L3
            LNODS(IE,4)=L1
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D4'
            IF(J.EQ.1) THEN
              LNODS(IE,4)=L01
              LNODS(IE,1)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ENDIF
      IF(NODE.GE.8) CALL NODXY(3,NELEM+1,IE)
      NELEM=IE
      NNODE=IN
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      INR1=IN
      INR2=INR1-NYRT
      END DO
C
C     NODE COORDINATES TRANSLATION
C
C     DO I=1,NNODE
C     COORD(I,1)=COORD(I,1)+XORIGN
C     COORD(I,2)=COORD(I,2)+YORIGN
C     END DO
C
      TEXT='END OF EXCUTING SUB. RIGMESH'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
