C
C     PROGRAM FOR GENERATING CRACK_TIP ELEMENT MESH
C
      SUBROUTINE UPDNMESH
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XP1(3),XP2(3)
      DIMENSION XSG1(3),YSG1(3),XSG2(3),YSG2(3),EL(100),CL(100)
      CHARACTER*6 CTYPE
C
C     INPUT INITIAL DATA
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. UPDNMESH'
      TEXT='NOW EXCUTING SUB. UPDNMESH'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      XP1(1) = -1.0E30
      XP1(3) = 0.0E0
      XP2(1) = 1.0E30
      XP2(3) = 0.0E0
C
      CALL LOCCHR(STRING,'XMIN    ',4,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) XP1(1)
      END IF
C
      CALL LOCCHR(STRING,'XMAX    ',4,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) XP2(1)
      END IF
C
      IE=NELEM
      IN=NNODE
      PI=4.0D0*ATAN(1.0D0)
C
C     GENERATING UPPER SIDE OR DOWN SIDE ELEMENT
C
      KCASE = 1
      IF(STRING(1:8).EQ.'*DWNMESH') KCASE = 2
      READ(IO_INPUT,*) IUP
C
      DO III=1,IUP
C
        CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
C
        IF(KCASE.EQ.1) THEN
          EL0    = ELU
          XP1(2) = YMAX
          XP2(2) = YMAX
          CALL FN_LIN_ND(XP1,XP2,IWORK,KU)
          CALL SORTCD(IWORK,KU,1)
        ELSE IF(KCASE.EQ.2) THEN
          EL0    = -ABS(ELD)
          XP1(2) = YMIN
          XP2(2) = YMIN
          CALL FN_LIN_ND(XP1,XP2,IWORK,KU)
          CALL SORTCD(IWORK,KU,1)
          CALL INVERIA(IWORK,KU)
        END IF
        IF(KU.LT.2) THEN
          RETURN
        END IF
      READ(IO_INPUT,*) NUP,YUP,IMSET,NODE
C
      IN1=IWORK(1)
      RL=YUP-COORD(IN1,2)
      IF(NUP.GT.0) THEN
        IF(NODE.GE.8) SCMAX=1.5
        IF(NODE.GE.8.AND.INT(NUP/2)*2.NE.NUP) NUP=NUP+1
        CALL SOLVSL(NUP,EL0,RL,SCL)
      ELSE IF(NUP.EQ.-999) THEN
        NUP=NINT(RL/EL0)
        IF(NODE.GE.8) NUP=2*NINT(RL/EL0/2.0)
        EL0=RL/NUP
        SCL=1.0
      ELSE
        NUP=IABS(NUP)
        IF(NODE.GE.8.AND.INT(NUP/2)*2.NE.NUP) NUP=NUP+1
        EL0=RL/NUP
        SCL=1.0
      END IF
C     WRITE(IWRITE,6006) SCL,NUP,EL0,RL
C     if(scl.ge.1.and.scl.lt.SCMAX) WRITE(IO_WORK,6006) SCL,NUP,EL0,RL
 6006 format(/' Suggest SCL in upper side',F6.3,' N=',I2,
     1 ' EL0=',E10.4,' RL=',E10.4)
      IF(SCL.GE.SCMAX) THEN
         SCL=1.4
         B=RL*(SCL-1.0)/SCL/EL0+1.0
         NUP=LOG(B)/LOG(SCL)
         IF(NUP.LT.1) NUP=1
         IF(NODE.GE.8.AND.INT(NUP/2)*2.NE.NUP) NUP=NUP+1
         CALL SOLVSL(NUP,EL0,RL,SCL)
C        WRITE(IO_WORK,6007) scl,nup,el0,rl
 6007    format(' SCL > SCMAX Program sets ',
     1    'that in upper side',' SCL=',F6.3,' N=',I2,
     1    ' EL0=',E10.4,' RL=',E10.4)
      ELSE IF(SCL.LT.1.0) THEN
         NUP=RL/EL0
         IF(NUP.LT.1) NUP=1
         IF(NODE.GE.8.AND.INT(NUP/2)*2.NE.NUP) NUP=NUP+1
         EL0=RL/NUP
         SCL=1.0D0
C        WRITE(IO_WORK,6008) scl,nup,el0,rl
 6008    format(' SCL < 1.0 Program sets ',
     1    'that in upper side SCL=',F6.3,' N=',I2,
     1    ' EL0=',E10.4,' RL=',E10.4)
      ENDIF
C
C     GENERATING NODE COORDINATES
C
      IN=NNODE
      Y=COORD(IN1,2)
      DO K=1,NUP
      Y=Y+EL0*SCL**K
      IF(K.EQ.NUP) Y=YUP
      DO I=1,KU
      IN=IN+1
      INP=IWORK(I)
      X=COORD(INP,1)
      COORD(IN,1)=X
      COORD(IN,2)=Y
      END DO
      END DO
C
C     GENERATING ELEMENT DEFINITIONS
C
      IF(NODE.EQ.8) THEN
        L6=NNODE-KU
        IE=NELEM
        DO J=1,NUP/2
          L1=L6-1
          DO I=1,KU/2
            L01=IWORK(2*I-1)
            L02=IWORK(2*I)
            L03=IWORK(2*I+1)
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+KU
            L5=L4+1
            L6=L5+1
            L7=L4+KU
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D8'
            IF(J.EQ.1) THEN
            LNODS(IE,1)=L01
            LNODS(IE,2)=L03
            LNODS(IE,5)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.9) THEN
        L6=NNODE-KU
        IE=NELEM
        DO J=1,NUP/2
          L1=L6-1
          DO I=1,KU/2
            L01=IWORK(2*I-1)
            L02=IWORK(2*I)
            L03=IWORK(2*I+1)
            L1=L1+2
            L2=L1+1
            L3=L2+1
            L4=L1+KU
            L5=L4+1
            L6=L5+1
            L7=L4+KU
            L8=L7+1
            L9=L8+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L3
            LNODS(IE,3)=L9
            LNODS(IE,4)=L7
            LNODS(IE,5)=L2
            LNODS(IE,6)=L6
            LNODS(IE,7)=L8
            LNODS(IE,8)=L4
            LNODS(IE,9)=L5
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D9'
            IF(J.EQ.1) THEN
            LNODS(IE,1)=L01
            LNODS(IE,2)=L03
            LNODS(IE,5)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      ELSE IF(NODE.EQ.4) THEN
        L2=NNODE-KU
        IE=NELEM
        DO J=1,NUP
          L1=L2
          DO I=1,KU-1
            L01=IWORK(I)
            L02=IWORK(I+1)
            L1=L1+1
            L2=L1+1
            L3=L1+KU
            L4=L3+1
            IE=IE+1
            MATSET(IMSET,1)=MATSET(IMSET,1)+1
            MATSET(IMSET,MATSET(IMSET,1))=IE
            LNODS(IE,1)=L1
            LNODS(IE,2)=L2
            LNODS(IE,3)=L4
            LNODS(IE,4)=L3
            LNODS(IE,MXNOD)=NODE
            LNODS(IE,MXNOD-1)=IMSET
            ELTYP(IE)='C2D4'
            IF(J.EQ.1) THEN
              LNODS(IE,1)=L01
              LNODS(IE,2)=L02
            ENDIF
            CALL DNODE(IE,NODE)
          END DO
        END DO
      END IF
      IF(NODE.GE.8) CALL NODXY(3,NELEM+1,IE)
      NELEM=IE
      NNODE=IN
C
      IF(KEY_WT.EQ.1) CALL DRAWMESH(1)
C
      N1=NNODE-KU+1
      N2=NNODE
      IF(KCASE.EQ.1) THEN
        ELU=EL0*SCL**NUP
      ELSE IF(KCASE.EQ.2) THEN
        ELD=EL0*SCL**NUP
      END IF
      END DO
C
C     NODE COORDINATES TRANSLATION
C
      DO I=1,NNODE
      COORD(I,1)=COORD(I,1)+XORIGN
      COORD(I,2)=COORD(I,2)+YORIGN
      END DO
C
      TEXT='END OF EXCUTING SUB. UPDNMESH'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
