C
C     SUBROUTINE FOR MESH MIRRORING
C
      SUBROUTINE MFLIP
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION XB(6),XBD(3),IELSET(20)
C
C---  Usage of IWORK
C---  IWORK(1..IADDR1): ELEMENT NUMBERS TO BE FLIPPED
C---  IWORK(IADDR1+1..IADDR2): NODE FLAGS/NEW NODE NUMBERS
C---  IWORK(IADDR2+1..IADDR3): NODES TO BE FLIPPED
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MFLIP  '
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. MFLIP  '
C
      iwrite = 21
C
      TEXT='NOW EXCUTING SUB. MFLIP  '
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      KD1   = 1
      KD2   = 2
      KD3   = 3
      IREMOVE = 0
      INEWSET = 0
      CALL LOCCHR(STRING,'DIR     ',3,4,K1,K2)
      IF(K2.GE.K1.AND.STRING(K1:K1).EQ.'Y') THEN
        KD1 = 2
        KD2 = 3
        KD3 = 1
      ELSE IF(K2.GE.K1.AND.STRING(K1:K1).EQ.'Z') THEN
        KD1 = 3
        KD2 = 1
        KD3 = 2
      END IF
      AREF = 0.0E0
      CALL LOCCHR(STRING,'REF     ',3,4,K1,K2)
      IF(K2.GE.K1) READ(STRING(K1:K2),*) AREF
      NREP = 1
      CALL LOCCHR(STRING,'REP     ',3,4,K1,K2)
      IF(K2.GE.K1) READ(STRING(K1:K2),*) NREP
      IF (INDEX(STRING,'REMOVE').NE.0) IREMOVE = 1
      IF (INDEX(STRING,'NEW').NE.0) INEWSET = 1
C
      XB(1) = -1.0E30
      XB(2) = -1.0E30
      XB(3) = -1.0E30
      XB(4) =  1.0E30
      XB(5) =  1.0E30
      XB(6) =  1.0E30
      IDETAI = 0

   10 CONTINUE
      READ(IO_INPUT,'(A)',END=30) STRING
   20 CONTINUE
      LEN = 150
      CALL DTEXT(STRING,LEN)
      IF(STRING(1:2).EQ.'**') THEN
        GOTO 10
      ELSE IF(STRING(1:7).EQ.'*DETAIL') THEN
	IDETAI = 1
        READ(IO_INPUT,*) XB
        GOTO 10
      ELSE IF(STRING(1:1).EQ.'*') THEN
	BACKSPACE IO_INPUT
        GOTO 30
      ELSE
        GOTO 10
      END IF
      GOTO 10
   30 CONTINUE
      XBD(1) = XB(4)-XB(1)
      XBD(2) = XB(5)-XB(2)
      XBD(3) = XB(6)-XB(3)
C
C     CALL SEAND(NDSYS,KSYSM,ASYSM,KNSYS,2)
C
C---  fill of IWORK with element numbers
      DO IREP=1,NREP
C *** REPEAT LOOP
      NCE   = 0
      IF (IDETAI .EQ. 1) THEN
         DO IE=1,NELEM
            NODE  = LNODS(IE,MXNOD)
            IMSET = LNODS(IE,MXNOD-1)
            XM    = 0.0E0
            YM    = 0.0E0
            ZM    = 0.0E0
            KINS  = 0
            DO K=1,NODE
              LNODE = LNODS(IE,K)
              XM = XM + COORD(LNODE,1)
              YM = YM + COORD(LNODE,2)
              ZM = ZM + COORD(LNODE,3)
            END DO
            XM = XM/FLOAT(NODE)
            YM = YM/FLOAT(NODE)
            ZM = ZM/FLOAT(NODE)
            HXM = (XM-XB(1))*(XM-XB(4))
            HYM = (YM-XB(2))*(YM-XB(5))
            HZM = (ZM-XB(3))*(ZM-XB(6))
            IF(HXM.LE.0.0E0.AND.HYM.LE.0.0E0.AND.HZM.LE.0.0E0) THEN
              NCE = NCE + 1
              IWORK(NCE) = IE
            END IF
          END DO
      ELSE
	  NCE = NELEM
          DO ICE = 1,NCE
	     IWORK(ICE) = ICE
	  END DO
      ENDIF
C
C---  fill of IWORK with node flags (1: node to be flipped)
      IADD0 = 1
      IADD1 = NCE + IADD0
      DO I=1,NNODE
        IGASH = IADD1 + I
        IWORK(IGASH) = 0
      END DO
      DO ICE=1,NCE
        IE    = IWORK(ICE)
        NODE  = LNODS(IE,MXNOD)
        DO K=1,NODE
          LNODE = LNODS(IE,K)
          IGASH = IADD1 + LNODE
          IWORK(IGASH) = 1
        END DO
      END DO
C
C---  fill of IWORK with node numbers to be flipped
      IADD2 = IADD1 + NNODE
      NCN   = 0
      DO I=1,NNODE
        IF(IWORK(IADD1+I).EQ.1) THEN
          NCN   = NCN   + 1
          IGASH = IADD2 + NCN
          IWORK(IGASH) = I
        END IF
      END DO
C
      WRITE (IO_WRITE,*) NCE,' Elements and ', NCN ,
     1                       ' nodes are going to be flipped'
C
      IF(IDETAI.EQ.0) THEN
        XB(1) =  1.0E30
        XB(2) =  1.0E30
        XB(3) =  1.0E30
        XB(4) = -1.0E30
        XB(5) = -1.0E30
        XB(6) = -1.0E30
        DO ICN = 1,NCN
          IGASH = IADD2 + ICN
          I = IWORK(IGASH)
          IF(INCOD(I).GT.0) THEN
            IF(XB(1).GT.COORD(I,1)) XB(1) = COORD(I,1)
            IF(XB(4).LT.COORD(I,1)) XB(4) = COORD(I,1)
            IF(XB(2).GT.COORD(I,2)) XB(2) = COORD(I,2)
            IF(XB(5).LT.COORD(I,2)) XB(5) = COORD(I,2)
            IF(XB(3).GT.COORD(I,3)) XB(3) = COORD(I,3)
            IF(XB(6).LT.COORD(I,3)) XB(6) = COORD(I,3)
          END IF
        END DO
        XBD(1) = XB(4)-XB(1)
        XBD(2) = XB(5)-XB(2)
        XBD(3) = XB(6)-XB(3)
      END IF
      INS = 0
      DO ICN = 1,NCN
        IGASH = IADD2 + ICN
        I = IWORK(IGASH)
        IF(INCOD(I).GT.0) THEN
          COONEW = 2.0D0*AREF-COORD(I,KD1)
	  IF (ABS(COONEW-AREF).GT.TOLER .OR. IREMOVE.EQ.0) THEN
             INS = INS + 1
             COORD(INS+NNODE,KD1)=COONEW
             COORD(INS+NNODE,KD2)=COORD(I,KD2)
             COORD(INS+NNODE,KD3)=COORD(I,KD3)
             IWORK(IADD1+I) = INS + NNODE
C-------     write (iwrite,*) 'Knoten ',i,' wird zu',ins+nnode
C-------     write (iwrite,'(I5,A,3F10.5)') 
C----1             ins,'hat die koords ',(coord(ins+nnode,i),i=1,3)
	  ELSE
	     IWORK(IADD1+I) = I
C-------     write (iwrite,*) 'Knoten ',i,' liegt auf der Linie'
          ENDIF
        ENDIF
      END DO
      DO ICE= 1,NCE
        IES   = ICE+NELEM
        IGASH = ICE
        IE    = IWORK(IGASH)
        NODE  = LNODS(IE,MXNOD)
        IMSET = LNODS(IE,MXNOD-1)
        LNODS(IES,MXNOD)   = NODE
	IF (INEWSET.EQ.1) THEN
           LNODS(IES,MXNOD-1) = NSETS+IMSET
	ELSE
           LNODS(IES,MXNOD-1) = IMSET
	ENDIF
        IF(ELTYP(IE)(1:4).EQ.'C2D8'.OR.
     &     ELTYP(IE)(1:4).EQ.'CPE8'.OR.
     &     ELTYP(IE)(1:4).EQ.'CPS8'.OR.
     &     ELTYP(IE)(1:2).EQ.'S8') THEN
          LNODS(IES,1)=IWORK(IADD1+LNODS(IE,2))
          LNODS(IES,2)=IWORK(IADD1+LNODS(IE,1))
          LNODS(IES,3)=IWORK(IADD1+LNODS(IE,4))
          LNODS(IES,4)=IWORK(IADD1+LNODS(IE,3))
          LNODS(IES,5)=IWORK(IADD1+LNODS(IE,5))
          LNODS(IES,6)=IWORK(IADD1+LNODS(IE,8))
          LNODS(IES,7)=IWORK(IADD1+LNODS(IE,7))
          LNODS(IES,8)=IWORK(IADD1+LNODS(IE,6))
        ELSE IF(ELTYP(IE)(1:4).EQ.'C2D6'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPE6'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPS6') THEN
          LNODS(IES,1)=IWORK(IADD1+LNODS(IE,1))
          LNODS(IES,2)=IWORK(IADD1+LNODS(IE,3))
          LNODS(IES,3)=IWORK(IADD1+LNODS(IE,2))
          LNODS(IES,4)=IWORK(IADD1+LNODS(IE,6))
          LNODS(IES,5)=IWORK(IADD1+LNODS(IE,5))
          LNODS(IES,6)=IWORK(IADD1+LNODS(IE,4))
        ELSE IF(ELTYP(IE)(1:4).EQ.'C2D4'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPE4'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPS4'.OR.
     &          ELTYP(IE)(1:2).EQ.'S4') THEN
          LNODS(IES,1)=IWORK(IADD1+LNODS(IE,1))
          LNODS(IES,2)=IWORK(IADD1+LNODS(IE,4))
          LNODS(IES,3)=IWORK(IADD1+LNODS(IE,3))
          LNODS(IES,4)=IWORK(IADD1+LNODS(IE,2))
        ELSE IF(ELTYP(IE)(1:4).EQ.'C2D3'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPE3'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPS3') THEN
          LNODS(IES,1)=IWORK(IADD1+LNODS(IE,1))
          LNODS(IES,2)=IWORK(IADD1+LNODS(IE,3))
          LNODS(IES,3)=IWORK(IADD1+LNODS(IE,2))
        ELSE IF(ELTYP(IE)(1:5).EQ.'C3D20') THEN
          LNODS(IES, 1)=IWORK(IADD1+LNODS(IE, 1))
          LNODS(IES, 2)=IWORK(IADD1+LNODS(IE, 4))
          LNODS(IES, 3)=IWORK(IADD1+LNODS(IE, 3))
          LNODS(IES, 4)=IWORK(IADD1+LNODS(IE, 2))
          LNODS(IES, 5)=IWORK(IADD1+LNODS(IE, 5))
          LNODS(IES, 6)=IWORK(IADD1+LNODS(IE, 8))
          LNODS(IES, 7)=IWORK(IADD1+LNODS(IE, 7))
          LNODS(IES, 8)=IWORK(IADD1+LNODS(IE, 6))
          LNODS(IES, 9)=IWORK(IADD1+LNODS(IE,12))
          LNODS(IES,10)=IWORK(IADD1+LNODS(IE,11))
          LNODS(IES,11)=IWORK(IADD1+LNODS(IE,10))
          LNODS(IES,12)=IWORK(IADD1+LNODS(IE, 9))
          LNODS(IES,13)=IWORK(IADD1+LNODS(IE,16))
          LNODS(IES,14)=IWORK(IADD1+LNODS(IE,15))
          LNODS(IES,15)=IWORK(IADD1+LNODS(IE,14))
          LNODS(IES,16)=IWORK(IADD1+LNODS(IE,13))
          LNODS(IES,17)=IWORK(IADD1+LNODS(IE,17))
          LNODS(IES,18)=IWORK(IADD1+LNODS(IE,20))
          LNODS(IES,19)=IWORK(IADD1+LNODS(IE,19))
          LNODS(IES,20)=IWORK(IADD1+LNODS(IE,18))
        ELSE IF(ELTYP(IE)(1:4).EQ.'C3D4') THEN
          LNODS(IES, 1)=IWORK(IADD1+LNODS(IE, 1))
          LNODS(IES, 2)=IWORK(IADD1+LNODS(IE, 3))
          LNODS(IES, 3)=IWORK(IADD1+LNODS(IE, 2))
          LNODS(IES, 4)=IWORK(IADD1+LNODS(IE, 4))
        ELSE IF(ELTYP(IE)(1:4).EQ.'C3D6') THEN
          LNODS(IES, 1)=IWORK(IADD1+LNODS(IE, 1))
          LNODS(IES, 2)=IWORK(IADD1+LNODS(IE, 3))
          LNODS(IES, 3)=IWORK(IADD1+LNODS(IE, 2))
          LNODS(IES, 4)=IWORK(IADD1+LNODS(IE, 4))
          LNODS(IES, 5)=IWORK(IADD1+LNODS(IE, 6))
          LNODS(IES, 6)=IWORK(IADD1+LNODS(IE, 5))
        ELSE IF(ELTYP(IE)(1:4).EQ.'C3D8') THEN
          LNODS(IES, 1)=IWORK(IADD1+LNODS(IE, 1))
          LNODS(IES, 2)=IWORK(IADD1+LNODS(IE, 4))
          LNODS(IES, 3)=IWORK(IADD1+LNODS(IE, 3))
          LNODS(IES, 4)=IWORK(IADD1+LNODS(IE, 2))
          LNODS(IES, 5)=IWORK(IADD1+LNODS(IE, 5))
          LNODS(IES, 6)=IWORK(IADD1+LNODS(IE, 8))
          LNODS(IES, 7)=IWORK(IADD1+LNODS(IE, 7))
          LNODS(IES, 8)=IWORK(IADD1+LNODS(IE, 6))
        ELSE IF(ELTYP(IE)(1:5).EQ.'C3D15') THEN
          LNODS(IES, 1)=IWORK(IADD1+LNODS(IE, 1))
          LNODS(IES, 2)=IWORK(IADD1+LNODS(IE, 3))
          LNODS(IES, 3)=IWORK(IADD1+LNODS(IE, 2))
          LNODS(IES, 4)=IWORK(IADD1+LNODS(IE, 4))
          LNODS(IES, 5)=IWORK(IADD1+LNODS(IE, 6))
          LNODS(IES, 6)=IWORK(IADD1+LNODS(IE, 5))
          LNODS(IES, 7)=IWORK(IADD1+LNODS(IE, 9))
          LNODS(IES, 8)=IWORK(IADD1+LNODS(IE, 8))
          LNODS(IES, 9)=IWORK(IADD1+LNODS(IE, 7))
          LNODS(IES,10)=IWORK(IADD1+LNODS(IE,12))
          LNODS(IES,11)=IWORK(IADD1+LNODS(IE,11))
          LNODS(IES,12)=IWORK(IADD1+LNODS(IE,10))
          LNODS(IES,13)=IWORK(IADD1+LNODS(IE,13))
          LNODS(IES,14)=IWORK(IADD1+LNODS(IE,15))
          LNODS(IES,15)=IWORK(IADD1+LNODS(IE,14))
        ENDIF
        CALL DNODE(IES,NODE)
	IF (INEWSET.EQ.1) THEN
           MATSET(NSETS+IMSET,1)=MATSET(NSETS+IMSET,1)+1
           MATSET(NSETS+IMSET,MATSET(NSETS+IMSET,1))=IES
	ELSE
           MATSET(IMSET,1)=MATSET(IMSET,1)+1
           MATSET(IMSET,MATSET(IMSET,1))=IES
	ENDIF
        ELTYP(IES)=ELTYP(IE)
C------ write (iwrite,*) 'Element',ies,'Knoten',(lnods(ies,i),i=1,4)
      END DO
C
      NNODE = NNODE + INS
      NELEM = NELEM + NCE
      IF (INEWSET.EQ.1) THEN
	 WRITE (IO_WRITE,*) NSETS,
     1              " NEW ELEMENT SETS DEFINED BY THE FLIP COMMAND"
         DO I = 1,NSETS
            ELSET_TYP(NSETS+I)=ELSET_TYP(I)
         END DO
      ENDIF
      NSETS = NSETS + NSETS
      AREF  = AREF + XBD(KD1)
      XB(KD1) = XB(KD1) + XBD(KD1)
      XB(KD1+3) = XB(KD1+3) + XBD(KD1)
C *** REPEAT LOOP
      END DO
C
      TEXT='END OF EXCUTING SUB. MFLIP'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
