C&             
C     READING  COORDINATES FOR GENERATING MAPE MESH
C
      SUBROUTINE COORDI
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      INCLUDE 'mcom_map'
      DIMENSION XSG(30),YSG(30),IDEL(4),SHF(30),IJ(30),ASH(30)
      DIMENSION LNCV(10,10)
      CHARACTER*6 CTYPE
      CHARACTER*120 CSTRI
C
C     INPUT INITIAL DATA
C
      PI  = 4.0D0*ATAN(1.0E0)
      TPI = PI/180.0D0
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. COORDI'
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. COORDI'
      TEXT='NOW EXCUTING SUB.COORDI'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      ITYPE(1) = 1
      ITYPE(2) = 2
      ITYPE(3) = 2
      ITYPE(4) = 2
      ITYPE(5) = 2
      ITYPE(6) = 2
      ITYPE(7) = 2
C
    5 CONTINUE
      CALL GETLINE (LEN,IERR)
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE IO_INPUT
        GOTO 9
      ELSE
        IF(STRING(1:1).EQ.'P') THEN
C ***   POLAR COORDINATE SYSTEMS
	  CSTRI = STRING(2:121)
	  LEN = LEN - 1
	  INVAR = 5
          CALL SLVLINE (CSTRI,LEN,IERR)
	  IP = IVARR(1)
	  DO I = 1,4
	     CDLRG(I,IP) = RVARR(I+1)
	  ENDDO
          ICDRG(IP) = 1
        ELSE IF(STRING(1:1).EQ.'O') THEN
C ***   POLAR COORDINATE SYSTEMS
	  CSTRI = STRING(2:121)
	  LEN = LEN - 1
	  INVAR = 7
          CALL SLVLINE (CSTRI,LEN,IERR)
	  IP = IVARR(1)
          ICDRG(IP) = 0
          DDMAX = 1.0E30
	  DO I = 1,6
	     CDLRG(I,IP) = RVARR(I+1)
	  ENDDO
          XM = RVARR(1)
          YM = RVARR(2)
          X1 = RVARR(3)
          Y1 = RVARR(4)
          X2 = RVARR(5)
          Y2 = RVARR(6)
          DO I=1,NELEM
            NODE  = LNODS(I,MXNOD)
            NN    = NODE
            IF(NODE.GE.6) NN  = NODE/2
            DO K=1,NN 
              IN=LNODS(I,K)
              IF(INCOD(IN).GT.0) THEN
                X = COORD(IN,1)
                Y = COORD(IN,2)
                DD = SQRT((X-XM)*(X-XM)+(Y-YM)*(Y-YM))
                DR = ABS((X-X1)*(Y1-Y2)-(X1-X2)*(Y-Y1))
                XR = (X-X1)*(X-X2)
                YR = (Y-Y1)*(Y-Y2)
                RR = SQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
                IF(RR.LE.TOLER) RR=1.0
                DR = DR/RR
                XR = SQSN(XR)/RR
                YR = SQSN(YR)/RR
                IF(DR.LT.TOLER.AND.XR.LE.TOLER.AND.YR.LE.TOLER) THEN
                  IF(DD.LT.DDMAX) THEN
                    DDMAX = DD
                    CDLRG(1,IP) = X
                    CDLRG(2,IP) = Y
                  END IF
                END IF
              END IF
            END DO
          END DO
        ELSE
	  CSTRI = STRING(1:120)
	  INVAR = 5
          CALL SLVLINE (CSTRI,LEN,IERR)
	  IP = IVARR(1)
	  CDLRG(1,IP) = RVARR(2) + RVARR(4)
	  CDLRG(2,IP) = RVARR(3) + RVARR(5)
	  CDLRG(3,IP) = RVARR(4)
	  CDLRG(4,IP) = RVARR(5)
          ICDRG(IP) = 0
        END IF
        GOTO 5
      END IF
    9 CONTINUE
      RETURN
      END
C
C     PROGRAM FOR GENERATING UNIFORM CRACK_TIP ELEMENT MESH
C
      SUBROUTINE MAPE2D
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      INCLUDE 'mcom_map'
      DIMENSION XSG(30),YSG(30),IDEL(4),NCOR(5),SHF(30),IJ(30),ASH(30)
      DIMENSION LNCV(10,10)
      CHARACTER*6 CTYPE
      CHARACTER*120 CSTRI
C
C     INPUT INITIAL DATA
C
      PI  = 4.0D0*ATAN(1.0E0)
      TPI = PI/180.0D0
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MAPE2D'
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. MAPE2D'
      TEXT='NOW EXCUTING SUB.MAPE2D'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      IRG0= NRG
      IMSET = 1
      CALL LOCCHR(STRING,'ELSET',5,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET
      END IF
      NODE = 4
      CALL LOCCHR(STRING,'NODE',4,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) NODE
      END IF
      ND2    = 1
      IF(NODE.GT.4) ND2 = 2
C
      NRG = NRG + 1
      IF(NRG.GT.MRG) THEN
        WRITE(IO_WRITE,'(A,A,1X,I3/24X,A)')
     & ' *** ERROR: MAPEmesh',
     & ' -- Mesh regions over given value',MRG,
     & 'Increasing MRG in common block *mcom_map*'
      END IF
      READ(IO_INPUT,*) NELRG,(LNSRG(NRG,K),K=1,NELRG)
      JELRG(NRG) = NELRG
      IF(NELRG.LT.4) THEN
        WRITE(IO_WRITE,'(A)') 'INPUT ERROR: in MAPEmesh'
        STOP
      END IF
      DO K=1,4
        IDEL(K)  = 1
        NCOR(K)  = K
        SCRB (NRG,K) = 1.0E0
        ICVRB(NRG,K) = 0
        JSCRB(NRG,K) = 0
      END DO
      NCOR(5)  = 1
    5 READ(IO_INPUT,'(A)') STRING
    6 IF(STRING(1:2).EQ.'**') THEN
         GOTO 5
      ELSE IF(STRING(1:5).EQ.'*EDGE') THEN
         READ(IO_INPUT,'(A)') STRING
         DO K=1,4
            IF(STRING(K:K).EQ.'C') IDEL(K) = 2
            IF(STRING(K:K).EQ.'P') IDEL(K) = 3
         END DO
         GOTO 5
      ELSE IF(STRING(1:7).EQ.'*CONNEC') THEN
         READ(IO_INPUT,*) (ICVRB(NRG,K),K=1,4)
         GOTO 5
      ELSE IF(STRING(1:7).EQ.'*CORNER') THEN
         READ(IO_INPUT,*) (NCOR(K),K=1,4)
         GOTO 5
      ELSE IF(STRING(1:5).EQ.'*BIAS') THEN
         READ(IO_INPUT,*) (SCRB (NRG,K),K=1,4)
C        READ(IO_INPUT,*) (JSCRB(NRG,K),K=1,4)
         GOTO 5
      ELSE IF(STRING(1:8).EQ.'*MESHING') THEN
         READ(IO_INPUT,*) (MSHRG(NRG,K),K=1,4)
         IF(MSHRG(NRG,3).NE.MSHRG(NRG,1)) MSHRG(NRG,3) = MSHRG(NRG,1)
         IF(MSHRG(NRG,4).NE.MSHRG(NRG,2)) MSHRG(NRG,4) = MSHRG(NRG,2)
         GOTO 5
      ELSE IF(STRING(1:6).EQ.'*COORD') THEN
         ITYPE(1) = 1
         ITYPE(2) = 2
         ITYPE(3) = 2
         ITYPE(4) = 2
         ITYPE(5) = 2
         ITYPE(6) = 2
         ITYPE(7) = 2
    7    CONTINUE
         CALL GETLINE (LEN,IERR)
         IF(STRING(1:1).EQ.'*') THEN
            GOTO 6
         ELSE IF(STRING(1:1).EQ.'P') THEN
C ***    POLAR COORDINATE SYSTEMS
	  CSTRI = STRING(2:121)
	  LEN = LEN - 1
	  INVAR = 5
          CALL SLVLINE (CSTRI,LEN,IERR)
	  IP = IVARR(1)
	  DO I = 1,4
	     CDLRG(I,IP) = RVARR(I+1)
	  ENDDO
          ICDRG(IP) = 1
        ELSE IF(STRING(1:1).EQ.'O') THEN
C ***   POLAR COORDINATE SYSTEMS
	  CSTRI = STRING(2:121)
	  LEN = LEN - 1
	  INVAR = 7
          CALL SLVLINE (CSTRI,LEN,IERR)
	  IP = IVARR(1)
          ICDRG(IP) = 0
          DDMAX = 1.0E30
	  DO I = 1,6
	     CDLRG(I,IP) = RVARR(I+1)
	  ENDDO
          XM = RVARR(1)
          YM = RVARR(2)
          X1 = RVARR(3)
          Y1 = RVARR(4)
          X2 = RVARR(5)
          Y2 = RVARR(6)
          DO I=1,NELEM
            NODE  = LNODS(I,MXNOD)
            NN    = NODE
            IF(NODE.GE.6) NN  = NODE/2
            DO K=1,NN 
              IN=LNODS(I,K)
              IF(INCOD(IN).GT.0) THEN
                X = COORD(IN,1)
                Y = COORD(IN,2)
                DD = SQRT((X-XM)*(X-XM)+(Y-YM)*(Y-YM))
                DR = ABS((X-X1)*(Y1-Y2)-(X1-X2)*(Y-Y1))
                XR = (X-X1)*(X-X2)
                YR = (Y-Y1)*(Y-Y2)
                RR = SQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
                IF(RR.LE.TOLER) RR=1.0
                DR = DR/RR
                XR = SQSN(XR)/RR
                YR = SQSN(YR)/RR
                IF(DR.LE.TOLER.AND.XR.LE.TOLER.AND.YR.LE.TOLER) THEN
                  IF(DD.LT.DDMAX) THEN
                    DDMAX = DD
                    CDLRG(1,IP) = X
                    CDLRG(2,IP) = Y
                  END IF
                END IF
              END IF
            END DO
          END DO
        ELSE
	  CSTRI = STRING(1:120)
	  INVAR = 5
          CALL SLVLINE (CSTRI,LEN,IERR)
	  IP = IVARR(1)
	  CDLRG(1,IP) = RVARR(2) + RVARR(4)
	  CDLRG(2,IP) = RVARR(3) + RVARR(5)
	  CDLRG(3,IP) = RVARR(4)
	  CDLRG(4,IP) = RVARR(5)
          ICDRG(IP) = 0
        END IF
        GOTO 7
      ELSE IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE IO_INPUT
        GOTO 9
      ELSE
        GOTO 5
      END IF
    9 CONTINUE
      DO K=1,4
        NTYRB(NRG,K) = IDEL(K)
        IF(ABS(SCRB(NRG,K)-1.0E0).GT.1.0E-2) THEN
          JSCRB(NRG,K) = 1
        ELSE
          SCRB (NRG,K) = 1.0E0
          JSCRB(NRG,K) = 0
        END IF
      END DO
C *** FIND BOUNDARY BOUNDARY TYPE
      DO K=1,4
        IP1 = LNSRG(NRG,NCOR(K))
        IP2 = LNSRG(NRG,NCOR(K+1))
        KT1 = ICDRG(IP1)
        KT2 = ICDRG(IP2)
        IF(KT1.EQ.1.AND.KT2.EQ.1) THEN
C ******* BOUNDARY BOUNDARY TYPE: POLAR
          R1 = CDLRG(1,IP1)
          X1 = CDLRG(3,IP1)
          Y1 = CDLRG(4,IP1)
          R2 = CDLRG(1,IP2)
          X2 = CDLRG(3,IP2)
          Y2 = CDLRG(4,IP2)
          XR = ABS(X1-X2)
          YR = ABS(Y1-Y2)
          RR = ABS(R1-R2)
          IF(XR.LT.TOLER.AND.YR.LT.TOLER.AND.RR.LT.TOLER)
     &       NTYRB(NRG,K) = 2
        END IF
      END DO
      IF(NRG.GT.1) THEN
C *** FIND BOUNDARY CONNECTIVITY OF MESH REGION  AND BOUNDARY TYPE
        DO K=1,4
          IP1 = LNSRG(NRG,NCOR(K))
          IP2 = LNSRG(NRG,NCOR(K+1))
          DO JRG=1,NRG-1
            DO KL=1,4
              JCL1 = NCOR(KL)
              JCL2 = NCOR(KL+1)
              JP1  = LNSRG(JRG,JCL1)
              JP2  = LNSRG(JRG,JCL2)
              IF((IP1.EQ.JP1.AND.IP2.EQ.JP2).OR.
     &           (IP2.EQ.JP1.AND.IP1.EQ.JP2)) GOTO 20
            END DO
          END DO
          GOTO 22
   20     CONTINUE
          LNSRG(NRG,K+4) = LNSRG(JRG,KL+4)
          ICVRB(NRG,K) = JRG*100+KL
          MSHRG(NRG,K) = MSHRG(JRG,KL)
          IF(K.EQ.1) KK = 3
          IF(K.EQ.3) KK = 1
          IF(K.EQ.2) KK = 4
          IF(K.EQ.4) KK = 2
          MSHRG(NRG,KK) = MSHRG(JRG,KL)
   22     CONTINUE
        END DO
      END IF
      DO K=1,2
        LNCV(K,1) = 2
        LNCV(K,2) = LNSRG(NRG,NCOR(K))
        LNCV(K,3) = LNSRG(NRG,NCOR(K+1))
        IF(LNSRG(NRG,4+K).NE.0) THEN
          LNCV(K,1) = 3
          LNCV(K,4) = LNSRG(NRG,4+K)
          IF(NTYRB(NRG,K).NE.2) NTYRB(NRG,K) = 3
        END IF
      END DO
      DO K=3,4
        LNCV(K,1) = 2
        LNCV(K,2) = LNSRG(NRG,NCOR(K+1))
        LNCV(K,3) = LNSRG(NRG,NCOR(K))
        IF(LNSRG(NRG,4+K).NE.0) THEN
          LNCV(K,1) = 3
          LNCV(K,4) = LNSRG(NRG,4+K)
          IF(NTYRB(NRG,K).NE.2) NTYRB(NRG,K) = 3
        END IF
      END DO
      DO K=1,4
        IF(ICVRB(NRG,K).LE.0) THEN
C ***   BOUNDARY NODE FOUND BY PROGRAM
C
          NN  = LNCV(K,1)
          LP1 = LNCV(K,2)
          LP2 = LNCV(K,3)
          IF(ICDRG(LP1).EQ.0) THEN
            X1  = CDLRG(1,LP1)
            Y1  = CDLRG(2,LP1)
          ELSE
            X0 = CDLRG(3,LP1)
            Y0 = CDLRG(4,LP1)
            R  = CDLRG(1,LP1)
            T  = CDLRG(2,LP1)*TPI
            X1 = X0+R*COS(T)
            Y1 = Y0+R*SIN(T)
          END IF
          IF(ICDRG(LP2).EQ.0) THEN
            X2  = CDLRG(1,LP2)
            Y2  = CDLRG(2,LP2)
          ELSE
            X0 = CDLRG(3,LP2)
            Y0 = CDLRG(4,LP2)
            R  = CDLRG(1,LP2)
            T  = CDLRG(2,LP2)*TPI
            X2 = X0+R*COS(T)
            Y2 = Y0+R*SIN(T)
          END IF
C
          NC = 0
          IP1= 0
          DO IP=1,NNODE
            IF(INCOD(IP).GT.0) THEN
              X = COORD(IP,1)
              Y = COORD(IP,2)
              DR = ABS((X-X1)*(Y2-Y1)-(X2-X1)*(Y-Y1))
              XR = (X-X1)*(X-X2)
              YR = (Y-Y1)*(Y-Y2)
              RR = SQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
              IF(RR.LE.TOLER) RR=1.0
              DR = DR/RR
              XR = SQSN(XR)/RR
              YR = SQSN(YR)/RR
              IF(DR.LE.TOLER.AND.XR.LE.TOLER.AND.YR.LE.TOLER) THEN
                NC = NC + 1
                IWORK(NC) = IP
                IF(ABS(X-X1).LT.TOLER.AND.ABS(Y-Y1).LT.TOLER) IP1= NC
              END IF
            END IF
          END DO
          IF(NC.LE.2) GOTO 59
          IF(IP1.EQ.0) THEN
            WRITE(IO_WRITE,'(3A)') 'ERROR in MAPE2D',
     &      ' Determining the NODES in the mesh boundary'
            STOP
          END IF
          JJ = 1
          NNRB(NRG,K,JJ) = IWORK(IP1)
          IWORK(IP1) = 0
          IP1 = NNRB(NRG,K,JJ)
   50     CONTINUE
          DIM = 1.0E30
          DO IC=1,NC
            IP = IWORK(IC)
            IF(IP.GT.0) THEN
              X   = COORD(IP,1)
              Y   = COORD(IP,2)
              DI = SQRT((X-X1)*(X-X1)+(Y-Y1)*(Y-Y1))
              IF(DI.LT.DIM) THEN
                IPI = IC
                DIM = DI
              END IF
            END IF
          END DO
   54     CONTINUE
          JJ = JJ + 1
          NNRB(NRG,K,JJ) = IWORK(IPI)
          IWORK(IPI) = 0
          IF(JJ.LT.NC) GOTO 50
          NUM2 = JJ
          NUM = (NUM2-1)/ND2
          MSHRG(NRG,K) = NUM
          IF(K.EQ.1) KK = 3
          IF(K.EQ.3) KK = 1
          IF(K.EQ.2) KK = 4
          IF(K.EQ.4) KK = 2
          MSHRG(NRG,KK) = MSHRG(NRG,K)
          XM = 0.5E0*(X1+X2)
          YM = 0.5E0*(Y1+Y2)
C         XR = ABS(XX-XM)
C         YR = ABS(YY-YM)
          DO J=1,NUM2
            IP = NNRB(NRG,K,J)
            XX = COORD(IP,1)
            YY = COORD(IP,2)
            IF(ABS(Y2-YM).GT.TOLER) THEN
              ET = (YY-YM)/(Y2-YM)
            ELSE
              ET = (XX-XM)/(X2-XM)
            END IF
            CDLRB(NRG,J,K) = ET
            CODRB(1,J,K) = XX
            CODRB(2,J,K) = YY
          END DO
          ICVRB(NRG,K) = -1
        END IF
   59   CONTINUE
      END DO
      KEYCV = 0
      NNODE0 = NNODE
      NELEM0 = NELEM
      NCOLS = MSHRG(NRG,1)
      NROWS = MSHRG(NRG,2)
      NCOLS2= NCOLS*ND2+1
      NROWS2= NROWS*ND2+1
      ADIST = 0.0E0
      DO K=1,4
        NUM = MSHRG(NRG,K)
        NN  = LNCV(K,1)
        LP1 = LNCV(K,2)
        LP2 = LNCV(K,3)
        IF(ICDRG(LP1).EQ.0) THEN
          X1  = CDLRG(1,LP1)
          Y1  = CDLRG(2,LP1)
        ELSE
          X0 = CDLRG(3,LP1)
          Y0 = CDLRG(4,LP1)
          R  = CDLRG(1,LP1)
          T  = CDLRG(2,LP1)*TPI
          X1 = X0+R*COS(T)
          Y1 = Y0+R*SIN(T)
        END IF
        IF(ICDRG(LP2).EQ.0) THEN
          X2  = CDLRG(1,LP2)
          Y2  = CDLRG(2,LP2)
        ELSE
          X0 = CDLRG(3,LP2)
          Y0 = CDLRG(4,LP2)
          R  = CDLRG(1,LP2)
          T  = CDLRG(2,LP2)*TPI
          X2 = X0+R*COS(T)
          Y2 = Y0+R*SIN(T)
        END IF
	ZVAL = 0.0
        ADIST = ADIST + 0.25*DISTN(X1,Y1,ZVAL,X2,Y2,ZVAL)/(NUM*ND2)
        IF(ICVRB(NRG,K).GT.0) THEN
C *****   BOUNDARY NODE DETERMINED BY MESH REGION CONNECTIVITY
          NUM  = MSHRG(NRG,K)
          NUM2 = NUM*ND2+1
          NG  = ICVRB(NRG,K)
          JRG = NG/100
          KL  = NG-JRG*100
          DO J=1,NUM2
            JN = NUM2+1-J
            AG = -1.0E0
            IF((K.GE.3.AND.KL.LT.3).OR.
     &         (K.LT.3.AND.KL.GE.3)) THEN
              AG = 1.0E0
              JN = J
            END IF
            CDLRB(NRG,JN,K) = AG*CDLRB(JRG,J,KL)
            NNRB(NRG,K,JN) = NNRB(JRG,KL,J)
            CODRB(1,JN,K) = COORD(NNRB(JRG,KL,J),1)
            CODRB(2,JN,K) = COORD(NNRB(JRG,KL,J),2)
          END DO
        ELSE IF(ICVRB(NRG,K).EQ.0) THEN
C *****   BOUNDARY NODE GENERATED BY PROGRAM
          BIAS = SCRB (NRG,K)
          KTYP = NTYRB(NRG,K)
          JBIA = JSCRB(NRG,K)
          NUM  = MSHRG(NRG,K)
          ANUM = FLOAT(NUM)
          IF(JBIA.EQ.1.AND.ABS(BIAS-1.0E0).GT.1.0E-2) THEN
            EL0 = 2.0E0*(1.0E0-BIAS)/(1.0E0-BIAS**ANUM)
          ELSE IF(JBIA.EQ.0.OR.ABS(BIAS-1.0E0).LE.1.0E-2) THEN
            BIAS= 1.0E0
            EL0 = 2.0E0/ANUM
          END IF
          ET0 = -1.0D0
          ET  = -1.0D0
          NC = 0
          DO J=1,NUM
            NC = NC + 1
            RWORK(NC) = ET
            ET = ET + EL0*BIAS**FLOAT(J-1)
            IF(ND2.EQ.2) THEN
              NC = NC + 1
              RWORK(NC) = 0.5D0*(ET0+ET)
            END IF
            ET0 = ET
          END DO
          NC = NC + 1
          RWORK( 1) =-1.0E0
          RWORK(NC) = 1.0E0
          NUM2 = NUM*ND2+1
          IF(KTYP.EQ.1) THEN
C *****     STRAIGHT BOUNDARY
            DO J=1,NUM2
              CDLRB(NRG,J,K) = RWORK(J)
              IF(K.EQ.1) THEN
                NC = J
              ELSE IF(K.EQ.2) THEN
                NC = J*NCOLS2
              ELSE IF(K.EQ.3) THEN
                NC = (NROWS2-1)*NCOLS2+J
              ELSE IF(K.EQ.4) THEN
                NC = (J-1)*NCOLS2+1
              END IF
              NNRB(NRG,K,J) = NNODE0+NC
              XX = 0.5E0*(X1+X2) + 0.5E0*RWORK(J)*(X2-X1)
              YY = 0.5E0*(Y1+Y2) + 0.5E0*RWORK(J)*(Y2-Y1)
              CODRB(1,J,K) = XX
              CODRB(2,J,K) = YY
            END DO
          ELSE IF(KTYP.EQ.2) THEN
C *****     CIRCLE   BOUNDARY
            R1  = CDLRG(1,LP1)
            T1  = CDLRG(2,LP1)*TPI
            X1  = CDLRG(3,LP1)
            Y1  = CDLRG(4,LP1)
            R2  = CDLRG(1,LP2)
            T2  = CDLRG(2,LP2)*TPI
            X2  = CDLRG(3,LP2)
            Y2  = CDLRG(4,LP2)
            LP3 = LNCV(K,4)
            IF(NN.EQ.3) THEN
              R3  = CDLRG(1,LP3)
              T3  = CDLRG(2,LP3)*TPI
              X3  = CDLRG(3,LP3)
              Y3  = CDLRG(4,LP3)
              DD = (T3-T1)*(T3-T2)
              D1 = (T3-T1)
              D2 = (T2-T3)
              IF(ABS(T1+T2-2*T3).GT.1.0E-4) THEN
                IF(ABS(D1).LT.ABS(D2)) THEN
                  IF(ABS(T1+T2+2.0E0*PI-2*T3).LT.1.0E-4) THEN
                    T2 = T2 + 2.0E0**PI
                  ELSE
                    T2 = T2 - 2.0E0*PI
                  END IF
                ELSE
                  IF(ABS(T1+T2+2.0E0*PI-2*T3).LT.1.0E-4) THEN
                    T1 = T1 + 2.0E0*PI
                  ELSE
                    T1 = T1 - 2.0E0*PI
                  END IF
                END IF
              END IF
            ELSE
              R3  = 0.5E0*(R1+R2)
              T3  = 0.5E0*(T1+T2)
              X3  = 0.5E0*(X1+X2)
              Y3  = 0.5E0*(Y1+Y2)
              INPRG = INPRG - 1
              LNCV(K,4) = INPRG
              ICDRG(INPRG) = 1
              LNSRG(NRG,4+K) = INPRG
              CDLRG(1,INPRG) = R3
              CDLRG(2,INPRG) = T3/TPI
              CDLRG(3,INPRG) = X3
              CDLRG(4,INPRG) = Y3
            END IF
            DO J=1,NUM2
              CDLRB(NRG,J,K) = RWORK(J)
              IF(K.EQ.1) THEN
                NC = J
              ELSE IF(K.EQ.2) THEN
                NC = J*NCOLS2
              ELSE IF(K.EQ.3) THEN
                NC = (NROWS2-1)*NCOLS2+J
              ELSE IF(K.EQ.4) THEN
                NC = (J-1)*NCOLS2+1
              END IF
              NNRB(NRG,K,J) = NNODE0+NC
              ST = RWORK(J)
              CALL SFR(SHF,ASH,1,ST,TT)
              TT = SHF(1)*T1+SHF(2)*T2+SHF(3)*T3
              XX = X0+R1*COS(TT)
              YY = Y0+R1*SIN(TT)
              CODRB(1,J,K) = XX
              CODRB(2,J,K) = YY
            END DO
          ELSE IF(KTYP.EQ.3) THEN
C *****     POLYNOMAL BOUNDARY
            LP3 = LNCV(K,4)
            X3  = CDLRG(1,LP3)
            Y3  = CDLRG(2,LP3)
            KEY = 1
            DO J=1,NUM2
              CDLRB(NRG,J,K) = RWORK(J)
              IF(K.EQ.1) THEN
                NC = J
              ELSE IF(K.EQ.2) THEN
                NC = J*NCOLS2
              ELSE IF(K.EQ.3) THEN
                NC = (NROWS2-1)*NCOLS2+J
              ELSE IF(K.EQ.4) THEN
                NC = (J-1)*NCOLS2+1
              END IF
              NNRB(NRG,K,J) = NNODE0+NC
              ST = RWORK(J)
              TT = 1.0E0
              CALL SFR(SHF,ASH,KEY,ST,TT)
              XX = X1*SHF(1)+X2*SHF(2)+X3*SHF(3)
              YY = Y1*SHF(1)+Y2*SHF(2)+Y3*SHF(3)
              CODRB(1,J,K) = XX
              CODRB(2,J,K) = YY
            END DO
          END IF
        END IF
      END DO
C
      DO K=1,4
        K1 = K
        IF(K.EQ.1) THEN
          K2=2
          J21=NCOLS2
          J22=1
        ELSE IF(K.EQ.2) THEN
          K2=3
          J21=NROWS2
          J22=NCOLS2
        ELSE IF(K.EQ.3) THEN
          K2=4
          J21=1
          J22=NROWS2
        ELSE IF(K.EQ.4) THEN
          K2=1
          J21=1
          J22=1
        END IF
        KCV1 = ICVRB(NRG,K)
        KCV2 = ICVRB(NRG,K2)
        IF(KCV1.EQ.-1.AND.KCV2.NE.-1) THEN
          NNRB(NRG,K2,J22) = NNRB(NRG,K1,J21)
          CODRB(1,J22,K2) = CODRB(1,J21,K1)
          CODRB(2,J22,K2) = CODRB(2,J21,K1)
        ELSE IF(KCV2.EQ.-1.AND.KCV1.NE.-1) THEN
          NNRB(NRG,K1,J21) = NNRB(NRG,K2,J22)
          CODRB(1,J21,K1) = CODRB(1,J22,K2)
          CODRB(2,J21,K1) = CODRB(2,J22,K2)
        ELSE IF(KCV1.GT.0.AND.KCV2.GE.0) THEN
          NNRB(NRG,K2,J22) = NNRB(NRG,K1,J21)
          CODRB(1,J22,K2) = CODRB(1,J21,K1)
          CODRB(2,J22,K2) = CODRB(2,J21,K1)
        ELSE IF(KCV2.GT.0.AND.KCV1.GE.0) THEN
          NNRB(NRG,K1,J21) = NNRB(NRG,K2,J22)
          CODRB(1,J21,K1) = CODRB(1,J22,K2)
          CODRB(2,J21,K1) = CODRB(2,J22,K2)
        END IF
      END DO
C
      NDRG=JELRG(NRG)
      DO K=1,8
        ASH(K) = 0.0E0
        XSG(K) = 0.0E0
        YSG(K) = 0.0E0
      END DO
      DO K=1,8
        LNI = LNSRG(NRG,K)
        IF(LNI.GT.0) THEN
          NDRG = K
          ASH(K) = 1.0E0
          IF(ICDRG(LNI).EQ.0) THEN
            XSG(K)=CDLRG(1,LNI)
            YSG(K)=CDLRG(2,LNI)
          ELSE
            X0 = CDLRG(3,LNI)
            Y0 = CDLRG(4,LNI)
            R  = CDLRG(1,LNI)
            T  = CDLRG(2,LNI)*TPI
            XSG(K) = X0+R*COS(T)
            YSG(K) = Y0+R*SIN(T)
          END IF
        END IF
      END DO
      NDIME = 2
      KEY   = 2
      DO J1=1,NROWS2
        NC = (J1-1)*NCOLS2
        TT1 = CDLRB(NRG,J1,4)
        TT2 = CDLRB(NRG,J1,2)
        DO J2=1,NCOLS2
          ST1 = CDLRB(NRG,J2,1)
          ST2 = CDLRB(NRG,J2,3)
          NNODE = NNODE + 1
          NC    = NC    + 1
          NNPRG(NC) = NNODE 
          AG = 1.0E0-0.25E0*(ST2-ST1)*(TT2-TT1)
          AG = 1.0E0/AG
          ST = 0.5E0*(ST1+ST2)+0.25E0*(TT2+TT1)*(ST2-ST1)
          TT = 0.5E0*(TT1+TT2)+0.25E0*(ST2+ST1)*(TT2-TT1)
          ST = ST*AG
          TT = TT*AG
          CALL SFR(SHF,ASH,KEY,ST,TT)
          XX = 0.0E0
          YY = 0.0E0
          DO J = 1,NDRG
            XX = XX + SHF(J)*XSG(J)
            YY = YY + SHF(J)*YSG(J)
          END DO
          CODRG(1,NC) = XX
          CODRG(2,NC) = YY
          CODRG(3,NC) = 0.0E0
        END DO
      END DO
      DO J=1,NCOLS2
        NC = J
        NNPRG(NC) = NNRB(NRG,1,J)
        CODRG(1,NC) = CODRB(1,J,1)
        CODRG(2,NC) = CODRB(2,J,1)
        NC = (NROWS2-1)*NCOLS2+J
        NNPRG(NC) = NNRB(NRG,3,J)
        CODRG(1,NC) = CODRB(1,J,3)
        CODRG(2,NC) = CODRB(2,J,3)
      END DO
      DO J=1,NROWS2
        NC = J*NCOLS2
        NNPRG(NC) = NNRB(NRG,2,J)
        CODRG(1,NC) = CODRB(1,J,2)
        CODRG(2,NC) = CODRB(2,J,2)
        NC = (J-1)*NCOLS2+1
        NNPRG(NC) = NNRB(NRG,4,J)
        CODRG(1,NC) = CODRB(1,J,4)
        CODRG(2,NC) = CODRB(2,J,4)
      END DO
      IENEW = NELEM0
      DO J1=1,NROWS
        DO J2=1,NCOLS
          IENEW = IENEW + 1
          IF(NODE.EQ.4) THEN
            JROW1 = J1
            JROW2 = JROW1 + 1
            JCOL1 = J2
            JCOL2 = JCOL1 + 1
            IJ(1) = MIJ(JROW1,JCOL1,NCOLS2)
            IJ(2) = MIJ(JROW1,JCOL2,NCOLS2)
            IJ(3) = MIJ(JROW2,JCOL2,NCOLS2)
            IJ(4) = MIJ(JROW2,JCOL1,NCOLS2)
            ELTYP(IENEW)='C2D4'
          ELSE IF(NODE.EQ.8) THEN
            JROW1 = 2*(J1-1)+1
            JROW2 = JROW1 + 1
            JROW3 = JROW2 + 1
            JCOL1 = 2*(J2-1)+1
            JCOL2 = JCOL1 + 1
            JCOL3 = JCOL2 + 1
            IJ(1) = MIJ(JROW1,JCOL1,NCOLS2)
            IJ(2) = MIJ(JROW1,JCOL3,NCOLS2)
            IJ(3) = MIJ(JROW3,JCOL3,NCOLS2)
            IJ(4) = MIJ(JROW3,JCOL1,NCOLS2)
            IJ(5) = MIJ(JROW1,JCOL2,NCOLS2)
            IJ(6) = MIJ(JROW2,JCOL3,NCOLS2)
            IJ(7) = MIJ(JROW3,JCOL2,NCOLS2)
            IJ(8) = MIJ(JROW2,JCOL1,NCOLS2)
            IJ(9) = MIJ(JROW2,JCOL2,NCOLS2)
            ELTYP(IENEW)='C2D8'
          END IF
          DO J=1,NODE
            LNODS(IENEW,J) = NNPRG(IJ(J))
            COORD(NNPRG(IJ(J)),1)=CODRG(1,IJ(J))
            COORD(NNPRG(IJ(J)),2)=CODRG(2,IJ(J))
          END DO
          MATSET(IMSET,1) = MATSET(IMSET,1) + 1
          MATSET(IMSET,MATSET(IMSET,1))=IENEW
          LNODS(IENEW,MXNOD)=NODE
          LNODS(IENEW,MXNOD-1)=IMSET
          CALL DNODE(IENEW,NODE)
        END DO
      END DO
      NELEM = IENEW
C
      IF(ELL.LT.ADIST) ELL = ADIST
      IF(ELR.LT.ADIST) ELR = ADIST
      IF(ELU.LT.ADIST) ELU = ADIST
      IF(ELD.LT.ADIST) ELD = ADIST
      RETURN
      END
C---------------------------------------------------------
C---------------------------------------------------------
C---------------------------------------------------------
      FUNCTION MIJ(I,J,NCOLS)
      MIJ = (I-1)*NCOLS+J
      RETURN
      END
C---------------------------------------------------------
C---------------------------------------------------------
C---------------------------------------------------------
      SUBROUTINE SFR(SHAPE,ASHF,NDIME,S,T)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION SHAPE(30),ASHF(30)
      ZERO      = 0.000D0
      ONE       = 1.000D0
      HALF      = 0.500D0
      FOURTH    = 0.250D0
      ST        = S*T
      S2        = S*S
      T2        = T*T
      IF(NDIME.EQ.1) THEN
        SHAPE(  1)=HALF*(S-ONE)*S
        SHAPE(  2)=HALF*(S+ONE)*S
        SHAPE(  3)=ONE-S2
      ELSE IF(NDIME.EQ.2) THEN
        SHAPE(  1)=(ONE-T-S+ST)*FOURTH
        SHAPE(  2)=(ONE-T+S-ST)*FOURTH
        SHAPE(  3)=(ONE+T+S+ST)*FOURTH
        SHAPE(  4)=(ONE+T-S-ST)*FOURTH
        SHAPE(  5)=HALF*(ONE-S2)*(ONE-T)*ASHF(5)
        SHAPE(  6)=HALF*(ONE-T2)*(ONE+S)*ASHF(6)
        SHAPE(  7)=HALF*(ONE-S2)*(ONE+T)*ASHF(7)
        SHAPE(  8)=HALF*(ONE-T2)*(ONE-S)*ASHF(8)
        SHAPE(  1)=SHAPE(1)-HALF*(SHAPE(5)+SHAPE(8))
        SHAPE(  2)=SHAPE(2)-HALF*(SHAPE(5)+SHAPE(6))
        SHAPE(  3)=SHAPE(3)-HALF*(SHAPE(6)+SHAPE(7))
        SHAPE(  4)=SHAPE(4)-HALF*(SHAPE(7)+SHAPE(8))
      ELSE IF(NDIME.EQ.3) THEN
        S2        = S*2.0D0
        T2        = T*2.0D0
        SS        = S*S
        TT        = T*T
        ST        = S*T
        SST       = S*S*T
        STT       = S*T*T
        ST2       = S*T*2.0D0
        SHAPE(  1)=(-ONE+ST+SS+TT-SST-STT)*FOURTH
        SHAPE(  2)=( ONE-T-SS+SST)*HALF
        SHAPE(  3)=(-ONE-ST+SS+TT-SST+STT)*FOURTH
        SHAPE(  4)=( ONE+S-TT-STT)*HALF
        SHAPE(  5)=(-ONE+ST+SS+TT+SST+STT)*FOURTH
        SHAPE(  6)=( ONE+T-SS-SST)*HALF
        SHAPE(  7)=(-ONE-ST+SS+TT+SST-STT)*FOURTH
        SHAPE(  8)=( ONE-S-TT+STT)*HALF
      END IF
      RETURN
      END
C
C---  function for the distance between p(x1,y1,z1) and p(x2,y2,z2)
C
      FUNCTION DISTN(X1,Y1,Z1,X2,Y2,Z2)
      REAL*8 X1,Y1,Z1,X2,Y2,Z2
      DISTN = SQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1)+(Z2-Z1)*(Z2-Z1))
      RETURN
      END
C
C---  function for the angle of the line between p(x1,y1,z1) and p(x2,y2,z2)
C
      FUNCTION ANGLE(X1,Y1,X2,Y2)
      REAL*8 X1,Y1,X2,Y2,PI,ATH,DX,DY,RR
      PI    = 4.0D0*ATAN(1.0E0)
      DX    = X2-X1
      DY    = Y2-Y1
      RR    = SQRT((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1))
      IF(RR.LE.1.0E-10) THEN
        ANGLE = 0.0D0
      ELSE
        ATH   = ASIN(DY/RR)
        IF(ABS(DY/RR).LT.1.0E-10) ATH = 0.0D0
        IF(DX.LT.0.0E0) ATH = SIGN(PI,DY) - ATH
        ANGLE = ATH
      END IF
      ANGLE = ANGLE*180.0D0/PI
      RETURN
      END
