      SUBROUTINE SEAND(NDU,KEY,YU,KU,IK)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDU(*),AXI(3)
C
C     SEARCH FOR NODES WHICH HAVE SPECIFIC VALUE (YU) IN DIRECTION (KEY)
C     IK=1  sort node array ascending
C     IK=2  dont sort node array 
C     IK=3  sort node array descending
C
      KU=0
      DO I=1,NNODE
        IF(INCOD(I).EQ.I) THEN
          A=COORD(I,KEY)
          IF(ABS(A-YU).LE.TOLER) THEN
            KU=KU+1
            NDU(KU)=I
          ENDIF
        ENDIF
      END DO
c     WRITE(IO_WORK,'(1HL,16I5)') (NDU(I),I=1,KU)
      IF(IK.EQ.2) RETURN
C---  sorting array NDU acc. to y-coord if key.ne.2, otherwise x-coord
C---  IK=1: sort ascending
      KDSORT = 1
      IF (KEY.NE.2) KDSORT = 2
      DO I=1,KU
         II=NDU(I)
         AREF=COORD(II,KDSORT)
	 JM1 = 0
         DO J=I+1,KU
            JJ=NDU(J)
	    A = COORD(JJ,KDSORT)
            IF(A.LT.AREF) THEN
               JM1=J
               JM2=JJ
               AREF=A
            END IF
         END DO
	 IF (JM1 .GT. 0) THEN 
	    NDU(I)=JM2
            NDU(JM1)=II
	 END IF
      END DO
C---  IK=3: sort descending
      IF(IK.GT.2) THEN
         DO I=1,KU/2
            K1=NDU(I)
            NDU(I)=NDU(KU-I+1)
            NDU(KU-I+1)=K1
         END DO
      END IF
c     WRITE(IO_WORK,'(1HB,16I5)') (NDU(I),I=1,KU)
      RETURN
      END
      SUBROUTINE SEAND1(NDU,KEY,YU,KU)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDU(*),AXI(3)
C
C     SEARCH FOR UPPER REGION BOUNDARY NODES
C
      KU=0
      I1=IRAXIS(1)
      I2=IRAXIS(2)
      I3=IRAXIS(3)
      DO I=1,NNODE
        IN=I
        IF(INCOD(I).NE.0) THEN
          IF(KEY_ROTAT2.EQ.0) THEN
            AXI(1)=COORD(IN,I1)
            AXI(2)=COORD(IN,I2)
            AXI(3)=COORD(IN,I3)
          ELSE
            X=COORD(IN,I1)
            Y=COORD(IN,I2)
            Z=COORD(IN,I3)
            DX=X-XO_ROTAT2
            DY=Y-YO_ROTAT2
            RO=SQRT(DX*DX+DY*DY)
            TH=ACOS(DX/RO)
            IF(DY.LT.0.0) TH=2*PI-TH
            IF(DY.EQ.0.0.AND.DX.LT.0.0) TH=PI
            IF(DY.EQ.0.0.AND.DX.GT.0.0) TH=0.0E0
            AXI(1)=RO
            AXI(2)=TH
            AXI(3)=Z
          ENDIF
          A=AXI(KEY)
          IF(ABS(A-YU).LE.TOLER) THEN
            KU=KU+1
            NDU(KU)=I
          ENDIF
        ENDIF
      END DO
c     WRITE(IO_WORK,'(1HL,16I5)') (NDU(I),I=1,KU)
      RETURN
      END
C
C     DEFINE THE NODE SETS AND THE ELEMENT SETS
C
      SUBROUTINE ENSET
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION KEYSET(6)
      CHARACTER*9 CH(0:1)
      CHARACTER SETS*100,EL_FACE_SET*8,JETIP*4,JNTIP*4
      DIMENSION NDU(MXNSET),JRRAY(4),XZ(2),IAXI(2),NFACE_EL(MXESET,9)
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. ENSET'
C
      CH(0)='         '
      CH(1)=',GENERATE'
C
      CALL CVMAX(CBOUND(2),CBOUND(1),CBOUND(4),CBOUND(3),
     &           CBOUND(6),CBOUND(5))
      READ(IO_INPUT,*) KEYSET
      IF(IOUT.NE.1) THEN
        DO K=1,6
          IF(KEYSET(K).NE.0) THEN
            NDSET = NDSET + 1
            CALL SEAND1(INSET(1,NDSET),K_AXIS(K),CBOUND(K),NNSET(NDSET))
            KU=NNSET(NDSET)
            CNDSET(NDSET) = CNSET(K)
            WRITE(IO_OUTP,1210) CNDSET(NDSET)
            WRITE(IO_OUTP,1000) (INSET(I,NDSET),I=1,KU)
          END IF
        END DO
      END IF
 1000 FORMAT(11(I6,','))
 1210 FORMAT('*NSET,NSET=',A8,A9)
 1211 FORMAT('*ELSET,ELSET=',A8,A9)
 1212 FORMAT('*ELSET,ELSET=',A8/A)
 1220 FORMAT('*NSET,NSET=',A7,I1)
 1221 FORMAT('*ELSET,ELSET=',A7,I1)
C
C     DEFINE ELEMENT SET
C
      READ(IO_INPUT,*) KEYSET
C     IF(IOUT.NE.1) THEN
        DO K=1,6
           DO I=1,6
             IESET(1,I)=1
           END DO
          IF(KEYSET(K).NE.0) THEN
C           CALL SEAEL(IESET(1,K),K_AXIS(K),CBOUND(K),NESET(K))
            XZ(1)=CBOUND(K)
            IAXI(1)=K_AXIS(K)
            XZ(2)=0.0
            IAXI(2)=0.0
            CALL DELFACE(IWORK,NFACE_EL,XZ,IAXI)
            DO I=2,IWORK(1)
              IE=IWORK(I)
              NODE=LNODS(IE,MXNOD)
              STRING=ELTYP(IE)
              LARRAY=NFACE_EL(I,1)-1
              IF((STRING(1:3).EQ.'C3D'.AND.LARRAY.GT.2).OR.
     &           (STRING(1:3).EQ.'C2D'.AND.LARRAY.GE.2)) THEN
                DO J=1,4
                  JRRAY(J)=0
                END DO
c
c       determin the surface for distributed load
c
                IF(STRING(1:4).EQ.'C3D8') THEN
                  NTFACE=6
                  ID_FACE=1
                ELSE IF(STRING(1:4).EQ.'C3D6') THEN
                  NTFACE=5
                  ID_FACE=2
                ELSE IF(STRING(1:4).EQ.'C3D4') THEN
                  NTFACE=4
                  ID_FACE=3
                ELSE IF(STRING(1:5).EQ.'C3D20') THEN
                  NTFACE=6
                  ID_FACE=4
                ELSE IF(STRING(1:5).EQ.'C3D15') THEN
                  NTFACE=5
                  ID_FACE=7
                ELSE IF(STRING(1:4).EQ.'C2D3'.OR.
     &                  STRING(1:4).EQ.'C2D6') THEN
                  NTFACE=3
                  ID_FACE=6
                ELSE IF(STRING(1:4).EQ.'C2D4'.OR.
     &                  STRING(1:4).EQ.'C2D8') THEN
                  NTFACE=4
                  ID_FACE=5
                END IF
                DO J=1,LARRAY
                  JRRAY(J)=NFACE_EL(I,J+1)
                END DO
                STRING=' '
                DO J=1,LARRAY
                  WRITE(STRING(J:J),'(I1)') JRRAY(J)
                END DO
                DO KFACE=1,NTFACE
                  IF(STRING(1:4).EQ.CFACE_DF(KFACE,ID_FACE)) GOTO 200
                END DO
  200           CONTINUE
                IF(KIDFACE(1,K).EQ.1) THEN
                  KIDFACE(1,K)=KIDFACE(1,K)+1
                  KIDFACE(KIDFACE(1,K),K)=KFACE
                ELSE
                  DO J=2,KIDFACE(1,K)
                    IF(KIDFACE(J,K).EQ.KFACE) GOTO 202
                  END DO
                  KIDFACE(1,K)=KIDFACE(1,K)+1
                  KIDFACE(KIDFACE(1,K),K)=KFACE
  202             CONTINUE
                END IF
                IESET(1,KFACE)=IESET(1,KFACE)+1
                IESET(IESET(1,KFACE),KFACE)=IE
              END IF
            END DO
c           NUM_FACE=0
c           DO KFACE=1,6
c             IF(IESET(1,KFACE).GT.1) NUM_FACE=NUM_FACE+1
c           END DO
c           IF(NUM_FACE.GT.1) THEN
              LSTRING=0
              DO KFACE=1,6
                IF(IESET(1,KFACE).GT.1) THEN
                  KU=IESET(1,KFACE)
                  EL_FACE_SET(1:5)='ELSET'
                  WRITE(EL_FACE_SET(6:6),'(I1)') K
                  EL_FACE_SET(7:7)='_'
                  WRITE(EL_FACE_SET(8:8),'(I1)') KFACE
                  IF(IOUT.NE.1) THEN
                    WRITE(IO_OUTP,1211) EL_FACE_SET
                    WRITE(IO_OUTP,1000) (IESET(J,KFACE),J=2,KU)
                  END IF
                  IF(LSTRING.GT.0) THEN
                    LSTRING=LSTRING+1
                    STRING(LSTRING:LSTRING)=','
                  END IF
                  STRING(LSTRING+1:LSTRING+8)=EL_FACE_SET(1:8)
                  LSTRING=LSTRING+8
                END IF
              END DO
              IF(LSTRING.GT.8.AND.IOUT.NE.1) THEN
C               WRITE(IO_OUTP,1212) CESET(K),STRING(1:LSTRING)
              END IF
c           ELSE
c             WRITE(IO_OUTP,1211) CESET(K)
c             WRITE(IO_OUTP,1000) (IWORK(K),I=2,IWORK(1))
c           END IF
          END IF
        END DO
C     END IF
C
C     OUTPUT CRACK SURFACE ELSET SETS TO IMPOSE SURFACE FORCE
C
      IF(NESUF(1).GE.2) THEN
        K=7
        XZ(1)=YORIGN
        IAXI(1)=2
        XZ(2)=0.0
        IAXI(2)=0.0
        CALL DELFACE1(NESUF,NFACE_EL,XZ,IAXI)
        DO I=1,10
          IESET(1,I)=1
        END DO
        CESET(K)='ELSETSUF'
        WRITE(IO_OUTP,1211) CESET(K)
        WRITE(IO_OUTP,1000) (NESUF(J),J=2,NESUF(1))
        DO I=2,NESUF(1)
          IE=NESUF(I)
          NODE=LNODS(IE,MXNOD)
          STRING=ELTYP(IE)
          LARRAY=NFACE_EL(I,1)-1
          IF((STRING(1:3).EQ.'C3D'.AND.LARRAY.GT.2).OR.
     &       (STRING(1:3).EQ.'C2D'.AND.LARRAY.GE.2)) THEN
            DO J=1,4
              JRRAY(J)=0
            END DO
c
c           determin the elset of crack surface for distributed load
c
            IF(STRING(1:4).EQ.'C3D8') THEN
              NTFACE=6
              ID_FACE=1
            ELSE IF(STRING(1:4).EQ.'C3D6') THEN
              NTFACE=5
              ID_FACE=2
            ELSE IF(STRING(1:4).EQ.'C3D4') THEN
              NTFACE=4
              ID_FACE=3
            ELSE IF(STRING(1:5).EQ.'C3D20') THEN
              NTFACE=6
              ID_FACE=4
            ELSE IF(STRING(1:5).EQ.'C3D15') THEN
              NTFACE=5
              ID_FACE=7
            ELSE IF(STRING(1:4).EQ.'C2D4') THEN
              NTFACE=4
              ID_FACE=5
            ELSE IF(STRING(1:4).EQ.'C2D8') THEN
              NTFACE=4
              ID_FACE=5
            END IF
            DO J=1,LARRAY
              JRRAY(J)=NFACE_EL(I,J+1)
            END DO
            STRING=' '
            DO J=1,LARRAY
              WRITE(STRING(J:J),'(I1)') JRRAY(J)
            END DO
            DO KFACE=1,NTFACE
              IF(STRING(1:4).EQ.CFACE_DF(KFACE,ID_FACE)) GOTO 220
            END DO
  220       CONTINUE
            IF(KIDFACE(1,K).EQ.1) THEN
              KIDFACE(1,K)=KIDFACE(1,K)+1
              KIDFACE(KIDFACE(1,K),K)=KFACE
            ELSE
              DO J=2,KIDFACE(1,K)
                IF(KIDFACE(J,K).EQ.KFACE) GOTO 222
              END DO
              KIDFACE(1,K)=KIDFACE(1,K)+1
              KIDFACE(KIDFACE(1,K),K)=KFACE
  222         CONTINUE
            END IF
            IESET(1,KFACE)=IESET(1,KFACE)+1
            IESET(IESET(1,KFACE),KFACE)=IE
          END IF
        END DO
        LSTRING=0
        DO KFACE=1,6
          IF(IESET(1,KFACE).GT.1) THEN
            KU=IESET(1,KFACE)
            EL_FACE_SET(1:5)='ELSET'
            WRITE(EL_FACE_SET(6:6),'(I1)') K
            EL_FACE_SET(7:7)='_'
            WRITE(EL_FACE_SET(8:8),'(I1)') KFACE
            IF(IOUT.NE.1) THEN
              WRITE(IO_OUTP,1211) EL_FACE_SET
              WRITE(IO_OUTP,1000) (IESET(J,KFACE),J=2,KU)
            END IF
            IF(LSTRING.GT.0) THEN
              LSTRING=LSTRING+1
              STRING(LSTRING:LSTRING)=','
            END IF
            STRING(LSTRING+1:LSTRING+8)=EL_FACE_SET(1:8)
            LSTRING=LSTRING+8
          END IF
        END DO
        IF(LSTRING.GT.8.AND.IOUT.NE.1) THEN
C         WRITE(IO_OUTP,1212) CESET(K),STRING(1:LSTRING)
        END IF
      END IF
C
C     OUTPUT LIGAMENT NODE SETS
C
      CALL GETLINE (LEN,IERR)
      DO I = 1,5
         ITYPE(I) = 1
      END DO
      INVAR = 5
      CALL SLVLINE (STRING,LEN,IERR)
      KDLIG = IVARR(1)
      KDSUF = IVARR(2)
      KTIP  = IVARR(3)
      KZSET = IVARR(4)
      KDCZE = IVARR(5)
      IF(KDLIG.NE.0.AND.IOUT.NE.1) THEN
	IF (KEY3D.EQ.0) THEN
          WRITE(IO_OUTP,1220) 'LIGASET',1
          WRITE(IO_OUTP,1000) (NDLIG(J),J=2,NDLIG(1))
        ELSE
          WRITE(IO_OUTP,2030)
 2030     FORMAT('*NSET,NSET=LIGASET1')
C         WRITE(IO_OUTP,1000) (NDLIG2(I),I=2,NDLIG2(1))
          WRITE(IO_OUTP,1000) (NDLIG(J),J=2,NDLIG(1))
        END IF
      END IF
C
C     WTITE Z=0 FACE SET
C
C     IF(KZSET.NE.0.AND.IOUT.NE.1) THEN
C       WRITE(IO_OUTP,2010)
C       WRITE(IO_OUTP,'(16I5)') (NTHICK(I,1),I=2,NTHICK(1,1))
C     END IF
C
C     WTITE CT LOAD SET
C
      IF(LDCT.NE.0.AND.IOUT.NE.1) THEN
        DO I=2,LDCT_3D(1)
          WRITE(IO_OUTP,2015) CNUM(I-1),LDCT_3D(I)
        END DO
      END IF
 2010 FORMAT('*NSET,NSET=ZSET0')
 2015 FORMAT('*NSET,NSET=LOADCT',A2/I5)
 2021 FORMAT('*NSET,NSET=',A)
C
C     WTITE TIP NODES SET
C
      IF(KTIP.NE.0.AND.IOUT.NE.1) THEN
C
C       determining element arround the crack tip for normal definition
C       with curve crack front
C
C       CALL DELNJS
C
        DO I=1,NTNUM
          JETIP(1:4)='JE'//CNUM(I)
          JNTIP(1:4)='JN'//CNUM(I)
          IF(NDTIP(I,1).EQ.2) THEN
            IJ=NDTIP(I,2)
            WRITE(IO_OUTP,2021) JNTIP(1:4)
            WRITE(IO_OUTP,'(16I5)') IJ
          ELSE
            WRITE(IO_OUTP,2021) JNTIP(1:4)
            WRITE(IO_OUTP,'(16I5)') (NDTIP(I,K),K=2,NDTIP(I,1))
          END IF
        END DO
C       DO I=1,NTNUM
C         IF(NELJS(I,1).GE.2.AND.IFRONT.EQ.1) THEN
C           JETIP(1:4)='JE'//CNUM(I)
C           JNTIP(1:4)='JN'//CNUM(I)
C           THN=TCFRONT(I)
C           CNX=SIN(THN)
C           CNY=1.0
C           CNZ=COS(THN)
C           WRITE(IO_OUTP,2022) JETIP(1:4),(NELJS(I,J),J=2,NELJS(I,1))
C           WRITE(IO_OUTP,2023) JETIP(1:4),JNTIP(1:4),CNX,CNY,CNZ
2022        FORMAT('*ELSET,ELSET=',A/(13(I5,1H,)))
2023        FORMAT(7H*NORMAL/1X,A,1X,A,3F10.6)
C         END IF
C       END DO
      END IF
C
C     WRITE NODE SET FOR ABAQUS 3D CZE's
C
      IF(KDCZE.NE.0.AND.IOUT.NE.1) THEN
	 DO ISET = 1,NDSET
	    IF (CNDSET(ISET)(1:6).EQ.'BOTTOM') GOTO 250
	 END DO
  250    CONTINUE
         WRITE(IO_OUTP,1210) CNDSET(ISET)
         WRITE(IO_OUTP,1000) (INSET(K,ISET),K=1,NNSET(ISET))
	 IF (KDCZE.EQ.2) THEN
	    DO IELS = 1,NTYPE
	       IF (ELSET_TYP(IELS)(1:1).EQ.'U')
     1            READ (ELSET_TYP(IELS)(2:2),'(I1)') IUTYP
	    END DO
	    WRITE (IO_OUTP,2100)
	    DO IEQ = 1,NNSET(ISET)
	       WRITE (IO_OUTP,2105) INSET(IEQ,ISET),INSET(IEQ,ISET+1)
	       WRITE (IO_OUTP,2106) INSET(IEQ,ISET),INSET(IEQ,ISET+1)
	       IF (IUTYP.GT.2) 
     1            WRITE (IO_OUTP,2107) INSET(IEQ,ISET),INSET(IEQ,ISET+1)
	    END DO
	 ENDIF
      ENDIF
 2100 FORMAT ('*EQUATION')
 2105 FORMAT ('2',/,I6,',1,1.0,',I6,',1,-1.0')
 2106 FORMAT ('2',/,I6,',2,1.0,',I6,',2, 1.0')
 2107 FORMAT ('2',/,I6,',3,1.0,',I6,',3,-1.0')
C
C
C     READ ADDITIONAL DEFINED ELSETS AND NSETS
C
      READ(IO_INPUT,*) NUSET
c     WRITE(IO_WRITE,*) NUSET
      IF(NUSET.NE.0) THEN
      DO I=1,NUSET
        READ(IO_INPUT,'(2I5,A8)') NEWSET,KEY,CUSET(I)
C
C       KEY=1 FOR DEFINING 'NUMBER' SET
C       KEY=2 FOR DEFINING 'SET   ' SET
C       KEY=3 FOR GIVEN COORDINATES POINTS SET
C       K2 =1 FOR NODE SET
C       K2 =2 FOR EL   SET
C
        IF(KEY.EQ.1) THEN
          READ(IO_INPUT,*) K1,K2,K3,(IUSET(J,I),J=4,K1+3)
          IUSET(1,I)=K1
          IUSET(2,I)=K2
          IUSET(3,I)=K3
          IF((K2.EQ.1.AND.IOUT.NE.1).OR.NEWSET.EQ.1)
     1       WRITE(IO_OUTP,1210) CUSET(I),CH(K3)
          IF((K2.EQ.2.AND.IOUT.NE.1).OR.NEWSET.EQ.1)
     1       WRITE(IO_OUTP,1211) CUSET(I),CH(K3)
          IF(IOUT.NE.1.OR.NEWSET.EQ.1) 
     &       WRITE(IO_OUTP,1000) (IUSET(J,I),J=4,K1+3)
        ELSE IF(KEY.EQ.2) THEN
          READ(IO_INPUT,'(I5,A)') K2,SETS
          IF((K2.EQ.1.AND.IOUT.NE.1).OR.NEWSET.EQ.1) 
     &          WRITE(IO_OUTP,1210) CUSET(I)
          IF((K2.EQ.2.AND.IOUT.NE.1).OR.NEWSET.EQ.1)
     &          WRITE(IO_OUTP,1211) CUSET(I)
          DO LSETS=100,1,-1
            IF(SETS(LSETS:LSETS).NE.' ') GOTO 400
          END DO
  400     CONTINUE
          IF(IOUT.NE.1.OR.NEWSET.EQ.1) 
     &      WRITE(IO_OUTP,'(A)') SETS(1:LSETS)
        ELSE IF(KEY.EQ.3) THEN
          CALL FIND_NSET(IWORK)
          IF(IOUT.NE.1.OR.NEWSET.EQ.1.AND.IWORK(1).GT.1) 
     &       WRITE(IO_OUTP,1301) CUSET(I),(IWORK(K),K=2,IWORK(1))
 1301     FORMAT('*NSET,NSET=',A8/(13(I5,1H,)))
        ELSE IF(KEY.EQ.4) THEN
          CALL FIND_ELSET(IESET(1,1),NIESET)
          IF(IOUT.NE.1.OR.NEWSET.EQ.1) THEN
             WRITE(IO_OUTP,1211) CUSET(I)
             WRITE(IO_OUTP,1000) (IESET(K,1),K=1,NIESET)
          END IF
        END IF
      END DO
      ENDIF
      RETURN
      END
C
      SUBROUTINE FIND_ELSET(NDU,LD)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDU(*)
      READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'C') THEN
        KEY=1
      ELSE IF(STRING(1:1).EQ.'R') THEN
        KEY=2
      END IF
      READ(IO_INPUT,*) XORIG_ENSET,YORIG_ENSET
      READ(IO_INPUT,*) T1,T2,R1,R2,Z1,Z2
      DO I=1,NELEM
        NODE=LNODS(I,MXNOD)
        IMSET=LNODS(I,MXNOD-1)
        STRING=ELSET_TYP(IMSET)
        IF(STRING(1:1).NE.'C') GOTO 331
        X=0.0
        Y=0.0
        Z=0.0
        NN = 0
        DO J=1,NODE
          IN=LNODS(I,J)
          IF(IN.NE.0) THEN
            NN =NN + 1
            X=X+COORD(IN,1)
            Y=Y+COORD(IN,2)
            Z=Z+COORD(IN,3)
          END IF
        END DO
        X=X/FLOAT(NN)
        Y=Y/FLOAT(NN)
        Z=Z/FLOAT(NN)
        IF(KEY.EQ.1) THEN
          DX=X-XORIG_ENSET
          DY=Y-YORIG_ENSET
          YM=SQRT(DX*DX+DY*DY)
          XM=DACOS(DX/YM)*180.0/PI
          IF(DY.LT.0.0) XM=360.0-XM
        ELSE IF(KEY.EQ.2) THEN
          XM=X
          YM=Y
        END IF
        IF(XM.GE.T1.AND.XM.LE.T2.AND.YM.GE.R1.AND.YM.LE.R2.
     &     AND.Z.GE.Z1.AND.Z.LE.Z2) THEN
          LD=LD+1
          NDU(LD)=I
        END IF
  331   CONTINUE
      END DO
      RETURN
      END
C
      SUBROUTINE SEAEL(NDU,KEY_AXIS,AU,LD)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDU(*),AXI(3)
C
      LD=0
      I1=IRAXIS(1)
      I2=IRAXIS(2)
      I3=IRAXIS(3)
      DO I=1,NELEM
        NODE=LNODS(I,MXNOD)
        IMSET=LNODS(I,MXNOD-1)
        STRING=ELSET_TYP(IMSET)
        IF(STRING(1:1).NE.'C') GOTO 331
        DO J=1,NODE
          IN=LNODS(I,J)
          IF(IN.NE.0) THEN
            IF(KEY_ROTAT2.EQ.0) THEN
              AXI(1)=COORD(IN,I1)
              AXI(2)=COORD(IN,I2)
              AXI(3)=COORD(IN,I3)
            ELSE
              X=COORD(IN,I1)
              Y=COORD(IN,I2)
              Z=COORD(IN,I3)
              DX=X-XO_ROTAT2
              DY=Y-YO_ROTAT2
              RO=SQRT(DX*DX+DY*DY)
              TH=ACOS(DX/RO)
              IF(DY.LT.0.0) TH=2*PI-TH
              IF(DY.EQ.0.0.AND.DX.LT.0.0) TH=PI
              IF(DY.EQ.0.0.AND.DX.GT.0.0) TH=0.0E0
              AXI(1)=RO
              AXI(2)=TH
              AXI(3)=Z
            ENDIF
            A=AXI(KEY_AXIS)
            IF(ABS(A-AU).LT.TOLER) THEN
              LD=LD+1
              NDU(LD)=I
              GOTO 331
            ENDIF
          ENDIF
        END DO
  331   CONTINUE
      END DO
C     WRITE(IO_WORK,'(20I5)') (NDU(I),I=1,LD)
      RETURN
      END
      SUBROUTINE DELNJS
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DO I=1,NTNUM
        NELJS(I,1)=1
      END DO
      DO IE=1,NELEM
        NODE=LNODS(IE,MXNOD)
        IMSET=LNODS(I,MXNOD-1)
        STRING=ELSET_TYP(IMSET)
        IF(STRING(1:1).NE.'C') GOTO 20
        DO K=1,NODE
          LN=LNODS(IE,K)
          DO I=1,NTNUM
            DO J=2,NDTIP(I,1)
              IJ=NDTIP(I,J)
              IF(LN.EQ.IJ) THEN
                NELJS(I,1)=NELJS(I,1)+1
                NELJS(I,NELJS(I,1))=IE
                GOTO 10
              END IF
            END DO
   10       CONTINUE
          END DO
        END DO
   20   CONTINUE
      END DO
      DO I=1,NTNUM
      write(22,'(I5)') (NELJS(I,J),J=2,NELJS(I,1))
      END DO
C
      DO I=1,NTNUM
        ITIP=NDTIP(I,2)
        X=COORD(ITIP,1)
        Y=COORD(ITIP,2)
        Z=COORD(ITIP,3)
        DX=X-XTIP
        DZ=Z-ZTIP
        IF(DX.EQ.0.0.AND.DZ.GT.0.0) THEN
          TH=PI/2.0
        ELSE IF(DX.EQ.0.0.AND.DZ.LT.0.0) THEN
          TH=-PI
        ELSE IF(DZ.EQ.0.0.AND.DX.GT.0.0) THEN
          TH=PI
        ELSE IF(DZ.EQ.0.0.AND.DX.LT.0.0) THEN
          TH=0.0
        ELSE
          TH=ATAN(-ELLIP_C*ELLIP_C/ELLIP_A/ELLIP_A*DZ/DX)
          IF(DX.GE.0.0) THEN
            TH=PI+TH
          ELSE IF(DZ.LT.0.0.AND.DX.LT.0.0) THEN
            TH=2.0*PI+TH
          END IF
        END IF
        TH=TH+PI/2.0
        TCFRONT(I)=TH
      END DO
      WRITE(22,'(I5,2X,F10.4)')
     &    (NDTIP(I,2),TCFRONT(I)*180.0/PI,I=1,NTNUM)
C
      RETURN
      END
