      SUBROUTINE MESH2
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION EL(500),CL(500),RBLF(500)
      CHARACTER*6 CTYPE
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. MESH2'
C
C     DETERMINE THE LIGAMENT NODES (STORED IN NDLIG(I))
C
      KL=1
      KR=1
      XL=XTIP
      XR=2.0D0*ASYSM-XTIP
      ZM=0.0D0
      IF(LDCT.NE.0) THEN
        X_LDCT=COORD(LDCT,1)
        Y_LDCT=COORD(LDCT,2)
        LDCT_3D(1)=1
      END IF
      DO IN=1,NNODE
        X=COORD(IN,1)
        Y=COORD(IN,2)
        Z=COORD(IN,3)
        IF(LDCT.NE.0) THEN
          R_LDCT=SQRT((X-X_LDCT)*(X-X_LDCT)+(Y-Y_LDCT)*(Y-Y_LDCT))
          IF(R_LDCT.LT.TOLER) THEN
            LDCT_3D(1)=LDCT_3D(1)+1
            LDCT_3D(LDCT_3D(1))=IN
          END IF
        END IF
        IF(ABS(Y-YTIP).LT.TOLER) THEN
          KL=KL+1
          NDLIG(KL)=IN
        ENDIF
      END DO
      IF(LDCT_3D(1).GT.2) CALL  ORDER_ZC(LDCT_3D)
      NDLIG(1)=KL
C     DO K=2,KL
C       IN=NDLIG(K)
C       WRITE(81,'(I5,3(1PE13.4))') (COORD(IN,J),J=1,3)
C     END DO
      RETURN
      END
C
C     ***  ROUTINE DNDSURF  ***
C
      SUBROUTINE DNDSURF
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER*6 CTYPE
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. DNDSURF'
C
C     DETERMINE CRACK TIP NODE (LGTIP) 
C
      NNSUF=0
      XL=XTIP
      LGTIP=0
      DO IN=1,NNODE
        X=COORD(IN,1)
        Y=COORD(IN,2)
        IF(INCOD(IN).NE.0) THEN
          IF (ABS(Y-YTIP).LT.TOLER .AND. ABS(X-XTIP).LT.TOLER) THEN
C  --------  CRACK TIP NODE	
             LGTIP=IN
          ENDIF
        ENDIF
      END DO
      RETURN
      END
C
C     ***  ROUTINE DELSURF  ***
C
      SUBROUTINE DELSURF
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER*6 CTYPE
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. DELSURF'
C
C     DETERMINE THE CRACK SURFACE ELEMENTS (NESUF(I))
C
      NESUF(1)=1
      XL=XTIP-TOLER
      DO IE=1,NELEM
        NODE=LNODS(IE,MXNOD)
        IMSET=LNODS(IE,MXNOD-1)
        STRING=ELTYP(IE)
        IF(STRING(1:1).NE.'C') GOTO 331
        DO J=1,NODE
          IN=LNODS(IE,J)
          IF(IN.NE.0) THEN
            X=COORD(IN,1)
            Y=COORD(IN,2)
            IF(ABS(Y-YORIGN).LT.TOLER.AND.X.LT.XL) THEN
              NESUF(1)=NESUF(1)+1
              NESUF(NESUF(1))=IE
              GOTO 331
            ENDIF
          ENDIF
        END DO
  331   CONTINUE
      END DO
      NESUF(MXESET)=NESUF(1)-1
      RETURN
      END
C
      SUBROUTINE WRITE_INFO
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      WRITE(IO_INFO,901) NELEM,NNODE
      WRITE(IO_WRITE,901) NELEM,NNODE
      STRING='E0000001'
      IF(NSETS.EQ.1) THEN
        WRITE(IO_INFO,910) STRING(1:8),ELSET_TYP(NSETS)
        WRITE(IO_WRITE,910) STRING(1:8),ELSET_TYP(NSETS)
      ELSE IF(NSETS.GT.1) THEN
        DO ISETS=1,NSETS
          WRITE(IO_INFO,911)
     &     STRING(1:6),CNUM(ISETS),ELSET_TYP(ISETS),MATSET(ISETS,1)-1
          WRITE(IO_WRITE,911) 
     &     STRING(1:6),CNUM(ISETS),ELSET_TYP(ISETS),MATSET(ISETS,1)-1
        END DO
      END IF
      WRITE(IO_INFO,950)
     &     GL_MAX_RATIO,GL_MAX,GL_MIN,EL_MAX_RATIO,IE_MAX_RATIO
C     WRITE(IO_WRITE,950) 
C    &     GL_MAX_RATIO,GL_MAX,GL_MIN,EL_MAX_RATIO,IE_MAX_RATIO
C     WRITE(IO_WRITE,'(10(/))')
  901 FORMAT(///
     & 5X,5(1H*),' O U T P U T     I N F O R M A T I O N ',5(1H*)//
     & 5X,'Total element number ........................ ',I6/
     & 5X,'Total node    number ........................ ',I6)
  910 FORMAT(/
     & 5X,'Homgeneous problem   : element set .......... ',A/
     & 5X,'                       element type ......... ',A8)
  911 FORMAT(/
     & 5X,'Unhomgeneous problem : element set .......... ',A,A/
     & 5X,'(or multi-mesh aera)   element type ......... ',A8/
     & 5X,'                       number of element .... ',I5/)
  950 FORMAT(/
     & 5X,'Mesh quality: Ratio of Max. EL /Min. EL ..... ',E8.3/
     & 5X,'              Max. element length ........... ',E8.3/
     & 5X,'              Min. element length ........... ',E8.3/
     & 5X,'              Max. Ratio of element aspect .. ',E8.3,
     &   ' at element ',I5)
      RETURN
      END
C
      SUBROUTINE CHECK_DAT
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      KC3D20=0
      KC3D15=0
      KC3D8 =0
      KC3D6 =0
      KC3D4 =0
      KC2D9 =0
      KC2D8 =0
      KC2D6 =0
      KC2D4 =0
      KC2D3 =0
      KCOHE1=0
      NSETS =0
      DO I=1,MXMSET
        IF(MATSET(I,1).GT.1) NSETS=NSETS+1
      END DO
      NTYPE=NSETS
      ISETS=0
      DO ISETS=1,NSETS
        DO K=2,MATSET(ISETS,1)
        IE=MATSET(ISETS,K)
        IF(IE.EQ.0) GOTO 100
        IF(ELTYP(IE)(1:5).EQ.'C3D20') THEN
          IF(ELSET_TYP(ISETS).EQ.' ') ELSET_TYP(ISETS)='C3D20R'
        ELSE IF(ELTYP(IE).EQ.'C3D15   ') THEN
          IF(ELSET_TYP(ISETS).EQ.' ') ELSET_TYP(ISETS)='C3D15'
        ELSE IF(ELTYP(IE).EQ.'C3D8    ') THEN
          IF(ELSET_TYP(ISETS).EQ.' ') ELSET_TYP(ISETS)='C3D8'
        ELSE IF(ELTYP(IE).EQ.'C3D6    ') THEN
          IF(ELSET_TYP(ISETS).EQ.' ') ELSET_TYP(ISETS)='C3D6'
        ELSE IF(ELTYP(IE).EQ.'C3D4    ') THEN
          IF(ELSET_TYP(ISETS).EQ.' ') ELSET_TYP(ISETS)='C3D4'
        ELSE IF(ELTYP(IE).EQ.'C2D9    ') THEN
          IF(ELSET_TYP(ISETS).EQ.' ') ELSET_TYP(ISETS)='U2090'
        ELSE IF(ELTYP(IE).EQ.'C2D8    ') THEN
          IF(ELSET_TYP(ISETS).EQ.' ') ELSET_TYP(ISETS)='CPE8R'
        ELSE IF(ELTYP(IE).EQ.'C2D6    ') THEN
          IF(ELSET_TYP(ISETS).EQ.' ') ELSET_TYP(ISETS)='CPE6'
        ELSE IF(ELTYP(IE).EQ.'C2D4    ') THEN
          IF(ELSET_TYP(ISETS).EQ.' ') ELSET_TYP(ISETS)='CPE4'
        ELSE IF(ELTYP(IE).EQ.'C2D3    ') THEN
          IF(ELSET_TYP(ISETS).EQ.' ') ELSET_TYP(ISETS)='CPE3'
        ELSE IF(ELTYP(IE).EQ.'ICOHE1  ') THEN
          IF(ELSET_TYP(ISETS).EQ.' ') ELSET_TYP(ISETS)='U1030'
        END IF
        GOTO 120
  100   CONTINUE
        END DO
  120   CONTINUE
      END DO
      RETURN
      END
C
C
C
      SUBROUTINE ROTAT
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      READ(IO_INPUT,*) KAXIS,ANGLE
C
      IF(KAXIS.EQ.1) THEN
        XAXIS = 2
        YAXIS = 3
      ELSE IF(KAXIS.EQ.2) THEN
        XAXIS = 3
        YAXIS = 1
      ELSE
        XAXIS = 1
        YAXIS = 2
      END IF
C
      ANGLE0=ANGLE*PI/180.0D0
C
      DO I=1,NNODE
        X=COORD(I,XAXIS)
        Y=COORD(I,YAXIS)
        R=SQRT(X*X+Y*Y)
        IF(R.NE.0.0) THEN
          ATH=DACOS(X/R)
	  IF (Y.LT.0.0) ATH = 2*PI - ATH
          ANGLE=ANGLE0+ATH
          CH=COS(ANGLE)
          SH=SIN(ANGLE)
          X_NEW=R*CH
          Y_NEW=R*SH
        ELSE
          X_NEW=X
          Y_NEW=Y
        END IF
        COORD(I,XAXIS)=X_NEW
        COORD(I,YAXIS)=Y_NEW
      END DO
      RETURN
      END
C
C
C     GENERATING A CRACK ALONG A DEFINED LINE WHICH HAS BEEN
C     DEFINED BY SUB. DSLINE
C     STRING=LINE  CRACKED ALONG THE SLINE 
C                  INSIDE POLYGON X1,Y1 TO X2,Y2
C            ARC   CRACKED ALONG ARC THE SLINE 
C                  START AT ANGLE THETA1 END AT THETA2
C
      SUBROUTINE CRACKED
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      DIMENSION NDCRACK(500,10)
      DIMENSION XO(10),YO(10),RO(10),THETA1(10),THETA2(10)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. CRACKED'
C
      TEXT='NOW EXCUTING SUB. CRACKED'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
    1 READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:1).EQ.'*') THEN
         BACKSPACE IO_INPUT
C
         TEXT='END OF EXCUTING SUB. CRACKED'
         TEXT1=' '
         IF(KEY_WT.EQ.1) THEN
           CALL WPROC(TEXT,2,TEXT1,0,0)
         END IF
C
         RETURN
      ELSE IF(STRING(1:3).EQ.'ARC') THEN
        PI=4.0D0*DATAN(1.0D0)
        READ(IO_INPUT,*) NC
        DO I=1,NC
          READ(IO_INPUT,'(6E15.8)') THETA1(I),THETA2(I)
        END DO
        DO I=1,NC
         NDCRACK(1,I)=1
         DO K=2,NSLINE(1,I)
          IN=NSLINE(K,I)/10
          THETA=CSLINE(K,I)*180.0/PI
          T1=THETA-THETA1(I)
          T2=THETA2(I)-THETA
          IF(T1.GT.0.0D0.AND.T2.GT.0.0D0) THEN
            NDCRACK(1,I)=NDCRACK(1,I)+1
            NDCRACK(NDCRACK(1,I),I)=NSLINE(K,I)
          END IF
         END DO
        END DO
        GOTO 10
      END IF
  10  CONTINUE
c     do i=1,interset(1)-1
c     write(41,'(10i8)') (ndcrack(j,i),j=2,ndcrack(1,i))
c     end do
      DO I=1,NNODE
       INCOD(I)=I*10
      END DO
      NDNEW=NNODE
      DO I=1,INTERSET(1)-1
       DO K=2,NDCRACK(1,I)
         IN=NDCRACK(K,I)/10
         IM=NDCRACK(K,I)-IN*10
         NDNEW=NDNEW+1
         INCOD(IN)=NDNEW*10+IM
         DO J=1,3
           COORD(NDNEW,J)=COORD(IN,J)
         END DO
       END DO
      END DO
      NNODE=NDNEW
      DO I=1,NELEM
       NODE=LNODS(I,MXNOD)
       LM=LNODS(I,MXNOD-1)
       DO J=1,NODE
         LN=LNODS(I,J)
         IN=INCOD(LN)/10
         IM=INCOD(LN)-IN*10
         IF(LN.NE.IN.AND.LM.NE.IM) THEN
           LNODS(I,J)=IN
         END IF
       END DO
      END DO
      GOTO 1
      RETURN
      END
C
      SUBROUTINE CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      XMAX=-1.0E20
      XMIN=1.0E20
      YMAX=-1.0E20
      YMIN=1.0E20
      ZMAX=-1.0E20
      ZMIN=1.0E20
      I1  =IRAXIS(1)
      I2  =IRAXIS(2)
      I3  =IRAXIS(3)
      DO I=1,NNODE
        IF(INCOD(I).NE.0) THEN
        X1=COORD(I,I1)
        Y1=COORD(I,I2)
        Z1=COORD(I,I3)
        IF(KEY_ROTAT2.EQ.0) THEN
          IF(X1.LT.XMIN) XMIN=X1
          IF(X1.GT.XMAX) XMAX=X1
          IF(Y1.LT.YMIN) YMIN=Y1
          IF(Y1.GT.YMAX) YMAX=Y1
          IF(Z1.LT.ZMIN) ZMIN=Z1
          IF(Z1.GT.ZMAX) ZMAX=Z1
        ELSE
          DX=X1-XO_ROTAT2
          DY=Y1-YO_ROTAT2
          RO=SQRT(DX*DX+DY*DY)
          IF(DX.EQ.0.0E0.AND.DY.EQ.0.0E0) THEN
            TH=0.0E0
          ELSE
            TH=ACOS(DX/RO)
          END IF
          IF(DY.LT.0.0) TH=2*PI-TH
          IF(DY.EQ.0.0.AND.DX.LT.0.0) TH=PI
          IF(DY.EQ.0.0.AND.DX.GT.0.0) TH=0.0E0
          IF(RO.LT.XMIN) XMIN=RO
          IF(RO.GT.XMAX) XMAX=RO
          IF(TH.LT.YMIN) YMIN=TH
          IF(TH.GT.YMAX) YMAX=TH
          IF(Z1.LT.ZMIN) ZMIN=Z1
          IF(Z1.GT.ZMAX) ZMAX=Z1
        END IF
        END IF
      END DO
      RETURN
      END
C
C     PROGRAM FOR GENERATING SYMMETRIC ELEMENT MESH
C
      SUBROUTINE SYSMESH
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION NDSYS(5000),NESYS(5000),NSYSE(9000),IEL(8)
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. SYSMESH'
C
      TEXT='NOW EXCUTING SUB. SYSMESH'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      READ(IO_INPUT,*) KSYSM,ASYSM,LAYERP,IMSET
      IF(KSYSM.EQ.0) RETURN
      CALL SEAND(NDSYS,KSYSM,ASYSM,KNSYS,2)
      DO I=1,NNODE
        IF(INCOD(I).GT.0) THEN
          INS=I+NNODE
          IF(KSYSM.EQ.1) THEN
            COORD(INS,1)=2.0D0*ASYSM-COORD(I,1)
            COORD(INS,2)=COORD(I,2)
            COORD(INS,3)=COORD(I,3)
          ELSE IF(KSYSM.EQ.2) THEN
            COORD(INS,1)=COORD(I,1)
            COORD(INS,2)=2.0D0*ASYSM-COORD(I,2)
            COORD(INS,3)=COORD(I,3)
          ELSE IF(KSYSM.EQ.3) THEN
            COORD(INS,1)=COORD(I,1)
            COORD(INS,2)=COORD(I,2)
            COORD(INS,3)=2.0D0*ASYSM-COORD(I,3)
          ENDIF
        ENDIF
      END DO
      DO IE=1,NELEM
        IES=IE+NELEM
        NODE=LNODS(IE,MXNOD)
        IF(IMSET.EQ.0) IMSET=LNODS(IE,MXNOD-1)
        LNODS(IES,MXNOD)=NODE
        LNODS(IES,MXNOD-1)=IMSET
        IF(ELTYP(IE)(1:4).EQ.'C2D8'.OR.
     &     ELTYP(IE)(1:4).EQ.'CPE8'.OR.
     &     ELTYP(IE)(1:4).EQ.'CPS8') THEN
          LNODS(IES,1)=LNODS(IE,2)+NNODE
          LNODS(IES,2)=LNODS(IE,1)+NNODE
          LNODS(IES,3)=LNODS(IE,4)+NNODE
          LNODS(IES,4)=LNODS(IE,3)+NNODE
          LNODS(IES,5)=LNODS(IE,5)+NNODE
          LNODS(IES,6)=LNODS(IE,8)+NNODE
          LNODS(IES,7)=LNODS(IE,7)+NNODE
          LNODS(IES,8)=LNODS(IE,6)+NNODE
        ELSE IF(ELTYP(IE)(1:4).EQ.'C2D6'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPE6'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPS6') THEN
          LNODS(IES,1)=LNODS(IE,1)+NNODE
          LNODS(IES,2)=LNODS(IE,3)+NNODE
          LNODS(IES,3)=LNODS(IE,2)+NNODE
          LNODS(IES,4)=LNODS(IE,6)+NNODE
          LNODS(IES,5)=LNODS(IE,5)+NNODE
          LNODS(IES,6)=LNODS(IE,4)+NNODE
        ELSE IF(ELTYP(IE)(1:4).EQ.'C2D4'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPE4'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPS4') THEN
          LNODS(IES,1)=LNODS(IE,1)+NNODE
          LNODS(IES,2)=LNODS(IE,4)+NNODE
          LNODS(IES,3)=LNODS(IE,3)+NNODE
          LNODS(IES,4)=LNODS(IE,2)+NNODE
        ELSE IF(ELTYP(IE)(1:4).EQ.'C2D3'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPE3'.OR.
     &          ELTYP(IE)(1:4).EQ.'CPS3') THEN
          LNODS(IES,1)=LNODS(IE,1)+NNODE
          LNODS(IES,2)=LNODS(IE,3)+NNODE
          LNODS(IES,3)=LNODS(IE,2)+NNODE
        ELSE IF(ELTYP(IE)(1:5).EQ.'C3D20') THEN
          LNODS(IES, 1)=LNODS(IE, 1)+NNODE
          LNODS(IES, 2)=LNODS(IE, 4)+NNODE
          LNODS(IES, 3)=LNODS(IE, 3)+NNODE
          LNODS(IES, 4)=LNODS(IE, 2)+NNODE
          LNODS(IES, 5)=LNODS(IE, 5)+NNODE
          LNODS(IES, 6)=LNODS(IE, 8)+NNODE
          LNODS(IES, 7)=LNODS(IE, 7)+NNODE
          LNODS(IES, 8)=LNODS(IE, 6)+NNODE
          LNODS(IES, 9)=LNODS(IE,12)+NNODE
          LNODS(IES,10)=LNODS(IE,11)+NNODE
          LNODS(IES,11)=LNODS(IE,10)+NNODE
          LNODS(IES,12)=LNODS(IE, 9)+NNODE
          LNODS(IES,13)=LNODS(IE,16)+NNODE
          LNODS(IES,14)=LNODS(IE,15)+NNODE
          LNODS(IES,15)=LNODS(IE,14)+NNODE
          LNODS(IES,16)=LNODS(IE,13)+NNODE
          LNODS(IES,17)=LNODS(IE,17)+NNODE
          LNODS(IES,18)=LNODS(IE,20)+NNODE
          LNODS(IES,19)=LNODS(IE,19)+NNODE
          LNODS(IES,20)=LNODS(IE,18)+NNODE
        ELSE IF(ELTYP(IE)(1:4).EQ.'C3D6') THEN
          LNODS(IES, 1)=LNODS(IE, 1)+NNODE
          LNODS(IES, 2)=LNODS(IE, 3)+NNODE
          LNODS(IES, 3)=LNODS(IE, 2)+NNODE
          LNODS(IES, 4)=LNODS(IE, 4)+NNODE
          LNODS(IES, 5)=LNODS(IE, 6)+NNODE
          LNODS(IES, 6)=LNODS(IE, 5)+NNODE
        ELSE IF(ELTYP(IE)(1:4).EQ.'C3D8') THEN
          LNODS(IES, 1)=LNODS(IE, 1)+NNODE
          LNODS(IES, 2)=LNODS(IE, 4)+NNODE
          LNODS(IES, 3)=LNODS(IE, 3)+NNODE
          LNODS(IES, 4)=LNODS(IE, 2)+NNODE
          LNODS(IES, 5)=LNODS(IE, 5)+NNODE
          LNODS(IES, 6)=LNODS(IE, 8)+NNODE
          LNODS(IES, 7)=LNODS(IE, 7)+NNODE
          LNODS(IES, 8)=LNODS(IE, 6)+NNODE
        ELSE IF(ELTYP(IE)(1:5).EQ.'C3D15') THEN
          LNODS(IES, 1)=LNODS(IE, 1)+NNODE
          LNODS(IES, 2)=LNODS(IE, 3)+NNODE
          LNODS(IES, 3)=LNODS(IE, 2)+NNODE
          LNODS(IES, 4)=LNODS(IE, 4)+NNODE
          LNODS(IES, 5)=LNODS(IE, 6)+NNODE
          LNODS(IES, 6)=LNODS(IE, 5)+NNODE
          LNODS(IES, 7)=LNODS(IE, 9)+NNODE
          LNODS(IES, 8)=LNODS(IE, 8)+NNODE
          LNODS(IES, 9)=LNODS(IE, 7)+NNODE
          LNODS(IES,10)=LNODS(IE,12)+NNODE
          LNODS(IES,11)=LNODS(IE,11)+NNODE
          LNODS(IES,12)=LNODS(IE,10)+NNODE
          LNODS(IES,13)=LNODS(IE,13)+NNODE
          LNODS(IES,14)=LNODS(IE,15)+NNODE
          LNODS(IES,15)=LNODS(IE,14)+NNODE
        ENDIF
        CALL DNODE(IES,NODE)
        MATSET(IMSET,1)=MATSET(IMSET,1)+1
        MATSET(IMSET,MATSET(IMSET,1))=IES
        ELTYP(IES)=ELTYP(IE)
      END DO
C
      IF(KSYSM.EQ.1) THEN
        DO I=1,NTNUM-1
          I1=2*NTNUM-I
          NDTIP(I1,1)=NDTIP(I,1)
          DO K=2,NDTIP(I1,1)
            NDTIP(I1,K)=NDTIP(I,K)+NNODE
          END DO
        END DO
        NTNUM=2*NTNUM-1
      ELSE IF(KSYSM.EQ.2) THEN
        DO I=1,NTNUM
          NN=NDTIP(I,1)
          DO K=2,NN-1
            K1=2*(NN-1)-K+2
            NDTIP(I,K1)=NDTIP(I,K)+NNODE
          END DO
          NDTIP(I,1)=2*(NN-1)
        END DO
      ELSE IF(KSYSM.EQ.3) THEN
        DO I=1,NTNUM
          I1=2*NTNUM-I+1
          NDTIP(I1,1)=NDTIP(I,1)
          DO K=2,NDTIP(I1,1)
            NDTIP(I1,K)=NDTIP(I,K)+NNODE
          END DO
          I1=2*NTNUM-I+1
        END DO
        NTNUM=2*NTNUM
      END IF
      IF(NESUF(1).GT.1) THEN
        NT=NESUF(1)
        DO K=2,NESUF(1)
          NT=NT+1
          IESUF=NESUF(K)+NELEM
          NESUF(NT)=IESUF
        END DO
        NESUF(1)=NT
      END IF
      NNODE=2*NNODE
      NELEM=2*NELEM
C
      TEXT='END OF EXCUTING SUB. SYSMESH'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
      SUBROUTINE DNODE(IE,NODE)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DO K=1,NODE
        INCOD(LNODS(IE,K))=LNODS(IE,K)
      END DO
      RETURN
      END
C
C     SUBROUTINE DETERMINING THE LIGAMENT NODES SET
C
      SUBROUTINE NODXY(KEY,IE1,IE2)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. DELCNE'
C
      TEXT='NOW EXCUTING SUB. NODXY'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      DO I=IE1,IE2
      NODE=LNODS(I,MXNOD)
      DO J=1,NODE
      INCOD(LNODS(I,J))=LNODS(I,J)
      END DO
      IF(KEY.EQ.1.OR.KEY.EQ.3) THEN
      DO J=1,3,2
      IM=LNODS(I,J+4)
      X=COORD(IM,1)
      Y=COORD(IM,2)
      R=X*X+Y*Y
      I1=J
      I2=J+1
      IF(I2.GT.4) I2=I2-4
      IN1=LNODS(I,I1)
      IN2=LNODS(I,I2)
      X1=COORD(IN1,1)
      Y1=COORD(IN1,2)
      X2=COORD(IN2,1)
      Y2=COORD(IN2,2)
      X=0.5*(X1+X2)
      Y=0.5*(Y1+Y2)
      COORD(IM,1)=X
      COORD(IM,2)=Y
      END DO
      END IF
      IF(KEY.EQ.2.OR.KEY.EQ.3) THEN
      DO J=2,4,2
      IM=LNODS(I,J+4)
      X=COORD(IM,1)
      Y=COORD(IM,2)
      R=X*X+Y*Y
      I1=J
      I2=J+1
      IF(I2.GT.4) I2=I2-4
      IN1=LNODS(I,I1)
      IN2=LNODS(I,I2)
      X1=COORD(IN1,1)
      Y1=COORD(IN1,2)
      X2=COORD(IN2,1)
      Y2=COORD(IN2,2)
      X=0.5*(X1+X2)
      Y=0.5*(Y1+Y2)
      COORD(IM,1)=X
      COORD(IM,2)=Y
      END DO
      END IF
      END DO
C
      TEXT='END OF EXCUTING SUB. NODXY'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
C
C
      SUBROUTINE SOLVSL(NY,EL0,RL,SCL)
      IMPLICIT REAL*8(A-H,O-Z)
      SCL=1.0
      NI=0
    1 CONTINUE
        ST=0.0
        DO I=1,NY
          ST=ST+SCL**I
        END DO
        F=RL/EL0-ST
        IF(DABS(F).LT.1.D-10) RETURN
        NI=NI+1
        IF(NI.GT.100) GOTO 10
        DF=0.0
        DO I=1,NY
          DF=DF+I*SCL**(I-1)
        END DO
        SCL=SCL+F/DF
      GOTO 1
   10 CONTINUE
      WRITE(*,100) RL,EL0,NY
  100 FORMAT(' NO SOLUTION IN SUB. SOLVSL',
     1 ' RL=',E10.4,' EL0=',E10.4,' NY=',I2)
      RETURN
      END
C
C     SCALING THE COORDINATES OF NODES
C
      SUBROUTINE SCALE
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. SCALE'
C
      TEXT='NOW EXCUTING SUB. SCALE'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
C
      READ(IO_INPUT,*) COORDSC
      IF(COORDSC.EQ.0) RETURN
      IF(COORDSC.LT.0.0) THEN
      CALL CVMAX(XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)
      IF(NINT(COORDSC).EQ.-1) COORDSC=1.0D0/(XMAX-XMIN)
      IF(NINT(COORDSC).EQ.-2) COORDSC=1.0D0/(YMAX-YMIN)
      END IF
      TOLER = TOLER*COORDSC
      DO I=1,NNODE
      DO J=1,3
      COORD(I,J)=COORD(I,J)*COORDSC
      END DO
      END DO
C
      TEXT='END OF EXCUTING SUB. SCALE'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
C     DECLINE THE SAME COORDINATE NODES
C
      SUBROUTINE TOLERAN
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. TOLERAN'
C
      TEXT='NOW EXCUTING SUB. TOLERAN'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      READ(IO_INPUT,'(E12.5)') TOLERM
      IF(TOLERM.EQ.0.0) TOLERM=1.0E-15
      DO I=1,NNODE
        DO K=1,3
          X=COORD(I,K)
          IF(ABS(X).LT.TOLERM) THEN
            COORD(I,K)=0.0D0
          END IF
        END DO
      END DO
C
      TEXT='END OF EXCUTING SUB. TOLERAN'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
      SUBROUTINE IARRANGE(JRRAY,MXRRAY,LRRAY)
      INTEGER JRRAY(MXRRAY)
      DO I=1,LRRAY-1
        IM=JRRAY(I)
        IK=I
        DO J=I+1,LRRAY
          JM=JRRAY(J)
          IF(JM.LT.IM) THEN
            IK=J
            IM=JM
          END IF
        END DO
        IF(IK.NE.I) THEN
          JM=JRRAY(I)
          JRRAY(I)=JRRAY(IK)
          JRRAY(IK)=JM
        END IF
      END DO
      RETURN
      END
C
C     REORDER THE NODES ORDER
C
      SUBROUTINE REORDER
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. REORDER'
C
      TEXT='NOW EXCUTING SUB. REORDER'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      DO I=1,NNODE
        INCOD(I)=0
      END DO
      DO IE=1,NELEM
        NODE=LNODS(IE,MXNOD)
        DO J=1,NODE
          IN=LNODS(IE,J)
          IF(IN.GT.0) INCOD(IN)=1
        END DO
      END DO
      INT=0
      DO I=1,NNODE
        IN1=INCOD(I)
        IF(IN1.NE.0) THEN
          INT=INT+1
          INCOD(I)=INT
          COORD(INT,1)=COORD(I,1)
          COORD(INT,2)=COORD(I,2)
          COORD(INT,3)=COORD(I,3)
        ENDIF
      END DO
      CALL REORDER_SUB
      NNODE=INT
C
      DO I=1,NNODE
        INCOD(I)=I
      END DO
C
      TEXT='END OF EXCUTING SUB. REORDER'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
      SUBROUTINE REORDER_SUB
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      INCLUDE 'mcom_map'
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. REORDER_SUB'
C
      TEXT='NOW EXCUTING SUB. REORDER_SUB'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
C     REORDER NODE SETS
C
      DO I = 1,NDSET
         IF (NNSET(I).GT.0) THEN
            DO J = 1,NNSET(I)
               INSET(J,I) = INCOD(INSET(J,I))
	    END DO
	 ENDIF
      END DO
C
C     REORDER LIGAMENT ORDER
C
      IF(NDLIG(1).GT.1) THEN
        NCOUNT=1
        DO J=2,NDLIG(1)
          IN=NDLIG(J)
          IF(INCOD(IN).NE.0) THEN
            NCOUNT=NCOUNT+1
            NDLIG(NCOUNT)=INCOD(IN)
          END IF
        END DO
        NDLIG(1)=NCOUNT
      END IF
C
C     REORDER CRACK TIP NODE
C
      DO I=1,NTNUM
        NCOUNT=1
        DO K=2,NDTIP(I,1)
          IN=NDTIP(I,K)
          IF(IN.NE.0.AND.INCOD(IN).NE.0) THEN
            IN_NEW=INCOD(IN)
            NCOUNT=NCOUNT+1
            NDTIP(I,NCOUNT)=IN_NEW
          END IF
        END DO
        NDTIP(I,1)=NCOUNT
      END DO
C
C     BOUNDARY LAYER FORMULATION 
C
      IF(NDBLF(1).NE.0) THEN
        DO K=2,NDBLF(1)
          IN=NDBLF(K)
          IF(IN.NE.0) THEN
            NDBLF(K) = INCOD(IN)
          END IF
        END DO
      END IF
C
C     REORDER CT SPECIMEN LOAD POINT
C
      IF(LDCT.NE.0) THEN
        DO I=1,LDCT_3D(1)
          IN=LDCT_3D(I+1)
          IF(IN.NE.0) THEN
            LDCT_3D(I+1)=INCOD(IN)
          END IF
        END DO
      END IF
C
C     REORDER MAPE REGION NODES IN LNSRG
C
      IF(NRG.NE.0) THEN
        DO I=1,NRG
	   DO J = 1,8
              IN=LNSRG(I,J)
              IF(IN.NE.0) THEN
		 INC = INCOD(IN)
C       	 if (inc.ne.in) print *,'Knoten',in,' wird mit',inc,' besetzt'
                 LNSRG(I,J) = INC
              END IF
           END DO
        END DO
      END IF
C
C     REORDER ELEMENT DEFINITION
C
      DO I=1,NELEM
        NODE=LNODS(I,MXNOD)
        DO J=1,NODE
          LN=LNODS(I,J)
          IF(LN.NE.0) LNODS(I,J)=INCOD(LN)
        END DO
      END DO
C
      TEXT='END OF EXCUTING SUB. REORDER_SUB'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      RETURN
      END
C
C     REORDER THE NODES ORDER
C
      SUBROUTINE ORDER_ZC(KWORK)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      CHARACTER REORDERT*8
      DIMENSION KWORK(MXZNUM)
C
      DO I=2,KWORK(1)-1
        JMIN=I
        IN1=KWORK(I)
        ZMIN=COORD(IN1,3)
        DO J=I+1,KWORK(1)
          IN2=KWORK(J)
          Z=COORD(IN2,3)
          IF(Z.LT.ZMIN) THEN
            JMIN=J
            ZMIN=Z
          END IF
        END DO
        IF(JMIN.NE.I) THEN
          JM=KWORK(I)
          KWORK(I)=KWORK(JMIN)
          KWORK(JMIN)=JM
        END IF
      END DO
c     WRITE(IO_WORK,'(I6,3E10.4)') 
c    &   (KWORK(I),(COORD(KWORK(I),K),K=1,3),I=2,KWORK(1))
      RETURN
      END
C
      SUBROUTINE WPROC(TEXT0,KEY,TEXT10,KPROC,NTOTAL)
      CHARACTER TEXT0*160,TEXT*160,TEXT1*160,TEXT10*160,
     &          TEXT_old*160,TEXT1_old*160
      COMMON /WINDOW/IWINDOW
      NT=2
      TEXT=TEXT0
      TEXT1=TEXT10
      IF(IWINDOW.EQ.1) RETURN
      IF(NCHAR_old.EQ.0) THEN
        NCHAR_old=1
        TEXT_old=' '
      END IF
      DO NCHAR=160,1,-1
        IF(TEXT(NCHAR:NCHAR).NE.' ') GOTO 5
      END DO
    5 CONTINUE
      IF(NCHAR.EQ.0) THEN
        NCHAR=1
        TEXT(NCHAR:NCHAR)=' '
      END IF
      DO NCHAR1=160,1,-1
        IF(TEXT1(NCHAR1:NCHAR1).NE.' ') GOTO 7
      END DO
    7 CONTINUE
      TEXT1(NCHAR1+1:NCHAR1+2)='  '
      NCHAR1=NCHAR1+2
      IP1X=0
      IP1Y=0
      SPSIZE=12.
      IF(KEY_open.GT.0) GOTO 100
      KEY_open=1
      CALL X11OPN(IFLAG,IWPX,IHPX)
      IX=40
      IY=40
      H=(NT+2)*(SPSIZE+4.)
      W=900
      IF(IFLAG.EQ.0) RETURN
      IP2X=IP1X+W+IX
      IP2Y=IP1Y+H+IY
      CALL X11WIN(IP1X,IP1Y,IP2X,IP2Y)
      CALL X11CHI(SPSIZE)
      IY1=IY+SPSIZE+4
  100 CONTINUE
      IF(TEXT_old(1:NCHAR_old).NE.TEXT(1:NCHAR)) THEN
        CALL X11COL(0)
        CALL X11CHR(IX,IY,NCHAR_old,TEXT_old)
      END IF
        CALL X11COL(1)
        CALL X11CHR(IX,IY,NCHAR,TEXT)
        NCHAR_old=NCHAR
        TEXT_old(1:NCHAR_old)=TEXT(1:NCHAR)
C     END IF
C
      IF(KEY.EQ.1) THEN
        WRITE(TEXT1(NCHAR1+1:NCHAR1+5),'(I5)') KPROC
        NCHAR1=NCHAR1+5
        TEXT1(NCHAR1+1:NCHAR1+1)='/'
        NCHAR1=NCHAR1+1
        WRITE(TEXT1(NCHAR1+1:NCHAR1+5),'(I5)') NTOTAL
        NCHAR1=NCHAR1+5
        IF(TEXT1_old(1:NCHAR1).NE.TEXT1(1:NCHAR1)) THEN
          CALL X11COL(0)
          CALL X11CHR(IX,IY1,NCHAR1_old,TEXT1_old)
          CALL X11COL(1)
          CALL X11CHR(IX,IY1,NCHAR1,TEXT1)
          NCHAR1_old=NCHAR1
          TEXT1_old(1:NCHAR1_old)=TEXT1(1:NCHAR1)
        END IF
      ELSE IF(KEY.EQ.2) THEN
        CALL X11COL(0)
        CALL X11CHR(IX,IY1,NCHAR1_old,TEXT1_old)
      ELSE IF(KEY.EQ.3) THEN
        WRITE(TEXT1(NCHAR1+1:NCHAR1+5),'(I5)') KPROC
        NCHAR1=NCHAR1+5
        IF(TEXT1_old(1:NCHAR1).NE.TEXT1(1:NCHAR1)) THEN
          CALL X11COL(0)
          CALL X11CHR(IX,IY1,NCHAR1_old,TEXT1_old)
          CALL X11COL(1)
          CALL X11CHR(IX,IY1,NCHAR1,TEXT1)
          NCHAR1_old=NCHAR1
          TEXT1_old(1:NCHAR1_old)=TEXT1(1:NCHAR1)
        END IF
      END IF
      CALL X11FLS
C
  999 CONTINUE
      RETURN
      END
