C----------------------------------------------------------------------
C     DEFINE ELEMENT SETS FOR DIFFERENT MATERIALS 
C----------------------------------------------------------------------
C
      SUBROUTINE MULTIMAT
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      PARAMETER ( MXAREA = 200)
      CHARACTER CH_MAT(MXAREA)*10
      DIMENSION X1(MXAREA),X2(MXAREA),Y1(MXAREA),Y2(MXAREA),
     &          Z1(MXAREA),Z2(MXAREA),XO(MXAREA),YO(MXAREA),
     &          ZO(MXAREA),MATSET_NEW(MXMSET)
C
      TEXT='NOW EXCUTING SUB. MULTIMAT'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
      CERRRPT(1)(20:80) = 'Sub. MULTIMAT'
C
      IMSET1 = 0
      CALL LOCCHR(STRING,'OLD ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET1
      END IF
      CALL LOCCHR(STRING,'NEW ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET2
      END IF
      IF(IMSET2.EQ.0) THEN
        WRITE(IO_WRITE,1000) 'MULTIMAT','No (NEW ELSET) parameter.',
     &  ' Please check file *.inf'
        WRITE(IO_INFO ,1000) 'MULTIMAT','No (NEW ELSET) parameter.'
        WRITE(IO_INFO ,1001) 'MULTIMAT'
        WRITE(IO_INFO ,1002)
C       STOP
      END IF
      KEY = 1
 1000 FORMAT(5X,'!!! ERROR     INPUT:',1X,A,' - ',A,A)
 1001 FORMAT(5X,'!!! COMMAND        :',1X,A,' - ',
     &  /20X,'*MULTIMAT,OLD ELSET=?,NEW ELSET=?')
 1002 FORMAT(
     & /20X,'*POLYGON',20X,'(option)'/21X,'X1, Y1, X2, Y2',
     & /20X,'*POINT  ',20X,'(option)'/21X,'X1, Y1, Z1',
     & /20X,'*CIRCLE ',20X,'(option)'/21X,'Xo, Yo , R1, R2, TH1, TH2'/)
 1010 FORMAT(5X,'!!! UNKNOWN COMMAND:',1X,A,' - ',A,A)
C
C
      NMAT = 0
   10 CONTINUE
      IF(NMAT.GE.MXAREA) THEN
        WRITE(STRING,'(A,I2)') 'maximum is',MXAREA
        CERRRPT(1)(20:80) = ': Too many material aeras, '//STRING
        NLERR = 1
        IUNIT = 6
        CALL MERRPT(IUNIT,KERR,NLERR)
        IUNIT = IO_INFO
        CALL MERRPT(IUNIT,KERR,NLERR)
      END IF
      READ(IO_INPUT,'(A)') STRING
      IF(STRING(1:2).EQ.'**') THEN
        GOTO 10
      ELSE IF(STRING(1:3).EQ.'ARC'.OR.STRING(1:3).EQ.'*AR') THEN
        NMAT = NMAT + 1
        IM   = NMAT
        CH_MAT(IM)='ARC'
        READ(IO_INPUT,*) XO(IM),YO(IM)
        READ(IO_INPUT,*) X1(IM),Y1(IM),X2(IM),Y2(IM),Z2(IM)
      ELSE IF(STRING(1:3).EQ.'POL'.OR.STRING(1:4).EQ.'*POL') THEN
        NMAT = NMAT + 1
        IM   = NMAT
        CH_MAT(IM)='POL'
        READ(IO_INPUT,*) X1(IM),Y1(IM),Z1(IM),X2(IM),Y2(IM),Z2(IM)
      ELSE IF(STRING(1:3).EQ.'POI'.OR.STRING(1:4).EQ.'*POI') THEN
        NMAT = NMAT + 1
        IM   = NMAT
        CH_MAT(IM)='POI'
        READ(IO_INPUT,*) X1(IM),Y1(IM),Z1(IM)
      ELSE IF(STRING(1:3).EQ.'*RE') THEN
        READ(IO_INPUT,*) NREP,DX,DY,DZ
        DO K=1,NREP
          IM0  = IM
          NMAT = NMAT + 1
          IM   = NMAT
          CH_MAT(IM)=CH_MAT(IM0)
          IF(CH_MAT(IM0)(1:3).EQ.'ARC') THEN
            XO(IM) = XO(IM0)+DX
            YO(IM) = YO(IM0)+DY
          ELSE IF(CH_MAT(IM0)(1:3).EQ.'POL') THEN
            X1(IM) = X1(IM0)+DX
            Y1(IM) = Y1(IM0)+DY
            Z1(IM) = Z1(IM0)+DZ
            X2(IM) = X2(IM0)+DX
            Y2(IM) = Y2(IM0)+DY
            Z2(IM) = Z2(IM0)+DZ
          ELSE IF(CH_MAT(IM0)(1:3).EQ.'POI') THEN
            X1(IM) = X1(IM0)+DX
            Y1(IM) = Y1(IM0)+DY
            Z1(IM) = Z1(IM0)+DZ
          END IF
        END DO
      ELSE IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE IO_INPUT
        GOTO 20
      ELSE
        GOTO 10
      END IF
      GOTO 10
C
C---  looking for elements...
C
   20 CONTINUE
      NSETS=0
      DO I=1,MXMSET
        IF(MATSET(I,1).GT.1) NSETS=NSETS+1
      END DO
      KSETB = 1
      KSETE = NSETS
      IF (IMSET2.EQ.0) IMSET2 = NSETS + 1
      IF(IMSET1.GT.0) THEN
        KSETB = IMSET1
        KSETE = IMSET1
      END IF
      DO IMSET=KSETB,KSETE
        NMELE=MATSET(IMSET,1)
        DO K=2,NMELE
          IE=MATSET(IMSET,K)
          NODE=LNODS(IE,MXNOD)
          XM  = 0.0D0
          YM  = 0.0D0
          ZM  = 0.0D0
          KIM = 0
          DO IN=1,NODE
            LNI=LNODS(IE,IN)
            X=COORD(LNI,1)
            Y=COORD(LNI,2)
            Z=COORD(LNI,3)
            XM=XM+X
            YM=YM+Y
            ZM=ZM+Z
            IF(CH_MAT(IM)(1:3).EQ.'POI') THEN
              DO IM=1,NMAT
                ERX1=ABS(X-X1(IM))
                ERY1=ABS(Y-Y1(IM))
                IF(ERX1.LT.TOLER.AND.ERY1.LT.TOLER) THEN
                   KIM=IM
                   GOTO 100
                END IF
              END DO
            END IF
C-------- end of element node loop
          END DO
          XM  = XM/NODE
          YM  = YM/NODE
          ZM  = ZM/NODE
          KEY = 0
          DO IM=1,NMAT
            IF(CH_MAT(IM)(1:3).EQ.'ARC') THEN
              KEY=1
              DX=XM-XO(IM)
              DY=YM-YO(IM)
              DR=SQRT(DX*DX+DY*DY)
              TH=DX/DR
              TH=ACOS(TH)
              TH=TH*180.0/PI
              IF(DY.LT.0.0) TH=360.0-TH
              ERX1=DR-X1(IM)
              ERY1=TH-X2(IM)
              ERX2=Y1(IM)-DR
              ERY2=Y2(IM)-TH
            ELSE IF(CH_MAT(IM)(1:3).EQ.'POL') THEN
              KEY=1
              ERX1=XM-X1(IM)
              ERY1=YM-Y1(IM)
              ERX2=X2(IM)-XM
              ERY2=Y2(IM)-YM
            ELSE
              IM0=IM
            END IF
            IF(ERX1.GE.0.0.AND.ERY1.GE.0.0.AND.
     &         ERX2.GE.0.0.AND.ERY2.GE.0.0.AND.KEY.EQ.1) THEN
               KIM=IM
               GOTO 100
            END IF
	    
C-------- end of NMAT definitions loop
          END DO
  100     CONTINUE
          IF(KIM.NE.0) THEN
            KIM = IMSET2
            MATSET(KIM,1)=MATSET(KIM,1)+1
            MATSET(KIM,MATSET(KIM,1))=IE
            LNODS(IE,MXNOD-1)=KIM
            MATSET(IMSET,K)=0
            IF(ELSET_TYP(KIM)(1:4).EQ.'    ') 
     &         ELSET_TYP(KIM)=ELSET_TYP(IMSET)
          END IF
C------ end of element loop
        END DO
C---- end of element group loop
      END DO
      CALL MATSET_ORDER
      DO IMSET=1,NTYPE
        DO J=2,MATSET(IMSET,1)
          IE =  MATSET(IMSET,J)
          LNODS(IE,MXNOD-1) = IMSET
        END DO
      END DO
      RETURN
      END
      SUBROUTINE MATSET_ORDER
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      DO IMSET=1,MXMSET
        IF(MATSET(IMSET,1).GT.1) THEN
          NSETS = IMSET
          NCONT = 1
          NMAT =NMAT +1
          IMSET1 = IMSET
          IF(IMSET.GT.NMAT) IMSET1 = NMAT
          DO K = 2,MATSET(IMSET,1)
            IF(MATSET(IMSET,K).GT.0) THEN
              NCONT = NCONT + 1
              MATSET(IMSET1,NCONT) = MATSET(IMSET,K)
              IF(K.GT.NCONT.OR.IMSET.GT.NMAT) MATSET(IMSET,K) = 0
            END IF
          END DO
          MATSET(IMSET1,1) = NCONT
        END IF
      END DO
C
      IMSET = 0
    8 CONTINUE
      IMSET = IMSET + 1
      IF(MATSET(IMSET,1).LE.1) THEN
        IMSET1 = IMSET+1
        DO KMSET=IMSET,NSETS-1
c         DO JMSET=IMSET1,NSETS 
          JMSET=KMSET+1
            DO K = 1,MATSET(JMSET,1)
              MATSET(KMSET,K) = MATSET(JMSET,K)
            END DO
C         MATSET(IMSET,1) = MATSET(JMSET,1)
c         END DO
        END DO
        NSETS = NSETS - 1
      END IF
      IF(IMSET.LT.NSETS) GOTO 8
      NTYPE=NSETS
      DO JMSET=NSETS +1,MXMSET
        MATSET(JMSET,1) = 1
      END DO
      RETURN
      END
