C
C     GENERATING COHESIVE ELEMENTS IN A GIVEN DOMAIN
C
      SUBROUTINE CZDOMAIN
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCc
C                                                           C
C      KOHSIVELEMENTE FECGS                                C
C     (6 KNOTEN):     (4 KNOTEN)                            C
C                                                           C
C     1---2---3        1----2   Liniendefinition            C
C     |       |        |    |   -------------------->       C
C     4---5---6        3----4                               C
C                                                           C
C     KOHSIVELEMENT ABAQUS (immer 4 KNOTEN)                C
C     (auch am Rand - Linie so definieren da der Rand      C
C      rechts liegt!  Knotenlinie 4-3 ist Randlinie)        C
C                                                           C
C     2-----1    Liniendefinition                           C
C     |     |    --------------------------->               C
C     4-----3                                               C
C                                                           C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCc
C
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION IND(8),IK(4),X21(3),X31(3),Y(3)
C
C
      TEXT='NOW EXCUTING SUB. CZDOMAIN'
      TEXT1=' '
      WRITE(IO_JNL,'(5X,A)') TEXT
      WRITE(IO_WRITE,'(5X,A)') TEXT
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      IMSET1 = 0
      CALL LOCCHR(STRING,'OLD ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET1
      END IF
      CALL LOCCHR(STRING,'NEW ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET2
      ELSE
         IMSET2 = 1
         DO I=1,MXMSET
           IF(MATSET(I,1).GT.1) IMSET2 = IMSET2 + 1
         END DO
      END IF
C
C
C---  find all elements in the domain
      CALL FIND_ELSET_new (IMSET1,IWORK,NELE)
      WRITE (IO_WRITE,*) "found ",nele," elements in domain"
C
C---  initializing variables
      NCZ = 0
      NODNEW = NNODE
      NELNEW = NELEM
C
C---  define adresses for the iwork array
      IADR1 = 1
      IADR2 = IADR1 + NELE
      IADR3 = IADR2 + NNODE
      DO I = 1,NNODE
	 IWORK(IADR2+I-1) = 0
      END DO
C
C---  determining coh. elements in terms of element edges
C
      WRITE (*,2221)
      DO I1 = 1,NELE
         IE1 = IWORK(I1)
         CALL ELEINF (IE1,NEDGE,NFACE,NFCND,NEDND,NCORN,NNDIM1)
	 I3D = 0
	 IF (NFACE.GT.1) I3D = 1
	 IF (I3D.EQ.1) NEDGE = NFACE
	 DO J1 = 1,NEDGE
	    IF (I3D.EQ.1) THEN
	       IF (NCORN.EQ.4) THEN
                  IK1 = LNODS(IE1,NFACE_DF(1,J1,3) )
                  IK2 = LNODS(IE1,NFACE_DF(2,J1,3) )
                  IK3 = LNODS(IE1,NFACE_DF(3,J1,3) )
	          IKRI1 = MIN(IK1,IK2,IK3)
	          IKRI2 = MAX(IK1,IK2,IK3)
	          IKRI3 = IK1+IK2+IK3
	       ELSE
	          IKRI1 = J1
	       ENDIF
	    ELSE
	       CALL EDGEND(IE1,J1,NN,IND)
	       NEL1N1 = IND(1)
	       NEL1N2 = IND(NN)
	    ENDIF
	    DO I2 = I1+1, NELE
               IE2 = IWORK(I2)
C              IF (LNODS(IE1,MXNOD).NE.LNODS(IE2,MXNOD)) GOTO 150
	       DO K1 = 1,NEDGE
		  IF (I3D.EQ.1) THEN
		     CALL EDGEQ (IE1,IKRI1,IKRI2,IKRI3,IE2,K1,JNU)
		     IF (JNU.NE.0) THEN
		        NCZ = NCZ + 1
		        IADAKT = IADR3 + (NCZ-1)*4
                        IWORK(IADAKT) = IE1
                        IWORK(IADAKT+1) = IE2
                        IWORK(IADAKT+2) = J1
                        IWORK(IADAKT+3) = K1
		        IF (IADAKT+3 .GT. MXMEM) GOTO 900
Ctest       print *,"el ",ie1,", face",j1," fit to el ",ie2,", face",k1
		        GOTO 100
		     ENDIF
		  ELSE
	             CALL EDGEND(IE2,K1,NN,IND)
	             NEL2N1 = IND(1)
	             NEL2N2 = IND(NN)
		     IF (NEL1N1.EQ.NEL2N2 .AND. NEL1N2.EQ.NEL2N1) THEN
C------------------     generate cohesive element at the edges J1 and K1
		        NCZ = NCZ + 1
		        IADAKT = IADR3 + (NCZ-1)*4
                        IWORK(IADAKT) = IE1
                        IWORK(IADAKT+1) = IE2
                        IWORK(IADAKT+2) = J1
                        IWORK(IADAKT+3) = K1
		        IF (IADAKT+3 .GT. MXMEM) GOTO 900
		        GOTO 100
                     ENDIF
                  ENDIF
	       END DO
  150          CONTINUE
	    END DO
  100       CONTINUE
	 END DO
	 IF (REAL(I1)/100.0-REAL(I1/100) .LT. 0.001) WRITE (*,2222) I1
 2221    FORMAT ($,"processing element     1")
 2222    FORMAT ($,"",I6)
 2223    FORMAT (  "",I6)
      END DO
      WRITE (*,2223) NELE
      WRITE (IO_WRITE,*) "found ",ncz," cohesive elements in domain"
C
C---  destroy element connection and generate new nodes 
C
      IADR4 = IADR3 + (NCZ*4)
      DO I = 1,NELE
         IE = IWORK(I)
	 NODE = LNODS(IE,MXNOD)
	 DO IN = 1, NODE
            INOD = LNODS(IE,IN)
	    IAD  = IADR2 + INOD - 1
	    IF (IWORK(IAD).NE.0) THEN
C------------  generate double node for element IE at node INOD
	       NODNEW = NODNEW + 1
	       COORD(NODNEW,1) = COORD(INOD,1)
	       COORD(NODNEW,2) = COORD(INOD,2)
	       COORD(NODNEW,3) = COORD(INOD,3)
	       INCOD(NODNEW)   = NODNEW
	       LNODS(IE,IN)    = NODNEW
	       IWORK(IADR4+NODNEW-NNODE) = INOD
	    ENDIF
	    IWORK(IAD) = IWORK(IAD) + 1
	 END DO
      END DO
      WRITE (IO_WRITE,*) "generated ",nodnew-nnode,
     &                   " new nodes in domain"
C
C---  generate coh. elements in terms of node numbers
C
      DO ICZ = 1,NCZ
	 NELNEW = NELNEW + 1
	 MATSET(IMSET2,1) = MATSET(IMSET2,1) + 1
	 MATSET(IMSET2,MATSET(IMSET2,1)) = NELNEW
	 LNODS(NELNEW,MXNOD-1) = IMSET2
	 IAD  = IADR3+(ICZ-1)*4
	 IEL1 = IWORK(IAD)
	 IEL2 = IWORK(IAD+1)
	 IED1 = IWORK(IAD+2)
	 IED2 = IWORK(IAD+3)
         CALL ELEINF (IE1,NEDGE,NFACE,NFCND,NEDND,NCORN,NNDIM1)
	 IF (NFACE.GT.1) THEN
	    ITET = 1
	    IF (NCORN.EQ.4) ITET = 3
C---------  3D cz element generation
	    X1   = COORD(LNODS(IEL1,NFACE_DF(1,IED1,ITET)),1)
	    Y1   = COORD(LNODS(IEL1,NFACE_DF(1,IED1,ITET)),2)
	    Z1   = COORD(LNODS(IEL1,NFACE_DF(1,IED1,ITET)),3)
	    X2   = COORD(LNODS(IEL1,NFACE_DF(2,IED1,ITET)),1)
	    Y2   = COORD(LNODS(IEL1,NFACE_DF(2,IED1,ITET)),2)
	    Z2   = COORD(LNODS(IEL1,NFACE_DF(2,IED1,ITET)),3)
	    X3   = COORD(LNODS(IEL1,NFACE_DF(3,IED1,ITET)),1)
	    Y3   = COORD(LNODS(IEL1,NFACE_DF(3,IED1,ITET)),2)
	    Z3   = COORD(LNODS(IEL1,NFACE_DF(3,IED1,ITET)),3)
	    X21(1) = X2 - X1
	    X21(2) = Y2 - Y1
	    X21(3) = Z2 - Z1
	    X31(1) = X3 - X1
	    X31(2) = Y3 - Y1
	    X31(3) = Z3 - Z1
	    CALL CROSSP (X21,X31,Y)
	    CALL DETELM2 (IEL1,XM,YM,ZM,NCORN)
	    XM = XM - X1
	    YM = YM - Y1
	    ZM = ZM - Z1
	    RMIU = Y(1)*XM + Y(2)*YM * Y(3)*ZM
	    ELTYP(NELNEW) = "ICOHE3"
	    NCZND2 = NFCND
	    IF (NCZND2.EQ.6) NCZND2 = 8
	    LNODS(NELNEW,MXNOD) = 2*NCZND2
C---------  define element node table
	    DO I = 1,NFCND 
	       IK(I) = LNODS(IEL1,NFACE_DF(I,IED1,ITET))
	       LNODS(NELNEW,I) = IK(I)
	    END DO
	    CALL SEANOD(IWORK(IADR4+1),IEL2,IED2,NFCND,IK,ITET)
	    DO I = 1,NFCND
	       LNODS(NELNEW,I+NCZND2) = IK(I)
	    END DO
	    IF (NFCND.EQ.6) THEN
	       LNODS(NELNEW,7) = LNODS(NELNEW,6)
	       LNODS(NELNEW,6) = LNODS(NELNEW,5)
	       LNODS(NELNEW,5) = LNODS(NELNEW,4)
	       LNODS(NELNEW,4) = LNODS(NELNEW,1)
	       LNODS(NELNEW,8) = LNODS(NELNEW,1)
	       LNODS(NELNEW,NCZND2+7) = LNODS(NELNEW,NCZND2+6)
	       LNODS(NELNEW,NCZND2+6) = LNODS(NELNEW,NCZND2+5)
	       LNODS(NELNEW,NCZND2+5) = LNODS(NELNEW,NCZND2+4)
	       LNODS(NELNEW,NCZND2+4) = LNODS(NELNEW,NCZND2+1)
	       LNODS(NELNEW,NCZND2+8) = LNODS(NELNEW,NCZND2+1)
	    ENDIF
	 ELSE
C---------  2D cz element generation
	    CALL EDGEND(IEL1,IED1,NND,IND)
	    X1   = COORD(IND(1),1)
	    Y1   = COORD(IND(1),2)
	    X2   = COORD(IND(NND),1)
	    Y2   = COORD(IND(NND),2)
	    DX   = X2 - X1
	    DY   = Y2 - Y1
	    RLEN = SQRT(DX*DX + DY*DY)
	    CALL DETELM2 (IEL1,XM,YM,ZM,NCORN)
            XM = XM - X1
            YM = YM - Y1
            RMIU = YM*DX - XM*DY
	    ELTYP(NELNEW) = "ICOHE2"
	    LNODS(NELNEW,MXNOD)   = 4
	    IF (NND .EQ. 2) THEN
C---------     generating new cohesive element between 4 node elements
	       IF (RMIU .GT. 0.0) THEN
C------------     nodes from the left side
	          LNODS(NELNEW,1) = IND(2)
	          LNODS(NELNEW,2) = IND(1)
C------------     nodes from the right side 
                  CALL EDGEND(IEL2,IED2,NND,IND)
	          LNODS(NELNEW,3) = IND(1)
	          LNODS(NELNEW,4) = IND(2)
	       ELSE
C------------     nodes from the right side
	          LNODS(NELNEW,1) = IND(1)
	          LNODS(NELNEW,2) = IND(2)
C------------     nodes from the left side 
                  CALL EDGEND(IEL2,IED2,NND,IND)
	          LNODS(NELNEW,3) = IND(2)
	          LNODS(NELNEW,4) = IND(1)
	       ENDIF
	    ELSE
C---------     generating new cohesive element between 6/8 node elements
	       IF (RMIU .GT. 0.0) THEN
C------------     nodes from the left side
	          LNODS(NELNEW,1) = IND(2)
	          LNODS(NELNEW,2) = IND(1)
	          LNODS(NELNEW+1,1) = IND(3)
	          LNODS(NELNEW+1,2) = IND(2)
C------------     nodes from the right side 
                  CALL EDGEND(IEL2,IED2,NND,IND)
	          LNODS(NELNEW,3) = IND(2)
	          LNODS(NELNEW,4) = IND(3)
	          LNODS(NELNEW+1,3) = IND(1)
	          LNODS(NELNEW+1,4) = IND(2)
	       ELSE
C------------     nodes from the right side
	          LNODS(NELNEW,3) = IND(2)
	          LNODS(NELNEW,4) = IND(3)
	          LNODS(NELNEW+1,3) = IND(1)
	          LNODS(NELNEW+1,4) = IND(2)
C------------     nodes from the left side 
                  CALL EDGEND(IEL2,IED2,NND,IND)
	          LNODS(NELNEW,1) = IND(2)
	          LNODS(NELNEW,2) = IND(1)
	          LNODS(NELNEW+1,1) = IND(3)
	          LNODS(NELNEW+1,2) = IND(2)
	       ENDIF
	       NELNEW = NELNEW + 1
	       MATSET(IMSET2,1) = MATSET(IMSET2,1) + 1
	       MATSET(IMSET2,MATSET(IMSET2,1)) = NELNEW
	       ELTYP(NELNEW) = "ICOHE2"
	       LNODS(NELNEW,MXNOD)   = 4
	       LNODS(NELNEW,MXNOD-1) = IMSET2
	    ENDIF
	 ENDIF
      END DO
C
      WRITE (IO_WRITE,*) nelnew-nelem," cz elements in elgroup ",
     &                   imset2,"defined"
C
      NELEM = NELNEW
      NNODE = NODNEW
C
C
      RETURN
C
  900 CONTINUE
      WRITE (6,*) "MEMORY EXCEEDED. PLEASE INCREASE MXMEM"
      RETURN
C
      END
C
C
C
C
C
C
C
C
C
      SUBROUTINE EDGEND (IEL,IEDGE,NND,INODE)
C
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION INODE(3)
C
C
      ND    = LNODS(IEL,MXNOD)
      NEDGE = ND
      NND   = 2
      IF(ND.GT.4) THEN
	 NEDGE  = ND/2
	 NND = 3
      ENDIF
      INODE(1) = LNODS(IEL,IEDGE)
C
      IEDG2 = IEDGE + 1
      IF (IEDGE.EQ.NEDGE) IEDG2 = 1
      IF (ND.GT.4) THEN
	 INODE(2) = LNODS(IEL,IEDGE+NEDGE)
	 INODE(3) = LNODS(IEL,IEDG2)
      ELSE
	 INODE(2) = LNODS(IEL,IEDG2)
      ENDIF
C
C
      RETURN
C
      END
C
C
C
C
C
C
C
      SUBROUTINE EDGEQ(IE1,IKRI1A,IKRI2A,IKRI3A,IE2,K1,JNU)
C
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
C
      NN = LNODS(IE1,MXNOD)
      JNU = 0
      IF (NN.EQ.4 .OR. NN.EQ.10) THEN
	 IKA = LNODS(IE2,NFACE_DF(1,K1,3))
	 IKB = LNODS(IE2,NFACE_DF(2,K1,3))
	 IKC = LNODS(IE2,NFACE_DF(3,K1,3))
	 IKRI1B = MIN(IKA,IKB,IKC)
	 IKRI2B = MAX(IKA,IKB,IKC)
	 IKRI3B = IKA+IKB+IKC
	IF (IKRI1A.EQ.IKRI1B .AND.  
     1      IKRI2A.EQ.IKRI2B .AND.
     2      IKRI3A.EQ.IKRI3B      ) JNU = 1
      ELSE
         IK1 = LNODS(IE1,NFACE_DF(1,IKRI1A,1) )
         IK2 = LNODS(IE1,NFACE_DF(2,IKRI1A,1) )
         IK3 = LNODS(IE1,NFACE_DF(3,IKRI1A,1) )
         IK4 = LNODS(IE1,NFACE_DF(4,IKRI1A,1) )
         IKA = LNODS(IE2,NFACE_DF(1,K1,1) )
         IKB = LNODS(IE2,NFACE_DF(3,K1,1) )
	 IF (IK1.EQ.IKA .AND. IK3.EQ.IKB .OR. 
     1       IK3.EQ.IKA .AND. IK1.EQ.IKB .OR. 
     2       IK2.EQ.IKA .AND. IK4.EQ.IKB .OR. 
     3       IK4.EQ.IKA .AND. IK2.EQ.IKB) JNU = 1
      ENDIF
      RETURN
      END
C
C
C
C
C
C
      SUBROUTINE SEANOD(INDTAB,IEL2,IED2,NFCND,IK,ITET)
C---  search corresponding node to node ik(i) in element iel2,edge ied2
C---  and store the node in ik(i)
C
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION INDTAB(*),IK(NFCND)
C
      DO I = 1,NFCND
	 IKAKT = IK(I)
	 IF (IK(I).GT.NNODE) IKAKT = INDTAB(IK(I)-NNODE)
	 DO J = 1,NFCND
	    IN = LNODS(IEL2,NFACE_DF(J,IED2,ITET))
	    IF (IN.GT.NNODE) IN = INDTAB(IN-NNODE)
	    IF (IN .EQ. IKAKT) THEN
	       IK(I) = LNODS(IEL2,NFACE_DF(J,IED2,ITET))
	       GOTO 100
	    ENDIF
	 END DO
	 print *,"El.",iel2," node",in,"not conn. to ",(ik(j),j=1,nfcnd)
 100     CONTINUE
      END DO
      RETURN
      END
