C
      SUBROUTINE CZDS2(ITYP3D,IMSET1,IMSET2,ICONOD)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCc
C                                                           C
C KOHSIVELEMENT ABAQUS (2D: 4 KNOTEN, 3D: 6 oder 8 Knoten) C
C     (auch am Rand - Linie so definieren da der Rand      C
C      rechts liegt!  Knotenlinie 4-3 ist Randlinie)        C
C                                                           C
C     2-----1    Liniendefinition                           C
C     |     |    --------------------------->               C
C     4-----3                                               C
C                                                           C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCc
C
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      PARAMETER (MXCZM = 5000)
      DIMENSION RLMBND(MXCZM),ICZMND(MXCZM)
      DIMENSION IND(9),INDND(9),IELFC3(4),IELFC4(6),ICZ3ND(3,4)
C
      DATA IELFC4 / 4321, 8765, 6521, 7632, 8743, 8541 /
      DATA IELFC3 / 321, 421, 432, 431 /
      DATA ICZ3ND / 1,2,3 , 1,2,4 , 1,3,4 , 2,3,4 /
C
C
      EPSTOL = 1.E-5
C---  PARAMETER INPUT
C
      IF(ITYP3D.EQ.0) THEN
C------  2D
         CALL GETLINE (LEN,IERR)
         DO I = 1,4
            ITYPE(I) = 2
         END DO
         INVAR = 4
         CALL SLVLINE (STRING,LEN,IERR)
         X1 = RVARR(1)
         Y1 = RVARR(2)
	 Z1 = 0.0
         X2 = RVARR(3)
         Y2 = RVARR(4)
	 Z2 = 0.0
         DX = X2 - X1
         DY = Y2 - Y1
	 DZ = 0.0
         RLEND2 = DX*DX+DY*DY
         RLENDX = SQRT(RLEND2)
         HX = -DY / RLENDX
         HY =  DX / RLENDX
         HZ =  0.0
      ELSEIF(ITYP3D.EQ.1) THEN
C------  3D
C        first line: crack tip position
         CALL GETLINE (LEN,IERR)
         DO I = 1,3
            ITYPE(I) = 2
         END DO
         INVAR = 3
         CALL SLVLINE (STRING,LEN,IERR)
         X1 = RVARR(1)
         Y1 = RVARR(2)
         Z1 = RVARR(3)
C        second line: crack prop direction, crack surface normal
         CALL GETLINE (LEN,IERR)
         DO I = 4,6
            ITYPE(I) = 2
         END DO
         INVAR = 6
         CALL SLVLINE (STRING,LEN,IERR)
         DX = RVARR(1)
         DY = RVARR(2)
         DZ = RVARR(3)
         HX = RVARR(4)
         HY = RVARR(5)
         HZ = RVARR(6)
         RLEND2 = DX*DX+DY*DY+DZ*DZ
         RLENDX = SQRT(RLEND2)
      ENDIF
Ctest print *,"Die Vektoren sind G=",dx,"/",dy,"; H=",hx,"/",hy
C
 10   CONTINUE
      IF (IMSET1.EQ.0) THEN
         NUMEL1 = 1
         NUMEL2 = NELEM
         IE     = 1
      ELSE
         NUMEL1 = 2
         NUMEL2 = MATSET(IMSET1,1)
         IE     = MATSET(IMSET1,2)
      END IF
C
C---  determining nodes at the cohesive line
C
      NCZMND = 0
C---  For all nodes do...
      DO INODE = 1, NNODE
	 IF (INCOD(INODE).NE.INODE) GOTO 90
	 RX = COORD(INODE,1) - X1
	 RY = COORD(INODE,2) - Y1
	 RZ = COORD(INODE,3) - Z1
	 RMIU = HX*RX + HY*RY + HZ*RZ
	 IF  (ABS(RMIU).LT.EPSTOL) THEN
	    RLAMB = (RX*DX + RY*DY + RZ*DZ)/RLEND2
	    IF (RLAMB.GT.0.0-EPSTOL .AND. RLAMB.LT. 1.0+EPSTOL) THEN
	       NCZMND = NCZMND + 1
	       ICZMND(NCZMND) = INODE
	       RLMBND(NCZMND) = RLAMB
Ctest          write (IO_JNL,*) inode," liegt auf der Linie mit lambda=",rlamb
	    ENDIF
	 ENDIF
  90     CONTINUE
      END DO
      print *,"found",nczmnd," nodes during processing of czds"
      IF (NCZMND .EQ. 0) GOTO 980
      IF (NCZMND .GT. MXCZM) GOTO 970
C
      IF (MATSET(IMSET2,1).LE.1) MATSET(IMSET2,1) = 1
      NELRIG = 0
      NELLEF = 0
      IELK   = 0
      NODNEW = NNODE
      NELNEW = NELEM
C
C---  initializing the iwork array for element and node storing
      IARLEN = NUMEL2 - NUMEL1 + 1
      IADR2 = IARLEN*2
      IADR3 = IADR2 + IARLEN*2
      IADR4 = IADR3 + IARLEN
      IAMAX = IADR4 + NNODE
      IF (IAMAX .GT. MXMEM) GOTO 996
      DO I = 1,IAMAX
	 IWORK(I) = 0.0
      END DO
C
C---  searching for elements containing a cohesive edge
      DO I = NUMEL1, NUMEL2
	 IF (IMSET1.EQ.0) THEN
	    IEL = I
	    IF (ELTYP(IEL)(1:2).EQ."IC") GOTO 200
	 ELSE
	    IEL = MATSET(IMSET1,I)
         ENDIF
	 IF (IEL.EQ.0) GOTO 200
	 NND = LNODS(IEL,MXNOD)
         CALL ELEINF (IEL,NEDGE,NFACE,NFCND,NEDND,NCORN,NNDIM1)
	 IN = 0
	 IFAC = 0
	 DO J = 1, NND
	    IAKT = LNODS(IEL,J)
	    DO K = 1,NCZMND
	       IF (IAKT.EQ.ICZMND(K)) THEN
		  IFAC = IFAC + J*10**IN
	          IN = IN + 1
	          IND(IN)   = J
	          INDND(IN) = K
	       ENDIF
	    END DO
	 END DO
	 if (in.gt.0) write (IO_JNL,2222) IEL,IN
 2222 FORMAT ('ELEMENT',I5,' BESITZT',I2,' KNOTEN AM INTERFACE')
	 IF (IN.GT.NNDIM1) GOTO 999
C
	 IF (IN.EQ.NNDIM1) THEN
C--------   Element hat eine Kante an der CZ
            CALL DETELM2 (IEL,XM,YM,ZM,NCORN)
            RMIU = ((XM-X1)*HX + (YM-Y1)*HY + (ZM-Z1)*HZ)
	    IF (RMIU .GT. 0.0) THEN
C-----------   Element an der linken Seite
	       NELLEF = NELLEF + 1
	       IF (ITYP3D.EQ.1) THEN
		  IF (NFACE.EQ.4) THEN
		  DO J = 1,NFACE
		     IF (IFAC.EQ.IELFC3(J)) GOTO 210
		  END DO
		  ELSE
		  DO J = 1,NFACE
		     IF (IFAC.EQ.IELFC4(J)) GOTO 210
		  END DO
		  ENDIF
		  print *,"edge",ifac," not found"
  210             CONTINUE
		  IAD = (NELLEF-1) * 4
		  IWORK(IAD+1) = IEL
		  IWORK(IAD+2) = J
Ctest             print *,"coh. edge:",J," of left el.",IEL 
               ELSE
	          IF (IND(1).EQ.1 .AND. IND(2).EQ.NCORN) THEN
Ctest                print *,"coh. edge:",NCORN," of left el.",IEL
	             IWORK(NELLEF) = IEL*10 + NCORN
	          ELSE
	             IWORK(NELLEF) = IEL*10 + IND(1)
Ctest                print *,"coh. edge:",IND(1)," of left el.",IEL
	          ENDIF
	          RWORK(NELLEF) = MIN(RLMBND(INDND(1)),RLMBND(INDND(2)))
	       ENDIF
	    ELSE
C--------      Element an der rechten Seite
	       NELRIG = NELRIG + 1
	       IF (ITYP3D.EQ.1) THEN
		  IF (NFACE.EQ.4) THEN
		  DO J = 1,NFACE
		     IF (IFAC.EQ.IELFC3(J)) GOTO 220
		  END DO
		  ELSE
		  DO J = 1,NFACE
		     IF (IFAC.EQ.IELFC4(J)) GOTO 220
		  END DO
		  ENDIF
		  print *,"edge",ifac," not found"
  220             CONTINUE
		  IAD = (NELRIG-1)*4 + 2
		  IWORK(IAD+1) = IEL
		  IWORK(IAD+2) = J
Ctest             print *,"coh. edge:",J," of right el.",IEL
	       ELSE
	          IF (IND(1).EQ.1 .AND. IND(2).EQ.NEDGE) THEN
Ctest                print *,"coh. edge:",NEDGE," of right el.",IEL
	             IWORK(IADR2+NELRIG) = IEL*10 + NEDGE
	          ELSE
Ctest                print *,"coh. edge:",ind(1)," of right el.",IEL
	             IWORK(IADR2+NELRIG) = IEL*10 + IND(1)
	          ENDIF
	          RWORK(IADR2+NELRIG) = 
     1                  MIN(RLMBND(INDND(1)),RLMBND(INDND(2)))
	       ENDIF
	    ENDIF
	 ELSEIF (IN.GT.0) THEN
C--------   Element on the right side and has one node at CZ
            CALL DETELM2 (IEL,XM,YM,ZM,NCORN)
            RMIU = ((XM-X1)*HX + (YM-Y1)*HY + (ZM-Z1)*HZ)
Ctest       print *,"element",iel," has nodes",(iczmnd(indnd(k)),k=1,in)
Ctest1             ,"at the CZ"
            IF (RMIU.LT.0.0) THEN
Ctest          print *,"     (right)"
	       IELK = IELK + 1
	       IWORK(IADR3+IELK) = IEL
            ENDIF
         ENDIF
 200     CONTINUE
      END DO
      print *,"found",nelrig," elements (right) and",nellef," (left)"
      IF (NELRIG .NE. NELLEF) THEN
	 IF     (NELRIG .EQ. 0 .OR. NELLEF.EQ.0) THEN
	    GOTO 991
	 ELSE
	    GOTO 992
	 ENDIF
      ENDIF
C---  sorting 3d-elements with a coh. edge acc. to node numbers
      IF (ITYP3D .EQ. 1) THEN
	 DO I = 1, NELLEF
	    IEL1 = IWORK((I-1)*4+1)
	    IFC1 = IWORK((I-1)*4+2)
            CALL ELEINF (IEL1,NEDGE,NFACE1,NFCND,NEDND,NCORN,NNDIM1)
	    DO J = 1, NELRIG
	       IEL2 = IWORK((J-1)*4+3)
	       IFC2 = IWORK((J  )*4  )
               CALL ELEINF (IEL2,NEDGE,NFACE2,NFCND,NEDND,NCORN,NNDIM1)
	       IF (NFACE1 .NE. NFACE2) GOTO 305
	       INO = 0
	       ITET = 1
	       IF (NFACE2.EQ.4) ITET = 3
	       DO K1 = 1, NFCND
		  KN1 = NFACE_DF(K1,IFC1,ITET)
	          DO K2 = 1, NFCND
		     KN2 = NFACE_DF(K2,IFC2,ITET)
		     IF (LNODS(IEL1,KN1).EQ.LNODS(IEL2,KN2)) GOTO 300
		  END DO
		  GOTO 305
  300             CONTINUE
		  INO = INO + 1
	       END DO
	       IF (INO.EQ.NFCND) GOTO 310
  305          CONTINUE
	    END DO
C---------- did not find any corresponding element face...
            print *,"element",iel1," has no corresponding el"
  310       CONTINUE
Ctest       print *,"generating cze from ",iel1," and ",iel2
	    IF (ICONOD.EQ.8) THEN
               NELNEW = NELNEW + 1
               MATSET(IMSET2,1) = MATSET(IMSET2,1) + 1
               MATSET(IMSET2,MATSET(IMSET2,1)) = NELNEW
	       ELTYP(NELNEW) = "ICOHE3" 
               LNODS(NELNEW,MXNOD) = 8
               LNODS(NELNEW,MXNOD-1) = IMSET2
	       DO J = 1, 4
C------------     1 quadrilateral CZE (8nodes)
	          INO = LNODS(IEL2,NFACE_DF(J,IFC2,1))
                  LNODS(NELNEW,J+4) = INO
	          IF (IWORK(IADR4+INO).EQ.0) THEN
	             NODNEW = NODNEW + 1
	             IWORK(IADR4+INO) = NODNEW
	             COORD(NODNEW,1) = COORD(INO,1)
	             COORD(NODNEW,2) = COORD(INO,2)
	             COORD(NODNEW,3) = COORD(INO,3)
	             INCOD(NODNEW)   = NODNEW
Ctest  	             print *,"node",ino," is now",nodnew
	          ENDIF
                  LNODS(NELNEW,J) = IWORK(IADR4+INO)
	       END DO
	    ELSEIF (ICONOD.EQ.6 .AND. NFACE2.EQ.4) THEN
C------------  1 triangular CZE (6nodes)
               NELNEW = NELNEW + 1
               MATSET(IMSET2,1) = MATSET(IMSET2,1) + 1
               MATSET(IMSET2,MATSET(IMSET2,1)) = NELNEW
	       ELTYP(NELNEW) = "ICOHE3" 
               LNODS(NELNEW,MXNOD) = 6
               LNODS(NELNEW,MXNOD-1) = IMSET2
	       DO J = 1, 3
	          INO = LNODS(IEL2,NFACE_DF(J,IFC2,3))
                  LNODS(NELNEW,J+3) = INO
	          IF (IWORK(IADR4+INO).EQ.0) THEN
	             NODNEW = NODNEW + 1
	             IWORK(IADR4+INO) = NODNEW
	             COORD(NODNEW,1) = COORD(INO,1)
	             COORD(NODNEW,2) = COORD(INO,2)
	             COORD(NODNEW,3) = COORD(INO,3)
	             INCOD(NODNEW)   = NODNEW
Ctest  	             print *,"node",ino," is now",nodnew
	          ENDIF
                  LNODS(NELNEW,J) = IWORK(IADR4+INO)
	       END DO
	    ELSE
C------------  4 triangular CZE's (6nodes)
	       DO IC = 1,4
	          NELNEW = NELNEW + 1
                  MATSET(IMSET2,1) = MATSET(IMSET2,1) + 1
                  MATSET(IMSET2,MATSET(IMSET2,1)) = NELNEW
	          ELTYP(NELNEW) = "ICOHE3" 
                  LNODS(NELNEW,MXNOD) = 6
                  LNODS(NELNEW,MXNOD-1) = IMSET2
		  DO J = 1, 3
	             INO = LNODS(IEL2,NFACE_DF(ICZ3ND(J,IC),IFC2,1))
                     LNODS(NELNEW,J+3) = INO
	             IF (IWORK(IADR4+INO).EQ.0) THEN
	                NODNEW = NODNEW + 1
	                IWORK(IADR4+INO) = NODNEW
	                COORD(NODNEW,1) = COORD(INO,1)
	                COORD(NODNEW,2) = COORD(INO,2)
	                COORD(NODNEW,3) = COORD(INO,3)
	                INCOD(NODNEW)   = NODNEW
Ctest  	                print *,"node",ino," is now",nodnew
	             ENDIF
                     LNODS(NELNEW,J) = IWORK(IADR4+INO)
	          END DO
	       END DO
	    ENDIF
C---------  modify the nodes of left element
	    DO J = 1, 4
	       INO = LNODS(IEL1,NFACE_DF(J,IFC1,ITET))
	       IW = IWORK(IADR4+INO)
	       IF (IW.NE.0) LNODS(IEL1,NFACE_DF(J,IFC1,ITET)) = IW
	    END DO
	 END DO
      ELSE
C------- in twodimensional case acc. to min. lambda
         CALL BBSORT (RWORK,IWORK,NELLEF)
         CALL BBSORT (RWORK(IADR2+1),IWORK(IADR2+1),NELRIG)
C------  generating the CE from right and left edges of solid elements
         DO I = 1,NELLEF
            NELNEW = NELNEW + 1
            MATSET(IMSET2,1) = MATSET(IMSET2,1) + 1
            MATSET(IMSET2,MATSET(IMSET2,1)) = NELNEW
            LNODS(NELNEW,MXNOD) = 4
            LNODS(NELNEW,MXNOD-1) = IMSET2
	    ELTYP(NELNEW) = "ICOHE2" 
	    IELLEF = IWORK(I)/10
	    IEDGLF = IWORK(I) - IELLEF*10
	    IF (NELRIG .NE. 0) THEN
	       IELRIG = IWORK(IADR2+I)/10
	       IEDGRG = IWORK(IADR2+I) - IELRIG*10
	    ENDIF
	    IF (LNODS(IELLEF,MXNOD).GT.4) THEN
C---------     quadratische Elemente bekommen 2 Kohsivzonenelemente
	       IF (IEDGLF.EQ.NEDGE) THEN
	          INDND(1) = 1
	          INDND(2) = NEDGE*2
	       ELSE
	          INDND(1) = IEDGLF + 1
	          INDND(2) = IEDGLF + NEDGE
	       ENDIF
	       IF (IEDGRG.EQ.NEDGE) THEN
	          INDND(3) = NEDGE
	          INDND(4) = NEDGE*2
	       ELSE
	          INDND(3) = IEDGRG
	          INDND(4) = IEDGRG + NEDGE
	       ENDIF
	       DO J = 1,2
	          NODLEF = LNODS(IELLEF,INDND(J  ))
	          IF (NELRIG .EQ. 0) THEN
		     NODRIG = NODLEF
	          ELSE
		     NODRIG = LNODS(IELRIG,INDND(J+2))
	          ENDIF
	          LNODS(NELNEW,J  ) = NODLEF
	          LNODS(NELNEW,J+2) = NODRIG
	          IF (NODLEF .EQ. NODRIG) THEN
                     IF (IWORK(IADR4+NODRIG).EQ.0) THEN
	                NODNEW = NODNEW + 1
	                IWORK(IADR4+NODRIG) = NODNEW
	                COORD(NODNEW,1) = COORD(NODRIG,1)
	                COORD(NODNEW,2) = COORD(NODRIG,2)
	                COORD(NODNEW,3) = COORD(NODRIG,3)
	                INCOD(NODNEW)   = NODNEW
Ctest  	                print *,"node",NODRIG," is now",nodnew
	             ENDIF
C---------------     and change elemnt conectivity card for CZ element 
                     LNODS(NELNEW,J+2) = IWORK(IADR4+NODRIG)
C---------------     and for solid element
		     IF (NELRIG .NE. 0) 
     1                  LNODS(IELRIG,INDND(J+2)) = IWORK(IADR4+NODRIG)
	          ENDIF
	       END DO
Ctest          print *,"CE",nelnew," consists of",(lnods(nelnew,kk),kk=1,4)
                  NELNEW = NELNEW + 1
               MATSET(IMSET2,1) = MATSET(IMSET2,1) + 1
               MATSET(IMSET2,MATSET(IMSET2,1)) = NELNEW
               LNODS(NELNEW,MXNOD) = 4
               LNODS(NELNEW,MXNOD-1) = IMSET2
	       ELTYP(NELNEW) = "ICOHE2" 
	       IF (IEDGLF.EQ.NEDGE) THEN
	          INDND(1) = NEDGE*2
	          INDND(2) = 1
	       ELSE
	          INDND(1) = IEDGLF + NEDGE
	          INDND(2) = IEDGLF
	       ENDIF
	       IF (IEDGRG.EQ.NEDGE) THEN
	          INDND(3) = NEDGE*2
	          INDND(4) = 1
	       ELSE
	          INDND(3) = IEDGRG + NEDGE
	          INDND(4) = IEDGRG + 1
	       ENDIF
	       DO J = 1,2
	          NODLEF = LNODS(IELLEF,INDND(J  ))
	          IF (NELRIG .EQ. 0) THEN
		     NODRIG = NODLEF
	          ELSE
		     NODRIG = LNODS(IELRIG,INDND(J+2))
	          ENDIF
	          LNODS(NELNEW,J  ) = NODLEF
	          LNODS(NELNEW,J+2) = NODRIG
	          IF (NODLEF .EQ. NODRIG) THEN
                     IF (IWORK(IADR4+NODRIG).EQ.0) THEN
	                NODNEW = NODNEW + 1
	                IWORK(IADR4+NODRIG) = NODNEW
	                COORD(NODNEW,1) = COORD(NODRIG,1)
	                COORD(NODNEW,2) = COORD(NODRIG,2)
	                COORD(NODNEW,3) = COORD(NODRIG,3)
	                INCOD(NODNEW)   = NODNEW
Ctest  	                print *,"node",NODRIG," is now",nodnew
	             ENDIF
C---------------     and change elemnt conectivity card for CZ element 
                     LNODS(NELNEW,J+2) = IWORK(IADR4+NODRIG)
C---------------     and for solid element
		     IF (NELRIG .NE. 0) 
     1                  LNODS(IELRIG,INDND(J+2)) = IWORK(IADR4+NODRIG)
	          ENDIF
	       END DO
Ctest       print *,"CE",nelnew," consists of",(lnods(nelnew,kk),kk=1,4)
            ELSE
	       IF (IEDGLF.EQ.NEDGE) THEN
	          INDND(1) = 1
	          INDND(2) = NEDGE
	       ELSE
	          INDND(1) = IEDGLF + 1
	          INDND(2) = IEDGLF
	       ENDIF
	       IF (IEDGRG.EQ.NEDGE) THEN
	          INDND(3) = NEDGE
	          INDND(4) = 1
	       ELSE
	          INDND(3) = IEDGRG
	          INDND(4) = IEDGRG + 1
	       ENDIF
	       DO J = 1,2
	          NODLEF = LNODS(IELLEF,INDND(J  ))
	          IF (NELRIG .EQ. 0) THEN
		     NODRIG = NODLEF
	          ELSE
		     NODRIG = LNODS(IELRIG,INDND(J+2))
	          ENDIF
	          LNODS(NELNEW,J  ) = NODLEF
	          LNODS(NELNEW,J+2) = NODRIG
	          IF (NODLEF .EQ. NODRIG) THEN
                     IF (IWORK(IADR4+NODRIG).EQ.0) THEN
	                NODNEW = NODNEW + 1
	                IWORK(IADR4+NODRIG) = NODNEW
	                COORD(NODNEW,1) = COORD(NODRIG,1)
	                COORD(NODNEW,2) = COORD(NODRIG,2)
	                COORD(NODNEW,3) = COORD(NODRIG,3)
	                INCOD(NODNEW)   = NODNEW
Ctest  	                print *,"node",NODRIG," is now",nodnew
	             ENDIF
C---------------     and change elemnt conectivity card for CZ element 
                     LNODS(NELNEW,J+2) = IWORK(IADR4+NODRIG)
C---------------     and for solid element
		     IF (NELRIG .NE. 0) 
     1                  LNODS(IELRIG,INDND(J+2)) = IWORK(IADR4+NODRIG)
	          ENDIF
	       END DO
Ctest       print *,"CE",nelnew," consists of",(lnods(nelnew,kk),kk=1,4)
	    ENDIF
         END DO
C
C------  modify elements on the right side of the CZ, which have nodes
C------  to be modified
         IF (NODNEW.GT.NNODE) THEN
	    DO I = 1,IELK
	       DO J = 1,NND
	          IE = IWORK(IADR3+I)
	          IF (IWORK(IADR4+LNODS(IE,J)).NE.0) THEN
		     LNODS(IE,J) = IWORK(IADR4+LNODS(IE,J))
	          ENDIF
               END DO
            END DO
         ENDIF
      ENDIF
C
C
      NNODE = NODNEW
      NELEM = NELNEW
C
      RETURN
C
 970  CONTINUE
      print *,'Anzahl Kohsivknoten ist grer als MXCZM(',mxczm,
     1        ') in Routine MCZDS2'
      RETURN
C
 980  CONTINUE
      print *,"keine Kohsivknoten auf der angegebenen Linie!"
      RETURN
C
 991  CONTINUE
      print *,"Auf einer Seite 0 Elemente."
      print *,"Bitte fuer 3D-Faelle *COHESIV3 verwenden"
 992  CONTINUE
      print *,"Auf der rechten Seite",nelrig," Elemente,"
      print *,"auf der linken Seite",nellef," Elemente an der CZ!"
      print *,"Abbruch."
      RETURN
 996  CONTINUE
      print *,"memory exceeded. Increase mxmem to",iamax
      RETURN
 999  CONTINUE
      print *,"element",iel," has",in," cohesive nodes, ",
     1        "but only",nndim1," are allowed"
      RETURN
      END
