C
      SUBROUTINE CZDS3(IMSET1,IMSET2)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                           C
C ZWEISEITIGES KOHAESIVELEMENT ABAQUS 2D/3D                 C
C TYP: VERBUNDENE ELEMENTSETS                               C 
C                                                           C 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC 
C
      IMPLICIT REAL*8 (A-H,O-Z)
      INCLUDE 'common'
      DIMENSION IELFC3(4),IELFC4(6),IGROUP(20),
     1          IND(4),INND(MXNOD),IFAC(6)
C
      DATA IELFC4 / 4321, 8765, 6521, 7632, 8743, 8541 /
      DATA IELFC3 / 321, 421, 432, 431 /
C
      EPSTOL = 1.E-5
C
C---  PARAMETER INPUT
C
C---  subsequent lines:
      IOPTIO = 2
      IMSET1 = 0
      CALL GETLINE (LEN,IERR)
      ITYPE(1) = 1
      INVAR = 1
      CALL SLVLINE(STRING,LEN,IERR)
      INUM = IVARR(1)
      CALL GETLINE (LEN,IERR)
      DO I = 1,INUM
         ITYPE(I) = 1
      END DO
      INVAR = INUM
      CALL SLVLINE(STRING,LEN,IERR)
      DO I = 1,INUM
         IGROUP(I) = IVARR(I)
      END DO
C
      INOT = 0
      NELCZ  = 0
      NODNEW = NNODE
      NELNEW = NELEM
C---  initializing the iwork array for element and node storing
C---  from 1 to iadr1: node index for comparison
C---  from iadr1+1 to iadr3: index table for new generated nodes
C---  from iadr3+1 to iadr4: cont.-el. with coh.surf's(el.+el-faces)
C---  from iadr4+1 to iamax: left elements with single coh. nodes
      IADR1 = NNODE*2
      IADR3 = IADR1 + NNODE
      IADR4 = IADR3 + NELEM
      DO I = IADR3+1,IAMAX
         IWORK(I) = 0
      END DO
C
C---  compare each elset with all following
      DO ISET = 1, INUM-1
	 IGAKT = IGROUP(ISET)
         NELLEF = 0
         IELK   = 0
C
         DO I = 1,IADR3
            IWORK(I) = 0
         END DO
C
C------  determine all nodes of following elsets
C
         DO INEXT = ISET+1,INUM
	    DO I = 2,MATSET(IGROUP(INEXT),1)
	       IE = MATSET(IGROUP(INEXT),I)
	       DO J = 1,LNODS(IE,MXNOD)
	          INOD = LNODS(IE,J)
	          IWORK(INOD) = -1
	       END DO
	    END DO
         END DO
C
C---  searching for elements of elgroup IGAKT containing a cohesive edge
C
         DO I = 2, MATSET(IGAKT,1)
            IEL = MATSET(IGAKT,I)
            NND = LNODS(IEL,MXNOD)
            CALL ELEINF (IEL,NEDGE,NFACE,NFCND,NEDND,NCORN,NNDIM1)
CC
            IN = 0
	    DO J = 1, NND
	       INND(J) = 0
	    END DO
            DO J = 1, NND
               IAKT = LNODS(IEL,J)
	       IF (IWORK(IAKT).NE.0) THEN
                  IN = IN + 1
		  INND(J) = IAKT
		  IWORK(IAKT) = IAKT
               ENDIF
            END DO
C
            IF (IN.GE.NNDIM1) THEN
C-----------   element has one or more cohesive edges
C-----------   element at positive side
               IF (NFACE.EQ.4) THEN
	          ITYP = 3
	          NCOMPA = NFACE
		  IFCED = 3
               ELSEIF (NFACE.EQ.3) THEN
                  ITYP = 1
	          NCOMPA = NFACE
	          IFCED = 4
               ELSEIF (NFACE.EQ.1) THEN
                  ITYP = 6
                  IF (NEDGE.EQ.4) ITYP = 5
	          NCOMPA = NEDGE
	          IFCED = 2
               ENDIF
	       NF = 0
	       DO JF = 1,NCOMPA
		  DO J = 1, IFCED
                     IF (INND(NFACE_DF(J,JF,ITYP)).EQ.0) GOTO 210
		  END DO
                  NELLEF = NELLEF + 1
                  IAD = IADR4 + (NELLEF+NELCZ-1) * 5
		  IF (IAD.GT.MXMEM) GOTO 996
                  IWORK(IAD+1) = IEL
                  IWORK(IAD+2) = JF
Ctest             print *,"coh. edge:",JF,"of pos. el.",IEL,",set",IGAKT
  210             CONTINUE
	       END DO
CC
CC
            ELSEIF (IN.GT.0) THEN
C-----------   Element on the positive side and has one node at CZ
               IELK = IELK + 1
               IWORK(IADR3+IELK) = IEL
            ENDIF
         END DO
C------  end of element loop for elgroup IGAKT
         write (IO_WRITE,*) "found",nellef," faces between elset",
     1                      igakt," and others"
C
C------  searching for el's of following groups containing cohesive edge
C
         DO INEXT = ISET+1,INUM
            IGNXT = IGROUP(INEXT)
            DO I = 2, MATSET(IGNXT,1)
               IEL = MATSET(IGNXT,I)
               NND = LNODS(IEL,MXNOD)
               CALL ELEINF (IEL,NEDGE,NFACE,NFCND,NEDND,NCORN,NNDIM1)
               IN = 0
	       DO J = 1, NND
		  INND(J) = 0
	       END DO
               DO J = 1, NND
                  IAKT = LNODS(IEL,J)
		  IF (IWORK(IAKT).EQ.IAKT) THEN
                     IN = IN + 1
		     INND(J) = IAKT
                  ENDIF
               END DO
C
               IF (IN.GE.NNDIM1) THEN
C--------------   element has one or more cohesive edges
                  IF (NFACE.EQ.4) THEN
	             ITYP = 3
	             NCOMPA = NFACE
		     IFCED = 3
                  ELSEIF (NFACE.EQ.3) THEN
                     ITYP = 1
	             NCOMPA = NFACE
	             IFCED = 4
                  ELSEIF (NFACE.EQ.1) THEN
                     ITYP = 6
                     IF (NEDGE.EQ.4) ITYP = 5
	             NCOMPA = NEDGE
	             IFCED = 2
                  ENDIF
		  NF = 0
		  DO JF = 1,NCOMPA
		     DO J = 1, IFCED
			IF (INND(NFACE_DF(J,JF,ITYP)).EQ.0) GOTO 220
		     END DO
		     NF = NF + 1
		     IFAC(NF) = JF
  220                CONTINUE
		  END DO
C
C---------------  find corresponding el-face,cut faces and generate nods
		  DO IF = 1,NF
	            DO J = NELCZ+1, NELCZ+NELLEF
                      IEL1 = IWORK(IADR4 + (J-1)*5+1)
                      IFC1 = IWORK(IADR4 + (J-1)*5+2)
                      CALL ELEINF
     1                     (IEL1,NEDGE,NFACE1,NFCND,NEDND,NCORN,NNDIM1)
                      IF (NFACE1 .NE. NFACE) GOTO 230
                      KN1 = LNODS(IEL1,NFACE_DF(1,IFC1,ITYP))
                      DO K2 = 1, IFCED
                        KN2 = LNODS(IEL,NFACE_DF(K2,IFAC(IF),ITYP))
                        IF (IWORK(KN1).EQ.IWORK(KN2)) THEN
			   IND(1) = KN1
			   IF (KN1.EQ.KN2) THEN
			      IF (IWORK(IADR1+KN1).LT.NNODE) THEN
				 NODNEW = NODNEW  + 1
                                 COORD(NODNEW,1) = COORD(KN1,1)
                                 COORD(NODNEW,2) = COORD(KN1,2)
                                 COORD(NODNEW,3) = COORD(KN1,3)
                                 INCOD(NODNEW)   = NODNEW
				 IWORK(IADR1+KN1) = NODNEW
				 IWORK(NODNEW)    = KN1
			      ENDIF
			      IND(1) = IWORK(IADR1+KN1)
			   ENDIF
			   DO K1B = 2,IFCED
		              K2B = MOD(K2-K1B+IFCED,IFCED)+1
                              KN1B = LNODS(IEL1,NFACE_DF(K1B,IFC1,ITYP))
                              KN2B = 
     1                            LNODS(IEL,NFACE_DF(K2B,IFAC(IF),ITYP))
		              IF (IWORK(KN1B).NE.IWORK(KN2B)) GOTO 230 
			      IND(K1B) = KN1B
			      IF (KN1B.EQ.KN2B) THEN
			 	 IF (IWORK(IADR1+KN1B).LT.NNODE) THEN
				    NODNEW = NODNEW  + 1
                                    COORD(NODNEW,1) = COORD(KN1B,1)
                                    COORD(NODNEW,2) = COORD(KN1B,2)
                                    COORD(NODNEW,3) = COORD(KN1B,3)
                                    INCOD(NODNEW)   = NODNEW
				    IWORK(IADR1+KN1B) = NODNEW
				    IWORK(NODNEW)    = KN1B
				 ENDIF
			         IND(K1B) = IWORK(IADR1+KN1B)
			      ENDIF
		           END DO
                           IAD = IADR4 + (J-1)*5
                           IWORK(IAD+3) = IEL
                           IWORK(IAD+4) = IFAC(IF)
                           IWORK(IAD+5) = K2
			   DO K = 1,IFCED
			      LNODS(IEL1,NFACE_DF(K,IFC1,ITYP)) = IND(K)
			   END DO
Ctest   		   print *,"coh. face1:",(ind(k),k=1,ifced)
Ctest   		   print *,"coh. face2:",
Ctest1                  (lnods(iel,nface_df(k,ifac(if),itYP)),k=1,ifced)
Ctest                      print *,"coh. edge:",IFAC(IF),
Ctest1                             " of neg. el.",IEL," set",IGAKT
                           GOTO 200
	                ENDIF
                      END DO
 230                  CONTINUE
	            END DO
		    INOT = INOT + 1
 200                CONTINUE
	          END DO
               ELSEIF (IN.GT.0) THEN
C-----------      Element on the positive side and has one node at CZ
C-----------      no storing required
               ENDIF
            END DO
C---------  end of element of following elgroup loop
         END DO
C------  end of following elgroup loop
C
         NELCZ = NELCZ + NELLEF
C
C------  modify "single node at the cz"-elements of IGAKT 
         DO I = 1,IELK
	    IEL = IWORK(IADR3+I)
	    NND = LNODS(IEL,MXNOD)
	    DO J = 1,NND
	       INO = LNODS(IEL,J)
	       IW  = IWORK(IADR1+INO)
	       IF (IW.GT.NNODE) LNODS(IEL,J) = IW
            END DO
         END DO
C
      END DO
C
      write (IO_WRITE,*) "generated",NODNEW-NNODE,
     1                   " new nodes for cohesive elements"
      IF (INOT.GT.0) 
     1    WRITE(IO_WRITE,*) INOT," el. faces have no corresponding edge"
C
C---  generate cohesive elements 
C
      DO I = 1,NELCZ
	 IADR = IADR4 + (I-1) * 5
         IEL1 = IWORK(IADR+1)
         IFC1 = IWORK(IADR+2)
         IEL2 = IWORK(IADR+3)
         IFC2 = IWORK(IADR+4)
	 ISHIFT = IWORK(IADR+5)
	 IF (IEL2.EQ.0) GOTO 400
         CALL ELEINF (IEL1,NEDGE,NFACE,NFCND,NEDND,NCORN,NNDIM1)
Ctest    print *,"generating cze from ",iel1," and ",iel2
	 ICONOD = 8
	 IF (NFACE.EQ.4) ICONOD = 6
	 IF (NFACE.EQ.1) ICONOD = 4
	 ICOEDG = ICONOD / 2
         NELNEW = NELNEW + 1
         MATSET(IMSET2,1) = MATSET(IMSET2,1) + 1
         MATSET(IMSET2,MATSET(IMSET2,1)) = NELNEW
	 IF (NFACE.EQ.1) THEN
            ELTYP(NELNEW) = "ICOHE2" 
	 ELSE
            ELTYP(NELNEW) = "ICOHE3" 
	 ENDIF
         LNODS(NELNEW,MXNOD) = ICONOD
         LNODS(NELNEW,MXNOD-1) = IMSET2
         DO J = 1, ICOEDG
C---------  1 CZE (6 or 8 nodes)
            INO1 = LNODS(IEL1,NFACE_DF(J,IFC1,ITYP))
            LNODS(NELNEW,J) = INO1
	    J2 = MOD(ISHIFT-J+ICOEDG,ICOEDG) + 1
            INO2 = LNODS(IEL2,NFACE_DF(J2,IFC2,ITYP))
            LNODS(NELNEW,J+ICOEDG) = INO2
         END DO
Ctest    print *,"coh. el.",nelnew,":",(lnods(nelnew,j),j=1,iconod)
 400  CONTINUE
      END DO
C
Ctest print *,"found ",nelnew-nelem," cohesive el's for elgroup ",imset2
      NNODE = NODNEW
      NELEM = NELNEW
C
      RETURN
C
 980  CONTINUE
      print *,"no cohesive nodes on the line!"
      RETURN
C
 996  CONTINUE
      print *,"memory exceeded. Increase mxmem to",iamax
      RETURN
 999  CONTINUE
      print *,"element",iel," has",in," cohesive nodes, ",
     1        "but only",nndim1," are allowed"
      RETURN
      END
