C
C     GENERATING COHESIVE ELEMENT ALONG A GIVEN LINE
C
      SUBROUTINE COHESIV5
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCc
C                                                           C
C      KOHSIVELEMENTE FECGS                                C
C     (6 KNOTEN):     (4 KNOTEN)                            C
C                                                           C
C     1---2---3        1----2   Liniendefinition            C
C     |       |        |    |   -------------------->       C
C     4---5---6        3----4                               C
C                                                           C
C     KOHSIVELEMENT ABAQUS (immer 4 KNOTEN)                C
C     (auch am Rand - Linie so definieren da der Rand      C
C      rechts liegt!  Knotenlinie 4-3 ist Randlinie)        C
C                                                           C
C     2-----1    Liniendefinition                           C
C     |     |    --------------------------->               C
C     4-----3                                               C
C                                                           C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCc
C
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C     INCLUDE 'mcommon1'
      PARAMETER (MXCZM = 1000)
      DIMENSION RLMBND(MXCZM),ICZMND(MXCZM)
      DIMENSION IND(9),INDND(9)
      LOGICAL LOGABA
C
      WRITE(IO_JNL,'(5X,A)') 'NOW EXCUTING SUB. COHESIV5'
      WRITE(IO_WRITE,'(5X,A)') 'NOW EXCUTING SUB. COHESIV5'
C
      TEXT='NOW EXCUTING SUB. COHESIV5'
      TEXT1=' '
      IF(KEY_WT.EQ.1) THEN
        CALL WPROC(TEXT,2,TEXT1,0,0)
      END IF
C
      EPSTOL = 1.E-5
      IMSET1 = 0
      CALL LOCCHR(STRING,'OLD ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET1
      END IF
      CALL LOCCHR(STRING,'NEW ELSET',8,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) IMSET2
      ELSE
         IMSET2 = 1
         DO I=1,MXMSET
           IF(MATSET(I,1).GT.1) IMSET2 = IMSET2 + 1
         END DO
      END IF
      CALL LOCCHR(STRING,'TOLER   ',5,1,K1,K2)
      IF(K2.GE.K1) THEN
        READ(STRING(K1:K2),*) EPSTOL
      ENDIF
      LOGABA = .FALSE.
      IF (INDEX(STRING,'ABAQUS').GT.0) THEN
        LOGABA = .TRUE.
      ENDIF
      CALL GETLINE (LEN,IERR)
      IF(STRING(1:1).EQ.'*') THEN
        BACKSPACE IO_INPUT
        RETURN
      ELSE
         DO I = 1,4
            ITYPE(I) = 2
         END DO
         INVAR = 4
         CALL SLVLINE (STRING,LEN,IERR)
         X1 = RVARR(1)
         Y1 = RVARR(2)
         X2 = RVARR(3)
         Y2 = RVARR(4)
         DX = X2 - X1
         DY = Y2 - Y1
         RLENDX = SQRT(DX*DX+DY*DY)
         HX = -DY / RLENDX
         HY =  DX / RLENDX
      END IF
Ctest print *,"Die Vektoren sind G=",dx,"/",dy,"; H=",hx,"/",hy
C
 10   CONTINUE
      IF (IMSET1.EQ.0) THEN
         NUMEL1 = 1
         NUMEL2 = NELEM
         IE     = 1
      ELSE
         NUMEL1 = 2
         NUMEL2 = MATSET(IMSET1,1)
         IE     = MATSET(IMSET1,2)
      END IF
      NND  = LNODS(IE,MXNOD)
      KND  = 2
      IF(NND.GT.4) KND = 3
      NEDGE  = NND/(KND-1)
C
C---  determining nodes at the cohesive line
C
      NCZMND = 0
C---  For all nodes do...
      DO INODE = 1, NNODE
	 IF (INCOD(INODE).NE.INODE) GOTO 90
	 RX = COORD(INODE,1) - X1
	 RY = COORD(INODE,2) - Y1
	 RMIU = (DX*RY - DY*RX)/RLENDX
	 IF  (ABS(RMIU).LT.EPSTOL) THEN
	    RLAMB = (RX*HY - RY*HX)/RLENDX
Ctest          print *,inode," liegt auf der Linie mit lambda=",rlamb
	    IF (RLAMB.GT.0.0-TOLER .AND. RLAMB.LT. 1.0+TOLER) THEN
	       NCZMND = NCZMND + 1
	       ICZMND(NCZMND) = INODE
	       RLMBND(NCZMND) = RLAMB
	    ENDIF
	 ENDIF
  90     CONTINUE
      END DO
      IF (NCZMND .EQ. 0) GOTO 980
C
      IF (MATSET(IMSET2,1).LE.1) MATSET(IMSET2,1) = 1
      NELRIG = 0
      NELLEF = 0
      IELK   = 0
      NODNEW = NNODE
      NELNEW = NELEM
C
C---  initializing the iwork array for element and node storing
      IARLEN = NUMEL2 - NUMEL1 + 1
      IADR2 = IARLEN
      IADR3 = IADR2 + IARLEN
      IADR4 = IADR3 + IARLEN
      IAMAX = IADR4 + NNODE
      IF (IAMAX .GT. MXMEM) GOTO 996
      DO I = 1,IAMAX
	 IWORK(I) = 0.0
      END DO
C
C---  searching for elements containing a cohesive edge
      DO I = NUMEL1, NUMEL2
	 IF (IMSET1.EQ.0) THEN
	    IEL = I
	    IF (ELTYP(IEL)(1:2).EQ."IC") GOTO 200
	 ELSE
	    IEL = MATSET(IMSET1,I)
         ENDIF
	 IF (IEL.EQ.0) GOTO 200
	 IN = 0
	 DO J = 1, NND
	    DO K = 1,NCZMND
	       IAKT = LNODS(IEL,J)
	       IF (IAKT.EQ.ICZMND(K)) THEN
	          IN = IN + 1
	          IND(IN)   = J
	          INDND(IN) = K
	       ENDIF
	    END DO
	 END DO
	 IF (IN.GT.KND) GOTO 999
C
	 IF (IN.EQ.KND) THEN
C--------   Element hat eine Kante an der CZ
            CALL DETELM (IEL,X1,Y1,DX,DY,RMIU)
	    RMIU = RMIU / RLENDX
	    IF (RMIU .GT. 0.0) THEN
C-----------   Element an der linken Seite
	       NELLEF = NELLEF + 1
	       IF (IND(1).EQ.1 .AND. IND(2).EQ.NEDGE) THEN
Ctest             print *,"coh. edge:",NEDGE," of left el.",IEL
	          IWORK(NELLEF) = IEL*10 + NEDGE
	       ELSE
	          IWORK(NELLEF) = IEL*10 + IND(1)
Ctest             print *,"coh. edge:",IND(1)," of left el.",IEL
	       ENDIF
	       RWORK(NELLEF) = MIN(RLMBND(INDND(1)),RLMBND(INDND(2)))
	    ELSE
C--------      Element an der rechten Seite
	       NELRIG = NELRIG + 1
	       IF (IND(1).EQ.1 .AND. IND(2).EQ.NEDGE) THEN
Ctest             print *,"coh. edge:",NEDGE," of right el.",IEL
	          IWORK(IADR2+NELRIG) = IEL*10 + NEDGE
	       ELSE
Ctest             print *,"coh. edge:",ind(1)," of right el.",IEL
	          IWORK(IADR2+NELRIG) = IEL*10 + IND(1)
	       ENDIF
	       RWORK(IADR2+NELRIG) = 
     1               MIN(RLMBND(INDND(1)),RLMBND(INDND(2)))
	    ENDIF
	 ELSEIF (IN.GT.0) THEN
C--------   Element on the right side and has one node at CZ
            CALL DETELM (IEL,X1,Y1,DX,DY,RMIU)
	    RMIU = RMIU / RLENDX
Ctest       print *,"element",iel," has a node at the CZ"
            IF (RMIU.LT.0.0) THEN
Ctest          print *,"     (right)"
	       IELK = IELK + 1
	       IWORK(IADR3+IELK) = IEL
            ENDIF
         ENDIF
 200     CONTINUE
      END DO
      IF (NELRIG .NE. NELLEF) THEN
	 IF     (NELRIG .EQ. 0 .AND. LOGABA) THEN
C---------- the program can handle this
	 ELSEIF (NELLEF .EQ. 0 .AND. LOGABA) THEN
C---------- change direction of line
            TMP = X1
	    X1  = X2
	    X2  = TMP
            TMP = Y1
	    Y1  = Y2
	    Y2  = TMP
            DX = X2 - X1
            DY = Y2 - Y1
            RLENDX = SQRT(DX*DX+DY*DY)
            HX = -DY / RLENDX
            HY =  DX / RLENDX
	    GOTO 10
	 ELSE
	    GOTO 992
	 ENDIF
      ENDIF
C---  sorting the elements with a coh. edge acc. to min. lambda
      CALL BBSORT (RWORK,IWORK,NELLEF)
      CALL BBSORT (RWORK(IADR2+1),IWORK(IADR2+1),NELRIG)
C---  generating the CE from right and left edges of solid elements
      IF (LOGABA) THEN
         CALL CZM5_ABA (IMSET2,IADR2,IADR4,
     1                  NELLEF,NELRIG,NELNEW,NEDGE,NODNEW)
      ELSE
      DO I = 1,NELLEF
         NELNEW = NELNEW + 1
         MATSET(IMSET2,1) = MATSET(IMSET2,1) + 1
         MATSET(IMSET2,MATSET(IMSET2,1)) = NELNEW
         LNODS(NELNEW,MXNOD) = KND*2
         LNODS(NELNEW,MXNOD-1) = IMSET2
	 IELLEF = IWORK(I)/10
	 IEDGLF = IWORK(I) - IELLEF*10
	 IELRIG = IWORK(IADR2+I)/10
	 IEDGRG = IWORK(IADR2+I) - IELRIG*10
	 IF (KND.EQ.3) THEN
	    ELTYP(NELNEW) = "ICOHE3" 
	    IF (IEDGLF.EQ.NEDGE) THEN
	       INDND(1) = NEDGE
	       INDND(2) = NEDGE*2
	       INDND(3) = 1
	    ELSE
	       INDND(1) = IEDGLF
	       INDND(2) = IEDGLF + NEDGE
	       INDND(3) = IEDGLF + 1
	    ENDIF
	    IF (IEDGRG.EQ.NEDGE) THEN
	       INDND(4) = 1
	       INDND(5) = NEDGE*2
	       INDND(6) = NEDGE
	    ELSE
	       INDND(4) = IEDGRG + 1
	       INDND(5) = IEDGRG + NEDGE
	       INDND(6) = IEDGRG
	    ENDIF
	    DO J = 1,3
	       LNODS(NELNEW,J  ) = LNODS(IELLEF,INDND(J  ))
	       LNODS(NELNEW,J+3) = LNODS(IELRIG,INDND(J+3))
	    END DO
         ELSE
	    ELTYP(NELNEW) = "ICOHE2" 
	    IF (IEDGLF.EQ.NEDGE) THEN
	       INDND(1) = NEDGE
	       INDND(2) = 1
	    ELSE
	       INDND(1) = IEDGLF
	       INDND(2) = IEDGLF + 1
	    ENDIF
	    IF (IEDGRG.EQ.NEDGE) THEN
	       INDND(3) = 1
	       INDND(4) = NEDGE
	    ELSE
	       INDND(3) = IEDGRG + 1
	       INDND(4) = IEDGRG
	    ENDIF
	    DO J = 1,2
	       LNODS(NELNEW,J  ) = LNODS(IELLEF,INDND(J  ))
	       LNODS(NELNEW,J+2) = LNODS(IELRIG,INDND(J+2))
	    END DO
	 ENDIF
C------  if nodes on left and right side are identical, give new
C------  number to node at right side ...
	 DO K = 1,KND
	    INO = LNODS(NELNEW,K+KND)
	    IF (INO.EQ.LNODS(NELNEW,K)) THEN
               IF (IWORK(IADR4+INO).EQ.0) THEN
	          NODNEW = NODNEW + 1
	          IWORK(IADR4+INO) = NODNEW
	          COORD(NODNEW,1) = COORD(INO,1)
	          COORD(NODNEW,2) = COORD(INO,2)
	          COORD(NODNEW,3) = COORD(INO,3)
	          INCOD(NODNEW)   = NODNEW
Ctest  	          print *,"node",ino," is now",nodnew
	       ENDIF
C------------  and change elemnt conectivity card for CZ element ...
               LNODS(NELNEW,K+KND) = IWORK(IADR4+INO)
C------------  and for solid element
               LNODS(IELRIG,INDND(K+KND)) = IWORK(IADR4+INO)
	    ENDIF
	 END DO
Ctest   print *,"CE",nelnew," consists of",(lnods(nelnew,kk),kk=1,knd*2)
      END DO
C
      ENDIF
C
C---  modify the elements on the right side of the CZ, which have nodes
C---  to be modified
      IF (NODNEW.GT.NNODE) THEN
	 DO I = 1,IELK
	    DO J = 1,NND
	       IE = IWORK(IADR3+I)
	       IF (IWORK(IADR4+LNODS(IE,J)).NE.0) THEN
		  LNODS(IE,J) = IWORK(IADR4+LNODS(IE,J))
	       ENDIF
            END DO
         END DO
      ENDIF
C
C
      NNODE = NODNEW
      NELEM = NELNEW
C
      RETURN
C
 980  CONTINUE
      print *,"keine Kohsivknoten auf der angegebenen Linie!"
      RETURN
C
 992  CONTINUE
      print *,"Auf der rechten Seite",nelrig," Elemente,"
      print *,"auf der linken Seite",nellef," Elemente an der CZ!"
      print *,"Abbruch."
      RETURN
 996  CONTINUE
      print *,"memory exceeded. Increase mxmem to",iamax
      RETURN
 999  CONTINUE
      RETURN
      END
C
C
C---  determine the element center
C
C
      SUBROUTINE DETELM (IELEM,X1,Y1,DX,DY,RMIU)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
C
      RMIU = 0.0
      IF (IELEM.EQ.0 .OR. ELTYP(IELEM)(1:2) .EQ. "IC") RETURN
      NND = LNODS(IELEM,MXNOD)
      KND = 1
      IF (NND.GT.4) KND = 2
      NEDGE = NND / KND
      XM = 0.0
      YM = 0.0
      DO K = 1,NEDGE
         XM = XM + COORD(LNODS(IELEM,K),1)
         YM = YM + COORD(LNODS(IELEM,K),2)
      END DO
      XM = XM/NEDGE - X1
      YM = YM/NEDGE - Y1
      RMIU = YM*DX - XM*DY
      RETURN
      END
C
C
C---  BUBBLE SORT
C
C
C---  sorting the nodes acc. to lambda
      SUBROUTINE BBSORT (RARR,IARR,NUM)
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION RARR(NUM),IARR(NUM)
      DO I = 1,NUM
	 VAL = RARR(I)
	 VALMIN = VAL
	 ICHNG = I
	 DO J = I+1,NUM
	    VAL2 = RARR(J)
	    IF (VAL2 .LT. VALMIN) THEN
	       ICHNG = J
	       VALMIN = VAL2
	    ENDIF
	 END DO
	 IF (ICHNG.NE.I) THEN
	    INTMP       = IARR(I)
	    IARR(I)     = IARR(ICHNG)
	    IARR(ICHNG) = INTMP
	    RARR(I)     = VALMIN
	    RARR(ICHNG) = VAL
	 ENDIF
      END DO
      RETURN
      END
C
C---  SUBROUTINE MCZM5_ABA for use of cohesive zone elements 
C---  within ABAQUS
C
      SUBROUTINE CZM5_ABA (IMSET,IADR2,IADR4,
     1                     NELLEF,NELRIG,NELNEW,NEDGE,NODNEW)
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'common'
      DIMENSION INDND(9)
C
C
      DO I = 1,NELLEF
         NELNEW = NELNEW + 1
         MATSET(IMSET,1) = MATSET(IMSET,1) + 1
         MATSET(IMSET,MATSET(IMSET,1)) = NELNEW
         LNODS(NELNEW,MXNOD) = 4
         LNODS(NELNEW,MXNOD-1) = IMSET
	 ELTYP(NELNEW) = "ICOHE2" 
	 IELLEF = IWORK(I)/10
	 IEDGLF = IWORK(I) - IELLEF*10
	 IF (NELRIG .NE. 0) THEN
	    IELRIG = IWORK(IADR2+I)/10
	    IEDGRG = IWORK(IADR2+I) - IELRIG*10
	 ENDIF
	 IF (LNODS(IELLEF,MXNOD).GT.4) THEN
C---------  quadratische Elemente bekommen 2 Kohsivzonenelemente
	    IF (IEDGLF.EQ.NEDGE) THEN
	       INDND(1) = 1
	       INDND(2) = NEDGE*2
	    ELSE
	       INDND(1) = IEDGLF + 1
	       INDND(2) = IEDGLF + NEDGE
	    ENDIF
	    IF (IEDGRG.EQ.NEDGE) THEN
	       INDND(3) = NEDGE
	       INDND(4) = NEDGE*2
	    ELSE
	       INDND(3) = IEDGRG
	       INDND(4) = IEDGRG + NEDGE
	    ENDIF
	    DO J = 1,2
	       NODLEF = LNODS(IELLEF,INDND(J  ))
	       IF (NELRIG .EQ. 0) THEN
		  NODRIG = NODLEF
	       ELSE
		  NODRIG = LNODS(IELRIG,INDND(J+2))
	       ENDIF
	       LNODS(NELNEW,J  ) = NODLEF
	       LNODS(NELNEW,J+2) = NODRIG
	       IF (NODLEF .EQ. NODRIG) THEN
                  IF (IWORK(IADR4+NODRIG).EQ.0) THEN
	             NODNEW = NODNEW + 1
	             IWORK(IADR4+NODRIG) = NODNEW
	             COORD(NODNEW,1) = COORD(NODRIG,1)
	             COORD(NODNEW,2) = COORD(NODRIG,2)
	             COORD(NODNEW,3) = COORD(NODRIG,3)
	             INCOD(NODNEW)   = NODNEW
Ctest  	             print *,"node",NODRIG," is now",nodnew
	          ENDIF
C---------------  and change elemnt conectivity card for CZ element ...
                  LNODS(NELNEW,J+2) = IWORK(IADR4+NODRIG)
C---------------  and for solid element
		  IF (NELRIG .NE. 0) 
     1               LNODS(IELRIG,INDND(J+2)) = IWORK(IADR4+NODRIG)
	       ENDIF
	    END DO
Ctest       print *,"CE",nelnew," consists of",(lnods(nelnew,kk),kk=1,4)
            NELNEW = NELNEW + 1
            MATSET(IMSET,1) = MATSET(IMSET,1) + 1
            MATSET(IMSET,MATSET(IMSET,1)) = NELNEW
            LNODS(NELNEW,MXNOD) = 4
            LNODS(NELNEW,MXNOD-1) = IMSET
	    ELTYP(NELNEW) = "ICOHE2" 
	    IF (IEDGLF.EQ.NEDGE) THEN
	       INDND(1) = NEDGE*2
	       INDND(2) = 1
	    ELSE
	       INDND(1) = IEDGLF + NEDGE
	       INDND(2) = IEDGLF
	    ENDIF
	    IF (IEDGRG.EQ.NEDGE) THEN
	       INDND(3) = NEDGE*2
	       INDND(4) = 1
	    ELSE
	       INDND(3) = IEDGRG + NEDGE
	       INDND(4) = IEDGRG + 1
	    ENDIF
	    DO J = 1,2
	       NODLEF = LNODS(IELLEF,INDND(J  ))
	       IF (NELRIG .EQ. 0) THEN
		  NODRIG = NODLEF
	       ELSE
		  NODRIG = LNODS(IELRIG,INDND(J+2))
	       ENDIF
	       LNODS(NELNEW,J  ) = NODLEF
	       LNODS(NELNEW,J+2) = NODRIG
	       IF (NODLEF .EQ. NODRIG) THEN
                  IF (IWORK(IADR4+NODRIG).EQ.0) THEN
	             NODNEW = NODNEW + 1
	             IWORK(IADR4+NODRIG) = NODNEW
	             COORD(NODNEW,1) = COORD(NODRIG,1)
	             COORD(NODNEW,2) = COORD(NODRIG,2)
	             COORD(NODNEW,3) = COORD(NODRIG,3)
	             INCOD(NODNEW)   = NODNEW
Ctest  	             print *,"node",NODRIG," is now",nodnew
	          ENDIF
C---------------  and change elemnt conectivity card for CZ element ...
                  LNODS(NELNEW,J+2) = IWORK(IADR4+NODRIG)
C---------------  and for solid element
		  IF (NELRIG .NE. 0) 
     1               LNODS(IELRIG,INDND(J+2)) = IWORK(IADR4+NODRIG)
	       ENDIF
	    END DO
Ctest       print *,"CE",nelnew," consists of",(lnods(nelnew,kk),kk=1,4)
         ELSE
	    IF (IEDGLF.EQ.NEDGE) THEN
	       INDND(1) = 1
	       INDND(2) = NEDGE
	    ELSE
	       INDND(1) = IEDGLF + 1
	       INDND(2) = IEDGLF
	    ENDIF
	    IF (IEDGRG.EQ.NEDGE) THEN
	       INDND(3) = NEDGE
	       INDND(4) = 1
	    ELSE
	       INDND(3) = IEDGRG
	       INDND(4) = IEDGRG + 1
	    ENDIF
	    DO J = 1,2
	       NODLEF = LNODS(IELLEF,INDND(J  ))
	       IF (NELRIG .EQ. 0) THEN
		  NODRIG = NODLEF
	       ELSE
		  NODRIG = LNODS(IELRIG,INDND(J+2))
	       ENDIF
	       LNODS(NELNEW,J  ) = NODLEF
	       LNODS(NELNEW,J+2) = NODRIG
	       IF (NODLEF .EQ. NODRIG) THEN
                  IF (IWORK(IADR4+NODRIG).EQ.0) THEN
	             NODNEW = NODNEW + 1
	             IWORK(IADR4+NODRIG) = NODNEW
	             COORD(NODNEW,1) = COORD(NODRIG,1)
	             COORD(NODNEW,2) = COORD(NODRIG,2)
	             COORD(NODNEW,3) = COORD(NODRIG,3)
	             INCOD(NODNEW)   = NODNEW
Ctest  	             print *,"node",NODRIG," is now",nodnew
	          ENDIF
C---------------  and change elemnt conectivity card for CZ element ...
                  LNODS(NELNEW,J+2) = IWORK(IADR4+NODRIG)
C---------------  and for solid element
		  IF (NELRIG .NE. 0) 
     1               LNODS(IELRIG,INDND(J+2)) = IWORK(IADR4+NODRIG)
	       ENDIF
	    END DO
Ctest       print *,"CE",nelnew," consists of",(lnods(nelnew,kk),kk=1,4)
	 ENDIF
      END DO
      RETURN
      END
